/* Playback.c generated by valac 0.44.11, the Vala compiler
 * generated from Playback.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gst/gst.h>
#include <float.h>
#include <math.h>

#define MUSIC_TYPE_PLAYBACK (music_playback_get_type ())
#define MUSIC_PLAYBACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK, MusicPlayback))
#define MUSIC_IS_PLAYBACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK))
#define MUSIC_PLAYBACK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), MUSIC_TYPE_PLAYBACK, MusicPlaybackIface))

typedef struct _MusicPlayback MusicPlayback;
typedef struct _MusicPlaybackIface MusicPlaybackIface;

#define MUSIC_TYPE_MEDIA (music_media_get_type ())
#define MUSIC_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MEDIA, MusicMedia))
#define MUSIC_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MEDIA, MusicMediaClass))
#define MUSIC_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MEDIA))
#define MUSIC_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MEDIA))
#define MUSIC_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MEDIA, MusicMediaClass))

typedef struct _MusicMedia MusicMedia;
typedef struct _MusicMediaClass MusicMediaClass;
enum  {
	MUSIC_PLAYBACK_END_OF_STREAM_SIGNAL,
	MUSIC_PLAYBACK_CURRENT_POSITION_UPDATE_SIGNAL,
	MUSIC_PLAYBACK_ERROR_OCCURED_SIGNAL,
	MUSIC_PLAYBACK_NUM_SIGNALS
};
static guint music_playback_signals[MUSIC_PLAYBACK_NUM_SIGNALS] = {0};

struct _MusicPlaybackIface {
	GTypeInterface parent_iface;
	GeeCollection* (*get_supported_uri) (MusicPlayback* self);
	void (*play) (MusicPlayback* self);
	void (*pause) (MusicPlayback* self);
	void (*set_state) (MusicPlayback* self, GstState s);
	void (*set_media) (MusicPlayback* self, MusicMedia* media);
	void (*set_position) (MusicPlayback* self, gint64 pos);
	gint64 (*get_position) (MusicPlayback* self);
	gint64 (*get_duration) (MusicPlayback* self);
	void (*set_volume) (MusicPlayback* self, gdouble val);
	gdouble (*get_volume) (MusicPlayback* self);
	gboolean (*update_position) (MusicPlayback* self);
	void (*enable_equalizer) (MusicPlayback* self);
	void (*disable_equalizer) (MusicPlayback* self);
	void (*set_equalizer_gain) (MusicPlayback* self, gint index, gint val);
};

GType music_media_get_type (void) G_GNUC_CONST;
GType music_playback_get_type (void) G_GNUC_CONST;
GeeCollection* music_playback_get_supported_uri (MusicPlayback* self);
void music_playback_play (MusicPlayback* self);
void music_playback_pause (MusicPlayback* self);
void music_playback_set_state (MusicPlayback* self,
                               GstState s);
void music_playback_set_media (MusicPlayback* self,
                               MusicMedia* media);
void music_playback_set_position (MusicPlayback* self,
                                  gint64 pos);
gint64 music_playback_get_position (MusicPlayback* self);
gint64 music_playback_get_duration (MusicPlayback* self);
void music_playback_set_volume (MusicPlayback* self,
                                gdouble val);
gdouble music_playback_get_volume (MusicPlayback* self);
gboolean music_playback_update_position (MusicPlayback* self);
void music_playback_enable_equalizer (MusicPlayback* self);
void music_playback_disable_equalizer (MusicPlayback* self);
void music_playback_set_equalizer_gain (MusicPlayback* self,
                                        gint index,
                                        gint val);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);

GeeCollection*
music_playback_get_supported_uri (MusicPlayback* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return MUSIC_PLAYBACK_GET_INTERFACE (self)->get_supported_uri (self);
}

void
music_playback_play (MusicPlayback* self)
{
	g_return_if_fail (self != NULL);
	MUSIC_PLAYBACK_GET_INTERFACE (self)->play (self);
}

void
music_playback_pause (MusicPlayback* self)
{
	g_return_if_fail (self != NULL);
	MUSIC_PLAYBACK_GET_INTERFACE (self)->pause (self);
}

void
music_playback_set_state (MusicPlayback* self,
                          GstState s)
{
	g_return_if_fail (self != NULL);
	MUSIC_PLAYBACK_GET_INTERFACE (self)->set_state (self, s);
}

void
music_playback_set_media (MusicPlayback* self,
                          MusicMedia* media)
{
	g_return_if_fail (self != NULL);
	MUSIC_PLAYBACK_GET_INTERFACE (self)->set_media (self, media);
}

void
music_playback_set_position (MusicPlayback* self,
                             gint64 pos)
{
	g_return_if_fail (self != NULL);
	MUSIC_PLAYBACK_GET_INTERFACE (self)->set_position (self, pos);
}

gint64
music_playback_get_position (MusicPlayback* self)
{
	g_return_val_if_fail (self != NULL, 0LL);
	return MUSIC_PLAYBACK_GET_INTERFACE (self)->get_position (self);
}

gint64
music_playback_get_duration (MusicPlayback* self)
{
	g_return_val_if_fail (self != NULL, 0LL);
	return MUSIC_PLAYBACK_GET_INTERFACE (self)->get_duration (self);
}

void
music_playback_set_volume (MusicPlayback* self,
                           gdouble val)
{
	g_return_if_fail (self != NULL);
	MUSIC_PLAYBACK_GET_INTERFACE (self)->set_volume (self, val);
}

gdouble
music_playback_get_volume (MusicPlayback* self)
{
	g_return_val_if_fail (self != NULL, 0.0);
	return MUSIC_PLAYBACK_GET_INTERFACE (self)->get_volume (self);
}

gboolean
music_playback_update_position (MusicPlayback* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return MUSIC_PLAYBACK_GET_INTERFACE (self)->update_position (self);
}

void
music_playback_enable_equalizer (MusicPlayback* self)
{
	g_return_if_fail (self != NULL);
	MUSIC_PLAYBACK_GET_INTERFACE (self)->enable_equalizer (self);
}

void
music_playback_disable_equalizer (MusicPlayback* self)
{
	g_return_if_fail (self != NULL);
	MUSIC_PLAYBACK_GET_INTERFACE (self)->disable_equalizer (self);
}

void
music_playback_set_equalizer_gain (MusicPlayback* self,
                                   gint index,
                                   gint val)
{
	g_return_if_fail (self != NULL);
	MUSIC_PLAYBACK_GET_INTERFACE (self)->set_equalizer_gain (self, index, val);
}

static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), data2);
}

static void
music_playback_default_init (MusicPlaybackIface * iface,
                             gpointer iface_data)
{
	music_playback_signals[MUSIC_PLAYBACK_END_OF_STREAM_SIGNAL] = g_signal_new ("end-of-stream", MUSIC_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_playback_signals[MUSIC_PLAYBACK_CURRENT_POSITION_UPDATE_SIGNAL] = g_signal_new ("current-position-update", MUSIC_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
	music_playback_signals[MUSIC_PLAYBACK_ERROR_OCCURED_SIGNAL] = g_signal_new ("error-occured", MUSIC_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

GType
music_playback_get_type (void)
{
	static volatile gsize music_playback_type_id__volatile = 0;
	if (g_once_init_enter (&music_playback_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicPlaybackIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_playback_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType music_playback_type_id;
		music_playback_type_id = g_type_register_static (G_TYPE_INTERFACE, "MusicPlayback", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (music_playback_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&music_playback_type_id__volatile, music_playback_type_id);
	}
	return music_playback_type_id__volatile;
}

