/* Settings.c generated by valac 0.44.11, the Vala compiler
 * generated from Settings.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <granite.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>

#define MUSIC_SETTINGS_TYPE_MAIN (music_settings_main_get_type ())
#define MUSIC_SETTINGS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_SETTINGS_TYPE_MAIN, MusicSettingsMain))
#define MUSIC_SETTINGS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_SETTINGS_TYPE_MAIN, MusicSettingsMainClass))
#define MUSIC_SETTINGS_IS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_SETTINGS_TYPE_MAIN))
#define MUSIC_SETTINGS_IS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_SETTINGS_TYPE_MAIN))
#define MUSIC_SETTINGS_MAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_SETTINGS_TYPE_MAIN, MusicSettingsMainClass))

typedef struct _MusicSettingsMain MusicSettingsMain;
typedef struct _MusicSettingsMainClass MusicSettingsMainClass;
typedef struct _MusicSettingsMainPrivate MusicSettingsMainPrivate;
typedef enum  {
	MUSIC_SETTINGS_SHUFFLE_OFF,
	MUSIC_SETTINGS_SHUFFLE_ALL
} MusicSettingsShuffle;

#define MUSIC_SETTINGS_TYPE_SHUFFLE (music_settings_shuffle_get_type ())
typedef enum  {
	MUSIC_SETTINGS_REPEAT_OFF,
	MUSIC_SETTINGS_REPEAT_MEDIA,
	MUSIC_SETTINGS_REPEAT_ALL,
	MUSIC_SETTINGS_REPEAT_ALBUM,
	MUSIC_SETTINGS_REPEAT_ARTIST
} MusicSettingsRepeat;

#define MUSIC_SETTINGS_TYPE_REPEAT (music_settings_repeat_get_type ())
enum  {
	MUSIC_SETTINGS_MAIN_0_PROPERTY,
	MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY,
	MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY,
	MUSIC_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY,
	MUSIC_SETTINGS_MAIN_REPEAT_MODE_PROPERTY,
	MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY,
	MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY,
	MUSIC_SETTINGS_MAIN_NUM_PROPERTIES
};
static GParamSpec* music_settings_main_properties[MUSIC_SETTINGS_MAIN_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MUSIC_SETTINGS_TYPE_EQUALIZER (music_settings_equalizer_get_type ())
#define MUSIC_SETTINGS_EQUALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_SETTINGS_TYPE_EQUALIZER, MusicSettingsEqualizer))
#define MUSIC_SETTINGS_EQUALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_SETTINGS_TYPE_EQUALIZER, MusicSettingsEqualizerClass))
#define MUSIC_SETTINGS_IS_EQUALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_SETTINGS_TYPE_EQUALIZER))
#define MUSIC_SETTINGS_IS_EQUALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_SETTINGS_TYPE_EQUALIZER))
#define MUSIC_SETTINGS_EQUALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_SETTINGS_TYPE_EQUALIZER, MusicSettingsEqualizerClass))

typedef struct _MusicSettingsEqualizer MusicSettingsEqualizer;
typedef struct _MusicSettingsEqualizerClass MusicSettingsEqualizerClass;
typedef struct _MusicSettingsEqualizerPrivate MusicSettingsEqualizerPrivate;
enum  {
	MUSIC_SETTINGS_EQUALIZER_0_PROPERTY,
	MUSIC_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY,
	MUSIC_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY,
	MUSIC_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY,
	MUSIC_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY,
	MUSIC_SETTINGS_EQUALIZER_NUM_PROPERTIES
};
static GParamSpec* music_settings_equalizer_properties[MUSIC_SETTINGS_EQUALIZER_NUM_PROPERTIES];

#define MUSIC_TYPE_EQUALIZER_PRESET (music_equalizer_preset_get_type ())
#define MUSIC_EQUALIZER_PRESET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset))
#define MUSIC_EQUALIZER_PRESET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPresetClass))
#define MUSIC_IS_EQUALIZER_PRESET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_EQUALIZER_PRESET))
#define MUSIC_IS_EQUALIZER_PRESET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_EQUALIZER_PRESET))
#define MUSIC_EQUALIZER_PRESET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPresetClass))

typedef struct _MusicEqualizerPreset MusicEqualizerPreset;
typedef struct _MusicEqualizerPresetClass MusicEqualizerPresetClass;

struct _MusicSettingsMain {
	GraniteServicesSettings parent_instance;
	MusicSettingsMainPrivate * priv;
};

struct _MusicSettingsMainClass {
	GraniteServicesSettingsClass parent_class;
};

struct _MusicSettingsMainPrivate {
	gchar* _music_mount_name;
	gchar* _music_folder;
	MusicSettingsShuffle _shuffle_mode;
	MusicSettingsRepeat _repeat_mode;
	gchar* _path_string;
	gchar** _plugins_disabled;
	gint _plugins_disabled_length1;
	gint __plugins_disabled_size_;
};

struct _MusicSettingsEqualizer {
	GraniteServicesSettings parent_instance;
	MusicSettingsEqualizerPrivate * priv;
};

struct _MusicSettingsEqualizerClass {
	GraniteServicesSettingsClass parent_class;
};

struct _MusicSettingsEqualizerPrivate {
	gboolean _equalizer_enabled;
	gboolean _auto_switch_preset;
	gchar* _selected_preset;
	gchar** _custom_presets;
	gint _custom_presets_length1;
	gint __custom_presets_size_;
};

static gint MusicSettingsMain_private_offset;
static gpointer music_settings_main_parent_class = NULL;
static MusicSettingsMain* music_settings_main_main_settings;
static MusicSettingsMain* music_settings_main_main_settings = NULL;
static gint MusicSettingsEqualizer_private_offset;
static gpointer music_settings_equalizer_parent_class = NULL;
static MusicSettingsEqualizer* music_settings_equalizer_equalizer;
static MusicSettingsEqualizer* music_settings_equalizer_equalizer = NULL;

GType music_settings_main_get_type (void) G_GNUC_CONST;
GType music_settings_shuffle_get_type (void) G_GNUC_CONST;
GType music_settings_repeat_get_type (void) G_GNUC_CONST;
MusicSettingsMain* music_settings_main_get_default (void);
static MusicSettingsMain* music_settings_main_new (void);
static MusicSettingsMain* music_settings_main_construct (GType object_type);
gboolean music_settings_main_privacy_mode_enabled (MusicSettingsMain* self);
const gchar* music_settings_main_get_music_folder (MusicSettingsMain* self);
void music_settings_main_set_music_folder (MusicSettingsMain* self,
                                           const gchar* value);
const gchar* music_settings_main_get_music_mount_name (MusicSettingsMain* self);
void music_settings_main_set_music_mount_name (MusicSettingsMain* self,
                                               const gchar* value);
MusicSettingsShuffle music_settings_main_get_shuffle_mode (MusicSettingsMain* self);
void music_settings_main_set_shuffle_mode (MusicSettingsMain* self,
                                           MusicSettingsShuffle value);
MusicSettingsRepeat music_settings_main_get_repeat_mode (MusicSettingsMain* self);
void music_settings_main_set_repeat_mode (MusicSettingsMain* self,
                                          MusicSettingsRepeat value);
const gchar* music_settings_main_get_path_string (MusicSettingsMain* self);
void music_settings_main_set_path_string (MusicSettingsMain* self,
                                          const gchar* value);
gchar** music_settings_main_get_plugins_disabled (MusicSettingsMain* self,
                                                  gint* result_length1);
void music_settings_main_set_plugins_disabled (MusicSettingsMain* self,
                                               gchar** value,
                                               gint value_length1);
static gchar** _vala_array_dup1 (gchar** self,
                          int length);
static void music_settings_main_finalize (GObject * obj);
static void _vala_music_settings_main_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_music_settings_main_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
GType music_settings_equalizer_get_type (void) G_GNUC_CONST;
MusicSettingsEqualizer* music_settings_equalizer_get_default (void);
static MusicSettingsEqualizer* music_settings_equalizer_new (void);
static MusicSettingsEqualizer* music_settings_equalizer_construct (GType object_type);
GType music_equalizer_preset_get_type (void) G_GNUC_CONST;
GeeCollection* music_settings_equalizer_get_presets (MusicSettingsEqualizer* self);
gchar** music_settings_equalizer_get_custom_presets (MusicSettingsEqualizer* self,
                                                     gint* result_length1);
MusicEqualizerPreset* music_equalizer_preset_new_from_string (const gchar* data);
MusicEqualizerPreset* music_equalizer_preset_construct_from_string (GType object_type,
                                                                    const gchar* data);
gboolean music_settings_equalizer_get_equalizer_enabled (MusicSettingsEqualizer* self);
void music_settings_equalizer_set_equalizer_enabled (MusicSettingsEqualizer* self,
                                                     gboolean value);
gboolean music_settings_equalizer_get_auto_switch_preset (MusicSettingsEqualizer* self);
void music_settings_equalizer_set_auto_switch_preset (MusicSettingsEqualizer* self,
                                                      gboolean value);
const gchar* music_settings_equalizer_get_selected_preset (MusicSettingsEqualizer* self);
void music_settings_equalizer_set_selected_preset (MusicSettingsEqualizer* self,
                                                   const gchar* value);
void music_settings_equalizer_set_custom_presets (MusicSettingsEqualizer* self,
                                                  gchar** value,
                                                  gint value_length1);
static gchar** _vala_array_dup2 (gchar** self,
                          int length);
static void music_settings_equalizer_finalize (GObject * obj);
static void _vala_music_settings_equalizer_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_music_settings_equalizer_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_settings_main_get_instance_private (MusicSettingsMain* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSettingsMain_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

MusicSettingsMain*
music_settings_main_get_default (void)
{
	MusicSettingsMain* _tmp0_;
	MusicSettingsMain* _tmp2_;
	MusicSettingsMain* _tmp3_;
	MusicSettingsMain* result = NULL;
	_tmp0_ = music_settings_main_main_settings;
	if (_tmp0_ == NULL) {
		MusicSettingsMain* _tmp1_;
		_tmp1_ = music_settings_main_new ();
		_g_object_unref0 (music_settings_main_main_settings);
		music_settings_main_main_settings = _tmp1_;
	}
	_tmp2_ = music_settings_main_main_settings;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

gboolean
music_settings_main_privacy_mode_enabled (MusicSettingsMain* self)
{
	GSettings* privacy_settings = NULL;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GSettings* _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_settings_new ("org.gnome.desktop.privacy");
	privacy_settings = _tmp0_;
	_tmp2_ = privacy_settings;
	if (g_settings_get_boolean (_tmp2_, "remember-app-usage")) {
		_tmp1_ = TRUE;
	} else {
		GSettings* _tmp3_;
		_tmp3_ = privacy_settings;
		_tmp1_ = g_settings_get_boolean (_tmp3_, "remember-recent-files");
	}
	result = !_tmp1_;
	_g_object_unref0 (privacy_settings);
	return result;
}

static MusicSettingsMain*
music_settings_main_construct (GType object_type)
{
	MusicSettingsMain * self = NULL;
	const gchar* _tmp0_;
	self = (MusicSettingsMain*) granite_services_settings_construct (object_type, "io.elementary.music.settings");
	_tmp0_ = self->priv->_music_folder;
	if (g_strcmp0 (_tmp0_, "") == 0) {
		const gchar* _tmp1_;
		_tmp1_ = g_get_user_special_dir (G_USER_DIRECTORY_MUSIC);
		music_settings_main_set_music_folder (self, _tmp1_);
	}
	return self;
}

static MusicSettingsMain*
music_settings_main_new (void)
{
	return music_settings_main_construct (MUSIC_SETTINGS_TYPE_MAIN);
}

const gchar*
music_settings_main_get_music_mount_name (MusicSettingsMain* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_music_mount_name;
	result = _tmp0_;
	return result;
}

void
music_settings_main_set_music_mount_name (MusicSettingsMain* self,
                                          const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, music_settings_main_get_music_mount_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_music_mount_name);
		self->priv->_music_mount_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_settings_main_properties[MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY]);
	}
}

const gchar*
music_settings_main_get_music_folder (MusicSettingsMain* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_music_folder;
	result = _tmp0_;
	return result;
}

void
music_settings_main_set_music_folder (MusicSettingsMain* self,
                                      const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, music_settings_main_get_music_folder (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_music_folder);
		self->priv->_music_folder = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_settings_main_properties[MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY]);
	}
}

MusicSettingsShuffle
music_settings_main_get_shuffle_mode (MusicSettingsMain* self)
{
	MusicSettingsShuffle result;
	MusicSettingsShuffle _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_shuffle_mode;
	result = _tmp0_;
	return result;
}

void
music_settings_main_set_shuffle_mode (MusicSettingsMain* self,
                                      MusicSettingsShuffle value)
{
	g_return_if_fail (self != NULL);
	if (music_settings_main_get_shuffle_mode (self) != value) {
		self->priv->_shuffle_mode = value;
		g_object_notify_by_pspec ((GObject *) self, music_settings_main_properties[MUSIC_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY]);
	}
}

MusicSettingsRepeat
music_settings_main_get_repeat_mode (MusicSettingsMain* self)
{
	MusicSettingsRepeat result;
	MusicSettingsRepeat _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_repeat_mode;
	result = _tmp0_;
	return result;
}

void
music_settings_main_set_repeat_mode (MusicSettingsMain* self,
                                     MusicSettingsRepeat value)
{
	g_return_if_fail (self != NULL);
	if (music_settings_main_get_repeat_mode (self) != value) {
		self->priv->_repeat_mode = value;
		g_object_notify_by_pspec ((GObject *) self, music_settings_main_properties[MUSIC_SETTINGS_MAIN_REPEAT_MODE_PROPERTY]);
	}
}

const gchar*
music_settings_main_get_path_string (MusicSettingsMain* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_path_string;
	result = _tmp0_;
	return result;
}

void
music_settings_main_set_path_string (MusicSettingsMain* self,
                                     const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, music_settings_main_get_path_string (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_path_string);
		self->priv->_path_string = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_settings_main_properties[MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY]);
	}
}

gchar**
music_settings_main_get_plugins_disabled (MusicSettingsMain* self,
                                          gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_plugins_disabled;
	_tmp0__length1 = self->priv->_plugins_disabled_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup1 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

void
music_settings_main_set_plugins_disabled (MusicSettingsMain* self,
                                          gchar** value,
                                          gint value_length1)
{
	gint old_value_length;
	g_return_if_fail (self != NULL);
	if (music_settings_main_get_plugins_disabled (self, &old_value_length) != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		_tmp0_ = (value != NULL) ? _vala_array_dup1 (value, value_length1) : ((gpointer) value);
		_tmp0__length1 = value_length1;
		self->priv->_plugins_disabled = (_vala_array_free (self->priv->_plugins_disabled, self->priv->_plugins_disabled_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_plugins_disabled = _tmp0_;
		self->priv->_plugins_disabled_length1 = _tmp0__length1;
		self->priv->__plugins_disabled_size_ = self->priv->_plugins_disabled_length1;
		g_object_notify_by_pspec ((GObject *) self, music_settings_main_properties[MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY]);
	}
}

static void
music_settings_main_class_init (MusicSettingsMainClass * klass,
                                gpointer klass_data)
{
	music_settings_main_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicSettingsMain_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_settings_main_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_settings_main_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_settings_main_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY, music_settings_main_properties[MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY] = g_param_spec_string ("music-mount-name", "music-mount-name", "music-mount-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY, music_settings_main_properties[MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY] = g_param_spec_string ("music-folder", "music-folder", "music-folder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY, music_settings_main_properties[MUSIC_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY] = g_param_spec_enum ("shuffle-mode", "shuffle-mode", "shuffle-mode", MUSIC_SETTINGS_TYPE_SHUFFLE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_MAIN_REPEAT_MODE_PROPERTY, music_settings_main_properties[MUSIC_SETTINGS_MAIN_REPEAT_MODE_PROPERTY] = g_param_spec_enum ("repeat-mode", "repeat-mode", "repeat-mode", MUSIC_SETTINGS_TYPE_REPEAT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY, music_settings_main_properties[MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY] = g_param_spec_string ("path-string", "path-string", "path-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY, music_settings_main_properties[MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY] = g_param_spec_boxed ("plugins-disabled", "plugins-disabled", "plugins-disabled", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
music_settings_main_instance_init (MusicSettingsMain * self,
                                   gpointer klass)
{
	self->priv = music_settings_main_get_instance_private (self);
}

static void
music_settings_main_finalize (GObject * obj)
{
	MusicSettingsMain * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_SETTINGS_TYPE_MAIN, MusicSettingsMain);
	_g_free0 (self->priv->_music_mount_name);
	_g_free0 (self->priv->_music_folder);
	_g_free0 (self->priv->_path_string);
	self->priv->_plugins_disabled = (_vala_array_free (self->priv->_plugins_disabled, self->priv->_plugins_disabled_length1, (GDestroyNotify) g_free), NULL);
	G_OBJECT_CLASS (music_settings_main_parent_class)->finalize (obj);
}

GType
music_settings_main_get_type (void)
{
	static volatile gsize music_settings_main_type_id__volatile = 0;
	if (g_once_init_enter (&music_settings_main_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicSettingsMainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_settings_main_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSettingsMain), 0, (GInstanceInitFunc) music_settings_main_instance_init, NULL };
		GType music_settings_main_type_id;
		music_settings_main_type_id = g_type_register_static (GRANITE_SERVICES_TYPE_SETTINGS, "MusicSettingsMain", &g_define_type_info, 0);
		MusicSettingsMain_private_offset = g_type_add_instance_private (music_settings_main_type_id, sizeof (MusicSettingsMainPrivate));
		g_once_init_leave (&music_settings_main_type_id__volatile, music_settings_main_type_id);
	}
	return music_settings_main_type_id__volatile;
}

static void
_vala_music_settings_main_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	MusicSettingsMain * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_SETTINGS_TYPE_MAIN, MusicSettingsMain);
	switch (property_id) {
		case MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY:
		g_value_set_string (value, music_settings_main_get_music_mount_name (self));
		break;
		case MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY:
		g_value_set_string (value, music_settings_main_get_music_folder (self));
		break;
		case MUSIC_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY:
		g_value_set_enum (value, music_settings_main_get_shuffle_mode (self));
		break;
		case MUSIC_SETTINGS_MAIN_REPEAT_MODE_PROPERTY:
		g_value_set_enum (value, music_settings_main_get_repeat_mode (self));
		break;
		case MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY:
		g_value_set_string (value, music_settings_main_get_path_string (self));
		break;
		case MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, music_settings_main_get_plugins_disabled (self, &length));
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_settings_main_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	MusicSettingsMain * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_SETTINGS_TYPE_MAIN, MusicSettingsMain);
	switch (property_id) {
		case MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY:
		music_settings_main_set_music_mount_name (self, g_value_get_string (value));
		break;
		case MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY:
		music_settings_main_set_music_folder (self, g_value_get_string (value));
		break;
		case MUSIC_SETTINGS_MAIN_SHUFFLE_MODE_PROPERTY:
		music_settings_main_set_shuffle_mode (self, g_value_get_enum (value));
		break;
		case MUSIC_SETTINGS_MAIN_REPEAT_MODE_PROPERTY:
		music_settings_main_set_repeat_mode (self, g_value_get_enum (value));
		break;
		case MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY:
		music_settings_main_set_path_string (self, g_value_get_string (value));
		break;
		case MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			music_settings_main_set_plugins_disabled (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
music_settings_equalizer_get_instance_private (MusicSettingsEqualizer* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSettingsEqualizer_private_offset);
}

MusicSettingsEqualizer*
music_settings_equalizer_get_default (void)
{
	MusicSettingsEqualizer* _tmp0_;
	MusicSettingsEqualizer* _tmp2_;
	MusicSettingsEqualizer* _tmp3_;
	MusicSettingsEqualizer* result = NULL;
	_tmp0_ = music_settings_equalizer_equalizer;
	if (_tmp0_ == NULL) {
		MusicSettingsEqualizer* _tmp1_;
		_tmp1_ = music_settings_equalizer_new ();
		_g_object_unref0 (music_settings_equalizer_equalizer);
		music_settings_equalizer_equalizer = _tmp1_;
	}
	_tmp2_ = music_settings_equalizer_equalizer;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

static MusicSettingsEqualizer*
music_settings_equalizer_construct (GType object_type)
{
	MusicSettingsEqualizer * self = NULL;
	self = (MusicSettingsEqualizer*) granite_services_settings_construct (object_type, "io.elementary.music.equalizer");
	return self;
}

static MusicSettingsEqualizer*
music_settings_equalizer_new (void)
{
	return music_settings_equalizer_construct (MUSIC_SETTINGS_TYPE_EQUALIZER);
}

GeeCollection*
music_settings_equalizer_get_presets (MusicSettingsEqualizer* self)
{
	GeeTreeSet* presets_data = NULL;
	GeeTreeSet* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
	GeeTreeSet* rv = NULL;
	GeeTreeSet* _tmp11_;
	GeeTreeSet* _tmp21_;
	GeeBidirSortedSet* _tmp22_;
	GeeBidirSortedSet* _tmp23_;
	GeeCollection* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	presets_data = _tmp0_;
	_tmp1_ = music_settings_equalizer_get_custom_presets (self, &_tmp1__length1);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp1__length1;
	if (_tmp2_ != NULL) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					gchar** _tmp5_;
					gint _tmp5__length1;
					gchar** _tmp6_;
					gint _tmp6__length1;
					GeeTreeSet* _tmp7_;
					gchar** _tmp8_;
					gint _tmp8__length1;
					gchar** _tmp9_;
					gint _tmp9__length1;
					const gchar* _tmp10_;
					if (!_tmp3_) {
						gint _tmp4_;
						_tmp4_ = i;
						i = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					_tmp5_ = music_settings_equalizer_get_custom_presets (self, &_tmp5__length1);
					_tmp6_ = _tmp5_;
					_tmp6__length1 = _tmp5__length1;
					if (!(i < _tmp6__length1)) {
						break;
					}
					_tmp7_ = presets_data;
					_tmp8_ = music_settings_equalizer_get_custom_presets (self, &_tmp8__length1);
					_tmp9_ = _tmp8_;
					_tmp9__length1 = _tmp8__length1;
					_tmp10_ = _tmp9_[i];
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp10_);
				}
			}
		}
	}
	_tmp11_ = gee_tree_set_new (MUSIC_TYPE_EQUALIZER_PRESET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	rv = _tmp11_;
	{
		GeeIterator* _preset_str_it = NULL;
		GeeTreeSet* _tmp12_;
		GeeIterator* _tmp13_;
		_tmp12_ = presets_data;
		_tmp13_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp12_);
		_preset_str_it = _tmp13_;
		while (TRUE) {
			GeeIterator* _tmp14_;
			gchar* preset_str = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			GeeTreeSet* _tmp17_;
			const gchar* _tmp18_;
			MusicEqualizerPreset* _tmp19_;
			MusicEqualizerPreset* _tmp20_;
			_tmp14_ = _preset_str_it;
			if (!gee_iterator_next (_tmp14_)) {
				break;
			}
			_tmp15_ = _preset_str_it;
			_tmp16_ = gee_iterator_get (_tmp15_);
			preset_str = (gchar*) _tmp16_;
			_tmp17_ = rv;
			_tmp18_ = preset_str;
			_tmp19_ = music_equalizer_preset_new_from_string (_tmp18_);
			_tmp20_ = _tmp19_;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp20_);
			_g_object_unref0 (_tmp20_);
			_g_free0 (preset_str);
		}
		_g_object_unref0 (_preset_str_it);
	}
	_tmp21_ = rv;
	_tmp22_ = gee_abstract_bidir_sorted_set_get_read_only_view ((GeeAbstractBidirSortedSet*) _tmp21_);
	_tmp23_ = _tmp22_;
	result = (GeeCollection*) _tmp23_;
	_g_object_unref0 (rv);
	_g_object_unref0 (presets_data);
	return result;
}

gboolean
music_settings_equalizer_get_equalizer_enabled (MusicSettingsEqualizer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_equalizer_enabled;
	return result;
}

void
music_settings_equalizer_set_equalizer_enabled (MusicSettingsEqualizer* self,
                                                gboolean value)
{
	g_return_if_fail (self != NULL);
	if (music_settings_equalizer_get_equalizer_enabled (self) != value) {
		self->priv->_equalizer_enabled = value;
		g_object_notify_by_pspec ((GObject *) self, music_settings_equalizer_properties[MUSIC_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY]);
	}
}

gboolean
music_settings_equalizer_get_auto_switch_preset (MusicSettingsEqualizer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_auto_switch_preset;
	return result;
}

void
music_settings_equalizer_set_auto_switch_preset (MusicSettingsEqualizer* self,
                                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	if (music_settings_equalizer_get_auto_switch_preset (self) != value) {
		self->priv->_auto_switch_preset = value;
		g_object_notify_by_pspec ((GObject *) self, music_settings_equalizer_properties[MUSIC_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY]);
	}
}

const gchar*
music_settings_equalizer_get_selected_preset (MusicSettingsEqualizer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_selected_preset;
	result = _tmp0_;
	return result;
}

void
music_settings_equalizer_set_selected_preset (MusicSettingsEqualizer* self,
                                              const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, music_settings_equalizer_get_selected_preset (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_selected_preset);
		self->priv->_selected_preset = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_settings_equalizer_properties[MUSIC_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY]);
	}
}

gchar**
music_settings_equalizer_get_custom_presets (MusicSettingsEqualizer* self,
                                             gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_custom_presets;
	_tmp0__length1 = self->priv->_custom_presets_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup2 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

void
music_settings_equalizer_set_custom_presets (MusicSettingsEqualizer* self,
                                             gchar** value,
                                             gint value_length1)
{
	gint old_value_length;
	g_return_if_fail (self != NULL);
	if (music_settings_equalizer_get_custom_presets (self, &old_value_length) != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		_tmp0_ = (value != NULL) ? _vala_array_dup2 (value, value_length1) : ((gpointer) value);
		_tmp0__length1 = value_length1;
		self->priv->_custom_presets = (_vala_array_free (self->priv->_custom_presets, self->priv->_custom_presets_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_custom_presets = _tmp0_;
		self->priv->_custom_presets_length1 = _tmp0__length1;
		self->priv->__custom_presets_size_ = self->priv->_custom_presets_length1;
		g_object_notify_by_pspec ((GObject *) self, music_settings_equalizer_properties[MUSIC_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY]);
	}
}

static void
music_settings_equalizer_class_init (MusicSettingsEqualizerClass * klass,
                                     gpointer klass_data)
{
	music_settings_equalizer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicSettingsEqualizer_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_settings_equalizer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_settings_equalizer_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_settings_equalizer_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY, music_settings_equalizer_properties[MUSIC_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY] = g_param_spec_boolean ("equalizer-enabled", "equalizer-enabled", "equalizer-enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY, music_settings_equalizer_properties[MUSIC_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY] = g_param_spec_boolean ("auto-switch-preset", "auto-switch-preset", "auto-switch-preset", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY, music_settings_equalizer_properties[MUSIC_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY] = g_param_spec_string ("selected-preset", "selected-preset", "selected-preset", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY, music_settings_equalizer_properties[MUSIC_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY] = g_param_spec_boxed ("custom-presets", "custom-presets", "custom-presets", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
music_settings_equalizer_instance_init (MusicSettingsEqualizer * self,
                                        gpointer klass)
{
	self->priv = music_settings_equalizer_get_instance_private (self);
}

static void
music_settings_equalizer_finalize (GObject * obj)
{
	MusicSettingsEqualizer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_SETTINGS_TYPE_EQUALIZER, MusicSettingsEqualizer);
	_g_free0 (self->priv->_selected_preset);
	self->priv->_custom_presets = (_vala_array_free (self->priv->_custom_presets, self->priv->_custom_presets_length1, (GDestroyNotify) g_free), NULL);
	G_OBJECT_CLASS (music_settings_equalizer_parent_class)->finalize (obj);
}

GType
music_settings_equalizer_get_type (void)
{
	static volatile gsize music_settings_equalizer_type_id__volatile = 0;
	if (g_once_init_enter (&music_settings_equalizer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicSettingsEqualizerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_settings_equalizer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSettingsEqualizer), 0, (GInstanceInitFunc) music_settings_equalizer_instance_init, NULL };
		GType music_settings_equalizer_type_id;
		music_settings_equalizer_type_id = g_type_register_static (GRANITE_SERVICES_TYPE_SETTINGS, "MusicSettingsEqualizer", &g_define_type_info, 0);
		MusicSettingsEqualizer_private_offset = g_type_add_instance_private (music_settings_equalizer_type_id, sizeof (MusicSettingsEqualizerPrivate));
		g_once_init_leave (&music_settings_equalizer_type_id__volatile, music_settings_equalizer_type_id);
	}
	return music_settings_equalizer_type_id__volatile;
}

static void
_vala_music_settings_equalizer_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	MusicSettingsEqualizer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_SETTINGS_TYPE_EQUALIZER, MusicSettingsEqualizer);
	switch (property_id) {
		case MUSIC_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY:
		g_value_set_boolean (value, music_settings_equalizer_get_equalizer_enabled (self));
		break;
		case MUSIC_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY:
		g_value_set_boolean (value, music_settings_equalizer_get_auto_switch_preset (self));
		break;
		case MUSIC_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY:
		g_value_set_string (value, music_settings_equalizer_get_selected_preset (self));
		break;
		case MUSIC_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, music_settings_equalizer_get_custom_presets (self, &length));
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_settings_equalizer_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	MusicSettingsEqualizer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_SETTINGS_TYPE_EQUALIZER, MusicSettingsEqualizer);
	switch (property_id) {
		case MUSIC_SETTINGS_EQUALIZER_EQUALIZER_ENABLED_PROPERTY:
		music_settings_equalizer_set_equalizer_enabled (self, g_value_get_boolean (value));
		break;
		case MUSIC_SETTINGS_EQUALIZER_AUTO_SWITCH_PRESET_PROPERTY:
		music_settings_equalizer_set_auto_switch_preset (self, g_value_get_boolean (value));
		break;
		case MUSIC_SETTINGS_EQUALIZER_SELECTED_PRESET_PROPERTY:
		music_settings_equalizer_set_selected_preset (self, g_value_get_string (value));
		break;
		case MUSIC_SETTINGS_EQUALIZER_CUSTOM_PRESETS_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			music_settings_equalizer_set_custom_presets (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

GType
music_settings_shuffle_get_type (void)
{
	static volatile gsize music_settings_shuffle_type_id__volatile = 0;
	if (g_once_init_enter (&music_settings_shuffle_type_id__volatile)) {
		static const GEnumValue values[] = {{MUSIC_SETTINGS_SHUFFLE_OFF, "MUSIC_SETTINGS_SHUFFLE_OFF", "off"}, {MUSIC_SETTINGS_SHUFFLE_ALL, "MUSIC_SETTINGS_SHUFFLE_ALL", "all"}, {0, NULL, NULL}};
		GType music_settings_shuffle_type_id;
		music_settings_shuffle_type_id = g_enum_register_static ("MusicSettingsShuffle", values);
		g_once_init_leave (&music_settings_shuffle_type_id__volatile, music_settings_shuffle_type_id);
	}
	return music_settings_shuffle_type_id__volatile;
}

GType
music_settings_repeat_get_type (void)
{
	static volatile gsize music_settings_repeat_type_id__volatile = 0;
	if (g_once_init_enter (&music_settings_repeat_type_id__volatile)) {
		static const GEnumValue values[] = {{MUSIC_SETTINGS_REPEAT_OFF, "MUSIC_SETTINGS_REPEAT_OFF", "off"}, {MUSIC_SETTINGS_REPEAT_MEDIA, "MUSIC_SETTINGS_REPEAT_MEDIA", "media"}, {MUSIC_SETTINGS_REPEAT_ALL, "MUSIC_SETTINGS_REPEAT_ALL", "all"}, {MUSIC_SETTINGS_REPEAT_ALBUM, "MUSIC_SETTINGS_REPEAT_ALBUM", "album"}, {MUSIC_SETTINGS_REPEAT_ARTIST, "MUSIC_SETTINGS_REPEAT_ARTIST", "artist"}, {0, NULL, NULL}};
		GType music_settings_repeat_type_id;
		music_settings_repeat_type_id = g_enum_register_static ("MusicSettingsRepeat", values);
		g_once_init_leave (&music_settings_repeat_type_id__volatile, music_settings_repeat_type_id);
	}
	return music_settings_repeat_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

