/* FileNotFoundDialog.c generated by valac 0.44.11, the Vala compiler
 * generated from FileNotFoundDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <granite.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#define MUSIC_TYPE_FILE_NOT_FOUND_DIALOG (music_file_not_found_dialog_get_type ())
#define MUSIC_FILE_NOT_FOUND_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, MusicFileNotFoundDialog))
#define MUSIC_FILE_NOT_FOUND_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, MusicFileNotFoundDialogClass))
#define MUSIC_IS_FILE_NOT_FOUND_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG))
#define MUSIC_IS_FILE_NOT_FOUND_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG))
#define MUSIC_FILE_NOT_FOUND_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, MusicFileNotFoundDialogClass))

typedef struct _MusicFileNotFoundDialog MusicFileNotFoundDialog;
typedef struct _MusicFileNotFoundDialogClass MusicFileNotFoundDialogClass;
typedef struct _MusicFileNotFoundDialogPrivate MusicFileNotFoundDialogPrivate;
enum  {
	MUSIC_FILE_NOT_FOUND_DIALOG_0_PROPERTY,
	MUSIC_FILE_NOT_FOUND_DIALOG_NUM_PROPERTIES
};
static GParamSpec* music_file_not_found_dialog_properties[MUSIC_FILE_NOT_FOUND_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block11Data Block11Data;

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define MUSIC_TYPE_LOCAL_LIBRARY (music_local_library_get_type ())
#define MUSIC_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary))
#define MUSIC_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))
#define MUSIC_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))

typedef struct _MusicLocalLibrary MusicLocalLibrary;
typedef struct _MusicLocalLibraryClass MusicLocalLibraryClass;

struct _MusicFileNotFoundDialog {
	GraniteMessageDialog parent_instance;
	MusicFileNotFoundDialogPrivate * priv;
};

struct _MusicFileNotFoundDialogClass {
	GraniteMessageDialogClass parent_class;
};

struct _MusicFileNotFoundDialogPrivate {
	GeeLinkedList* media_list;
};

struct _Block11Data {
	int _ref_count_;
	MusicFileNotFoundDialog* self;
	GtkButton* rescan_library;
};

static gint MusicFileNotFoundDialog_private_offset;
static gpointer music_file_not_found_dialog_parent_class = NULL;

GType music_file_not_found_dialog_get_type (void) G_GNUC_CONST;
MusicFileNotFoundDialog* music_file_not_found_dialog_new (GeeCollection* _media_list);
MusicFileNotFoundDialog* music_file_not_found_dialog_construct (GType object_type,
                                                                GeeCollection* _media_list);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
GType music_library_window_get_type (void) G_GNUC_CONST;
MusicLibraryWindow* music_app_get_main_window (void);
static void __lambda43_ (MusicFileNotFoundDialog* self,
                  gint response_id);
static void music_file_not_found_dialog_rescan_library_clicked (MusicFileNotFoundDialog* self);
static void music_file_not_found_dialog_remove_media_clicked (MusicFileNotFoundDialog* self);
static void music_file_not_found_dialog_locate_media_clicked (MusicFileNotFoundDialog* self);
static void ___lambda43__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void __lambda44_ (Block11Data* _data11_);
static void ___lambda44__music_library_file_operations_started (MusicLibrary* _sender,
                                                         gpointer self);
static void __lambda45_ (Block11Data* _data11_);
static void ___lambda45__music_library_file_operations_done (MusicLibrary* _sender,
                                                      gpointer self);
GType music_local_library_get_type (void) G_GNUC_CONST;
void music_local_library_rescan_music_folder (MusicLocalLibrary* self);
static void music_file_not_found_dialog_finalize (GObject * obj);

static inline gpointer
music_file_not_found_dialog_get_instance_private (MusicFileNotFoundDialog* self)
{
	return G_STRUCT_MEMBER_P (self, MusicFileNotFoundDialog_private_offset);
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		MusicFileNotFoundDialog* self;
		self = _data11_->self;
		_g_object_unref0 (_data11_->rescan_library);
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda43_ (MusicFileNotFoundDialog* self,
             gint response_id)
{
	switch (response_id) {
		case 1:
		{
			music_file_not_found_dialog_rescan_library_clicked (self);
			break;
		}
		case 2:
		{
			music_file_not_found_dialog_remove_media_clicked (self);
			break;
		}
		case 3:
		{
			music_file_not_found_dialog_locate_media_clicked (self);
			break;
		}
		case GTK_RESPONSE_CLOSE:
		{
			gtk_widget_destroy ((GtkWidget*) self);
			break;
		}
		default:
		break;
	}
}

static void
___lambda43__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
	__lambda43_ ((MusicFileNotFoundDialog*) self, response_id);
}

static void
__lambda44_ (Block11Data* _data11_)
{
	MusicFileNotFoundDialog* self;
	self = _data11_->self;
	gtk_widget_set_sensitive ((GtkWidget*) _data11_->rescan_library, FALSE);
}

static void
___lambda44__music_library_file_operations_started (MusicLibrary* _sender,
                                                    gpointer self)
{
	__lambda44_ (self);
}

static void
__lambda45_ (Block11Data* _data11_)
{
	MusicFileNotFoundDialog* self;
	self = _data11_->self;
	gtk_widget_set_sensitive ((GtkWidget*) _data11_->rescan_library, TRUE);
}

static void
___lambda45__music_library_file_operations_done (MusicLibrary* _sender,
                                                 gpointer self)
{
	__lambda45_ (self);
}

MusicFileNotFoundDialog*
music_file_not_found_dialog_construct (GType object_type,
                                       GeeCollection* _media_list)
{
	MusicFileNotFoundDialog * self = NULL;
	Block11Data* _data11_;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	MusicLibraryWindow* _tmp3_;
	GeeLinkedList* _tmp4_;
	GeeLinkedList* _tmp5_;
	GeeLinkedList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GtkWidget* _tmp28_;
	GtkButton* _tmp29_;
	MusicLibrariesManager* _tmp30_;
	MusicLibrary* _tmp31_;
	MusicLibrariesManager* _tmp32_;
	MusicLibrary* _tmp33_;
	MusicLibrariesManager* _tmp34_;
	MusicLibrary* _tmp35_;
	g_return_val_if_fail (_media_list != NULL, NULL);
	_data11_ = g_slice_new0 (Block11Data);
	_data11_->_ref_count_ = 1;
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
	_tmp1_ = _tmp0_;
	_tmp2_ = music_app_get_main_window ();
	_tmp3_ = _tmp2_;
	self = (MusicFileNotFoundDialog*) g_object_new (object_type, "destroy-with-parent", TRUE, "image-icon", _tmp1_, "primary-text", _ ("File not found"), "transient-for", _tmp3_, NULL);
	_data11_->self = g_object_ref (self);
	_g_object_unref0 (_tmp1_);
	_tmp4_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->media_list);
	self->priv->media_list = _tmp4_;
	_tmp5_ = self->priv->media_list;
	gee_collection_add_all ((GeeCollection*) _tmp5_, _media_list);
	_tmp6_ = self->priv->media_list;
	_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
	_tmp8_ = _tmp7_;
	if (_tmp8_ == 1) {
		MusicMedia* s = NULL;
		GeeLinkedList* _tmp9_;
		gpointer _tmp10_;
		MusicMedia* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		MusicMedia* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		_tmp9_ = self->priv->media_list;
		_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, 0);
		s = (MusicMedia*) _tmp10_;
		_tmp11_ = s;
		_tmp12_ = music_media_get_title (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_markup_escape_text (_tmp13_, (gssize) -1);
		_tmp15_ = _tmp14_;
		_tmp16_ = s;
		_tmp17_ = music_media_get_artist (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_markup_escape_text (_tmp18_, (gssize) -1);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_strdup_printf (_ ("The music file for <b>%s</b> by <b>%s</b> could not be found."), _tmp15_, _tmp20_);
		_tmp22_ = _tmp21_;
		granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp22_);
		_g_free0 (_tmp22_);
		_g_free0 (_tmp20_);
		_g_free0 (_tmp15_);
		_g_object_unref0 (s);
	} else {
		GeeLinkedList* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		_tmp23_ = self->priv->media_list;
		_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = g_strdup_printf (_ ("%i music files could not be found?"), _tmp25_);
		_tmp27_ = _tmp26_;
		granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp27_);
		_g_free0 (_tmp27_);
	}
	_tmp28_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Rescan Library"), 1);
	_tmp29_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_button_get_type (), GtkButton));
	_data11_->rescan_library = _tmp29_;
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Remove Song"), 2);
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CLOSE);
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Find Song"), 3);
	_tmp30_ = music_libraries_manager;
	_tmp31_ = _tmp30_->local_library;
	gtk_widget_set_sensitive ((GtkWidget*) _data11_->rescan_library, !music_library_doing_file_operations (_tmp31_));
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) ___lambda43__gtk_dialog_response, self, 0);
	_tmp32_ = music_libraries_manager;
	_tmp33_ = _tmp32_->local_library;
	g_signal_connect_data (_tmp33_, "file-operations-started", (GCallback) ___lambda44__music_library_file_operations_started, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	_tmp34_ = music_libraries_manager;
	_tmp35_ = _tmp34_->local_library;
	g_signal_connect_data (_tmp35_, "file-operations-done", (GCallback) ___lambda45__music_library_file_operations_done, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	block11_data_unref (_data11_);
	_data11_ = NULL;
	return self;
}

MusicFileNotFoundDialog*
music_file_not_found_dialog_new (GeeCollection* _media_list)
{
	return music_file_not_found_dialog_construct (MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, _media_list);
}

static void
music_file_not_found_dialog_remove_media_clicked (MusicFileNotFoundDialog* self)
{
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	GeeLinkedList* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	_tmp2_ = self->priv->media_list;
	music_library_remove_medias (_tmp1_, (GeeCollection*) _tmp2_, FALSE);
	gtk_widget_destroy ((GtkWidget*) self);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
music_file_not_found_dialog_locate_media_clicked (MusicFileNotFoundDialog* self)
{
	MusicMedia* m = NULL;
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	gint64 media_id = 0LL;
	MusicMedia* _tmp2_;
	gint64 _tmp3_;
	gint64 _tmp4_;
	GtkFileChooserNative* file_chooser = NULL;
	GtkFileChooserNative* _tmp5_;
	GFile* invalid_file = NULL;
	MusicLibrariesManager* _tmp6_;
	MusicLibrary* _tmp7_;
	MusicMedia* _tmp8_;
	MusicMedia* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	gchar* music_folder = NULL;
	MusicSettingsMain* _tmp15_;
	MusicSettingsMain* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GFile* _tmp21_;
	GFile* _tmp22_;
	GFile* _tmp23_;
	gboolean _tmp24_;
	gchar* file = NULL;
	gchar* _tmp62_;
	GtkFileChooserNative* _tmp63_;
	GtkFileChooserNative* _tmp66_;
	gboolean _tmp67_ = FALSE;
	const gchar* _tmp68_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->media_list;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
	m = (MusicMedia*) _tmp1_;
	_tmp2_ = m;
	_tmp3_ = music_media_get_rowid (_tmp2_);
	_tmp4_ = _tmp3_;
	media_id = _tmp4_;
	_tmp5_ = gtk_file_chooser_native_new (_ ("Choose Music Folder"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Open"), _ ("Cancel"));
	file_chooser = _tmp5_;
	_tmp6_ = music_libraries_manager;
	_tmp7_ = _tmp6_->local_library;
	_tmp8_ = music_library_media_from_id (_tmp7_, media_id);
	_tmp9_ = _tmp8_;
	_tmp10_ = music_media_get_uri (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _tmp11_;
	_tmp13_ = g_file_new_for_uri (_tmp12_);
	_tmp14_ = _tmp13_;
	_g_free0 (_tmp12_);
	_g_object_unref0 (_tmp9_);
	invalid_file = _tmp14_;
	_tmp15_ = music_settings_main_get_default ();
	_tmp16_ = _tmp15_;
	_tmp17_ = music_settings_main_get_music_folder (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_strdup (_tmp18_);
	_tmp20_ = _tmp19_;
	_g_object_unref0 (_tmp16_);
	music_folder = _tmp20_;
	_tmp21_ = invalid_file;
	_tmp22_ = g_file_get_parent (_tmp21_);
	_tmp23_ = _tmp22_;
	_tmp24_ = g_file_query_exists (_tmp23_, NULL);
	_g_object_unref0 (_tmp23_);
	if (_tmp24_) {
		GtkFileChooserNative* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
		GFile* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		_tmp25_ = file_chooser;
		_tmp26_ = invalid_file;
		_tmp27_ = g_file_get_parent (_tmp26_);
		_tmp28_ = _tmp27_;
		_tmp29_ = g_file_get_path (_tmp28_);
		_tmp30_ = _tmp29_;
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp25_, _tmp30_);
		_g_free0 (_tmp30_);
		_g_object_unref0 (_tmp28_);
	} else {
		gboolean _tmp31_ = FALSE;
		GFile* _tmp32_;
		GFile* _tmp33_;
		GFile* _tmp34_;
		GFile* _tmp35_;
		GFile* _tmp36_;
		gboolean _tmp37_;
		_tmp32_ = invalid_file;
		_tmp33_ = g_file_get_parent (_tmp32_);
		_tmp34_ = _tmp33_;
		_tmp35_ = g_file_get_parent (_tmp34_);
		_tmp36_ = _tmp35_;
		_tmp37_ = g_file_query_exists (_tmp36_, NULL);
		_g_object_unref0 (_tmp36_);
		_g_object_unref0 (_tmp34_);
		if (_tmp37_) {
			GFile* _tmp38_;
			GFile* _tmp39_;
			GFile* _tmp40_;
			GFile* _tmp41_;
			GFile* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			const gchar* _tmp45_;
			_tmp38_ = invalid_file;
			_tmp39_ = g_file_get_parent (_tmp38_);
			_tmp40_ = _tmp39_;
			_tmp41_ = g_file_get_parent (_tmp40_);
			_tmp42_ = _tmp41_;
			_tmp43_ = g_file_get_path (_tmp42_);
			_tmp44_ = _tmp43_;
			_tmp45_ = music_folder;
			_tmp31_ = string_contains (_tmp44_, _tmp45_);
			_g_free0 (_tmp44_);
			_g_object_unref0 (_tmp42_);
			_g_object_unref0 (_tmp40_);
		} else {
			_tmp31_ = FALSE;
		}
		if (_tmp31_) {
			GtkFileChooserNative* _tmp46_;
			GFile* _tmp47_;
			GFile* _tmp48_;
			GFile* _tmp49_;
			GFile* _tmp50_;
			GFile* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			_tmp46_ = file_chooser;
			_tmp47_ = invalid_file;
			_tmp48_ = g_file_get_parent (_tmp47_);
			_tmp49_ = _tmp48_;
			_tmp50_ = g_file_get_parent (_tmp49_);
			_tmp51_ = _tmp50_;
			_tmp52_ = g_file_get_path (_tmp51_);
			_tmp53_ = _tmp52_;
			gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp46_, _tmp53_);
			_g_free0 (_tmp53_);
			_g_object_unref0 (_tmp51_);
			_g_object_unref0 (_tmp49_);
		} else {
			const gchar* _tmp54_;
			GFile* _tmp55_;
			GFile* _tmp56_;
			gboolean _tmp57_;
			_tmp54_ = music_folder;
			_tmp55_ = g_file_new_for_path (_tmp54_);
			_tmp56_ = _tmp55_;
			_tmp57_ = g_file_query_exists (_tmp56_, NULL);
			_g_object_unref0 (_tmp56_);
			if (_tmp57_) {
				GtkFileChooserNative* _tmp58_;
				const gchar* _tmp59_;
				_tmp58_ = file_chooser;
				_tmp59_ = music_folder;
				gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp58_, _tmp59_);
			} else {
				GtkFileChooserNative* _tmp60_;
				const gchar* _tmp61_;
				_tmp60_ = file_chooser;
				_tmp61_ = g_get_home_dir ();
				gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp60_, _tmp61_);
			}
		}
	}
	_tmp62_ = g_strdup ("");
	file = _tmp62_;
	_tmp63_ = file_chooser;
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp63_) == ((gint) GTK_RESPONSE_ACCEPT)) {
		GtkFileChooserNative* _tmp64_;
		gchar* _tmp65_;
		_tmp64_ = file_chooser;
		_tmp65_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp64_);
		_g_free0 (file);
		file = _tmp65_;
	}
	_tmp66_ = file_chooser;
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp66_);
	_tmp68_ = file;
	if (g_strcmp0 (_tmp68_, "") != 0) {
		const gchar* _tmp69_;
		GFile* _tmp70_;
		GFile* _tmp71_;
		_tmp69_ = file;
		_tmp70_ = g_file_new_for_path (_tmp69_);
		_tmp71_ = _tmp70_;
		_tmp67_ = g_file_query_exists (_tmp71_, NULL);
		_g_object_unref0 (_tmp71_);
	} else {
		_tmp67_ = FALSE;
	}
	if (_tmp67_) {
		MusicMedia* _tmp72_;
		const gchar* _tmp73_;
		GFile* _tmp74_;
		GFile* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
		MusicMedia* _tmp78_;
		MusicMedia* _tmp79_;
		MusicLibrariesManager* _tmp80_;
		MusicLibrary* _tmp81_;
		MusicMedia* _tmp82_;
		_tmp72_ = m;
		_tmp73_ = file;
		_tmp74_ = g_file_new_for_path (_tmp73_);
		_tmp75_ = _tmp74_;
		_tmp76_ = g_file_get_uri (_tmp75_);
		_tmp77_ = _tmp76_;
		music_media_set_uri (_tmp72_, _tmp77_);
		_g_free0 (_tmp77_);
		_g_object_unref0 (_tmp75_);
		_tmp78_ = m;
		music_media_set_location_unknown (_tmp78_, FALSE);
		_tmp79_ = m;
		music_media_set_unique_status_image (_tmp79_, NULL);
		_tmp80_ = music_libraries_manager;
		_tmp81_ = _tmp80_->local_library;
		_tmp82_ = m;
		music_library_update_media (_tmp81_, _tmp82_, FALSE, FALSE);
		gtk_widget_destroy ((GtkWidget*) self);
	}
	_g_free0 (file);
	_g_free0 (music_folder);
	_g_object_unref0 (invalid_file);
	_g_object_unref0 (file_chooser);
	_g_object_unref0 (m);
}

static void
music_file_not_found_dialog_rescan_library_clicked (MusicFileNotFoundDialog* self)
{
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	music_local_library_rescan_music_folder (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary));
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
music_file_not_found_dialog_class_init (MusicFileNotFoundDialogClass * klass,
                                        gpointer klass_data)
{
	music_file_not_found_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicFileNotFoundDialog_private_offset);
	G_OBJECT_CLASS (klass)->finalize = music_file_not_found_dialog_finalize;
}

static void
music_file_not_found_dialog_instance_init (MusicFileNotFoundDialog * self,
                                           gpointer klass)
{
	self->priv = music_file_not_found_dialog_get_instance_private (self);
}

static void
music_file_not_found_dialog_finalize (GObject * obj)
{
	MusicFileNotFoundDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_FILE_NOT_FOUND_DIALOG, MusicFileNotFoundDialog);
	_g_object_unref0 (self->priv->media_list);
	G_OBJECT_CLASS (music_file_not_found_dialog_parent_class)->finalize (obj);
}

GType
music_file_not_found_dialog_get_type (void)
{
	static volatile gsize music_file_not_found_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&music_file_not_found_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicFileNotFoundDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_file_not_found_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicFileNotFoundDialog), 0, (GInstanceInitFunc) music_file_not_found_dialog_instance_init, NULL };
		GType music_file_not_found_dialog_type_id;
		music_file_not_found_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "MusicFileNotFoundDialog", &g_define_type_info, 0);
		MusicFileNotFoundDialog_private_offset = g_type_add_instance_private (music_file_not_found_dialog_type_id, sizeof (MusicFileNotFoundDialogPrivate));
		g_once_init_leave (&music_file_not_found_dialog_type_id__volatile, music_file_not_found_dialog_type_id);
	}
	return music_file_not_found_dialog_type_id__volatile;
}

