/* ViewInterface.c generated by valac 0.44.11, the Vala compiler
 * generated from ViewInterface.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include "io.elementary.music-core.h"

#define MUSIC_TYPE_VIEW_INTERFACE (music_view_interface_get_type ())
#define MUSIC_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_INTERFACE, MusicViewInterface))
#define MUSIC_IS_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_INTERFACE))
#define MUSIC_VIEW_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), MUSIC_TYPE_VIEW_INTERFACE, MusicViewInterfaceIface))

typedef struct _MusicViewInterface MusicViewInterface;
typedef struct _MusicViewInterfaceIface MusicViewInterfaceIface;
enum  {
	MUSIC_VIEW_INTERFACE_IMPORT_REQUESTED_SIGNAL,
	MUSIC_VIEW_INTERFACE_NUM_SIGNALS
};
static guint music_view_interface_signals[MUSIC_VIEW_INTERFACE_NUM_SIGNALS] = {0};

struct _MusicViewInterfaceIface {
	GTypeInterface parent_iface;
	GeeCollection* (*get_media) (MusicViewInterface* self);
	GeeCollection* (*get_visible_media) (MusicViewInterface* self);
	void (*refilter) (MusicViewInterface* self);
	void (*set_media) (MusicViewInterface* self, GeeCollection* new_media);
	void (*add_media) (MusicViewInterface* self, GeeCollection* to_add);
	void (*remove_media) (MusicViewInterface* self, GeeCollection* to_remove);
	void (*update_media) (MusicViewInterface* self, GeeCollection* to_update);
};

GType music_view_interface_get_type (void) G_GNUC_CONST;
GeeCollection* music_view_interface_get_media (MusicViewInterface* self);
GeeCollection* music_view_interface_get_visible_media (MusicViewInterface* self);
void music_view_interface_refilter (MusicViewInterface* self);
void music_view_interface_set_media (MusicViewInterface* self,
                                     GeeCollection* new_media);
void music_view_interface_add_media (MusicViewInterface* self,
                                     GeeCollection* to_add);
void music_view_interface_remove_media (MusicViewInterface* self,
                                        GeeCollection* to_remove);
void music_view_interface_update_media (MusicViewInterface* self,
                                        GeeCollection* to_update);

/**
     * For some views, get_media() and get_visible_media() return the same contents, since
     * the view doesn't have any kind of built-in filters. For other views, they don't return
     * the same since the view has some kind of internal browsing mechanism (e.g. Miller Columns).
     */
GeeCollection*
music_view_interface_get_media (MusicViewInterface* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return MUSIC_VIEW_INTERFACE_GET_INTERFACE (self)->get_media (self);
}

GeeCollection*
music_view_interface_get_visible_media (MusicViewInterface* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return MUSIC_VIEW_INTERFACE_GET_INTERFACE (self)->get_visible_media (self);
}

/**
     * Requests the view to apply a filter to only show the media matching the
     * search string.
     *
     * @param search Search string; pass null to use the previous search string.
     */
void
music_view_interface_refilter (MusicViewInterface* self)
{
	g_return_if_fail (self != NULL);
	MUSIC_VIEW_INTERFACE_GET_INTERFACE (self)->refilter (self);
}

void
music_view_interface_set_media (MusicViewInterface* self,
                                GeeCollection* new_media)
{
	g_return_if_fail (self != NULL);
	MUSIC_VIEW_INTERFACE_GET_INTERFACE (self)->set_media (self, new_media);
}

void
music_view_interface_add_media (MusicViewInterface* self,
                                GeeCollection* to_add)
{
	g_return_if_fail (self != NULL);
	MUSIC_VIEW_INTERFACE_GET_INTERFACE (self)->add_media (self, to_add);
}

void
music_view_interface_remove_media (MusicViewInterface* self,
                                   GeeCollection* to_remove)
{
	g_return_if_fail (self != NULL);
	MUSIC_VIEW_INTERFACE_GET_INTERFACE (self)->remove_media (self, to_remove);
}

void
music_view_interface_update_media (MusicViewInterface* self,
                                   GeeCollection* to_update)
{
	g_return_if_fail (self != NULL);
	MUSIC_VIEW_INTERFACE_GET_INTERFACE (self)->update_media (self, to_update);
}

static void
music_view_interface_default_init (MusicViewInterfaceIface * iface,
                                   gpointer iface_data)
{
	/**
	     * Used for device syncing.
	     */
	music_view_interface_signals[MUSIC_VIEW_INTERFACE_IMPORT_REQUESTED_SIGNAL] = g_signal_new ("import-requested", MUSIC_TYPE_VIEW_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
}

GType
music_view_interface_get_type (void)
{
	static volatile gsize music_view_interface_type_id__volatile = 0;
	if (g_once_init_enter (&music_view_interface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicViewInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_view_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType music_view_interface_type_id;
		music_view_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "MusicViewInterface", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (music_view_interface_type_id, gtk_widget_get_type ());
		g_once_init_leave (&music_view_interface_type_id__volatile, music_view_interface_type_id);
	}
	return music_view_interface_type_id__volatile;
}

