/* LocalSmartPlaylist.c generated by valac 0.44.11, the Vala compiler
 * generated from LocalSmartPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <libgda/libgda.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib/gi18n-lib.h>

#define MUSIC_TYPE_LOCAL_SMART_PLAYLIST (music_local_smart_playlist_get_type ())
#define MUSIC_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylist))
#define MUSIC_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylistClass))
#define MUSIC_IS_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST))
#define MUSIC_IS_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_SMART_PLAYLIST))
#define MUSIC_LOCAL_SMART_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylistClass))

typedef struct _MusicLocalSmartPlaylist MusicLocalSmartPlaylist;
typedef struct _MusicLocalSmartPlaylistClass MusicLocalSmartPlaylistClass;
typedef struct _MusicLocalSmartPlaylistPrivate MusicLocalSmartPlaylistPrivate;
enum  {
	MUSIC_LOCAL_SMART_PLAYLIST_0_PROPERTY,
	MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY,
	MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY,
	MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY,
	MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY,
	MUSIC_LOCAL_SMART_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _MusicLocalSmartPlaylist {
	MusicSmartPlaylist parent_instance;
	MusicLocalSmartPlaylistPrivate * priv;
};

struct _MusicLocalSmartPlaylistClass {
	MusicSmartPlaylistClass parent_class;
};

struct _MusicLocalSmartPlaylistPrivate {
	GdaConnection* connection;
	gchar* _name;
};

static gint MusicLocalSmartPlaylist_private_offset;
static gpointer music_local_smart_playlist_parent_class = NULL;

GType music_local_smart_playlist_get_type (void) G_GNUC_CONST;
#define MUSIC_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR "<query_sep>"
#define MUSIC_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR "<val_sep>"
MusicLocalSmartPlaylist* music_local_smart_playlist_new (gint64 rowid,
                                                         GdaConnection* connection);
MusicLocalSmartPlaylist* music_local_smart_playlist_construct (GType object_type,
                                                               gint64 rowid,
                                                               GdaConnection* connection);
GValue* music_database_query_field (gint64 rowid,
                                    GdaConnection* connection,
                                    const gchar* table,
                                    const gchar* field);
#define MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME "smart_playlists"
static void _vala_GValue_free (GValue* self);
void music_local_smart_playlist_queries_from_string (MusicLocalSmartPlaylist* self,
                                                     const gchar* q);
static void music_local_smart_playlist_real_analyse_all (MusicSmartPlaylist* base);
static gint64* _int64_dup (gint64* self);
#define MUSIC_DATABASE_MEDIA_TABLE_NAME "media"
GdaSqlBuilderId music_database_process_smart_query (GdaSqlBuilder* builder,
                                                    MusicSmartQuery* sq);
static void _vala_array_add2 (GdaSqlBuilderId* * array,
                       int* length,
                       int* size,
                       GdaSqlBuilderId value);
static void music_local_smart_playlist_real_clear_queries (MusicSmartPlaylist* base);
void music_database_set_field (gint64 rowid,
                               GdaConnection* connection,
                               const gchar* table,
                               const gchar* field,
                               GValue* value);
static void music_local_smart_playlist_real_add_query (MusicSmartPlaylist* base,
                                                MusicSmartQuery* s);
static gchar* music_local_smart_playlist_queries_to_string (MusicLocalSmartPlaylist* self);
static void music_local_smart_playlist_real_add_queries (MusicSmartPlaylist* base,
                                                  GeeCollection* queries);
void music_local_smart_playlist_add_defaults (GdaConnection* connection);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void music_local_smart_playlist_finalize (GObject * obj);
static void _vala_music_local_smart_playlist_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_music_local_smart_playlist_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
music_local_smart_playlist_get_instance_private (MusicLocalSmartPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, MusicLocalSmartPlaylist_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_vala_GValue_free (GValue* self)
{
	g_value_unset (self);
	g_free (self);
}

MusicLocalSmartPlaylist*
music_local_smart_playlist_construct (GType object_type,
                                      gint64 rowid,
                                      GdaConnection* connection)
{
	MusicLocalSmartPlaylist * self = NULL;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	GdaConnection* _tmp2_;
	gchar* queries_str = NULL;
	GValue* _tmp3_;
	GValue* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	g_return_val_if_fail (connection != NULL, NULL);
	_tmp0_ = music_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	self = (MusicLocalSmartPlaylist*) music_smart_playlist_construct (object_type, _tmp1_);
	_tmp2_ = _g_object_ref0 (connection);
	_g_object_unref0 (self->priv->connection);
	self->priv->connection = _tmp2_;
	music_playlist_set_rowid ((MusicPlaylist*) self, rowid);
	_tmp3_ = music_database_query_field (rowid, connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries");
	_tmp4_ = _tmp3_;
	_tmp5_ = g_value_get_string (_tmp4_);
	_tmp6_ = g_strdup (_tmp5_);
	_tmp7_ = _tmp6_;
	__vala_GValue_free0 (_tmp4_);
	queries_str = _tmp7_;
	music_local_smart_playlist_queries_from_string (self, queries_str);
	_g_free0 (queries_str);
	return self;
}

MusicLocalSmartPlaylist*
music_local_smart_playlist_new (gint64 rowid,
                                GdaConnection* connection)
{
	return music_local_smart_playlist_construct (MUSIC_TYPE_LOCAL_SMART_PLAYLIST, rowid, connection);
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}

static void
_vala_array_add2 (GdaSqlBuilderId* * array,
                  int* length,
                  int* size,
                  GdaSqlBuilderId value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GdaSqlBuilderId, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
music_local_smart_playlist_real_analyse_all (MusicSmartPlaylist* base)
{
	MusicLocalSmartPlaylist * self;
	GeeTreeSet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeTreeSet* rowids = NULL;
	GeeTreeSet* _tmp10_;
	GError* _inner_error0_ = NULL;
	self = (MusicLocalSmartPlaylist*) base;
	_tmp0_ = ((MusicSmartPlaylist*) self)->queries;
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GeeCollection* meds = NULL;
		MusicLibrary* _tmp3_;
		MusicLibrary* _tmp4_;
		GeeCollection* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
		_tmp3_ = music_smart_playlist_get_library ((MusicSmartPlaylist*) self);
		_tmp4_ = _tmp3_;
		_tmp5_ = music_library_get_medias (_tmp4_);
		meds = _tmp5_;
		_tmp6_ = music_playlist_get_medias ((MusicPlaylist*) self);
		_tmp7_ = _tmp6_;
		_tmp8_ = meds;
		gee_array_list_add_all (_tmp7_, _tmp8_);
		_tmp9_ = meds;
		g_signal_emit_by_name ((MusicPlaylist*) self, "media-added", _tmp9_);
		_g_object_unref0 (meds);
		return;
	}
	_tmp10_ = gee_tree_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	rowids = _tmp10_;
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp11_;
		GdaSqlBuilder* _tmp12_;
		GdaSqlBuilder* _tmp13_;
		GdaSqlBuilderId* ids = NULL;
		gint ids_length1;
		gint _ids_size_;
		GdaSqlOperatorType sql_operator_type = 0;
		MusicSmartPlaylistConditionalType _tmp22_;
		MusicSmartPlaylistConditionalType _tmp23_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp24_;
		GdaSqlOperatorType _tmp25_;
		GdaSqlBuilderId* _tmp26_;
		gint _tmp26__length1;
		GdaSqlBuilder* _tmp27_;
		GdaStatement* statm = NULL;
		GdaSqlBuilder* _tmp28_;
		GdaStatement* _tmp29_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp30_;
		GdaStatement* _tmp31_;
		GdaDataModel* _tmp32_;
		GdaDataModelIter* data_model_iter = NULL;
		GdaDataModel* _tmp33_;
		GdaDataModelIter* _tmp34_;
		GdaDataModelIter* _tmp35_;
		GeeCollection* meds = NULL;
		MusicLibrary* _tmp41_;
		MusicLibrary* _tmp42_;
		GeeTreeSet* _tmp43_;
		GeeCollection* _tmp44_;
		GeeArrayList* _tmp45_;
		GeeArrayList* _tmp46_;
		GeeCollection* _tmp47_;
		GeeCollection* _tmp48_;
		_tmp11_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
		sql = _tmp11_;
		_tmp12_ = sql;
		gda_sql_builder_select_add_target (_tmp12_, MUSIC_DATABASE_MEDIA_TABLE_NAME, NULL);
		_tmp13_ = sql;
		gda_sql_builder_select_add_field (_tmp13_, "rowid", NULL, NULL);
		ids = NULL;
		ids_length1 = 0;
		_ids_size_ = ids_length1;
		{
			GeeIterator* _q_it = NULL;
			GeeTreeSet* _tmp14_;
			GeeIterator* _tmp15_;
			_tmp14_ = ((MusicSmartPlaylist*) self)->queries;
			_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
			_q_it = _tmp15_;
			while (TRUE) {
				GeeIterator* _tmp16_;
				MusicSmartQuery* q = NULL;
				GeeIterator* _tmp17_;
				gpointer _tmp18_;
				GdaSqlBuilderId* _tmp19_;
				gint _tmp19__length1;
				GdaSqlBuilder* _tmp20_;
				MusicSmartQuery* _tmp21_;
				_tmp16_ = _q_it;
				if (!gee_iterator_next (_tmp16_)) {
					break;
				}
				_tmp17_ = _q_it;
				_tmp18_ = gee_iterator_get (_tmp17_);
				q = (MusicSmartQuery*) _tmp18_;
				_tmp19_ = ids;
				_tmp19__length1 = ids_length1;
				_tmp20_ = sql;
				_tmp21_ = q;
				_vala_array_add2 (&ids, &ids_length1, &_ids_size_, music_database_process_smart_query (_tmp20_, _tmp21_));
				_g_object_unref0 (q);
			}
			_g_object_unref0 (_q_it);
		}
		sql_operator_type = GDA_SQL_OPERATOR_TYPE_AND;
		_tmp22_ = music_smart_playlist_get_conditional ((MusicSmartPlaylist*) self);
		_tmp23_ = _tmp22_;
		if (_tmp23_ == MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ANY) {
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_OR;
		}
		_tmp24_ = sql;
		_tmp25_ = sql_operator_type;
		_tmp26_ = ids;
		_tmp26__length1 = ids_length1;
		id_cond = gda_sql_builder_add_cond_v (_tmp24_, _tmp25_, _tmp26_, (gint) _tmp26__length1);
		_tmp27_ = sql;
		gda_sql_builder_set_where (_tmp27_, id_cond);
		_tmp28_ = sql;
		_tmp29_ = gda_sql_builder_get_statement (_tmp28_, &_inner_error0_);
		statm = _tmp29_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			ids = (g_free (ids), NULL);
			_g_object_unref0 (sql);
			goto __catch67_g_error;
		}
		_tmp30_ = self->priv->connection;
		_tmp31_ = statm;
		_tmp32_ = gda_connection_statement_execute_select (_tmp30_, _tmp31_, NULL, &_inner_error0_);
		data_model = _tmp32_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (statm);
			ids = (g_free (ids), NULL);
			_g_object_unref0 (sql);
			goto __catch67_g_error;
		}
		_tmp33_ = data_model;
		_tmp34_ = gda_data_model_create_iter (_tmp33_);
		data_model_iter = _tmp34_;
		_tmp35_ = data_model_iter;
		gda_data_model_iter_move_to_row (_tmp35_, -1);
		while (TRUE) {
			GdaDataModelIter* _tmp36_;
			GValue* val = NULL;
			GdaDataModelIter* _tmp37_;
			GeeTreeSet* _tmp38_;
			GValue* _tmp39_;
			gint64 _tmp40_;
			_tmp36_ = data_model_iter;
			if (!gda_data_model_iter_move_next (_tmp36_)) {
				break;
			}
			_tmp37_ = data_model_iter;
			val = gda_data_model_iter_get_value_at (_tmp37_, 0);
			_tmp38_ = rowids;
			_tmp39_ = val;
			_tmp40_ = g_value_get_int64 (_tmp39_);
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, &_tmp40_);
		}
		_tmp41_ = music_smart_playlist_get_library ((MusicSmartPlaylist*) self);
		_tmp42_ = _tmp41_;
		_tmp43_ = rowids;
		_tmp44_ = music_library_medias_from_ids (_tmp42_, (GeeCollection*) _tmp43_);
		meds = _tmp44_;
		_tmp45_ = music_playlist_get_medias ((MusicPlaylist*) self);
		_tmp46_ = _tmp45_;
		_tmp47_ = meds;
		gee_array_list_add_all (_tmp46_, _tmp47_);
		_tmp48_ = meds;
		g_signal_emit_by_name ((MusicPlaylist*) self, "media-added", _tmp48_);
		_g_object_unref0 (meds);
		_g_object_unref0 (data_model_iter);
		_g_object_unref0 (data_model);
		_g_object_unref0 (statm);
		ids = (g_free (ids), NULL);
		_g_object_unref0 (sql);
	}
	goto __finally67;
	__catch67_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
		GError* _tmp51_;
		const gchar* _tmp52_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp49_ = music_playlist_get_name ((MusicPlaylist*) self);
		_tmp50_ = _tmp49_;
		_tmp51_ = e;
		_tmp52_ = _tmp51_->message;
		g_critical ("LocalSmartPlaylist.vala:129: Could not query media for smart playlist " \
"%s: %s", _tmp50_, _tmp52_);
		_g_error_free0 (e);
	}
	__finally67:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (rowids);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (rowids);
}

static void
music_local_smart_playlist_real_clear_queries (MusicSmartPlaylist* base)
{
	MusicLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
	self = (MusicLocalSmartPlaylist*) base;
	MUSIC_SMART_PLAYLIST_CLASS (music_local_smart_playlist_parent_class)->clear_queries (G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist));
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	g_value_init (&_tmp3_, G_TYPE_STRING);
	g_value_set_string (&_tmp3_, "");
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
}

static void
music_local_smart_playlist_real_add_query (MusicSmartPlaylist* base,
                                           MusicSmartQuery* s)
{
	MusicLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	gchar* _tmp3_;
	GValue _tmp4_ = {0};
	self = (MusicLocalSmartPlaylist*) base;
	g_return_if_fail (s != NULL);
	MUSIC_SMART_PLAYLIST_CLASS (music_local_smart_playlist_parent_class)->add_query (G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist), s);
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = music_local_smart_playlist_queries_to_string (self);
	g_value_init (&_tmp4_, G_TYPE_STRING);
	g_value_take_string (&_tmp4_, _tmp3_);
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp4_);
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
}

static void
music_local_smart_playlist_real_add_queries (MusicSmartPlaylist* base,
                                             GeeCollection* queries)
{
	MusicLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	gchar* _tmp3_;
	GValue _tmp4_ = {0};
	self = (MusicLocalSmartPlaylist*) base;
	g_return_if_fail (queries != NULL);
	MUSIC_SMART_PLAYLIST_CLASS (music_local_smart_playlist_parent_class)->add_queries (G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist), queries);
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = music_local_smart_playlist_queries_to_string (self);
	g_value_init (&_tmp4_, G_TYPE_STRING);
	g_value_take_string (&_tmp4_, _tmp3_);
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp4_);
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
}

static gchar*
music_local_smart_playlist_queries_to_string (MusicLocalSmartPlaylist* self)
{
	GString* sb = NULL;
	GString* _tmp0_;
	GString* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	{
		GeeIterator* _q_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeIterator* _tmp2_;
		_tmp1_ = ((MusicSmartPlaylist*) self)->queries;
		_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
		_q_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			MusicSmartQuery* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GString* _tmp6_;
			GString* _tmp8_;
			MusicSmartQuery* _tmp9_;
			MusicSmartQueryFieldType _tmp10_;
			MusicSmartQueryFieldType _tmp11_;
			GString* _tmp12_;
			GString* _tmp13_;
			MusicSmartQuery* _tmp14_;
			MusicSmartQueryComparatorType _tmp15_;
			MusicSmartQueryComparatorType _tmp16_;
			GString* _tmp17_;
			MusicSmartQuery* _tmp18_;
			GValue _tmp19_ = {0};
			GValue _tmp20_;
			_tmp3_ = _q_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _q_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			q = (MusicSmartQuery*) _tmp5_;
			_tmp6_ = sb;
			if (_tmp6_->len != ((gssize) 0)) {
				GString* _tmp7_;
				_tmp7_ = sb;
				g_string_append (_tmp7_, MUSIC_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR);
			}
			_tmp8_ = sb;
			_tmp9_ = q;
			_tmp10_ = music_smart_query_get_field (_tmp9_);
			_tmp11_ = _tmp10_;
			g_string_append_printf (_tmp8_, "%d", (gint) _tmp11_);
			_tmp12_ = sb;
			g_string_append (_tmp12_, MUSIC_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR);
			_tmp13_ = sb;
			_tmp14_ = q;
			_tmp15_ = music_smart_query_get_comparator (_tmp14_);
			_tmp16_ = _tmp15_;
			g_string_append_printf (_tmp13_, "%d", (gint) _tmp16_);
			_tmp17_ = sb;
			g_string_append (_tmp17_, MUSIC_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR);
			_tmp18_ = q;
			music_smart_query_get_value (_tmp18_, &_tmp19_);
			_tmp20_ = _tmp19_;
			if (G_VALUE_TYPE (&_tmp20_) == G_TYPE_STRING) {
				GString* _tmp21_;
				MusicSmartQuery* _tmp22_;
				GValue _tmp23_ = {0};
				GValue _tmp24_;
				const gchar* _tmp25_;
				_tmp21_ = sb;
				_tmp22_ = q;
				music_smart_query_get_value (_tmp22_, &_tmp23_);
				_tmp24_ = _tmp23_;
				_tmp25_ = g_value_get_string (&_tmp24_);
				g_string_append (_tmp21_, _tmp25_);
			} else {
				GString* _tmp26_;
				MusicSmartQuery* _tmp27_;
				GValue _tmp28_ = {0};
				GValue _tmp29_;
				_tmp26_ = sb;
				_tmp27_ = q;
				music_smart_query_get_value (_tmp27_, &_tmp28_);
				_tmp29_ = _tmp28_;
				g_string_append_printf (_tmp26_, "%d", g_value_get_int (&_tmp29_));
			}
			_g_object_unref0 (q);
		}
		_g_object_unref0 (_q_it);
	}
	_tmp30_ = sb;
	_tmp31_ = _tmp30_->str;
	_tmp32_ = g_strdup (_tmp31_);
	result = _tmp32_;
	_g_string_free0 (sb);
	return result;
}

void
music_local_smart_playlist_queries_from_string (MusicLocalSmartPlaylist* self,
                                                const gchar* q)
{
	gchar** queries_in_string = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint queries_in_string_length1;
	gint _queries_in_string_size_;
	GeeTreeSet* new_queries = NULL;
	GeeTreeSet* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GeeTreeSet* _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (q != NULL);
	_tmp1_ = _tmp0_ = g_strsplit (q, MUSIC_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR, 0);
	queries_in_string = _tmp1_;
	queries_in_string_length1 = _vala_array_length (_tmp0_);
	_queries_in_string_size_ = queries_in_string_length1;
	_tmp2_ = gee_tree_set_new (MUSIC_TYPE_SMART_QUERY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	new_queries = _tmp2_;
	_tmp3_ = queries_in_string;
	_tmp3__length1 = queries_in_string_length1;
	{
		gchar** query_string_collection = NULL;
		gint query_string_collection_length1 = 0;
		gint _query_string_collection_size_ = 0;
		gint query_string_it = 0;
		query_string_collection = _tmp3_;
		query_string_collection_length1 = _tmp3__length1;
		for (query_string_it = 0; query_string_it < query_string_collection_length1; query_string_it = query_string_it + 1) {
			gchar* _tmp4_;
			gchar* query_string = NULL;
			_tmp4_ = g_strdup (query_string_collection[query_string_it]);
			query_string = _tmp4_;
			{
				const gchar* _tmp5_;
				gchar** pieces_of_query = NULL;
				const gchar* _tmp6_;
				gchar** _tmp7_;
				gchar** _tmp8_;
				gint pieces_of_query_length1;
				gint _pieces_of_query_size_;
				gint _tmp9_;
				MusicSmartQuery* sq = NULL;
				MusicSmartQuery* _tmp10_;
				MusicSmartQuery* _tmp11_;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				MusicSmartQuery* _tmp14_;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				MusicSmartQuery* _tmp17_;
				MusicSmartQueryFieldType _tmp18_;
				MusicSmartQueryFieldType _tmp19_;
				GeeTreeSet* _tmp30_;
				MusicSmartQuery* _tmp31_;
				_tmp5_ = query_string;
				if (g_strcmp0 (_tmp5_, "") == 0) {
					_g_free0 (query_string);
					continue;
				}
				_tmp6_ = query_string;
				_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, MUSIC_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR, 3);
				pieces_of_query = _tmp8_;
				pieces_of_query_length1 = _vala_array_length (_tmp7_);
				_pieces_of_query_size_ = pieces_of_query_length1;
				_tmp9_ = 3;
				pieces_of_query = g_renew (gchar*, pieces_of_query, 3);
				(_tmp9_ > pieces_of_query_length1) ? memset (pieces_of_query + pieces_of_query_length1, 0, sizeof (gchar*) * (_tmp9_ - pieces_of_query_length1)) : NULL;
				pieces_of_query_length1 = _tmp9_;
				_pieces_of_query_size_ = _tmp9_;
				_tmp10_ = music_smart_query_new ();
				sq = _tmp10_;
				_tmp11_ = sq;
				_tmp12_ = pieces_of_query;
				_tmp12__length1 = pieces_of_query_length1;
				_tmp13_ = _tmp12_[0];
				music_smart_query_set_field (_tmp11_, (MusicSmartQueryFieldType) atoi (_tmp13_));
				_tmp14_ = sq;
				_tmp15_ = pieces_of_query;
				_tmp15__length1 = pieces_of_query_length1;
				_tmp16_ = _tmp15_[1];
				music_smart_query_set_comparator (_tmp14_, (MusicSmartQueryComparatorType) atoi (_tmp16_));
				_tmp17_ = sq;
				_tmp18_ = music_smart_query_get_field (_tmp17_);
				_tmp19_ = _tmp18_;
				switch (_tmp19_) {
					case MUSIC_SMART_QUERY_FIELD_TYPE_ALBUM:
					case MUSIC_SMART_QUERY_FIELD_TYPE_ARTIST:
					case MUSIC_SMART_QUERY_FIELD_TYPE_COMPOSER:
					case MUSIC_SMART_QUERY_FIELD_TYPE_COMMENT:
					case MUSIC_SMART_QUERY_FIELD_TYPE_GENRE:
					case MUSIC_SMART_QUERY_FIELD_TYPE_GROUPING:
					case MUSIC_SMART_QUERY_FIELD_TYPE_TITLE:
					case MUSIC_SMART_QUERY_FIELD_TYPE_URI:
					{
						GValue val = {0};
						GValue _tmp20_ = {0};
						gchar** _tmp21_;
						gint _tmp21__length1;
						const gchar* _tmp22_;
						MusicSmartQuery* _tmp23_;
						GValue _tmp24_;
						g_value_init (&_tmp20_, G_TYPE_STRING);
						val = _tmp20_;
						_tmp21_ = pieces_of_query;
						_tmp21__length1 = pieces_of_query_length1;
						_tmp22_ = _tmp21_[2];
						g_value_set_string (&val, _tmp22_);
						_tmp23_ = sq;
						_tmp24_ = val;
						music_smart_query_set_value (_tmp23_, &_tmp24_);
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
						break;
					}
					default:
					{
						GValue val = {0};
						GValue _tmp25_ = {0};
						gchar** _tmp26_;
						gint _tmp26__length1;
						const gchar* _tmp27_;
						MusicSmartQuery* _tmp28_;
						GValue _tmp29_;
						g_value_init (&_tmp25_, G_TYPE_INT);
						val = _tmp25_;
						_tmp26_ = pieces_of_query;
						_tmp26__length1 = pieces_of_query_length1;
						_tmp27_ = _tmp26_[2];
						g_value_set_int (&val, atoi (_tmp27_));
						_tmp28_ = sq;
						_tmp29_ = val;
						music_smart_query_set_value (_tmp28_, &_tmp29_);
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
						break;
					}
				}
				_tmp30_ = new_queries;
				_tmp31_ = sq;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
				_g_object_unref0 (sq);
				pieces_of_query = (_vala_array_free (pieces_of_query, pieces_of_query_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (query_string);
			}
		}
	}
	_tmp32_ = new_queries;
	music_smart_playlist_add_queries ((MusicSmartPlaylist*) self, (GeeCollection*) _tmp32_);
	_g_object_unref0 (new_queries);
	queries_in_string = (_vala_array_free (queries_in_string, queries_in_string_length1, (GDestroyNotify) g_free), NULL);
}

static void
__vala_GValue_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
}

static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}

void
music_local_smart_playlist_add_defaults (GdaConnection* connection)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (connection != NULL);
	{
		GSList* col_names = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GSList* values = NULL;
		GValue* _tmp5_ = NULL;
		GValue* _tmp6_ = NULL;
		GValue* _tmp7_ = NULL;
		GValue* _tmp8_ = NULL;
		GValue* _tmp9_ = NULL;
		GSList* _tmp10_;
		GSList* _tmp11_;
		GValue* _tmp12_ = NULL;
		GValue* _tmp13_ = NULL;
		GValue* _tmp14_ = NULL;
		GValue* _tmp15_ = NULL;
		GValue* _tmp16_ = NULL;
		GSList* _tmp17_;
		GSList* _tmp18_;
		GValue* _tmp19_ = NULL;
		GValue* _tmp20_ = NULL;
		GValue* _tmp21_ = NULL;
		GValue* _tmp22_ = NULL;
		GValue* _tmp23_ = NULL;
		GSList* _tmp24_;
		GSList* _tmp25_;
		GValue* _tmp26_ = NULL;
		GValue* _tmp27_ = NULL;
		GValue* _tmp28_ = NULL;
		GValue* _tmp29_ = NULL;
		GValue* _tmp30_ = NULL;
		GSList* _tmp31_;
		GSList* _tmp32_;
		GValue* _tmp33_ = NULL;
		GValue* _tmp34_ = NULL;
		GValue* _tmp35_ = NULL;
		GValue* _tmp36_ = NULL;
		GValue* _tmp37_ = NULL;
		GSList* _tmp38_;
		GSList* _tmp39_;
		GValue* _tmp40_ = NULL;
		GValue* _tmp41_ = NULL;
		GValue* _tmp42_ = NULL;
		GValue* _tmp43_ = NULL;
		GValue* _tmp44_ = NULL;
		GSList* _tmp45_;
		GSList* _tmp46_;
		col_names = NULL;
		_tmp0_ = g_strdup ("name");
		col_names = g_slist_append (col_names, _tmp0_);
		_tmp1_ = g_strdup ("queries");
		col_names = g_slist_append (col_names, _tmp1_);
		_tmp2_ = g_strdup ("and_or");
		col_names = g_slist_append (col_names, _tmp2_);
		_tmp3_ = g_strdup ("limited");
		col_names = g_slist_append (col_names, _tmp3_);
		_tmp4_ = g_strdup ("limit_amount");
		col_names = g_slist_append (col_names, _tmp4_);
		values = NULL;
		_tmp5_ = g_new0 (GValue, 1);
		g_value_init (_tmp5_, G_TYPE_STRING);
		g_value_set_string (_tmp5_, _ ("Favorite Songs"));
		values = g_slist_append (values, _tmp5_);
		_tmp6_ = g_new0 (GValue, 1);
		g_value_init (_tmp6_, G_TYPE_STRING);
		g_value_set_string (_tmp6_, "10<val_sep>2<val_sep>4<query_sep>12<val_sep>0<val_sep>0<query_sep>11<v" \
"al_sep>6<val_sep>3");
		values = g_slist_append (values, _tmp6_);
		_tmp7_ = g_new0 (GValue, 1);
		g_value_init (_tmp7_, G_TYPE_INT);
		g_value_set_int (_tmp7_, 1);
		values = g_slist_append (values, _tmp7_);
		_tmp8_ = g_new0 (GValue, 1);
		g_value_init (_tmp8_, G_TYPE_INT);
		g_value_set_int (_tmp8_, 1);
		values = g_slist_append (values, _tmp8_);
		_tmp9_ = g_new0 (GValue, 1);
		g_value_init (_tmp9_, G_TYPE_INT);
		g_value_set_int (_tmp9_, 50);
		values = g_slist_append (values, _tmp9_);
		_tmp10_ = col_names;
		_tmp11_ = values;
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp10_, _tmp11_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		values = NULL;
		_tmp12_ = g_new0 (GValue, 1);
		g_value_init (_tmp12_, G_TYPE_STRING);
		g_value_set_string (_tmp12_, _ ("Recently Added"));
		values = g_slist_append (values, _tmp12_);
		_tmp13_ = g_new0 (GValue, 1);
		g_value_init (_tmp13_, G_TYPE_STRING);
		g_value_set_string (_tmp13_, "5<val_sep>7<val_sep>7");
		values = g_slist_append (values, _tmp13_);
		_tmp14_ = g_new0 (GValue, 1);
		g_value_init (_tmp14_, G_TYPE_INT);
		g_value_set_int (_tmp14_, 1);
		values = g_slist_append (values, _tmp14_);
		_tmp15_ = g_new0 (GValue, 1);
		g_value_init (_tmp15_, G_TYPE_INT);
		g_value_set_int (_tmp15_, 1);
		values = g_slist_append (values, _tmp15_);
		_tmp16_ = g_new0 (GValue, 1);
		g_value_init (_tmp16_, G_TYPE_INT);
		g_value_set_int (_tmp16_, 50);
		values = g_slist_append (values, _tmp16_);
		_tmp17_ = col_names;
		_tmp18_ = values;
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp17_, _tmp18_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		values = NULL;
		_tmp19_ = g_new0 (GValue, 1);
		g_value_init (_tmp19_, G_TYPE_STRING);
		g_value_set_string (_tmp19_, _ ("Recent Favorites"));
		values = g_slist_append (values, _tmp19_);
		_tmp20_ = g_new0 (GValue, 1);
		g_value_init (_tmp20_, G_TYPE_STRING);
		g_value_set_string (_tmp20_, "10<val_sep>2<val_sep>4<query_sep>12<val_sep>0<val_sep>0<query_sep>8<va" \
"l_sep>7<val_sep>7");
		values = g_slist_append (values, _tmp20_);
		_tmp21_ = g_new0 (GValue, 1);
		g_value_init (_tmp21_, G_TYPE_INT);
		g_value_set_int (_tmp21_, 1);
		values = g_slist_append (values, _tmp21_);
		_tmp22_ = g_new0 (GValue, 1);
		g_value_init (_tmp22_, G_TYPE_INT);
		g_value_set_int (_tmp22_, 1);
		values = g_slist_append (values, _tmp22_);
		_tmp23_ = g_new0 (GValue, 1);
		g_value_init (_tmp23_, G_TYPE_INT);
		g_value_set_int (_tmp23_, 50);
		values = g_slist_append (values, _tmp23_);
		_tmp24_ = col_names;
		_tmp25_ = values;
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp24_, _tmp25_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		values = NULL;
		_tmp26_ = g_new0 (GValue, 1);
		g_value_init (_tmp26_, G_TYPE_STRING);
		g_value_set_string (_tmp26_, _ ("Never Played"));
		values = g_slist_append (values, _tmp26_);
		_tmp27_ = g_new0 (GValue, 1);
		g_value_init (_tmp27_, G_TYPE_STRING);
		g_value_set_string (_tmp27_, "10<val_sep>0<val_sep>0");
		values = g_slist_append (values, _tmp27_);
		_tmp28_ = g_new0 (GValue, 1);
		g_value_init (_tmp28_, G_TYPE_INT);
		g_value_set_int (_tmp28_, 0);
		values = g_slist_append (values, _tmp28_);
		_tmp29_ = g_new0 (GValue, 1);
		g_value_init (_tmp29_, G_TYPE_INT);
		g_value_set_int (_tmp29_, 1);
		values = g_slist_append (values, _tmp29_);
		_tmp30_ = g_new0 (GValue, 1);
		g_value_init (_tmp30_, G_TYPE_INT);
		g_value_set_int (_tmp30_, 50);
		values = g_slist_append (values, _tmp30_);
		_tmp31_ = col_names;
		_tmp32_ = values;
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp31_, _tmp32_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		values = NULL;
		_tmp33_ = g_new0 (GValue, 1);
		g_value_init (_tmp33_, G_TYPE_STRING);
		g_value_set_string (_tmp33_, _ ("Over Played"));
		values = g_slist_append (values, _tmp33_);
		_tmp34_ = g_new0 (GValue, 1);
		g_value_init (_tmp34_, G_TYPE_STRING);
		g_value_set_string (_tmp34_, "10<val_sep>6<val_sep>10");
		values = g_slist_append (values, _tmp34_);
		_tmp35_ = g_new0 (GValue, 1);
		g_value_init (_tmp35_, G_TYPE_INT);
		g_value_set_int (_tmp35_, 1);
		values = g_slist_append (values, _tmp35_);
		_tmp36_ = g_new0 (GValue, 1);
		g_value_init (_tmp36_, G_TYPE_INT);
		g_value_set_int (_tmp36_, 1);
		values = g_slist_append (values, _tmp36_);
		_tmp37_ = g_new0 (GValue, 1);
		g_value_init (_tmp37_, G_TYPE_INT);
		g_value_set_int (_tmp37_, 50);
		values = g_slist_append (values, _tmp37_);
		_tmp38_ = col_names;
		_tmp39_ = values;
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp38_, _tmp39_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		values = NULL;
		_tmp40_ = g_new0 (GValue, 1);
		g_value_init (_tmp40_, G_TYPE_STRING);
		g_value_set_string (_tmp40_, _ ("Not Recently Played"));
		values = g_slist_append (values, _tmp40_);
		_tmp41_ = g_new0 (GValue, 1);
		g_value_init (_tmp41_, G_TYPE_STRING);
		g_value_set_string (_tmp41_, "8<val_sep>8<val_sep>7");
		values = g_slist_append (values, _tmp41_);
		_tmp42_ = g_new0 (GValue, 1);
		g_value_init (_tmp42_, G_TYPE_INT);
		g_value_set_int (_tmp42_, 1);
		values = g_slist_append (values, _tmp42_);
		_tmp43_ = g_new0 (GValue, 1);
		g_value_init (_tmp43_, G_TYPE_INT);
		g_value_set_int (_tmp43_, 1);
		values = g_slist_append (values, _tmp43_);
		_tmp44_ = g_new0 (GValue, 1);
		g_value_init (_tmp44_, G_TYPE_INT);
		g_value_set_int (_tmp44_, 50);
		values = g_slist_append (values, _tmp44_);
		_tmp45_ = col_names;
		_tmp46_ = values;
		gda_connection_insert_row_into_table_v (connection, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp45_, _tmp46_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			goto __catch68_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
	}
	goto __finally68;
	__catch68_g_error:
	{
		GError* e = NULL;
		GError* _tmp47_;
		const gchar* _tmp48_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp47_ = e;
		_tmp48_ = _tmp47_->message;
		g_critical ("LocalSmartPlaylist.vala:264: Could not initialize smart playlists: %s", _tmp48_);
		_g_error_free0 (e);
	}
	__finally68:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static const gchar*
music_local_smart_playlist_real_get_name (MusicPlaylist* base)
{
	const gchar* result;
	MusicLocalSmartPlaylist* self;
	const gchar* _tmp0_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue* _tmp5_;
	GValue* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	self = (MusicLocalSmartPlaylist*) base;
	_tmp0_ = self->priv->_name;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		_tmp1_ = self->priv->_name;
		result = _tmp1_;
		return result;
	}
	_tmp2_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->connection;
	_tmp5_ = music_database_query_field (_tmp3_, _tmp4_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "name");
	_tmp6_ = _tmp5_;
	_tmp7_ = g_value_dup_string (_tmp6_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp7_;
	__vala_GValue_free0 (_tmp6_);
	_tmp8_ = self->priv->_name;
	result = _tmp8_;
	return result;
}

static void
music_local_smart_playlist_real_set_name (MusicPlaylist* base,
                                          const gchar* value)
{
	MusicLocalSmartPlaylist* self;
	gchar* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GdaConnection* _tmp3_;
	GValue _tmp4_ = {0};
	self = (MusicLocalSmartPlaylist*) base;
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp0_;
	_tmp1_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->connection;
	g_value_init (&_tmp4_, G_TYPE_STRING);
	g_value_set_string (&_tmp4_, value);
	music_database_set_field (_tmp2_, _tmp3_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "name", &_tmp4_);
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
	g_object_notify_by_pspec ((GObject *) self, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY]);
}

static MusicSmartPlaylistConditionalType
music_local_smart_playlist_real_get_conditional (MusicSmartPlaylist* base)
{
	MusicSmartPlaylistConditionalType result;
	MusicLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	MusicSmartPlaylistConditionalType _tmp5_;
	self = (MusicLocalSmartPlaylist*) base;
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = music_database_query_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "and_or");
	_tmp4_ = _tmp3_;
	_tmp5_ = (MusicSmartPlaylistConditionalType) g_value_get_int (_tmp4_);
	__vala_GValue_free0 (_tmp4_);
	result = _tmp5_;
	return result;
}

static void
music_local_smart_playlist_real_set_conditional (MusicSmartPlaylist* base,
                                                 MusicSmartPlaylistConditionalType value)
{
	MusicLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
	self = (MusicLocalSmartPlaylist*) base;
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	g_value_init (&_tmp3_, MUSIC_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE);
	g_value_set_enum (&_tmp3_, value);
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "and_or", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
	g_object_notify_by_pspec ((GObject *) self, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY]);
}

static guint
music_local_smart_playlist_real_get_limit_amount (MusicSmartPlaylist* base)
{
	guint result;
	MusicLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	guint _tmp5_;
	self = (MusicLocalSmartPlaylist*) base;
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = music_database_query_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limit_amount");
	_tmp4_ = _tmp3_;
	_tmp5_ = (guint) g_value_get_int (_tmp4_);
	__vala_GValue_free0 (_tmp4_);
	result = _tmp5_;
	return result;
}

static void
music_local_smart_playlist_real_set_limit_amount (MusicSmartPlaylist* base,
                                                  guint value)
{
	MusicLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
	self = (MusicLocalSmartPlaylist*) base;
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	g_value_init (&_tmp3_, G_TYPE_UINT);
	g_value_set_uint (&_tmp3_, value);
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limit_amount", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
	g_object_notify_by_pspec ((GObject *) self, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY]);
}

static gboolean
music_local_smart_playlist_real_get_limit (MusicSmartPlaylist* base)
{
	gboolean result;
	MusicLocalSmartPlaylist* self;
	GValue* val = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	self = (MusicLocalSmartPlaylist*) base;
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = music_database_query_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limited");
	val = _tmp3_;
	result = (gboolean) g_value_get_int (val);
	__vala_GValue_free0 (val);
	return result;
}

static void
music_local_smart_playlist_real_set_limit (MusicSmartPlaylist* base,
                                           gboolean value)
{
	MusicLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
	self = (MusicLocalSmartPlaylist*) base;
	_tmp0_ = music_playlist_get_rowid ((MusicPlaylist*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	g_value_init (&_tmp3_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp3_, value);
	music_database_set_field (_tmp1_, _tmp2_, MUSIC_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limited", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
	g_object_notify_by_pspec ((GObject *) self, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY]);
}

static void
music_local_smart_playlist_class_init (MusicLocalSmartPlaylistClass * klass,
                                       gpointer klass_data)
{
	music_local_smart_playlist_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicLocalSmartPlaylist_private_offset);
	((MusicSmartPlaylistClass *) klass)->analyse_all = (void (*) (MusicSmartPlaylist*)) music_local_smart_playlist_real_analyse_all;
	((MusicSmartPlaylistClass *) klass)->clear_queries = (void (*) (MusicSmartPlaylist*)) music_local_smart_playlist_real_clear_queries;
	((MusicSmartPlaylistClass *) klass)->add_query = (void (*) (MusicSmartPlaylist*, MusicSmartQuery*)) music_local_smart_playlist_real_add_query;
	((MusicSmartPlaylistClass *) klass)->add_queries = (void (*) (MusicSmartPlaylist*, GeeCollection*)) music_local_smart_playlist_real_add_queries;
	MUSIC_PLAYLIST_CLASS (klass)->get_name = music_local_smart_playlist_real_get_name;
	MUSIC_PLAYLIST_CLASS (klass)->set_name = music_local_smart_playlist_real_set_name;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_conditional = music_local_smart_playlist_real_get_conditional;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_conditional = music_local_smart_playlist_real_set_conditional;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_limit_amount = music_local_smart_playlist_real_get_limit_amount;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_limit_amount = music_local_smart_playlist_real_set_limit_amount;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_limit = music_local_smart_playlist_real_get_limit;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_limit = music_local_smart_playlist_real_set_limit;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_local_smart_playlist_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_local_smart_playlist_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_local_smart_playlist_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY] = g_param_spec_enum ("conditional", "conditional", "conditional", MUSIC_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY] = g_param_spec_uint ("limit-amount", "limit-amount", "limit-amount", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY, music_local_smart_playlist_properties[MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY] = g_param_spec_boolean ("limit", "limit", "limit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
music_local_smart_playlist_instance_init (MusicLocalSmartPlaylist * self,
                                          gpointer klass)
{
	self->priv = music_local_smart_playlist_get_instance_private (self);
	self->priv->_name = NULL;
}

static void
music_local_smart_playlist_finalize (GObject * obj)
{
	MusicLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylist);
	_g_object_unref0 (self->priv->connection);
	_g_free0 (self->priv->_name);
	G_OBJECT_CLASS (music_local_smart_playlist_parent_class)->finalize (obj);
}

GType
music_local_smart_playlist_get_type (void)
{
	static volatile gsize music_local_smart_playlist_type_id__volatile = 0;
	if (g_once_init_enter (&music_local_smart_playlist_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicLocalSmartPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_local_smart_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLocalSmartPlaylist), 0, (GInstanceInitFunc) music_local_smart_playlist_instance_init, NULL };
		GType music_local_smart_playlist_type_id;
		music_local_smart_playlist_type_id = g_type_register_static (MUSIC_TYPE_SMART_PLAYLIST, "MusicLocalSmartPlaylist", &g_define_type_info, 0);
		MusicLocalSmartPlaylist_private_offset = g_type_add_instance_private (music_local_smart_playlist_type_id, sizeof (MusicLocalSmartPlaylistPrivate));
		g_once_init_leave (&music_local_smart_playlist_type_id__volatile, music_local_smart_playlist_type_id);
	}
	return music_local_smart_playlist_type_id__volatile;
}

static void
_vala_music_local_smart_playlist_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	MusicLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylist);
	switch (property_id) {
		case MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY:
		g_value_set_string (value, music_playlist_get_name ((MusicPlaylist*) self));
		break;
		case MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
		g_value_set_enum (value, music_smart_playlist_get_conditional ((MusicSmartPlaylist*) self));
		break;
		case MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
		g_value_set_uint (value, music_smart_playlist_get_limit_amount ((MusicSmartPlaylist*) self));
		break;
		case MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY:
		g_value_set_boolean (value, music_smart_playlist_get_limit ((MusicSmartPlaylist*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_local_smart_playlist_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	MusicLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylist);
	switch (property_id) {
		case MUSIC_LOCAL_SMART_PLAYLIST_NAME_PROPERTY:
		music_playlist_set_name ((MusicPlaylist*) self, g_value_get_string (value));
		break;
		case MUSIC_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
		music_smart_playlist_set_conditional ((MusicSmartPlaylist*) self, g_value_get_enum (value));
		break;
		case MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
		music_smart_playlist_set_limit_amount ((MusicSmartPlaylist*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY:
		music_smart_playlist_set_limit ((MusicSmartPlaylist*) self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

