/* PlaybackManager.c generated by valac 0.44.11, the Vala compiler
 * generated from PlaybackManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
typedef struct _MusicPlaybackManagerPrivate MusicPlaybackManagerPrivate;

#define MUSIC_TYPE_HISTORY_PLAYLIST (music_history_playlist_get_type ())
#define MUSIC_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylist))
#define MUSIC_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylistClass))
#define MUSIC_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_HISTORY_PLAYLIST))
#define MUSIC_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_HISTORY_PLAYLIST))
#define MUSIC_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylistClass))

typedef struct _MusicHistoryPlaylist MusicHistoryPlaylist;
typedef struct _MusicHistoryPlaylistClass MusicHistoryPlaylistClass;

#define MUSIC_TYPE_STREAMER (music_streamer_get_type ())
#define MUSIC_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_STREAMER, MusicStreamer))
#define MUSIC_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_STREAMER, MusicStreamerClass))
#define MUSIC_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_STREAMER))
#define MUSIC_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_STREAMER))
#define MUSIC_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_STREAMER, MusicStreamerClass))

typedef struct _MusicStreamer MusicStreamer;
typedef struct _MusicStreamerClass MusicStreamerClass;
enum  {
	MUSIC_PLAYBACK_MANAGER_0_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY,
	MUSIC_PLAYBACK_MANAGER_NUM_PROPERTIES
};
static GParamSpec* music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _g_free0(var) (var = (g_free (var), NULL))

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	MUSIC_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL,
	MUSIC_PLAYBACK_MANAGER_NUM_SIGNALS
};
static guint music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_NUM_SIGNALS] = {0};

struct _MusicPlaybackManager {
	GObject parent_instance;
	MusicPlaybackManagerPrivate * priv;
	MusicStaticPlaylist* queue_playlist;
	MusicHistoryPlaylist* history_playlist;
	MusicStreamer* file_player;
	MusicPlayback* player;
};

struct _MusicPlaybackManagerClass {
	GObjectClass parent_class;
};

struct _MusicPlaybackManagerPrivate {
	GeeTreeSet* playbacks;
	GRecMutex __lock_playbacks;
	GeeHashMap* _current;
	GeeHashMap* _current_shuffled;
	gint _current_index;
	gint _current_shuffled_index;
	gboolean _playing;
	gdouble saved_volume;
	gboolean _playing_queued_song;
	MusicMedia* _current_media;
};

struct _Block10Data {
	int _ref_count_;
	MusicPlaybackManager* self;
	MusicMedia* m;
};

static gint MusicPlaybackManager_private_offset;
static gpointer music_playback_manager_parent_class = NULL;

GType music_playback_manager_get_type (void) G_GNUC_CONST;
GType music_history_playlist_get_type (void) G_GNUC_CONST;
GType music_streamer_get_type (void) G_GNUC_CONST;
void music_playback_manager_add_playback (MusicPlaybackManager* self,
                                          MusicPlayback* playback);
void music_playback_manager_queue_media (MusicPlaybackManager* self,
                                         GeeCollection* to_queue);
static void music_playback_manager_add_to_current (MusicPlaybackManager* self,
                                            MusicMedia* m);
static void music_playback_manager_reshuffle (MusicPlaybackManager* self);
void music_playback_manager_unqueue_media (MusicPlaybackManager* self,
                                           GeeCollection* to_unqueue);
MusicMedia* music_playback_manager_get_current_media (MusicPlaybackManager* self);
gint music_playback_manager_get_current_index (MusicPlaybackManager* self);
void music_playback_manager_set_current_index (MusicPlaybackManager* self,
                                               gint value);
static void music_playback_manager_set_current_media (MusicPlaybackManager* self,
                                               MusicMedia* value);
void music_playback_manager_play_media (MusicPlaybackManager* self,
                                        MusicMedia* m);
void music_playback_manager_stop_playback (MusicPlaybackManager* self);
void music_playback_manager_clear_queue (MusicPlaybackManager* self);
MusicMedia* music_playback_manager_media_from_current_index (MusicPlaybackManager* self,
                                                             gint index_in_current);
GeeCollection* music_playback_manager_get_current_media_list (MusicPlaybackManager* self);
void music_playback_manager_set_repeat_mode (MusicPlaybackManager* self,
                                             MusicSettingsRepeat mode);
void music_playback_manager_set_shuffle_mode (MusicPlaybackManager* self,
                                              MusicSettingsShuffle mode);
MusicMedia* music_playback_manager_get_next (MusicPlaybackManager* self,
                                             gboolean play);
static MusicLibrary* music_playback_manager_get_library (MusicPlaybackManager* self);
MusicMedia* music_playback_manager_get_previous (MusicPlaybackManager* self,
                                                 gboolean play);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
void music_playback_manager_set_volume (MusicPlaybackManager* self,
                                        gdouble value);
void music_playback_manager_change_gains_thread (MusicPlaybackManager* self);
gboolean music_playback_manager_get_playing (MusicPlaybackManager* self);
GSettings* music_app_get_saved_state (void);
static gboolean __lambda30_ (Block10Data* _data10_);
static gboolean ___lambda30__gsource_func (gpointer self);
static void music_playback_manager_set_playing (MusicPlaybackManager* self,
                                         gboolean value);
void music_playback_manager_start_playback (MusicPlaybackManager* self);
GType music_library_window_get_type (void) G_GNUC_CONST;
MusicLibraryWindow* music_app_get_main_window (void);
#define MUSIC_LIBRARY_WINDOW_ACTION_PLAY "action_play"
static GVariant* _variant_new4 (gboolean value);
void music_playback_manager_pause_playback (MusicPlaybackManager* self);
static GVariant* _variant_new5 (gboolean value);
MusicPlaybackManager* music_playback_manager_new (void);
MusicPlaybackManager* music_playback_manager_construct (GType object_type);
gdouble music_playback_manager_get_volume (MusicPlaybackManager* self);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);
static GObject * music_playback_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
MusicHistoryPlaylist* music_history_playlist_new (void);
MusicHistoryPlaylist* music_history_playlist_construct (GType object_type);
MusicStreamer* music_streamer_new (void);
MusicStreamer* music_streamer_construct (GType object_type);
static void music_playback_manager_finalize (GObject * obj);
static void _vala_music_playback_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_music_playback_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
music_playback_manager_get_instance_private (MusicPlaybackManager* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPlaybackManager_private_offset);
}

void
music_playback_manager_add_playback (MusicPlaybackManager* self,
                                     MusicPlayback* playback)
{
	GeeTreeSet* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (playback != NULL);
	_tmp0_ = self->priv->playbacks;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, playback);
}

void
music_playback_manager_queue_media (MusicPlaybackManager* self,
                                    GeeCollection* to_queue)
{
	gint _tmp0_;
	gint _tmp1_;
	MusicStaticPlaylist* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_queue != NULL);
	_tmp0_ = gee_collection_get_size (to_queue);
	_tmp1_ = _tmp0_;
	if (_tmp1_ < 1) {
		return;
	}
	{
		GeeIterator* _q_it = NULL;
		GeeIterator* _tmp2_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) to_queue);
		_q_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			MusicMedia* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			MusicMedia* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			MusicMedia* _tmp9_;
			_tmp3_ = _q_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _q_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			q = (MusicMedia*) _tmp5_;
			_tmp6_ = q;
			_tmp7_ = music_media_get_title (_tmp6_);
			_tmp8_ = _tmp7_;
			g_debug ("PlaybackManager.vala:125: QUEUED: %s", _tmp8_);
			_tmp9_ = q;
			music_playback_manager_add_to_current (self, _tmp9_);
			_g_object_unref0 (q);
		}
		_g_object_unref0 (_q_it);
	}
	_tmp10_ = self->queue_playlist;
	music_playlist_add_medias ((MusicPlaylist*) _tmp10_, to_queue);
	music_playback_manager_reshuffle (self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
music_playback_manager_unqueue_media (MusicPlaybackManager* self,
                                      GeeCollection* to_unqueue)
{
	MusicStaticPlaylist* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeHashMap* _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_unqueue != NULL);
	_tmp0_ = self->queue_playlist;
	music_playlist_remove_medias ((MusicPlaylist*) _tmp0_, to_unqueue);
	_tmp1_ = self->priv->_current;
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_collection_get_size (to_unqueue);
	_tmp5_ = _tmp4_;
	if ((_tmp3_ - _tmp5_) > 0) {
		gboolean current_media_changed = FALSE;
		gboolean _tmp29_ = FALSE;
		current_media_changed = FALSE;
		while (TRUE) {
			gboolean _tmp6_ = FALSE;
			MusicMedia* _tmp7_;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			GeeHashMap* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			GeeHashMap* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			_tmp7_ = self->priv->_current_media;
			if (_tmp7_ != NULL) {
				MusicMedia* _tmp8_;
				_tmp8_ = self->priv->_current_media;
				_tmp6_ = gee_collection_contains (to_unqueue, _tmp8_);
			} else {
				_tmp6_ = FALSE;
			}
			if (!_tmp6_) {
				break;
			}
			current_media_changed = TRUE;
			_tmp9_ = music_playback_manager_get_current_index (self);
			_tmp10_ = _tmp9_;
			music_playback_manager_set_current_index (self, _tmp10_ + 1);
			_tmp11_ = music_playback_manager_get_current_index (self);
			_tmp12_ = _tmp11_;
			_tmp13_ = self->priv->_current;
			_tmp14_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp13_);
			_tmp15_ = _tmp14_;
			if (_tmp12_ >= _tmp15_) {
				music_playback_manager_set_current_index (self, 0);
			}
			_tmp16_ = self->priv->_current_shuffled;
			_tmp17_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp16_);
			_tmp18_ = _tmp17_;
			if (_tmp18_ == 0) {
				GeeHashMap* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gpointer _tmp22_;
				MusicMedia* _tmp23_;
				_tmp19_ = self->priv->_current;
				_tmp20_ = music_playback_manager_get_current_index (self);
				_tmp21_ = _tmp20_;
				_tmp22_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, (gpointer) ((gintptr) _tmp21_));
				_tmp23_ = (MusicMedia*) _tmp22_;
				music_playback_manager_set_current_media (self, _tmp23_);
				_g_object_unref0 (_tmp23_);
			} else {
				GeeHashMap* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gpointer _tmp27_;
				MusicMedia* _tmp28_;
				_tmp24_ = self->priv->_current_shuffled;
				_tmp25_ = music_playback_manager_get_current_index (self);
				_tmp26_ = _tmp25_;
				_tmp27_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp24_, (gpointer) ((gintptr) _tmp26_));
				_tmp28_ = (MusicMedia*) _tmp27_;
				music_playback_manager_set_current_media (self, _tmp28_);
				_g_object_unref0 (_tmp28_);
			}
		}
		if (current_media_changed) {
			MusicMedia* _tmp30_;
			_tmp30_ = self->priv->_current_media;
			_tmp29_ = _tmp30_ != NULL;
		} else {
			_tmp29_ = FALSE;
		}
		if (_tmp29_) {
			MusicMedia* _tmp31_;
			_tmp31_ = self->priv->_current_media;
			music_playback_manager_play_media (self, _tmp31_);
		}
	} else {
		music_playback_manager_set_current_media (self, NULL);
		music_playback_manager_stop_playback (self);
	}
	_tmp32_ = self->priv->_current;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp32_);
	{
		GeeArrayList* _q_list = NULL;
		MusicStaticPlaylist* _tmp33_;
		GeeArrayList* _tmp34_;
		GeeArrayList* _tmp35_;
		GeeArrayList* _tmp36_;
		gint _q_size = 0;
		GeeArrayList* _tmp37_;
		gint _tmp38_;
		gint _tmp39_;
		gint _q_index = 0;
		_tmp33_ = self->queue_playlist;
		_tmp34_ = music_playlist_get_medias ((MusicPlaylist*) _tmp33_);
		_tmp35_ = _tmp34_;
		_tmp36_ = _g_object_ref0 (_tmp35_);
		_q_list = _tmp36_;
		_tmp37_ = _q_list;
		_tmp38_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp37_);
		_tmp39_ = _tmp38_;
		_q_size = _tmp39_;
		_q_index = -1;
		while (TRUE) {
			MusicMedia* q = NULL;
			GeeArrayList* _tmp40_;
			gpointer _tmp41_;
			MusicMedia* _tmp42_;
			const gchar* _tmp43_;
			const gchar* _tmp44_;
			MusicMedia* _tmp45_;
			_q_index = _q_index + 1;
			if (!(_q_index < _q_size)) {
				break;
			}
			_tmp40_ = _q_list;
			_tmp41_ = gee_abstract_list_get ((GeeAbstractList*) _tmp40_, _q_index);
			q = (MusicMedia*) _tmp41_;
			_tmp42_ = q;
			_tmp43_ = music_media_get_title (_tmp42_);
			_tmp44_ = _tmp43_;
			g_debug ("PlaybackManager.vala:162: REQUEUED: %s", _tmp44_);
			_tmp45_ = q;
			music_playback_manager_add_to_current (self, _tmp45_);
			_g_object_unref0 (q);
		}
		_g_object_unref0 (_q_list);
	}
	music_playback_manager_reshuffle (self);
}

void
music_playback_manager_clear_queue (MusicPlaybackManager* self)
{
	MusicStaticPlaylist* _tmp0_;
	GeeHashMap* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->queue_playlist;
	music_playlist_clear ((MusicPlaylist*) _tmp0_);
	_tmp1_ = self->priv->_current;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp1_);
	music_playback_manager_set_current_index (self, 0);
	music_playback_manager_reshuffle (self);
}

MusicMedia*
music_playback_manager_media_from_current_index (MusicPlaybackManager* self,
                                                 gint index_in_current)
{
	MusicSettingsMain* _tmp0_;
	MusicSettingsMain* _tmp1_;
	MusicSettingsShuffle _tmp2_;
	MusicSettingsShuffle _tmp3_;
	gboolean _tmp4_;
	MusicMedia* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_settings_main_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_settings_main_get_shuffle_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ == MUSIC_SETTINGS_SHUFFLE_OFF;
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		GeeHashMap* _tmp5_;
		gpointer _tmp6_;
		_tmp5_ = self->priv->_current;
		_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) index_in_current));
		result = (MusicMedia*) _tmp6_;
		return result;
	} else {
		GeeHashMap* _tmp7_;
		gpointer _tmp8_;
		_tmp7_ = self->priv->_current_shuffled;
		_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) index_in_current));
		result = (MusicMedia*) _tmp8_;
		return result;
	}
}

GeeCollection*
music_playback_manager_get_current_media_list (MusicPlaybackManager* self)
{
	MusicSettingsMain* _tmp0_;
	MusicSettingsMain* _tmp1_;
	MusicSettingsShuffle _tmp2_;
	MusicSettingsShuffle _tmp3_;
	gboolean _tmp4_;
	GeeCollection* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_settings_main_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_settings_main_get_shuffle_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ == MUSIC_SETTINGS_SHUFFLE_OFF;
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		GeeHashMap* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
		_tmp5_ = self->priv->_current_shuffled;
		_tmp6_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp5_);
		_tmp7_ = _tmp6_;
		result = _tmp7_;
		return result;
	} else {
		GeeHashMap* _tmp8_;
		GeeCollection* _tmp9_;
		GeeCollection* _tmp10_;
		_tmp8_ = self->priv->_current;
		_tmp9_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp8_);
		_tmp10_ = _tmp9_;
		result = _tmp10_;
		return result;
	}
}

static void
music_playback_manager_add_to_current (MusicPlaybackManager* self,
                                       MusicMedia* m)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_tmp0_ = self->priv->_current;
	_tmp1_ = self->priv->_current;
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
	_tmp3_ = _tmp2_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) _tmp3_), m);
}

void
music_playback_manager_set_repeat_mode (MusicPlaybackManager* self,
                                        MusicSettingsRepeat mode)
{
	MusicSettingsMain* main_settings = NULL;
	MusicSettingsMain* _tmp0_;
	MusicSettingsMain* _tmp1_;
	MusicSettingsRepeat _tmp2_;
	MusicSettingsRepeat _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_settings_main_get_default ();
	main_settings = _tmp0_;
	_tmp1_ = main_settings;
	_tmp2_ = music_settings_main_get_repeat_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != mode) {
		MusicSettingsMain* _tmp4_;
		_tmp4_ = main_settings;
		music_settings_main_set_repeat_mode (_tmp4_, mode);
	}
	_g_object_unref0 (main_settings);
}

void
music_playback_manager_set_shuffle_mode (MusicPlaybackManager* self,
                                         MusicSettingsShuffle mode)
{
	MusicSettingsMain* main_settings = NULL;
	MusicSettingsMain* _tmp0_;
	MusicSettingsMain* _tmp1_;
	MusicSettingsShuffle _tmp2_;
	MusicSettingsShuffle _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_settings_main_get_default ();
	main_settings = _tmp0_;
	_tmp1_ = main_settings;
	_tmp2_ = music_settings_main_get_shuffle_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != mode) {
		MusicSettingsMain* _tmp4_;
		_tmp4_ = main_settings;
		music_settings_main_set_shuffle_mode (_tmp4_, mode);
		music_playback_manager_reshuffle (self);
	}
	_g_object_unref0 (main_settings);
}

/**
    * Regenerate the shuffled queue if needed
    */
static void
music_playback_manager_reshuffle (MusicPlaybackManager* self)
{
	GeeHashMap* _tmp0_;
	MusicSettingsMain* main_settings = NULL;
	MusicSettingsMain* _tmp1_;
	MusicSettingsMain* _tmp2_;
	MusicSettingsShuffle _tmp3_;
	MusicSettingsShuffle _tmp4_;
	g_return_if_fail (self != NULL);
	g_debug ("PlaybackManager.vala:216: Reshuffling");
	_tmp0_ = self->priv->_current_shuffled;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
	self->priv->_current_shuffled_index = 0;
	_tmp1_ = music_settings_main_get_default ();
	main_settings = _tmp1_;
	_tmp2_ = main_settings;
	_tmp3_ = music_settings_main_get_shuffle_mode (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == MUSIC_SETTINGS_SHUFFLE_OFF) {
		MusicMedia* _tmp5_;
		_tmp5_ = self->priv->_current_media;
		if (_tmp5_ != NULL) {
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp6_ = FALSE;
					_tmp6_ = TRUE;
					while (TRUE) {
						GeeHashMap* _tmp7_;
						gint _tmp8_;
						gint _tmp9_;
						GeeHashMap* _tmp10_;
						gpointer _tmp11_;
						MusicMedia* _tmp12_;
						MusicMedia* _tmp13_;
						gboolean _tmp14_;
						if (!_tmp6_) {
							i = i + 1;
						}
						_tmp6_ = FALSE;
						_tmp7_ = self->priv->_current;
						_tmp8_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp7_);
						_tmp9_ = _tmp8_;
						if (!(i < _tmp9_)) {
							break;
						}
						_tmp10_ = self->priv->_current;
						_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((gintptr) i));
						_tmp12_ = (MusicMedia*) _tmp11_;
						_tmp13_ = self->priv->_current_media;
						_tmp14_ = _tmp12_ == _tmp13_;
						_g_object_unref0 (_tmp12_);
						if (_tmp14_) {
							self->priv->_current_index = i;
							_g_object_unref0 (main_settings);
							return;
						}
					}
				}
			}
		} else {
			self->priv->_current_index = 0;
		}
	} else {
		MusicSettingsMain* _tmp15_;
		MusicSettingsShuffle _tmp16_;
		MusicSettingsShuffle _tmp17_;
		_tmp15_ = main_settings;
		_tmp16_ = music_settings_main_get_shuffle_mode (_tmp15_);
		_tmp17_ = _tmp16_;
		if (_tmp17_ == MUSIC_SETTINGS_SHUFFLE_ALL) {
			GeeLinkedList* temp = NULL;
			GeeLinkedList* _tmp18_;
			gboolean current_media_found = FALSE;
			gboolean _tmp32_ = FALSE;
			MusicMedia* _tmp33_;
			_tmp18_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
			temp = _tmp18_;
			current_media_found = FALSE;
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp19_;
				GeeCollection* _tmp20_;
				GeeCollection* _tmp21_;
				GeeCollection* _tmp22_;
				GeeIterator* _tmp23_;
				GeeIterator* _tmp24_;
				_tmp19_ = self->priv->_current;
				_tmp20_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp19_);
				_tmp21_ = _tmp20_;
				_tmp22_ = _tmp21_;
				_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
				_tmp24_ = _tmp23_;
				_g_object_unref0 (_tmp22_);
				_m_it = _tmp24_;
				while (TRUE) {
					GeeIterator* _tmp25_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp26_;
					gpointer _tmp27_;
					MusicMedia* _tmp28_;
					MusicMedia* _tmp29_;
					_tmp25_ = _m_it;
					if (!gee_iterator_next (_tmp25_)) {
						break;
					}
					_tmp26_ = _m_it;
					_tmp27_ = gee_iterator_get (_tmp26_);
					m = (MusicMedia*) _tmp27_;
					_tmp28_ = self->priv->_current_media;
					_tmp29_ = m;
					if (_tmp28_ != _tmp29_) {
						GeeLinkedList* _tmp30_;
						MusicMedia* _tmp31_;
						_tmp30_ = temp;
						_tmp31_ = m;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
					} else {
						current_media_found = TRUE;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
			_tmp33_ = self->priv->_current_media;
			if (_tmp33_ != NULL) {
				_tmp32_ = current_media_found;
			} else {
				_tmp32_ = FALSE;
			}
			if (_tmp32_) {
				GeeHashMap* _tmp34_;
				MusicMedia* _tmp35_;
				_tmp34_ = self->priv->_current_shuffled;
				_tmp35_ = self->priv->_current_media;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp34_, (gpointer) ((gintptr) 0), _tmp35_);
			} else {
				gboolean _tmp36_ = FALSE;
				MusicMedia* _tmp37_;
				_tmp37_ = self->priv->_current_media;
				if (_tmp37_ != NULL) {
					GeeHashMap* _tmp38_;
					gint _tmp39_;
					gint _tmp40_;
					_tmp38_ = self->priv->_current;
					_tmp39_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp38_);
					_tmp40_ = _tmp39_;
					_tmp36_ = _tmp40_ != 0;
				} else {
					_tmp36_ = FALSE;
				}
				if (_tmp36_) {
					GeeHashMap* _tmp41_;
					GeeHashMap* _tmp42_;
					gpointer _tmp43_;
					MusicMedia* _tmp44_;
					_tmp41_ = self->priv->_current_shuffled;
					_tmp42_ = self->priv->_current;
					_tmp43_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp42_, (gpointer) ((gintptr) 0));
					_tmp44_ = (MusicMedia*) _tmp43_;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp41_, (gpointer) ((gintptr) 0), _tmp44_);
					_g_object_unref0 (_tmp44_);
				}
			}
			{
				gint _tmp45_ = 0;
				MusicMedia* _tmp46_;
				gint i = 0;
				_tmp46_ = self->priv->_current_media;
				if (_tmp46_ == NULL) {
					_tmp45_ = 0;
				} else {
					_tmp45_ = 1;
				}
				i = _tmp45_;
				{
					gboolean _tmp47_ = FALSE;
					_tmp47_ = TRUE;
					while (TRUE) {
						GeeHashMap* _tmp49_;
						gint _tmp50_;
						gint _tmp51_;
						gint n_media = 0;
						GeeLinkedList* _tmp52_;
						gint _tmp53_;
						gint _tmp54_;
						gint random = 0;
						GeeHashMap* _tmp55_;
						GeeLinkedList* _tmp56_;
						gpointer _tmp57_;
						MusicMedia* _tmp58_;
						GeeLinkedList* _tmp59_;
						GeeLinkedList* _tmp60_;
						gpointer _tmp61_;
						MusicMedia* _tmp62_;
						if (!_tmp47_) {
							gint _tmp48_;
							_tmp48_ = i;
							i = _tmp48_ + 1;
						}
						_tmp47_ = FALSE;
						_tmp49_ = self->priv->_current;
						_tmp50_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp49_);
						_tmp51_ = _tmp50_;
						if (!(i < _tmp51_)) {
							break;
						}
						_tmp52_ = temp;
						_tmp53_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp52_);
						_tmp54_ = _tmp53_;
						n_media = _tmp54_;
						if (n_media == 0) {
							break;
						}
						random = (gint) g_random_int_range ((gint32) 0, (gint32) n_media);
						_tmp55_ = self->priv->_current_shuffled;
						_tmp56_ = temp;
						_tmp57_ = gee_abstract_list_get ((GeeAbstractList*) _tmp56_, random);
						_tmp58_ = (MusicMedia*) _tmp57_;
						gee_abstract_map_set ((GeeAbstractMap*) _tmp55_, (gpointer) ((gintptr) i), _tmp58_);
						_g_object_unref0 (_tmp58_);
						_tmp59_ = temp;
						_tmp60_ = temp;
						_tmp61_ = gee_abstract_list_get ((GeeAbstractList*) _tmp60_, random);
						_tmp62_ = (MusicMedia*) _tmp61_;
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp59_, _tmp62_);
						_g_object_unref0 (_tmp62_);
					}
				}
			}
			_g_object_unref0 (temp);
		}
	}
	_g_object_unref0 (main_settings);
}

MusicMedia*
music_playback_manager_get_next (MusicPlaybackManager* self,
                                 gboolean play)
{
	MusicMedia* rv = NULL;
	MusicSettingsMain* main_settings = NULL;
	MusicSettingsMain* _tmp0_;
	MusicSettingsMain* _tmp1_;
	MusicSettingsShuffle _tmp2_;
	MusicSettingsShuffle _tmp3_;
	MusicStaticPlaylist* _tmp162_;
	GeeArrayList* _tmp163_;
	GeeArrayList* _tmp164_;
	MusicMedia* _tmp165_;
	MusicMedia* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	rv = NULL;
	_tmp0_ = music_settings_main_get_default ();
	main_settings = _tmp0_;
	_tmp1_ = main_settings;
	_tmp2_ = music_settings_main_get_shuffle_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != MUSIC_SETTINGS_SHUFFLE_OFF) {
		GeeHashMap* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GeeHashMap* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		MusicMedia* _tmp17_;
		_tmp4_ = self->priv->_current_shuffled;
		_tmp5_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp4_);
		_tmp6_ = _tmp5_;
		g_debug ("PlaybackManager.vala:277: Shuffled size: %d", _tmp6_);
		_tmp7_ = self->priv->_current_shuffled;
		_tmp8_ = gee_map_get_is_empty ((GeeMap*) _tmp7_);
		_tmp9_ = _tmp8_;
		if (_tmp9_) {
			GeeHashMap* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
			_tmp10_ = self->priv->_current;
			_tmp11_ = gee_map_get_is_empty ((GeeMap*) _tmp10_);
			_tmp12_ = _tmp11_;
			if (_tmp12_) {
				MusicLibrary* _tmp13_;
				MusicLibrary* _tmp14_;
				GeeCollection* _tmp15_;
				GeeCollection* _tmp16_;
				_tmp13_ = music_playback_manager_get_library (self);
				_tmp14_ = _tmp13_;
				_tmp15_ = music_library_get_medias (_tmp14_);
				_tmp16_ = _tmp15_;
				music_playback_manager_queue_media (self, _tmp16_);
				_g_object_unref0 (_tmp16_);
			}
			music_playback_manager_reshuffle (self);
		}
		self->priv->_playing_queued_song = FALSE;
		_tmp17_ = self->priv->_current_media;
		if (_tmp17_ == NULL) {
			GeeHashMap* _tmp18_;
			gpointer _tmp19_;
			self->priv->_current_shuffled_index = 0;
			_tmp18_ = self->priv->_current_shuffled;
			_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) 0));
			_g_object_unref0 (rv);
			rv = (MusicMedia*) _tmp19_;
		} else {
			MusicSettingsMain* _tmp20_;
			MusicSettingsRepeat _tmp21_;
			MusicSettingsRepeat _tmp22_;
			_tmp20_ = main_settings;
			_tmp21_ = music_settings_main_get_repeat_mode (_tmp20_);
			_tmp22_ = _tmp21_;
			if (_tmp22_ == MUSIC_SETTINGS_REPEAT_MEDIA) {
				GeeHashMap* _tmp23_;
				gpointer _tmp24_;
				_tmp23_ = self->priv->_current_shuffled;
				_tmp24_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
				_g_object_unref0 (rv);
				rv = (MusicMedia*) _tmp24_;
			} else {
				GeeHashMap* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				_tmp25_ = self->priv->_current_shuffled;
				_tmp26_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp25_);
				_tmp27_ = _tmp26_;
				if (self->priv->_current_shuffled_index == (_tmp27_ - 1)) {
					MusicSettingsMain* _tmp28_;
					MusicSettingsRepeat _tmp29_;
					MusicSettingsRepeat _tmp30_;
					GeeHashMap* _tmp31_;
					gpointer _tmp32_;
					_tmp28_ = main_settings;
					_tmp29_ = music_settings_main_get_repeat_mode (_tmp28_);
					_tmp30_ = _tmp29_;
					if (_tmp30_ == MUSIC_SETTINGS_REPEAT_ALL) {
						self->priv->_current_shuffled_index = 0;
					} else {
						if (play) {
							music_playback_manager_stop_playback (self);
						}
						result = NULL;
						_g_object_unref0 (main_settings);
						_g_object_unref0 (rv);
						return result;
					}
					_tmp31_ = self->priv->_current_shuffled;
					_tmp32_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp31_, (gpointer) ((gintptr) 0));
					_g_object_unref0 (rv);
					rv = (MusicMedia*) _tmp32_;
				} else {
					gboolean _tmp33_ = FALSE;
					if (self->priv->_current_shuffled_index >= 0) {
						GeeHashMap* _tmp34_;
						gint _tmp35_;
						gint _tmp36_;
						_tmp34_ = self->priv->_current_shuffled;
						_tmp35_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp34_);
						_tmp36_ = _tmp35_;
						_tmp33_ = self->priv->_current_shuffled_index < (_tmp36_ - 1);
					} else {
						_tmp33_ = FALSE;
					}
					if (_tmp33_) {
						MusicMedia* next_current = NULL;
						GeeHashMap* _tmp37_;
						gpointer _tmp38_;
						MusicMedia* now_current = NULL;
						GeeHashMap* _tmp39_;
						gpointer _tmp40_;
						gboolean _tmp41_ = FALSE;
						MusicSettingsMain* _tmp42_;
						MusicSettingsRepeat _tmp43_;
						MusicSettingsRepeat _tmp44_;
						GeeHashMap* _tmp82_;
						gpointer _tmp83_;
						_tmp37_ = self->priv->_current_shuffled;
						_tmp38_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp37_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
						next_current = (MusicMedia*) _tmp38_;
						_tmp39_ = self->priv->_current_shuffled;
						_tmp40_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp39_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						now_current = (MusicMedia*) _tmp40_;
						_tmp42_ = main_settings;
						_tmp43_ = music_settings_main_get_repeat_mode (_tmp42_);
						_tmp44_ = _tmp43_;
						if (_tmp44_ == MUSIC_SETTINGS_REPEAT_ARTIST) {
							MusicMedia* _tmp45_;
							const gchar* _tmp46_;
							const gchar* _tmp47_;
							MusicMedia* _tmp48_;
							const gchar* _tmp49_;
							const gchar* _tmp50_;
							_tmp45_ = next_current;
							_tmp46_ = music_media_get_artist (_tmp45_);
							_tmp47_ = _tmp46_;
							_tmp48_ = now_current;
							_tmp49_ = music_media_get_artist (_tmp48_);
							_tmp50_ = _tmp49_;
							_tmp41_ = g_strcmp0 (_tmp47_, _tmp50_) != 0;
						} else {
							_tmp41_ = FALSE;
						}
						if (_tmp41_) {
							while (TRUE) {
								GeeHashMap* _tmp51_;
								gpointer _tmp52_;
								MusicMedia* _tmp53_;
								const gchar* _tmp54_;
								const gchar* _tmp55_;
								MusicMedia* _tmp56_;
								const gchar* _tmp57_;
								const gchar* _tmp58_;
								gboolean _tmp59_;
								gint _tmp60_;
								_tmp51_ = self->priv->_current_shuffled;
								_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp51_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
								_tmp53_ = (MusicMedia*) _tmp52_;
								_tmp54_ = music_media_get_artist (_tmp53_);
								_tmp55_ = _tmp54_;
								_tmp56_ = self->priv->_current_media;
								_tmp57_ = music_media_get_artist (_tmp56_);
								_tmp58_ = _tmp57_;
								_tmp59_ = !(g_strcmp0 (_tmp55_, _tmp58_) == 0);
								_g_object_unref0 (_tmp53_);
								if (_tmp59_) {
									break;
								}
								_tmp60_ = self->priv->_current_shuffled_index;
								self->priv->_current_shuffled_index = _tmp60_ - 1;
							}
						} else {
							gboolean _tmp61_ = FALSE;
							MusicSettingsMain* _tmp62_;
							MusicSettingsRepeat _tmp63_;
							MusicSettingsRepeat _tmp64_;
							_tmp62_ = main_settings;
							_tmp63_ = music_settings_main_get_repeat_mode (_tmp62_);
							_tmp64_ = _tmp63_;
							if (_tmp64_ == MUSIC_SETTINGS_REPEAT_ALBUM) {
								MusicMedia* _tmp65_;
								const gchar* _tmp66_;
								const gchar* _tmp67_;
								MusicMedia* _tmp68_;
								const gchar* _tmp69_;
								const gchar* _tmp70_;
								_tmp65_ = next_current;
								_tmp66_ = music_media_get_album (_tmp65_);
								_tmp67_ = _tmp66_;
								_tmp68_ = now_current;
								_tmp69_ = music_media_get_album (_tmp68_);
								_tmp70_ = _tmp69_;
								_tmp61_ = g_strcmp0 (_tmp67_, _tmp70_) != 0;
							} else {
								_tmp61_ = FALSE;
							}
							if (_tmp61_) {
								while (TRUE) {
									GeeHashMap* _tmp71_;
									gpointer _tmp72_;
									MusicMedia* _tmp73_;
									const gchar* _tmp74_;
									const gchar* _tmp75_;
									MusicMedia* _tmp76_;
									const gchar* _tmp77_;
									const gchar* _tmp78_;
									gboolean _tmp79_;
									gint _tmp80_;
									_tmp71_ = self->priv->_current_shuffled;
									_tmp72_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp71_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
									_tmp73_ = (MusicMedia*) _tmp72_;
									_tmp74_ = music_media_get_album (_tmp73_);
									_tmp75_ = _tmp74_;
									_tmp76_ = self->priv->_current_media;
									_tmp77_ = music_media_get_album (_tmp76_);
									_tmp78_ = _tmp77_;
									_tmp79_ = !(g_strcmp0 (_tmp75_, _tmp78_) == 0);
									_g_object_unref0 (_tmp73_);
									if (_tmp79_) {
										break;
									}
									_tmp80_ = self->priv->_current_shuffled_index;
									self->priv->_current_shuffled_index = _tmp80_ - 1;
								}
							} else {
								gint _tmp81_;
								_tmp81_ = self->priv->_current_shuffled_index;
								self->priv->_current_shuffled_index = _tmp81_ + 1;
							}
						}
						_tmp82_ = self->priv->_current_shuffled;
						_tmp83_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp82_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp83_;
						_g_object_unref0 (now_current);
						_g_object_unref0 (next_current);
					} else {
						GeeHashMap* _tmp84_;
						gpointer _tmp85_;
						self->priv->_current_shuffled_index = 0;
						music_playback_manager_set_shuffle_mode (self, MUSIC_SETTINGS_SHUFFLE_ALL);
						_tmp84_ = self->priv->_current_shuffled;
						_tmp85_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp84_, (gpointer) ((gintptr) 0));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp85_;
					}
				}
			}
		}
	} else {
		GeeHashMap* _tmp86_;
		gboolean _tmp87_;
		gboolean _tmp88_;
		MusicMedia* _tmp93_;
		self->priv->_playing_queued_song = FALSE;
		_tmp86_ = self->priv->_current;
		_tmp87_ = gee_map_get_is_empty ((GeeMap*) _tmp86_);
		_tmp88_ = _tmp87_;
		if (_tmp88_) {
			MusicLibrary* _tmp89_;
			MusicLibrary* _tmp90_;
			GeeCollection* _tmp91_;
			GeeCollection* _tmp92_;
			_tmp89_ = music_playback_manager_get_library (self);
			_tmp90_ = _tmp89_;
			_tmp91_ = music_library_get_medias (_tmp90_);
			_tmp92_ = _tmp91_;
			music_playback_manager_queue_media (self, _tmp92_);
			_g_object_unref0 (_tmp92_);
		}
		_tmp93_ = self->priv->_current_media;
		if (_tmp93_ == NULL) {
			GeeHashMap* _tmp94_;
			gpointer _tmp95_;
			self->priv->_current_index = 0;
			_tmp94_ = self->priv->_current;
			_tmp95_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp94_, (gpointer) ((gintptr) 0));
			_g_object_unref0 (rv);
			rv = (MusicMedia*) _tmp95_;
		} else {
			MusicSettingsMain* _tmp96_;
			MusicSettingsRepeat _tmp97_;
			MusicSettingsRepeat _tmp98_;
			_tmp96_ = main_settings;
			_tmp97_ = music_settings_main_get_repeat_mode (_tmp96_);
			_tmp98_ = _tmp97_;
			if (_tmp98_ == MUSIC_SETTINGS_REPEAT_MEDIA) {
				GeeHashMap* _tmp99_;
				gpointer _tmp100_;
				_tmp99_ = self->priv->_current;
				_tmp100_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp99_, (gpointer) ((gintptr) self->priv->_current_index));
				_g_object_unref0 (rv);
				rv = (MusicMedia*) _tmp100_;
			} else {
				GeeHashMap* _tmp101_;
				gint _tmp102_;
				gint _tmp103_;
				_tmp101_ = self->priv->_current;
				_tmp102_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp101_);
				_tmp103_ = _tmp102_;
				if (self->priv->_current_index == (_tmp103_ - 1)) {
					MusicSettingsMain* _tmp104_;
					MusicSettingsRepeat _tmp105_;
					MusicSettingsRepeat _tmp106_;
					GeeHashMap* _tmp107_;
					gpointer _tmp108_;
					_tmp104_ = main_settings;
					_tmp105_ = music_settings_main_get_repeat_mode (_tmp104_);
					_tmp106_ = _tmp105_;
					if (_tmp106_ == MUSIC_SETTINGS_REPEAT_ALL) {
						self->priv->_current_index = 0;
					} else {
						if (play) {
							music_playback_manager_stop_playback (self);
						}
						result = NULL;
						_g_object_unref0 (main_settings);
						_g_object_unref0 (rv);
						return result;
					}
					_tmp107_ = self->priv->_current;
					_tmp108_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp107_, (gpointer) ((gintptr) 0));
					_g_object_unref0 (rv);
					rv = (MusicMedia*) _tmp108_;
				} else {
					gboolean _tmp109_ = FALSE;
					if (self->priv->_current_index >= 0) {
						GeeHashMap* _tmp110_;
						gint _tmp111_;
						gint _tmp112_;
						_tmp110_ = self->priv->_current;
						_tmp111_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp110_);
						_tmp112_ = _tmp111_;
						_tmp109_ = self->priv->_current_index < (_tmp112_ - 1);
					} else {
						_tmp109_ = FALSE;
					}
					if (_tmp109_) {
						MusicMedia* next_current = NULL;
						GeeHashMap* _tmp113_;
						gpointer _tmp114_;
						MusicMedia* now_current = NULL;
						GeeHashMap* _tmp115_;
						gpointer _tmp116_;
						gboolean _tmp117_ = FALSE;
						MusicSettingsMain* _tmp118_;
						MusicSettingsRepeat _tmp119_;
						MusicSettingsRepeat _tmp120_;
						GeeHashMap* _tmp158_;
						gpointer _tmp159_;
						_tmp113_ = self->priv->_current;
						_tmp114_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp113_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
						next_current = (MusicMedia*) _tmp114_;
						_tmp115_ = self->priv->_current;
						_tmp116_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp115_, (gpointer) ((gintptr) self->priv->_current_index));
						now_current = (MusicMedia*) _tmp116_;
						_tmp118_ = main_settings;
						_tmp119_ = music_settings_main_get_repeat_mode (_tmp118_);
						_tmp120_ = _tmp119_;
						if (_tmp120_ == MUSIC_SETTINGS_REPEAT_ARTIST) {
							MusicMedia* _tmp121_;
							const gchar* _tmp122_;
							const gchar* _tmp123_;
							MusicMedia* _tmp124_;
							const gchar* _tmp125_;
							const gchar* _tmp126_;
							_tmp121_ = next_current;
							_tmp122_ = music_media_get_artist (_tmp121_);
							_tmp123_ = _tmp122_;
							_tmp124_ = now_current;
							_tmp125_ = music_media_get_artist (_tmp124_);
							_tmp126_ = _tmp125_;
							_tmp117_ = g_strcmp0 (_tmp123_, _tmp126_) != 0;
						} else {
							_tmp117_ = FALSE;
						}
						if (_tmp117_) {
							while (TRUE) {
								GeeHashMap* _tmp127_;
								gpointer _tmp128_;
								MusicMedia* _tmp129_;
								const gchar* _tmp130_;
								const gchar* _tmp131_;
								MusicMedia* _tmp132_;
								const gchar* _tmp133_;
								const gchar* _tmp134_;
								gboolean _tmp135_;
								gint _tmp136_;
								_tmp127_ = self->priv->_current;
								_tmp128_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp127_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
								_tmp129_ = (MusicMedia*) _tmp128_;
								_tmp130_ = music_media_get_artist (_tmp129_);
								_tmp131_ = _tmp130_;
								_tmp132_ = self->priv->_current_media;
								_tmp133_ = music_media_get_artist (_tmp132_);
								_tmp134_ = _tmp133_;
								_tmp135_ = !(g_strcmp0 (_tmp131_, _tmp134_) == 0);
								_g_object_unref0 (_tmp129_);
								if (_tmp135_) {
									break;
								}
								_tmp136_ = self->priv->_current_index;
								self->priv->_current_index = _tmp136_ - 1;
							}
						} else {
							gboolean _tmp137_ = FALSE;
							MusicSettingsMain* _tmp138_;
							MusicSettingsRepeat _tmp139_;
							MusicSettingsRepeat _tmp140_;
							_tmp138_ = main_settings;
							_tmp139_ = music_settings_main_get_repeat_mode (_tmp138_);
							_tmp140_ = _tmp139_;
							if (_tmp140_ == MUSIC_SETTINGS_REPEAT_ALBUM) {
								MusicMedia* _tmp141_;
								const gchar* _tmp142_;
								const gchar* _tmp143_;
								MusicMedia* _tmp144_;
								const gchar* _tmp145_;
								const gchar* _tmp146_;
								_tmp141_ = next_current;
								_tmp142_ = music_media_get_album (_tmp141_);
								_tmp143_ = _tmp142_;
								_tmp144_ = now_current;
								_tmp145_ = music_media_get_album (_tmp144_);
								_tmp146_ = _tmp145_;
								_tmp137_ = g_strcmp0 (_tmp143_, _tmp146_) != 0;
							} else {
								_tmp137_ = FALSE;
							}
							if (_tmp137_) {
								while (TRUE) {
									GeeHashMap* _tmp147_;
									gpointer _tmp148_;
									MusicMedia* _tmp149_;
									const gchar* _tmp150_;
									const gchar* _tmp151_;
									MusicMedia* _tmp152_;
									const gchar* _tmp153_;
									const gchar* _tmp154_;
									gboolean _tmp155_;
									gint _tmp156_;
									_tmp147_ = self->priv->_current;
									_tmp148_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp147_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
									_tmp149_ = (MusicMedia*) _tmp148_;
									_tmp150_ = music_media_get_album (_tmp149_);
									_tmp151_ = _tmp150_;
									_tmp152_ = self->priv->_current_media;
									_tmp153_ = music_media_get_album (_tmp152_);
									_tmp154_ = _tmp153_;
									_tmp155_ = !(g_strcmp0 (_tmp151_, _tmp154_) == 0);
									_g_object_unref0 (_tmp149_);
									if (_tmp155_) {
										break;
									}
									_tmp156_ = self->priv->_current_index;
									self->priv->_current_index = _tmp156_ - 1;
								}
							} else {
								gint _tmp157_;
								_tmp157_ = self->priv->_current_index;
								self->priv->_current_index = _tmp157_ + 1;
							}
						}
						_tmp158_ = self->priv->_current;
						_tmp159_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp158_, (gpointer) ((gintptr) self->priv->_current_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp159_;
						_g_object_unref0 (now_current);
						_g_object_unref0 (next_current);
					} else {
						GeeHashMap* _tmp160_;
						gpointer _tmp161_;
						self->priv->_current_index = 0;
						_tmp160_ = self->priv->_current;
						_tmp161_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp160_, (gpointer) ((gintptr) 0));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp161_;
					}
				}
			}
		}
	}
	_tmp162_ = self->queue_playlist;
	_tmp163_ = music_playlist_get_medias ((MusicPlaylist*) _tmp162_);
	_tmp164_ = _tmp163_;
	_tmp165_ = rv;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp164_, _tmp165_)) {
		self->priv->_playing_queued_song = TRUE;
	}
	if (play) {
		MusicMedia* _tmp166_;
		_tmp166_ = rv;
		music_playback_manager_play_media (self, _tmp166_);
	}
	result = rv;
	_g_object_unref0 (main_settings);
	return result;
}

MusicMedia*
music_playback_manager_get_previous (MusicPlaybackManager* self,
                                     gboolean play)
{
	MusicMedia* rv = NULL;
	MusicSettingsMain* main_settings = NULL;
	MusicSettingsMain* _tmp0_;
	MusicSettingsMain* _tmp1_;
	MusicSettingsShuffle _tmp2_;
	MusicSettingsShuffle _tmp3_;
	MusicStaticPlaylist* _tmp176_;
	GeeArrayList* _tmp177_;
	GeeArrayList* _tmp178_;
	MusicMedia* _tmp179_;
	MusicMedia* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	rv = NULL;
	_tmp0_ = music_settings_main_get_default ();
	main_settings = _tmp0_;
	_tmp1_ = main_settings;
	_tmp2_ = music_settings_main_get_shuffle_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != MUSIC_SETTINGS_SHUFFLE_OFF) {
		GeeHashMap* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		MusicMedia* _tmp14_;
		_tmp4_ = self->priv->_current_shuffled;
		_tmp5_ = gee_map_get_is_empty ((GeeMap*) _tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_) {
			GeeHashMap* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
			_tmp7_ = self->priv->_current;
			_tmp8_ = gee_map_get_is_empty ((GeeMap*) _tmp7_);
			_tmp9_ = _tmp8_;
			if (_tmp9_) {
				MusicLibrary* _tmp10_;
				MusicLibrary* _tmp11_;
				GeeCollection* _tmp12_;
				GeeCollection* _tmp13_;
				_tmp10_ = music_playback_manager_get_library (self);
				_tmp11_ = _tmp10_;
				_tmp12_ = music_library_get_medias (_tmp11_);
				_tmp13_ = _tmp12_;
				music_playback_manager_queue_media (self, _tmp13_);
				_g_object_unref0 (_tmp13_);
			}
			music_playback_manager_reshuffle (self);
		}
		self->priv->_playing_queued_song = FALSE;
		_tmp14_ = self->priv->_current_media;
		if (_tmp14_ == NULL) {
			GeeHashMap* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			GeeHashMap* _tmp18_;
			gpointer _tmp19_;
			_tmp15_ = self->priv->_current_shuffled;
			_tmp16_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp15_);
			_tmp17_ = _tmp16_;
			self->priv->_current_shuffled_index = _tmp17_ - 1;
			_tmp18_ = self->priv->_current_shuffled;
			_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
			_g_object_unref0 (rv);
			rv = (MusicMedia*) _tmp19_;
		} else {
			MusicSettingsMain* _tmp20_;
			MusicSettingsRepeat _tmp21_;
			MusicSettingsRepeat _tmp22_;
			_tmp20_ = main_settings;
			_tmp21_ = music_settings_main_get_repeat_mode (_tmp20_);
			_tmp22_ = _tmp21_;
			if (_tmp22_ == MUSIC_SETTINGS_REPEAT_MEDIA) {
				GeeHashMap* _tmp23_;
				gpointer _tmp24_;
				_tmp23_ = self->priv->_current_shuffled;
				_tmp24_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
				_g_object_unref0 (rv);
				rv = (MusicMedia*) _tmp24_;
			} else {
				if (self->priv->_current_shuffled_index == 0) {
					MusicSettingsMain* _tmp25_;
					MusicSettingsRepeat _tmp26_;
					MusicSettingsRepeat _tmp27_;
					GeeHashMap* _tmp31_;
					gpointer _tmp32_;
					_tmp25_ = main_settings;
					_tmp26_ = music_settings_main_get_repeat_mode (_tmp25_);
					_tmp27_ = _tmp26_;
					if (_tmp27_ == MUSIC_SETTINGS_REPEAT_ALL) {
						GeeHashMap* _tmp28_;
						gint _tmp29_;
						gint _tmp30_;
						_tmp28_ = self->priv->_current_shuffled;
						_tmp29_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp28_);
						_tmp30_ = _tmp29_;
						self->priv->_current_shuffled_index = _tmp30_ - 1;
					} else {
						music_playback_manager_stop_playback (self);
						result = NULL;
						_g_object_unref0 (main_settings);
						_g_object_unref0 (rv);
						return result;
					}
					_tmp31_ = self->priv->_current_shuffled;
					_tmp32_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp31_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
					_g_object_unref0 (rv);
					rv = (MusicMedia*) _tmp32_;
				} else {
					gboolean _tmp33_ = FALSE;
					if (self->priv->_current_shuffled_index > 0) {
						GeeHashMap* _tmp34_;
						gint _tmp35_;
						gint _tmp36_;
						_tmp34_ = self->priv->_current_shuffled;
						_tmp35_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp34_);
						_tmp36_ = _tmp35_;
						_tmp33_ = self->priv->_current_shuffled_index < _tmp36_;
					} else {
						_tmp33_ = FALSE;
					}
					if (_tmp33_) {
						gboolean _tmp37_ = FALSE;
						MusicSettingsMain* _tmp38_;
						MusicSettingsRepeat _tmp39_;
						MusicSettingsRepeat _tmp40_;
						GeeHashMap* _tmp83_;
						gpointer _tmp84_;
						_tmp38_ = main_settings;
						_tmp39_ = music_settings_main_get_repeat_mode (_tmp38_);
						_tmp40_ = _tmp39_;
						if (_tmp40_ == MUSIC_SETTINGS_REPEAT_ARTIST) {
							GeeHashMap* _tmp41_;
							gpointer _tmp42_;
							MusicMedia* _tmp43_;
							const gchar* _tmp44_;
							const gchar* _tmp45_;
							GeeHashMap* _tmp46_;
							gpointer _tmp47_;
							MusicMedia* _tmp48_;
							const gchar* _tmp49_;
							const gchar* _tmp50_;
							_tmp41_ = self->priv->_current_shuffled;
							_tmp42_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp41_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
							_tmp43_ = (MusicMedia*) _tmp42_;
							_tmp44_ = music_media_get_artist (_tmp43_);
							_tmp45_ = _tmp44_;
							_tmp46_ = self->priv->_current_shuffled;
							_tmp47_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp46_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
							_tmp48_ = (MusicMedia*) _tmp47_;
							_tmp49_ = music_media_get_artist (_tmp48_);
							_tmp50_ = _tmp49_;
							_tmp37_ = g_strcmp0 (_tmp45_, _tmp50_) != 0;
							_g_object_unref0 (_tmp48_);
							_g_object_unref0 (_tmp43_);
						} else {
							_tmp37_ = FALSE;
						}
						if (_tmp37_) {
							while (TRUE) {
								GeeHashMap* _tmp51_;
								gpointer _tmp52_;
								MusicMedia* _tmp53_;
								const gchar* _tmp54_;
								const gchar* _tmp55_;
								MusicMedia* _tmp56_;
								const gchar* _tmp57_;
								const gchar* _tmp58_;
								gboolean _tmp59_;
								_tmp51_ = self->priv->_current_shuffled;
								_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp51_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
								_tmp53_ = (MusicMedia*) _tmp52_;
								_tmp54_ = music_media_get_artist (_tmp53_);
								_tmp55_ = _tmp54_;
								_tmp56_ = self->priv->_current_media;
								_tmp57_ = music_media_get_artist (_tmp56_);
								_tmp58_ = _tmp57_;
								_tmp59_ = !(g_strcmp0 (_tmp55_, _tmp58_) == 0);
								_g_object_unref0 (_tmp53_);
								if (_tmp59_) {
									break;
								}
								self->priv->_current_shuffled_index = self->priv->_current_shuffled_index + 1;
							}
						} else {
							gboolean _tmp60_ = FALSE;
							MusicSettingsMain* _tmp61_;
							MusicSettingsRepeat _tmp62_;
							MusicSettingsRepeat _tmp63_;
							_tmp61_ = main_settings;
							_tmp62_ = music_settings_main_get_repeat_mode (_tmp61_);
							_tmp63_ = _tmp62_;
							if (_tmp63_ == MUSIC_SETTINGS_REPEAT_ALBUM) {
								GeeHashMap* _tmp64_;
								gpointer _tmp65_;
								MusicMedia* _tmp66_;
								const gchar* _tmp67_;
								const gchar* _tmp68_;
								GeeHashMap* _tmp69_;
								gpointer _tmp70_;
								MusicMedia* _tmp71_;
								const gchar* _tmp72_;
								const gchar* _tmp73_;
								_tmp64_ = self->priv->_current_shuffled;
								_tmp65_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp64_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
								_tmp66_ = (MusicMedia*) _tmp65_;
								_tmp67_ = music_media_get_album (_tmp66_);
								_tmp68_ = _tmp67_;
								_tmp69_ = self->priv->_current_shuffled;
								_tmp70_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp69_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
								_tmp71_ = (MusicMedia*) _tmp70_;
								_tmp72_ = music_media_get_album (_tmp71_);
								_tmp73_ = _tmp72_;
								_tmp60_ = g_strcmp0 (_tmp68_, _tmp73_) != 0;
								_g_object_unref0 (_tmp71_);
								_g_object_unref0 (_tmp66_);
							} else {
								_tmp60_ = FALSE;
							}
							if (_tmp60_) {
								while (TRUE) {
									GeeHashMap* _tmp74_;
									gpointer _tmp75_;
									MusicMedia* _tmp76_;
									const gchar* _tmp77_;
									const gchar* _tmp78_;
									MusicMedia* _tmp79_;
									const gchar* _tmp80_;
									const gchar* _tmp81_;
									gboolean _tmp82_;
									_tmp74_ = self->priv->_current_shuffled;
									_tmp75_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp74_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
									_tmp76_ = (MusicMedia*) _tmp75_;
									_tmp77_ = music_media_get_album (_tmp76_);
									_tmp78_ = _tmp77_;
									_tmp79_ = self->priv->_current_media;
									_tmp80_ = music_media_get_album (_tmp79_);
									_tmp81_ = _tmp80_;
									_tmp82_ = !(g_strcmp0 (_tmp78_, _tmp81_) == 0);
									_g_object_unref0 (_tmp76_);
									if (_tmp82_) {
										break;
									}
									self->priv->_current_shuffled_index = self->priv->_current_shuffled_index + 1;
								}
							} else {
								self->priv->_current_shuffled_index = self->priv->_current_shuffled_index - 1;
							}
						}
						_tmp83_ = self->priv->_current_shuffled;
						_tmp84_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp83_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp84_;
					} else {
						GeeHashMap* _tmp85_;
						gint _tmp86_;
						gint _tmp87_;
						GeeHashMap* _tmp88_;
						gpointer _tmp89_;
						_tmp85_ = self->priv->_current_shuffled;
						_tmp86_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp85_);
						_tmp87_ = _tmp86_;
						self->priv->_current_shuffled_index = _tmp87_ - 1;
						_tmp88_ = self->priv->_current_shuffled;
						_tmp89_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp88_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp89_;
					}
				}
			}
		}
	} else {
		GeeHashMap* _tmp90_;
		gboolean _tmp91_;
		gboolean _tmp92_;
		MusicMedia* _tmp97_;
		self->priv->_playing_queued_song = FALSE;
		_tmp90_ = self->priv->_current;
		_tmp91_ = gee_map_get_is_empty ((GeeMap*) _tmp90_);
		_tmp92_ = _tmp91_;
		if (_tmp92_) {
			MusicLibrary* _tmp93_;
			MusicLibrary* _tmp94_;
			GeeCollection* _tmp95_;
			GeeCollection* _tmp96_;
			_tmp93_ = music_playback_manager_get_library (self);
			_tmp94_ = _tmp93_;
			_tmp95_ = music_library_get_medias (_tmp94_);
			_tmp96_ = _tmp95_;
			music_playback_manager_queue_media (self, _tmp96_);
			_g_object_unref0 (_tmp96_);
		}
		_tmp97_ = self->priv->_current_media;
		if (_tmp97_ == NULL) {
			GeeHashMap* _tmp98_;
			gint _tmp99_;
			gint _tmp100_;
			GeeHashMap* _tmp101_;
			gpointer _tmp102_;
			_tmp98_ = self->priv->_current;
			_tmp99_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp98_);
			_tmp100_ = _tmp99_;
			self->priv->_current_index = _tmp100_ - 1;
			_tmp101_ = self->priv->_current;
			_tmp102_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp101_, (gpointer) ((gintptr) self->priv->_current_index));
			_g_object_unref0 (rv);
			rv = (MusicMedia*) _tmp102_;
		} else {
			MusicSettingsMain* _tmp103_;
			MusicSettingsRepeat _tmp104_;
			MusicSettingsRepeat _tmp105_;
			_tmp103_ = main_settings;
			_tmp104_ = music_settings_main_get_repeat_mode (_tmp103_);
			_tmp105_ = _tmp104_;
			if (_tmp105_ == MUSIC_SETTINGS_REPEAT_MEDIA) {
				GeeHashMap* _tmp106_;
				gpointer _tmp107_;
				_tmp106_ = self->priv->_current;
				_tmp107_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp106_, (gpointer) ((gintptr) self->priv->_current_index));
				_g_object_unref0 (rv);
				rv = (MusicMedia*) _tmp107_;
			} else {
				if (self->priv->_current_index == 0) {
					MusicSettingsMain* _tmp108_;
					MusicSettingsRepeat _tmp109_;
					MusicSettingsRepeat _tmp110_;
					GeeHashMap* _tmp114_;
					gpointer _tmp115_;
					_tmp108_ = main_settings;
					_tmp109_ = music_settings_main_get_repeat_mode (_tmp108_);
					_tmp110_ = _tmp109_;
					if (_tmp110_ == MUSIC_SETTINGS_REPEAT_ALL) {
						GeeHashMap* _tmp111_;
						gint _tmp112_;
						gint _tmp113_;
						_tmp111_ = self->priv->_current;
						_tmp112_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp111_);
						_tmp113_ = _tmp112_;
						self->priv->_current_index = _tmp113_ - 1;
					} else {
						music_playback_manager_stop_playback (self);
						result = NULL;
						_g_object_unref0 (main_settings);
						_g_object_unref0 (rv);
						return result;
					}
					_tmp114_ = self->priv->_current;
					_tmp115_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp114_, (gpointer) ((gintptr) self->priv->_current_index));
					_g_object_unref0 (rv);
					rv = (MusicMedia*) _tmp115_;
				} else {
					gboolean _tmp116_ = FALSE;
					if (self->priv->_current_index > 0) {
						GeeHashMap* _tmp117_;
						gint _tmp118_;
						gint _tmp119_;
						_tmp117_ = self->priv->_current;
						_tmp118_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp117_);
						_tmp119_ = _tmp118_;
						_tmp116_ = self->priv->_current_index < _tmp119_;
					} else {
						_tmp116_ = FALSE;
					}
					if (_tmp116_) {
						gboolean _tmp120_ = FALSE;
						MusicSettingsMain* _tmp121_;
						MusicSettingsRepeat _tmp122_;
						MusicSettingsRepeat _tmp123_;
						GeeHashMap* _tmp169_;
						gpointer _tmp170_;
						_tmp121_ = main_settings;
						_tmp122_ = music_settings_main_get_repeat_mode (_tmp121_);
						_tmp123_ = _tmp122_;
						if (_tmp123_ == MUSIC_SETTINGS_REPEAT_ARTIST) {
							GeeHashMap* _tmp124_;
							gpointer _tmp125_;
							MusicMedia* _tmp126_;
							const gchar* _tmp127_;
							const gchar* _tmp128_;
							GeeHashMap* _tmp129_;
							gpointer _tmp130_;
							MusicMedia* _tmp131_;
							const gchar* _tmp132_;
							const gchar* _tmp133_;
							_tmp124_ = self->priv->_current;
							_tmp125_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp124_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
							_tmp126_ = (MusicMedia*) _tmp125_;
							_tmp127_ = music_media_get_artist (_tmp126_);
							_tmp128_ = _tmp127_;
							_tmp129_ = self->priv->_current;
							_tmp130_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp129_, (gpointer) ((gintptr) self->priv->_current_index));
							_tmp131_ = (MusicMedia*) _tmp130_;
							_tmp132_ = music_media_get_artist (_tmp131_);
							_tmp133_ = _tmp132_;
							_tmp120_ = g_strcmp0 (_tmp128_, _tmp133_) != 0;
							_g_object_unref0 (_tmp131_);
							_g_object_unref0 (_tmp126_);
						} else {
							_tmp120_ = FALSE;
						}
						if (_tmp120_) {
							while (TRUE) {
								GeeHashMap* _tmp134_;
								gpointer _tmp135_;
								MusicMedia* _tmp136_;
								const gchar* _tmp137_;
								const gchar* _tmp138_;
								MusicMedia* _tmp139_;
								const gchar* _tmp140_;
								const gchar* _tmp141_;
								gboolean _tmp142_;
								gint _tmp143_;
								_tmp134_ = self->priv->_current;
								_tmp135_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp134_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
								_tmp136_ = (MusicMedia*) _tmp135_;
								_tmp137_ = music_media_get_artist (_tmp136_);
								_tmp138_ = _tmp137_;
								_tmp139_ = self->priv->_current_media;
								_tmp140_ = music_media_get_artist (_tmp139_);
								_tmp141_ = _tmp140_;
								_tmp142_ = !(g_strcmp0 (_tmp138_, _tmp141_) == 0);
								_g_object_unref0 (_tmp136_);
								if (_tmp142_) {
									break;
								}
								_tmp143_ = self->priv->_current_index;
								self->priv->_current_index = _tmp143_ + 1;
							}
						} else {
							gboolean _tmp144_ = FALSE;
							MusicSettingsMain* _tmp145_;
							MusicSettingsRepeat _tmp146_;
							MusicSettingsRepeat _tmp147_;
							_tmp145_ = main_settings;
							_tmp146_ = music_settings_main_get_repeat_mode (_tmp145_);
							_tmp147_ = _tmp146_;
							if (_tmp147_ == MUSIC_SETTINGS_REPEAT_ALBUM) {
								GeeHashMap* _tmp148_;
								gpointer _tmp149_;
								MusicMedia* _tmp150_;
								const gchar* _tmp151_;
								const gchar* _tmp152_;
								GeeHashMap* _tmp153_;
								gpointer _tmp154_;
								MusicMedia* _tmp155_;
								const gchar* _tmp156_;
								const gchar* _tmp157_;
								_tmp148_ = self->priv->_current;
								_tmp149_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp148_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
								_tmp150_ = (MusicMedia*) _tmp149_;
								_tmp151_ = music_media_get_album (_tmp150_);
								_tmp152_ = _tmp151_;
								_tmp153_ = self->priv->_current;
								_tmp154_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp153_, (gpointer) ((gintptr) self->priv->_current_index));
								_tmp155_ = (MusicMedia*) _tmp154_;
								_tmp156_ = music_media_get_album (_tmp155_);
								_tmp157_ = _tmp156_;
								_tmp144_ = g_strcmp0 (_tmp152_, _tmp157_) != 0;
								_g_object_unref0 (_tmp155_);
								_g_object_unref0 (_tmp150_);
							} else {
								_tmp144_ = FALSE;
							}
							if (_tmp144_) {
								while (TRUE) {
									GeeHashMap* _tmp158_;
									gpointer _tmp159_;
									MusicMedia* _tmp160_;
									const gchar* _tmp161_;
									const gchar* _tmp162_;
									MusicMedia* _tmp163_;
									const gchar* _tmp164_;
									const gchar* _tmp165_;
									gboolean _tmp166_;
									gint _tmp167_;
									_tmp158_ = self->priv->_current;
									_tmp159_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp158_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
									_tmp160_ = (MusicMedia*) _tmp159_;
									_tmp161_ = music_media_get_album (_tmp160_);
									_tmp162_ = _tmp161_;
									_tmp163_ = self->priv->_current_media;
									_tmp164_ = music_media_get_album (_tmp163_);
									_tmp165_ = _tmp164_;
									_tmp166_ = !(g_strcmp0 (_tmp162_, _tmp165_) == 0);
									_g_object_unref0 (_tmp160_);
									if (_tmp166_) {
										break;
									}
									_tmp167_ = self->priv->_current_index;
									self->priv->_current_index = _tmp167_ + 1;
								}
							} else {
								gint _tmp168_;
								_tmp168_ = self->priv->_current_index;
								self->priv->_current_index = _tmp168_ - 1;
							}
						}
						_tmp169_ = self->priv->_current;
						_tmp170_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp169_, (gpointer) ((gintptr) self->priv->_current_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp170_;
					} else {
						GeeHashMap* _tmp171_;
						gint _tmp172_;
						gint _tmp173_;
						GeeHashMap* _tmp174_;
						gpointer _tmp175_;
						_tmp171_ = self->priv->_current;
						_tmp172_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp171_);
						_tmp173_ = _tmp172_;
						self->priv->_current_index = _tmp173_ - 1;
						_tmp174_ = self->priv->_current;
						_tmp175_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp174_, (gpointer) ((gintptr) self->priv->_current_index));
						_g_object_unref0 (rv);
						rv = (MusicMedia*) _tmp175_;
					}
				}
			}
		}
	}
	_tmp176_ = self->queue_playlist;
	_tmp177_ = music_playlist_get_medias ((MusicPlaylist*) _tmp176_);
	_tmp178_ = _tmp177_;
	_tmp179_ = rv;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp178_, _tmp179_)) {
		self->priv->_playing_queued_song = TRUE;
	}
	if (play) {
		MusicMedia* _tmp180_;
		_tmp180_ = rv;
		music_playback_manager_play_media (self, _tmp180_);
	}
	result = rv;
	_g_object_unref0 (main_settings);
	return result;
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		MusicPlaybackManager* self;
		self = _data10_->self;
		_g_object_unref0 (_data10_->m);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}

static gboolean
__lambda30_ (Block10Data* _data10_)
{
	MusicPlaybackManager* self;
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	self = _data10_->self;
	if (_data10_->m != NULL) {
		MusicMedia* _tmp1_;
		_tmp1_ = self->priv->_current_media;
		_tmp0_ = _tmp1_ == _data10_->m;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		MusicHistoryPlaylist* _tmp2_;
		guint player_duration_s = 0U;
		MusicPlayback* _tmp3_;
		_tmp2_ = self->history_playlist;
		music_playlist_add_media ((MusicPlaylist*) _tmp2_, _data10_->m);
		_tmp3_ = self->player;
		player_duration_s = (guint) (music_playback_get_duration (_tmp3_) / MUSIC_TIME_UTILS_NANO_INV);
		if (player_duration_s > ((guint) 1)) {
			gint delta_s = 0;
			guint _tmp4_;
			guint _tmp5_;
			_tmp4_ = music_media_get_length (_data10_->m);
			_tmp5_ = _tmp4_;
			delta_s = ((gint) player_duration_s) - ((gint) (_tmp5_ / MUSIC_TIME_UTILS_MILI_INV));
			if (fabs ((gdouble) delta_s) > ((gdouble) 3)) {
				MusicLibrary* _tmp6_;
				MusicLibrary* _tmp7_;
				music_media_set_length (_data10_->m, (guint) (player_duration_s * MUSIC_TIME_UTILS_MILI_INV));
				_tmp6_ = music_playback_manager_get_library (self);
				_tmp7_ = _tmp6_;
				music_library_update_media (_tmp7_, _data10_->m, FALSE, FALSE);
			}
		}
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda30__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda30_ (self);
	return result;
}

void
music_playback_manager_play_media (MusicPlaybackManager* self,
                                   MusicMedia* m)
{
	Block10Data* _data10_;
	MusicMedia* _tmp0_;
	gint64 old_id = 0LL;
	MusicMedia* _tmp1_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean found = FALSE;
	GFile* _tmp41_;
	GFile* _tmp42_;
	MusicPlayback* _tmp52_;
	gboolean _tmp53_;
	gboolean _tmp55_ = FALSE;
	gint64 _tmp56_;
	gint64 _tmp57_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (m);
	_g_object_unref0 (_data10_->m);
	_data10_->m = _tmp0_;
	old_id = (gint64) -1;
	_tmp1_ = self->priv->_current_media;
	if (_tmp1_ != NULL) {
		MusicMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
		_tmp2_ = self->priv->_current_media;
		_tmp3_ = music_media_get_rowid (_tmp2_);
		_tmp4_ = _tmp3_;
		old_id = _tmp4_;
	}
	music_playback_manager_set_current_media (self, _data10_->m);
	_tmp5_ = music_media_get_location_unknown (_data10_->m);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gboolean _tmp12_;
		_tmp7_ = music_media_get_uri (_data10_->m);
		_tmp8_ = _tmp7_;
		_tmp9_ = _tmp8_;
		_tmp10_ = g_file_new_for_uri (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_file_query_exists (_tmp11_, NULL);
		_g_object_unref0 (_tmp11_);
		_g_free0 (_tmp9_);
		if (_tmp12_) {
			music_media_set_location_unknown (_data10_->m, FALSE);
			music_media_set_unique_status_image (_data10_->m, NULL);
		} else {
			music_playback_manager_stop_playback (self);
			block10_data_unref (_data10_);
			_data10_ = NULL;
			return;
		}
	}
	found = FALSE;
	{
		GeeTreeSet* _tmp13_;
		_tmp13_ = self->priv->playbacks;
		g_rec_mutex_lock (&self->priv->__lock_playbacks);
		{
			{
				GeeIterator* _playback_it = NULL;
				GeeTreeSet* _tmp14_;
				GeeIterator* _tmp15_;
				_tmp14_ = self->priv->playbacks;
				_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
				_playback_it = _tmp15_;
				while (TRUE) {
					GeeIterator* _tmp16_;
					MusicPlayback* playback = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
					_tmp16_ = _playback_it;
					if (!gee_iterator_next (_tmp16_)) {
						break;
					}
					_tmp17_ = _playback_it;
					_tmp18_ = gee_iterator_get (_tmp17_);
					playback = (MusicPlayback*) _tmp18_;
					{
						GeeIterator* _supported_uri_it = NULL;
						MusicPlayback* _tmp19_;
						GeeCollection* _tmp20_;
						GeeCollection* _tmp21_;
						GeeIterator* _tmp22_;
						GeeIterator* _tmp23_;
						_tmp19_ = playback;
						_tmp20_ = music_playback_get_supported_uri (_tmp19_);
						_tmp21_ = _tmp20_;
						_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
						_tmp23_ = _tmp22_;
						_g_object_unref0 (_tmp21_);
						_supported_uri_it = _tmp23_;
						while (TRUE) {
							GeeIterator* _tmp24_;
							gchar* supported_uri = NULL;
							GeeIterator* _tmp25_;
							gpointer _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
							gchar* _tmp29_;
							const gchar* _tmp30_;
							gboolean _tmp31_;
							_tmp24_ = _supported_uri_it;
							if (!gee_iterator_next (_tmp24_)) {
								break;
							}
							_tmp25_ = _supported_uri_it;
							_tmp26_ = gee_iterator_get (_tmp25_);
							supported_uri = (gchar*) _tmp26_;
							_tmp27_ = music_media_get_uri (_data10_->m);
							_tmp28_ = _tmp27_;
							_tmp29_ = _tmp28_;
							_tmp30_ = supported_uri;
							_tmp31_ = g_str_has_prefix (_tmp29_, _tmp30_);
							_g_free0 (_tmp29_);
							if (_tmp31_) {
								MusicPlayback* _tmp32_;
								MusicPlayback* _tmp33_;
								MusicPlayback* _tmp34_;
								MusicPlayback* _tmp35_;
								_tmp32_ = self->player;
								self->priv->saved_volume = music_playback_get_volume (_tmp32_);
								g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL], 0);
								_tmp33_ = self->player;
								music_playback_set_state (_tmp33_, GST_STATE_NULL);
								found = TRUE;
								_tmp34_ = playback;
								_tmp35_ = _g_object_ref0 (_tmp34_);
								_g_object_unref0 (self->player);
								self->player = _tmp35_;
								music_playback_manager_set_volume (self, self->priv->saved_volume);
								g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL], 0);
								_g_free0 (supported_uri);
								break;
							}
							_g_free0 (supported_uri);
						}
						_g_object_unref0 (_supported_uri_it);
					}
					if (found == TRUE) {
						break;
					}
				}
				_g_object_unref0 (_playback_it);
			}
		}
		__finally19:
		{
			GeeTreeSet* _tmp36_;
			_tmp36_ = self->priv->playbacks;
			g_rec_mutex_unlock (&self->priv->__lock_playbacks);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			block10_data_unref (_data10_);
			_data10_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (!found) {
		GThemedIcon* _tmp37_;
		GThemedIcon* _tmp38_;
		MusicMedia* _tmp39_;
		MusicMedia* _tmp40_;
		_tmp37_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
		_tmp38_ = _tmp37_;
		music_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp38_);
		_g_object_unref0 (_tmp38_);
		_tmp39_ = music_playback_manager_get_next (self, TRUE);
		_tmp40_ = _tmp39_;
		_g_object_unref0 (_tmp40_);
		block10_data_unref (_data10_);
		_data10_ = NULL;
		return;
	}
	_tmp41_ = music_media_get_file (_data10_->m);
	_tmp42_ = _tmp41_;
	if (!g_file_query_exists (_tmp42_, NULL)) {
		GThemedIcon* _tmp43_;
		GThemedIcon* _tmp44_;
		MusicMedia* _tmp45_;
		MusicMedia* _tmp46_;
		_tmp43_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
		_tmp44_ = _tmp43_;
		music_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp44_);
		_g_object_unref0 (_tmp44_);
		music_media_set_location_unknown (_data10_->m, TRUE);
		_tmp45_ = music_playback_manager_get_next (self, TRUE);
		_tmp46_ = _tmp45_;
		_g_object_unref0 (_tmp46_);
		block10_data_unref (_data10_);
		_data10_ = NULL;
		return;
	} else {
		gboolean _tmp47_ = FALSE;
		gboolean _tmp48_;
		gboolean _tmp49_;
		_tmp48_ = music_media_get_location_unknown (_data10_->m);
		_tmp49_ = _tmp48_;
		if (_tmp49_) {
			GIcon* _tmp50_;
			GIcon* _tmp51_;
			_tmp50_ = music_media_get_unique_status_image (_data10_->m);
			_tmp51_ = _tmp50_;
			_tmp47_ = _tmp51_ != NULL;
		} else {
			_tmp47_ = FALSE;
		}
		if (_tmp47_) {
			music_media_set_unique_status_image (_data10_->m, NULL);
			music_media_set_location_unknown (_data10_->m, FALSE);
		}
	}
	music_playback_manager_change_gains_thread (self);
	_tmp52_ = self->player;
	music_playback_set_media (_tmp52_, _data10_->m);
	_tmp53_ = self->priv->_playing;
	if (!_tmp53_) {
		MusicPlayback* _tmp54_;
		_tmp54_ = self->player;
		music_playback_pause (_tmp54_);
	}
	_tmp56_ = music_media_get_rowid (_data10_->m);
	_tmp57_ = _tmp56_;
	if (_tmp57_ >= ((gint64) 0)) {
		MusicSettingsMain* _tmp58_;
		MusicSettingsMain* _tmp59_;
		_tmp58_ = music_settings_main_get_default ();
		_tmp59_ = _tmp58_;
		_tmp55_ = !music_settings_main_privacy_mode_enabled (_tmp59_);
		_g_object_unref0 (_tmp59_);
	} else {
		_tmp55_ = FALSE;
	}
	if (_tmp55_) {
		GSettings* _tmp60_;
		GSettings* _tmp61_;
		gint64 _tmp62_;
		gint64 _tmp63_;
		_tmp60_ = music_app_get_saved_state ();
		_tmp61_ = _tmp60_;
		_tmp62_ = music_media_get_rowid (_data10_->m);
		_tmp63_ = _tmp62_;
		g_settings_set_int64 (_tmp61_, "last-media-playing", _tmp63_);
	}
	if (_data10_->m != NULL) {
		g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL], 0, _data10_->m);
	}
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda30__gsource_func, block10_data_ref (_data10_), block10_data_unref);
	block10_data_unref (_data10_);
	_data10_ = NULL;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

void
music_playback_manager_change_gains_thread (MusicPlaybackManager* self)
{
	MusicSettingsEqualizer* equalizer_settings = NULL;
	MusicSettingsEqualizer* _tmp0_;
	MusicSettingsEqualizer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_settings_equalizer_get_default ();
	equalizer_settings = _tmp0_;
	_tmp1_ = equalizer_settings;
	_tmp2_ = music_settings_equalizer_get_equalizer_enabled (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		gboolean automatic_enabled = FALSE;
		MusicSettingsEqualizer* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		gchar* selected_preset = NULL;
		MusicSettingsEqualizer* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp4_ = equalizer_settings;
		_tmp5_ = music_settings_equalizer_get_auto_switch_preset (_tmp4_);
		_tmp6_ = _tmp5_;
		automatic_enabled = _tmp6_;
		_tmp7_ = equalizer_settings;
		_tmp8_ = music_settings_equalizer_get_selected_preset (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strdup (_tmp9_);
		selected_preset = _tmp10_;
		{
			GeeIterator* _p_it = NULL;
			MusicSettingsEqualizer* _tmp11_;
			GeeCollection* _tmp12_;
			GeeCollection* _tmp13_;
			GeeIterator* _tmp14_;
			GeeIterator* _tmp15_;
			_tmp11_ = equalizer_settings;
			_tmp12_ = music_settings_equalizer_get_presets (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
			_tmp15_ = _tmp14_;
			_g_object_unref0 (_tmp13_);
			_p_it = _tmp15_;
			while (TRUE) {
				GeeIterator* _tmp16_;
				MusicEqualizerPreset* p = NULL;
				GeeIterator* _tmp17_;
				gpointer _tmp18_;
				gboolean _tmp19_ = FALSE;
				MusicEqualizerPreset* _tmp20_;
				_tmp16_ = _p_it;
				if (!gee_iterator_next (_tmp16_)) {
					break;
				}
				_tmp17_ = _p_it;
				_tmp18_ = gee_iterator_get (_tmp17_);
				p = (MusicEqualizerPreset*) _tmp18_;
				_tmp20_ = p;
				if (_tmp20_ != NULL) {
					MusicMedia* _tmp21_;
					_tmp21_ = self->priv->_current_media;
					_tmp19_ = _tmp21_ != NULL;
				} else {
					_tmp19_ = FALSE;
				}
				if (_tmp19_) {
					gchar* preset_name = NULL;
					MusicEqualizerPreset* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* media_genre = NULL;
					MusicMedia* _tmp26_;
					const gchar* _tmp27_;
					const gchar* _tmp28_;
					gchar* _tmp29_;
					gboolean _tmp30_ = FALSE;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean match_genre = FALSE;
					gboolean _tmp35_ = FALSE;
					gboolean _tmp36_ = FALSE;
					_tmp22_ = p;
					_tmp23_ = music_equalizer_preset_get_name (_tmp22_);
					_tmp24_ = _tmp23_;
					_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
					preset_name = _tmp25_;
					_tmp26_ = self->priv->_current_media;
					_tmp27_ = music_media_get_genre (_tmp26_);
					_tmp28_ = _tmp27_;
					_tmp29_ = g_utf8_strdown (_tmp28_, (gssize) -1);
					media_genre = _tmp29_;
					_tmp31_ = media_genre;
					_tmp32_ = preset_name;
					if (string_contains (_tmp31_, _tmp32_)) {
						_tmp30_ = TRUE;
					} else {
						const gchar* _tmp33_;
						const gchar* _tmp34_;
						_tmp33_ = preset_name;
						_tmp34_ = media_genre;
						_tmp30_ = string_contains (_tmp33_, _tmp34_);
					}
					match_genre = _tmp30_;
					if (automatic_enabled) {
						_tmp36_ = match_genre;
					} else {
						_tmp36_ = FALSE;
					}
					if (_tmp36_) {
						_tmp35_ = TRUE;
					} else {
						gboolean _tmp37_ = FALSE;
						if (!automatic_enabled) {
							MusicEqualizerPreset* _tmp38_;
							const gchar* _tmp39_;
							const gchar* _tmp40_;
							const gchar* _tmp41_;
							_tmp38_ = p;
							_tmp39_ = music_equalizer_preset_get_name (_tmp38_);
							_tmp40_ = _tmp39_;
							_tmp41_ = selected_preset;
							_tmp37_ = g_strcmp0 (_tmp40_, _tmp41_) == 0;
						} else {
							_tmp37_ = FALSE;
						}
						_tmp35_ = _tmp37_;
					}
					if (_tmp35_) {
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp42_ = FALSE;
								_tmp42_ = TRUE;
								while (TRUE) {
									MusicPlayback* _tmp44_;
									MusicEqualizerPreset* _tmp45_;
									if (!_tmp42_) {
										gint _tmp43_;
										_tmp43_ = i;
										i = _tmp43_ + 1;
									}
									_tmp42_ = FALSE;
									if (!(i < 10)) {
										break;
									}
									_tmp44_ = self->player;
									_tmp45_ = p;
									music_playback_set_equalizer_gain (_tmp44_, i, music_equalizer_preset_get_gain (_tmp45_, i));
								}
							}
						}
						_g_free0 (media_genre);
						_g_free0 (preset_name);
						_g_object_unref0 (p);
						_g_object_unref0 (_p_it);
						_g_free0 (selected_preset);
						_g_object_unref0 (equalizer_settings);
						return;
					}
					_g_free0 (media_genre);
					_g_free0 (preset_name);
				}
				_g_object_unref0 (p);
			}
			_g_object_unref0 (_p_it);
		}
		{
			GeeIterator* _p_it = NULL;
			GeeCollection* _tmp46_;
			GeeCollection* _tmp47_;
			GeeIterator* _tmp48_;
			GeeIterator* _tmp49_;
			_tmp46_ = music_equalizer_get_default_presets ();
			_tmp47_ = _tmp46_;
			_tmp48_ = gee_iterable_iterator ((GeeIterable*) _tmp47_);
			_tmp49_ = _tmp48_;
			_g_object_unref0 (_tmp47_);
			_p_it = _tmp49_;
			while (TRUE) {
				GeeIterator* _tmp50_;
				MusicEqualizerPreset* p = NULL;
				GeeIterator* _tmp51_;
				gpointer _tmp52_;
				gboolean _tmp53_ = FALSE;
				MusicEqualizerPreset* _tmp54_;
				_tmp50_ = _p_it;
				if (!gee_iterator_next (_tmp50_)) {
					break;
				}
				_tmp51_ = _p_it;
				_tmp52_ = gee_iterator_get (_tmp51_);
				p = (MusicEqualizerPreset*) _tmp52_;
				_tmp54_ = p;
				if (_tmp54_ != NULL) {
					MusicMedia* _tmp55_;
					_tmp55_ = self->priv->_current_media;
					_tmp53_ = _tmp55_ != NULL;
				} else {
					_tmp53_ = FALSE;
				}
				if (_tmp53_) {
					gchar* preset_name = NULL;
					MusicEqualizerPreset* _tmp56_;
					const gchar* _tmp57_;
					const gchar* _tmp58_;
					gchar* _tmp59_;
					gchar* media_genre = NULL;
					MusicMedia* _tmp60_;
					const gchar* _tmp61_;
					const gchar* _tmp62_;
					gchar* _tmp63_;
					gboolean _tmp64_ = FALSE;
					const gchar* _tmp65_;
					const gchar* _tmp66_;
					gboolean match_genre = FALSE;
					gboolean _tmp69_ = FALSE;
					gboolean _tmp70_ = FALSE;
					_tmp56_ = p;
					_tmp57_ = music_equalizer_preset_get_name (_tmp56_);
					_tmp58_ = _tmp57_;
					_tmp59_ = g_utf8_strdown (_tmp58_, (gssize) -1);
					preset_name = _tmp59_;
					_tmp60_ = self->priv->_current_media;
					_tmp61_ = music_media_get_genre (_tmp60_);
					_tmp62_ = _tmp61_;
					_tmp63_ = g_utf8_strdown (_tmp62_, (gssize) -1);
					media_genre = _tmp63_;
					_tmp65_ = media_genre;
					_tmp66_ = preset_name;
					if (string_contains (_tmp65_, _tmp66_)) {
						_tmp64_ = TRUE;
					} else {
						const gchar* _tmp67_;
						const gchar* _tmp68_;
						_tmp67_ = preset_name;
						_tmp68_ = media_genre;
						_tmp64_ = string_contains (_tmp67_, _tmp68_);
					}
					match_genre = _tmp64_;
					if (automatic_enabled) {
						_tmp70_ = match_genre;
					} else {
						_tmp70_ = FALSE;
					}
					if (_tmp70_) {
						_tmp69_ = TRUE;
					} else {
						gboolean _tmp71_ = FALSE;
						if (!automatic_enabled) {
							MusicEqualizerPreset* _tmp72_;
							const gchar* _tmp73_;
							const gchar* _tmp74_;
							const gchar* _tmp75_;
							_tmp72_ = p;
							_tmp73_ = music_equalizer_preset_get_name (_tmp72_);
							_tmp74_ = _tmp73_;
							_tmp75_ = selected_preset;
							_tmp71_ = g_strcmp0 (_tmp74_, _tmp75_) == 0;
						} else {
							_tmp71_ = FALSE;
						}
						_tmp69_ = _tmp71_;
					}
					if (_tmp69_) {
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp76_ = FALSE;
								_tmp76_ = TRUE;
								while (TRUE) {
									MusicPlayback* _tmp78_;
									MusicEqualizerPreset* _tmp79_;
									if (!_tmp76_) {
										gint _tmp77_;
										_tmp77_ = i;
										i = _tmp77_ + 1;
									}
									_tmp76_ = FALSE;
									if (!(i < 10)) {
										break;
									}
									_tmp78_ = self->player;
									_tmp79_ = p;
									music_playback_set_equalizer_gain (_tmp78_, i, music_equalizer_preset_get_gain (_tmp79_, i));
								}
							}
						}
						_g_free0 (media_genre);
						_g_free0 (preset_name);
						_g_object_unref0 (p);
						_g_object_unref0 (_p_it);
						_g_free0 (selected_preset);
						_g_object_unref0 (equalizer_settings);
						return;
					}
					_g_free0 (media_genre);
					_g_free0 (preset_name);
				}
				_g_object_unref0 (p);
			}
			_g_object_unref0 (_p_it);
		}
		_g_free0 (selected_preset);
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp80_ = FALSE;
			_tmp80_ = TRUE;
			while (TRUE) {
				MusicPlayback* _tmp81_;
				if (!_tmp80_) {
					i = i + 1;
				}
				_tmp80_ = FALSE;
				if (!(i < 10)) {
					break;
				}
				_tmp81_ = self->player;
				music_playback_set_equalizer_gain (_tmp81_, i, 0);
			}
		}
	}
	_g_object_unref0 (equalizer_settings);
}

void
music_playback_manager_stop_playback (MusicPlaybackManager* self)
{
	MusicPlayback* _tmp0_;
	gint64 was_playing = 0LL;
	MusicMedia* _tmp1_;
	MusicSettingsMain* _tmp5_;
	MusicSettingsMain* _tmp6_;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	music_playback_pause (_tmp0_);
	music_playback_manager_set_playing (self, FALSE);
	was_playing = (gint64) 0;
	_tmp1_ = self->priv->_current_media;
	if (_tmp1_ != NULL) {
		MusicMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
		_tmp2_ = self->priv->_current_media;
		_tmp3_ = music_media_get_rowid (_tmp2_);
		_tmp4_ = _tmp3_;
		was_playing = _tmp4_;
	}
	_tmp5_ = music_settings_main_get_default ();
	_tmp6_ = _tmp5_;
	_tmp7_ = !music_settings_main_privacy_mode_enabled (_tmp6_);
	_g_object_unref0 (_tmp6_);
	if (_tmp7_) {
		GSettings* _tmp8_;
		GSettings* _tmp9_;
		_tmp8_ = music_app_get_saved_state ();
		_tmp9_ = _tmp8_;
		g_settings_set_int64 (_tmp9_, "last-media-playing", (gint64) 0);
	}
	music_playback_manager_set_current_media (self, NULL);
	g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL], 0, was_playing);
}

static GVariant*
_variant_new4 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

void
music_playback_manager_start_playback (MusicPlaybackManager* self)
{
	MusicPlayback* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	GAction* _tmp3_;
	GVariant* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	music_playback_play (_tmp0_);
	music_playback_manager_set_playing (self, TRUE);
	_tmp1_ = music_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) _tmp2_, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
	_tmp4_ = _variant_new4 (TRUE);
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction), _tmp4_);
	_g_variant_unref0 (_tmp4_);
	g_signal_emit (self, music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL], 0);
}

static GVariant*
_variant_new5 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

void
music_playback_manager_pause_playback (MusicPlaybackManager* self)
{
	MusicPlayback* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	GAction* _tmp3_;
	GVariant* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	music_playback_pause (_tmp0_);
	music_playback_manager_set_playing (self, FALSE);
	_tmp1_ = music_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) _tmp2_, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
	_tmp4_ = _variant_new5 (FALSE);
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction), _tmp4_);
	_g_variant_unref0 (_tmp4_);
}

MusicPlaybackManager*
music_playback_manager_construct (GType object_type)
{
	MusicPlaybackManager * self = NULL;
	self = (MusicPlaybackManager*) g_object_new (object_type, NULL);
	return self;
}

MusicPlaybackManager*
music_playback_manager_new (void)
{
	return music_playback_manager_construct (MUSIC_TYPE_PLAYBACK_MANAGER);
}

static MusicLibrary*
music_playback_manager_get_library (MusicPlaybackManager* self)
{
	MusicLibrary* result;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	result = _tmp1_;
	return result;
}

gint
music_playback_manager_get_current_index (MusicPlaybackManager* self)
{
	gint result;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_current_shuffled;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		result = self->priv->_current_index;
		return result;
	} else {
		result = self->priv->_current_shuffled_index;
		return result;
	}
}

void
music_playback_manager_set_current_index (MusicPlaybackManager* self,
                                          gint value)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	g_debug ("PlaybackManager.vala:71: Current index: %d", value);
	_tmp0_ = self->priv->_current_shuffled;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		self->priv->_current_index = value;
	} else {
		self->priv->_current_shuffled_index = value;
	}
	g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY]);
}

gboolean
music_playback_manager_get_playing (MusicPlaybackManager* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_playing;
	return result;
}

static void
music_playback_manager_set_playing (MusicPlaybackManager* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	if (music_playback_manager_get_playing (self) != value) {
		self->priv->_playing = value;
		g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY]);
	}
}

gdouble
music_playback_manager_get_volume (MusicPlaybackManager* self)
{
	gdouble result;
	MusicPlayback* _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->player;
	result = music_playback_get_volume (_tmp0_);
	return result;
}

void
music_playback_manager_set_volume (MusicPlaybackManager* self,
                                   gdouble value)
{
	MusicPlayback* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->saved_volume = value;
	_tmp0_ = self->player;
	music_playback_set_volume (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY]);
}

MusicMedia*
music_playback_manager_get_current_media (MusicPlaybackManager* self)
{
	MusicMedia* result;
	MusicMedia* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_current_media;
	result = _tmp0_;
	return result;
}

static void
music_playback_manager_set_current_media (MusicPlaybackManager* self,
                                          MusicMedia* value)
{
	g_return_if_fail (self != NULL);
	if (music_playback_manager_get_current_media (self) != value) {
		MusicMedia* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_current_media);
		self->priv->_current_media = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), data2);
}

static GObject *
music_playback_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicPlaybackManager * self;
	MusicHistoryPlaylist* _tmp0_;
	MusicStaticPlaylist* _tmp1_;
	MusicStaticPlaylist* _tmp2_;
	MusicStaticPlaylist* _tmp3_;
	MusicStaticPlaylist* _tmp4_;
	MusicStaticPlaylist* _tmp5_;
	MusicStaticPlaylist* _tmp6_;
	GThemedIcon* _tmp7_;
	MusicStreamer* _tmp8_;
	GeeTreeSet* _tmp9_;
	MusicStreamer* _tmp10_;
	MusicStreamer* _tmp11_;
	MusicPlayback* _tmp12_;
	parent_class = G_OBJECT_CLASS (music_playback_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
	_tmp0_ = music_history_playlist_new ();
	_g_object_unref0 (self->history_playlist);
	self->history_playlist = _tmp0_;
	_tmp1_ = music_static_playlist_new ();
	_g_object_unref0 (self->queue_playlist);
	self->queue_playlist = _tmp1_;
	_tmp2_ = self->queue_playlist;
	music_playlist_set_name ((MusicPlaylist*) _tmp2_, C_ ("Name of the playlist", "Queue"));
	_tmp3_ = self->queue_playlist;
	music_static_playlist_set_read_only (_tmp3_, TRUE);
	_tmp4_ = self->queue_playlist;
	music_static_playlist_set_allow_duplicate (_tmp4_, TRUE);
	_tmp5_ = self->queue_playlist;
	music_static_playlist_set_show_badge (_tmp5_, TRUE);
	_tmp6_ = self->queue_playlist;
	_tmp7_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
	_g_object_unref0 (((MusicPlaylist*) _tmp6_)->icon);
	((MusicPlaylist*) _tmp6_)->icon = (GIcon*) _tmp7_;
	_tmp8_ = music_streamer_new ();
	_g_object_unref0 (self->file_player);
	self->file_player = _tmp8_;
	_tmp9_ = self->priv->playbacks;
	_tmp10_ = self->file_player;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (MusicPlayback*) _tmp10_);
	_tmp11_ = self->file_player;
	_tmp12_ = _g_object_ref0 ((MusicPlayback*) _tmp11_);
	_g_object_unref0 (self->player);
	self->player = _tmp12_;
	return obj;
}

static void
music_playback_manager_class_init (MusicPlaybackManagerClass * klass,
                                   gpointer klass_data)
{
	music_playback_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPlaybackManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_playback_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_playback_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_playback_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_playback_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY] = g_param_spec_int ("current-index", "current-index", "current-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY] = g_param_spec_boolean ("playing", "playing", "playing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY, music_playback_manager_properties[MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY] = g_param_spec_object ("current-media", "current-media", "current-media", MUSIC_TYPE_MEDIA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL] = g_signal_new ("changing-player", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL] = g_signal_new ("media-played", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_MEDIA);
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL] = g_signal_new ("playback-stopped", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL] = g_signal_new ("playback-started", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL] = g_signal_new ("player-changed", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_playback_manager_signals[MUSIC_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL] = g_signal_new ("queue-cleared", MUSIC_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
music_playback_manager_instance_init (MusicPlaybackManager * self,
                                      gpointer klass)
{
	GeeTreeSet* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	self->priv = music_playback_manager_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_playbacks);
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_PLAYBACK, NULL, NULL, NULL, NULL, NULL);
	self->priv->playbacks = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->_current = _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->_current_shuffled = _tmp2_;
	self->priv->_playing = FALSE;
	self->priv->saved_volume = (gdouble) 1;
}

static void
music_playback_manager_finalize (GObject * obj)
{
	MusicPlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
	g_rec_mutex_clear (&self->priv->__lock_playbacks);
	_g_object_unref0 (self->priv->playbacks);
	_g_object_unref0 (self->priv->_current);
	_g_object_unref0 (self->priv->_current_shuffled);
	_g_object_unref0 (self->queue_playlist);
	_g_object_unref0 (self->history_playlist);
	_g_object_unref0 (self->file_player);
	_g_object_unref0 (self->player);
	_g_object_unref0 (self->priv->_current_media);
	G_OBJECT_CLASS (music_playback_manager_parent_class)->finalize (obj);
}

/**
* Manages song playback, queue, repeating and shuffling
*
* Finds the appropriate {@link Music.Playback} to play a media
*/
GType
music_playback_manager_get_type (void)
{
	static volatile gsize music_playback_manager_type_id__volatile = 0;
	if (g_once_init_enter (&music_playback_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicPlaybackManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_playback_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPlaybackManager), 0, (GInstanceInitFunc) music_playback_manager_instance_init, NULL };
		GType music_playback_manager_type_id;
		music_playback_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicPlaybackManager", &g_define_type_info, 0);
		MusicPlaybackManager_private_offset = g_type_add_instance_private (music_playback_manager_type_id, sizeof (MusicPlaybackManagerPrivate));
		g_once_init_leave (&music_playback_manager_type_id__volatile, music_playback_manager_type_id);
	}
	return music_playback_manager_type_id__volatile;
}

static void
_vala_music_playback_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	MusicPlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
	switch (property_id) {
		case MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
		g_value_set_int (value, music_playback_manager_get_current_index (self));
		break;
		case MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY:
		g_value_set_boolean (value, music_playback_manager_get_playing (self));
		break;
		case MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY:
		g_value_set_double (value, music_playback_manager_get_volume (self));
		break;
		case MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
		g_value_set_object (value, music_playback_manager_get_current_media (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_playback_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	MusicPlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager);
	switch (property_id) {
		case MUSIC_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
		music_playback_manager_set_current_index (self, g_value_get_int (value));
		break;
		case MUSIC_PLAYBACK_MANAGER_PLAYING_PROPERTY:
		music_playback_manager_set_playing (self, g_value_get_boolean (value));
		break;
		case MUSIC_PLAYBACK_MANAGER_VOLUME_PROPERTY:
		music_playback_manager_set_volume (self, g_value_get_double (value));
		break;
		case MUSIC_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
		music_playback_manager_set_current_media (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

