/* MusicListView.c generated by valac 0.44.11, the Vala compiler
 * generated from MusicListView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Corentin Noël <corentin@elementary.io>,
 *              Lucas Baudin <xapantu@gmail.com>,
 *              ammonkey <am.monkeyd@gmail.com>,
 *              Victor Martinez <victoreduardm@gmail.com>,
 *              Sergey Davidoff <shnatsel@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>

#define MUSIC_TYPE_GENERIC_LIST (music_generic_list_get_type ())
#define MUSIC_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericList))
#define MUSIC_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))
#define MUSIC_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))

typedef struct _MusicGenericList MusicGenericList;
typedef struct _MusicGenericListClass MusicGenericListClass;
typedef struct _MusicGenericListPrivate MusicGenericListPrivate;
typedef enum  {
	MUSIC_LIST_COLUMN_ICON = 0,
	MUSIC_LIST_COLUMN_NUMBER,
	MUSIC_LIST_COLUMN_TRACK,
	MUSIC_LIST_COLUMN_TITLE,
	MUSIC_LIST_COLUMN_LENGTH,
	MUSIC_LIST_COLUMN_ARTIST,
	MUSIC_LIST_COLUMN_ALBUM,
	MUSIC_LIST_COLUMN_ALBUM_ARTIST,
	MUSIC_LIST_COLUMN_COMPOSER,
	MUSIC_LIST_COLUMN_GENRE,
	MUSIC_LIST_COLUMN_YEAR,
	MUSIC_LIST_COLUMN_GROUPING,
	MUSIC_LIST_COLUMN_BITRATE,
	MUSIC_LIST_COLUMN_RATING,
	MUSIC_LIST_COLUMN_PLAY_COUNT,
	MUSIC_LIST_COLUMN_SKIP_COUNT,
	MUSIC_LIST_COLUMN_DATE_ADDED,
	MUSIC_LIST_COLUMN_LAST_PLAYED,
	MUSIC_LIST_COLUMN_BPM,
	MUSIC_LIST_COLUMN_FILE_LOCATION,
	MUSIC_LIST_COLUMN_FILE_SIZE,
	MUSIC_LIST_COLUMN_N_COLUMNS
} MusicListColumn;

#define MUSIC_TYPE_LIST_COLUMN (music_list_column_get_type ())

#define MUSIC_TYPE_FAST_MODEL (music_fast_model_get_type ())
#define MUSIC_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_FAST_MODEL, MusicFastModel))
#define MUSIC_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_FAST_MODEL, MusicFastModelClass))
#define MUSIC_IS_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_FAST_MODEL))
#define MUSIC_IS_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_FAST_MODEL))
#define MUSIC_FAST_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_FAST_MODEL, MusicFastModelClass))

typedef struct _MusicFastModel MusicFastModel;
typedef struct _MusicFastModelClass MusicFastModelClass;

#define MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER (music_cell_data_function_helper_get_type ())
#define MUSIC_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, MusicCellDataFunctionHelper))
#define MUSIC_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, MusicCellDataFunctionHelperClass))
#define MUSIC_IS_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER))
#define MUSIC_IS_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER))
#define MUSIC_CELL_DATA_FUNCTION_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_CELL_DATA_FUNCTION_HELPER, MusicCellDataFunctionHelperClass))

typedef struct _MusicCellDataFunctionHelper MusicCellDataFunctionHelper;
typedef struct _MusicCellDataFunctionHelperClass MusicCellDataFunctionHelperClass;

#define MUSIC_TYPE_MUSIC_LIST_VIEW (music_music_list_view_get_type ())
#define MUSIC_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView))
#define MUSIC_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))
#define MUSIC_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))

typedef struct _MusicMusicListView MusicMusicListView;
typedef struct _MusicMusicListViewClass MusicMusicListViewClass;
typedef struct _MusicMusicListViewPrivate MusicMusicListViewPrivate;

#define MUSIC_TYPE_MEDIA_MENU (music_media_menu_get_type ())
#define MUSIC_MEDIA_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MEDIA_MENU, MusicMediaMenu))
#define MUSIC_MEDIA_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MEDIA_MENU, MusicMediaMenuClass))
#define MUSIC_IS_MEDIA_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MEDIA_MENU))
#define MUSIC_IS_MEDIA_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MEDIA_MENU))
#define MUSIC_MEDIA_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MEDIA_MENU, MusicMediaMenuClass))

typedef struct _MusicMediaMenu MusicMediaMenu;
typedef struct _MusicMediaMenuClass MusicMediaMenuClass;
enum  {
	MUSIC_MUSIC_LIST_VIEW_0_PROPERTY,
	MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY,
	MUSIC_MUSIC_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* music_music_list_view_properties[MUSIC_MUSIC_LIST_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MUSIC_TYPE_VIEW_WRAPPER (music_view_wrapper_get_type ())
#define MUSIC_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper))
#define MUSIC_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))
#define MUSIC_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))

typedef struct _MusicViewWrapper MusicViewWrapper;
typedef struct _MusicViewWrapperClass MusicViewWrapperClass;

#define MUSIC_TYPE_TREE_VIEW_SETUP (music_tree_view_setup_get_type ())
#define MUSIC_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetup))
#define MUSIC_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetupClass))
#define MUSIC_IS_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_TREE_VIEW_SETUP))
#define MUSIC_IS_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_TREE_VIEW_SETUP))
#define MUSIC_TREE_VIEW_SETUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetupClass))

typedef struct _MusicTreeViewSetup MusicTreeViewSetup;
typedef struct _MusicTreeViewSetupClass MusicTreeViewSetupClass;
typedef struct _Block23Data Block23Data;
typedef enum  {
	MUSIC_VIEW_WRAPPER_HINT_NONE,
	MUSIC_VIEW_WRAPPER_HINT_MUSIC,
	MUSIC_VIEW_WRAPPER_HINT_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_CDROM,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST,
	MUSIC_VIEW_WRAPPER_HINT_QUEUE
} MusicViewWrapperHint;

#define MUSIC_VIEW_WRAPPER_TYPE_HINT (music_view_wrapper_hint_get_type ())
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef struct _Block24Data Block24Data;

#define MUSIC_TYPE_REMOVE_FILES_DIALOG (music_remove_files_dialog_get_type ())
#define MUSIC_REMOVE_FILES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_REMOVE_FILES_DIALOG, MusicRemoveFilesDialog))
#define MUSIC_REMOVE_FILES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_REMOVE_FILES_DIALOG, MusicRemoveFilesDialogClass))
#define MUSIC_IS_REMOVE_FILES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_REMOVE_FILES_DIALOG))
#define MUSIC_IS_REMOVE_FILES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_REMOVE_FILES_DIALOG))
#define MUSIC_REMOVE_FILES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_REMOVE_FILES_DIALOG, MusicRemoveFilesDialogClass))

typedef struct _MusicRemoveFilesDialog MusicRemoveFilesDialog;
typedef struct _MusicRemoveFilesDialogClass MusicRemoveFilesDialogClass;

#define MUSIC_TYPE_DEVICE_VIEW_WRAPPER (music_device_view_wrapper_get_type ())
#define MUSIC_DEVICE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper))
#define MUSIC_DEVICE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapperClass))
#define MUSIC_IS_DEVICE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_DEVICE_VIEW_WRAPPER))
#define MUSIC_IS_DEVICE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_DEVICE_VIEW_WRAPPER))
#define MUSIC_DEVICE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapperClass))

typedef struct _MusicDeviceViewWrapper MusicDeviceViewWrapper;
typedef struct _MusicDeviceViewWrapperClass MusicDeviceViewWrapperClass;

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MusicPlaybackManagerPrivate MusicPlaybackManagerPrivate;

#define MUSIC_TYPE_HISTORY_PLAYLIST (music_history_playlist_get_type ())
#define MUSIC_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylist))
#define MUSIC_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylistClass))
#define MUSIC_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_HISTORY_PLAYLIST))
#define MUSIC_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_HISTORY_PLAYLIST))
#define MUSIC_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylistClass))

typedef struct _MusicHistoryPlaylist MusicHistoryPlaylist;
typedef struct _MusicHistoryPlaylistClass MusicHistoryPlaylistClass;

#define MUSIC_TYPE_STREAMER (music_streamer_get_type ())
#define MUSIC_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_STREAMER, MusicStreamer))
#define MUSIC_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_STREAMER, MusicStreamerClass))
#define MUSIC_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_STREAMER))
#define MUSIC_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_STREAMER))
#define MUSIC_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_STREAMER, MusicStreamerClass))

typedef struct _MusicStreamer MusicStreamer;
typedef struct _MusicStreamerClass MusicStreamerClass;

#define MUSIC_TYPE_RATING_CELL_RENDERER (music_rating_cell_renderer_get_type ())
#define MUSIC_RATING_CELL_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRenderer))
#define MUSIC_RATING_CELL_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRendererClass))
#define MUSIC_IS_RATING_CELL_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_RATING_CELL_RENDERER))
#define MUSIC_IS_RATING_CELL_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_RATING_CELL_RENDERER))
#define MUSIC_RATING_CELL_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRendererClass))

typedef struct _MusicRatingCellRenderer MusicRatingCellRenderer;
typedef struct _MusicRatingCellRendererClass MusicRatingCellRendererClass;
typedef GValue* (*MusicFastModelValueReturnFunc) (gint row, gint column, GObject* o, gpointer user_data);
typedef gint (*MusicGenericListSortCompareFunc) (gint sort_column_id, GtkSortType sort_direction, MusicMedia* a, MusicMedia* b, gint index_a, gint index_b, gpointer user_data);
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MusicGenericList {
	GtkTreeView parent_instance;
	MusicGenericListPrivate * priv;
	MusicFastModel* fm;
	GeeArrayList* table;
	GeeArrayList* showing;
	gint sort_column_id;
	GtkSortType sort_direction;
	gboolean dragging;
	MusicCellDataFunctionHelper* cell_data_helper;
};

struct _MusicGenericListClass {
	GtkTreeViewClass parent_class;
	void (*add_column) (MusicGenericList* self, GtkTreeViewColumn* column, MusicListColumn type);
	void (*media_remove_clicked) (MusicGenericList* self);
};

struct _MusicMusicListView {
	MusicGenericList parent_instance;
	MusicMusicListViewPrivate * priv;
	GtkMenu* column_chooser_menu;
};

struct _MusicMusicListViewClass {
	MusicGenericListClass parent_class;
	void (*on_drag_data_get) (MusicMusicListView* self, GdkDragContext* context, GtkSelectionData* selection_data, guint info, guint time_);
};

struct _MusicMusicListViewPrivate {
	MusicMediaMenu* _media_action_menu;
	GtkMenuItem* autosize_menu_item;
};

struct _Block23Data {
	int _ref_count_;
	MusicMusicListView* self;
	GtkCheckMenuItem* menu_item;
	GtkTreeViewColumn* tvc;
};

struct _Block24Data {
	int _ref_count_;
	MusicMusicListView* self;
	GeeCollection* selected_media;
};

struct _MusicPlaybackManager {
	GObject parent_instance;
	MusicPlaybackManagerPrivate * priv;
	MusicStaticPlaylist* queue_playlist;
	MusicHistoryPlaylist* history_playlist;
	MusicStreamer* file_player;
	MusicPlayback* player;
};

struct _MusicPlaybackManagerClass {
	GObjectClass parent_class;
};

static gint MusicMusicListView_private_offset;
static gpointer music_music_list_view_parent_class = NULL;

GType music_generic_list_get_type (void) G_GNUC_CONST;
GType music_list_column_get_type (void) G_GNUC_CONST;
GType music_fast_model_get_type (void) G_GNUC_CONST;
gpointer music_cell_data_function_helper_ref (gpointer instance);
void music_cell_data_function_helper_unref (gpointer instance);
GParamSpec* music_param_spec_cell_data_function_helper (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags);
void music_value_set_cell_data_function_helper (GValue* value,
                                                gpointer v_object);
void music_value_take_cell_data_function_helper (GValue* value,
                                                 gpointer v_object);
gpointer music_value_get_cell_data_function_helper (const GValue* value);
GType music_cell_data_function_helper_get_type (void) G_GNUC_CONST;
GType music_music_list_view_get_type (void) G_GNUC_CONST;
GType music_media_menu_get_type (void) G_GNUC_CONST;
GType music_view_wrapper_get_type (void) G_GNUC_CONST;
GType music_tree_view_setup_get_type (void) G_GNUC_CONST;
MusicMusicListView* music_music_list_view_new (MusicViewWrapper* view_wrapper,
                                               MusicTreeViewSetup* tvs);
MusicMusicListView* music_music_list_view_construct (GType object_type,
                                                     MusicViewWrapper* view_wrapper,
                                                     MusicTreeViewSetup* tvs);
static void music_music_list_view_add_column_chooser_menu_item (MusicMusicListView* self,
                                                         GtkTreeViewColumn* tvc,
                                                         MusicListColumn type);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
GType music_view_wrapper_hint_get_type (void) G_GNUC_CONST;
MusicViewWrapperHint music_generic_list_get_hint (MusicGenericList* self);
static void music_music_list_view_columns_autosize (MusicMusicListView* self);
static void _music_music_list_view_columns_autosize_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                     gpointer self);
static void __lambda62_ (Block23Data* _data23_);
static void ___lambda62__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                               gpointer self);
void music_music_list_view_add_media (MusicMusicListView* self,
                                      GeeCollection* to_add);
void music_generic_list_resort (MusicGenericList* self);
void music_music_list_view_remove_media (MusicMusicListView* self,
                                         GeeCollection* to_remove);
void music_generic_list_set_table (MusicGenericList* self,
                                   GeeArrayList* table,
                                   gboolean do_resort);
static gboolean music_music_list_view_real_button_press_event (GtkWidget* base,
                                                        GdkEventButton* event);
static gboolean music_music_list_view_check_selection_event (MusicMusicListView* self,
                                                      GdkEventButton* event);
MusicMediaMenu* music_music_list_view_get_media_action_menu (MusicMusicListView* self);
void music_media_menu_popup_media_menu (MusicMediaMenu* self,
                                        GeeCollection* selection);
GeeCollection* music_generic_list_get_selected_medias (MusicGenericList* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void music_music_list_view_reset_column_widths (MusicMusicListView* self);
static gboolean music_music_list_view_view_click_release (MusicMusicListView* self,
                                                   GtkWidget* sender,
                                                   GdkEventButton* event);
static gboolean music_music_list_view_view_header_click (MusicMusicListView* self,
                                                  GdkEventButton* e,
                                                  gboolean is_selector_col);
static void music_music_list_view_real_media_remove_clicked (MusicGenericList* base);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
GType music_remove_files_dialog_get_type (void) G_GNUC_CONST;
MusicRemoveFilesDialog* music_remove_files_dialog_new (GeeCollection* to_remove);
MusicRemoveFilesDialog* music_remove_files_dialog_construct (GType object_type,
                                                             GeeCollection* to_remove);
static void ___lambda63_ (Block24Data* _data24_,
                   gboolean delete_files);
MusicViewWrapper* music_generic_list_get_parent_wrapper (MusicGenericList* self);
MusicLibrary* music_view_wrapper_get_library (MusicViewWrapper* self);
static void ____lambda63__music_remove_files_dialog_remove_media (MusicRemoveFilesDialog* _sender,
                                                           gboolean response,
                                                           gpointer self);
GType music_device_view_wrapper_get_type (void) G_GNUC_CONST;
MusicPlaylist* music_generic_list_get_playlist (MusicGenericList* self);
GType music_playback_manager_get_type (void) G_GNUC_CONST;
MusicPlaybackManager* music_app_get_player (void);
void music_playback_manager_unqueue_media (MusicPlaybackManager* self,
                                           GeeCollection* to_unqueue);
void music_music_list_view_on_drag_data_get (MusicMusicListView* self,
                                             GdkDragContext* context,
                                             GtkSelectionData* selection_data,
                                             guint info,
                                             guint time_);
static void music_music_list_view_real_on_drag_data_get (MusicMusicListView* self,
                                                  GdkDragContext* context,
                                                  GtkSelectionData* selection_data,
                                                  guint info,
                                                  guint time_);
static void _vala_array_add14 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
gint music_music_list_view_view_compare_func (MusicMusicListView* self,
                                              gint column,
                                              GtkSortType dir,
                                              MusicMedia* media_a,
                                              MusicMedia* media_b,
                                              gint a_pos,
                                              gint b_pos);
GType music_history_playlist_get_type (void) G_GNUC_CONST;
GType music_streamer_get_type (void) G_GNUC_CONST;
GValue* music_music_list_view_view_value_func (MusicMusicListView* self,
                                               gint row,
                                               gint column,
                                               GObject* o);
GValue* music_list_column_get_value_for_media (MusicListColumn self,
                                               MusicMedia* m,
                                               gint media_row_index);
static void music_music_list_view_real_add_column (MusicGenericList* base,
                                            GtkTreeViewColumn* tvc,
                                            MusicListColumn type);
void music_cell_data_function_helper_icon_func (MusicCellDataFunctionHelper* self,
                                                GtkCellLayout* layout,
                                                GtkCellRenderer* renderer,
                                                GtkTreeModel* model,
                                                GtkTreeIter* iter);
static void _music_cell_data_function_helper_icon_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                           GtkCellRenderer* cell,
                                                                           GtkTreeModel* tree_model,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self);
void music_cell_data_function_helper_spinner_func (MusicCellDataFunctionHelper* self,
                                                   GtkCellLayout* layout,
                                                   GtkCellRenderer* renderer,
                                                   GtkTreeModel* model,
                                                   GtkTreeIter* iter);
static void _music_cell_data_function_helper_spinner_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                              GtkCellRenderer* cell,
                                                                              GtkTreeModel* tree_model,
                                                                              GtkTreeIter* iter,
                                                                              gpointer self);
void music_cell_data_function_helper_bitrate_func (GtkCellLayout* layout,
                                                   GtkCellRenderer* cell,
                                                   GtkTreeModel* tree_model,
                                                   GtkTreeIter* iter);
static void _music_cell_data_function_helper_bitrate_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                              GtkCellRenderer* cell,
                                                                              GtkTreeModel* tree_model,
                                                                              GtkTreeIter* iter,
                                                                              gpointer self);
static void _vala_array_add15 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void music_cell_data_function_helper_length_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
static void _music_cell_data_function_helper_length_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void _vala_array_add16 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void music_cell_data_function_helper_date_func (GtkCellLayout* layout,
                                                GtkCellRenderer* cell,
                                                GtkTreeModel* tree_model,
                                                GtkTreeIter* iter);
static void _music_cell_data_function_helper_date_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                           GtkCellRenderer* cell,
                                                                           GtkTreeModel* tree_model,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self);
gchar* music_cell_data_function_helper_get_date_string (guint n);
static void _vala_array_add17 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add18 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
GType music_rating_cell_renderer_get_type (void) G_GNUC_CONST;
MusicRatingCellRenderer* music_rating_cell_renderer_new (GtkIconSize icon_size);
MusicRatingCellRenderer* music_rating_cell_renderer_construct (GType object_type,
                                                               GtkIconSize icon_size);
void music_generic_list_on_rating_cell_changed (MusicGenericList* self,
                                                gint new_rating,
                                                GtkWidget* widget,
                                                const gchar* path);
static void _music_generic_list_on_rating_cell_changed_music_rating_cell_renderer_rating_changed (MusicRatingCellRenderer* _sender,
                                                                                           gint new_rating,
                                                                                           GtkWidget* widget,
                                                                                           const gchar* path,
                                                                                           gpointer self);
void music_cell_data_function_helper_rating_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
static void _music_cell_data_function_helper_rating_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
void music_cell_data_function_helper_number_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
static void _music_cell_data_function_helper_number_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void _vala_array_add19 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void music_cell_data_function_helper_intelligent_func (GtkCellLayout* layout,
                                                       GtkCellRenderer* cell,
                                                       GtkTreeModel* tree_model,
                                                       GtkTreeIter* iter);
static void _music_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                  GtkCellRenderer* cell,
                                                                                  GtkTreeModel* tree_model,
                                                                                  GtkTreeIter* iter,
                                                                                  gpointer self);
static void _vala_array_add20 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add21 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void music_cell_data_function_helper_string_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
static void _music_cell_data_function_helper_string_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void _vala_array_add22 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add23 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void music_cell_data_function_helper_file_size_func (GtkCellLayout* layout,
                                                     GtkCellRenderer* cell,
                                                     GtkTreeModel* tree_model,
                                                     GtkTreeIter* iter);
static void _music_cell_data_function_helper_file_size_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                GtkCellRenderer* cell,
                                                                                GtkTreeModel* tree_model,
                                                                                GtkTreeIter* iter,
                                                                                gpointer self);
static void _vala_array_add24 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void music_generic_list_set_fixed_column_width (MusicGenericList* self,
                                                GtkWidget* treeview,
                                                GtkTreeViewColumn* column,
                                                GtkCellRendererText* renderer,
                                                gchar** strings,
                                                gint strings_length1,
                                                gint padding);
static gboolean ___lambda64_ (MusicMusicListView* self,
                       GdkEventButton* e);
static gboolean ____lambda64__gtk_widget_button_press_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static gboolean ___lambda65_ (MusicMusicListView* self,
                       GdkEventButton* e);
static gboolean ____lambda65__gtk_widget_button_press_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static void music_music_list_view_set_media_action_menu (MusicMusicListView* self,
                                                  MusicMediaMenu* value);
static GObject * music_music_list_view_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
void music_generic_list_set_value_func (MusicGenericList* self,
                                        MusicFastModelValueReturnFunc func,
                                        gpointer func_target);
static GValue* _music_music_list_view_view_value_func_music_fast_model_value_return_func (gint row,
                                                                                   gint column,
                                                                                   GObject* o,
                                                                                   gpointer self);
void music_generic_list_set_compare_func (MusicGenericList* self,
                                          MusicGenericListSortCompareFunc func,
                                          gpointer func_target);
static gint _music_music_list_view_view_compare_func_music_generic_list_sort_compare_func (gint sort_column_id,
                                                                                    GtkSortType sort_direction,
                                                                                    MusicMedia* a,
                                                                                    MusicMedia* b,
                                                                                    gint index_a,
                                                                                    gint index_b,
                                                                                    gpointer self);
static gboolean _music_music_list_view_view_click_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                    GdkEventButton* event,
                                                                                    gpointer self);
MusicMediaMenu* music_media_menu_new (MusicGenericList* generic_list);
MusicMediaMenu* music_media_menu_construct (GType object_type,
                                            MusicGenericList* generic_list);
static void music_music_list_view_finalize (GObject * obj);
static void _vala_music_music_list_view_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_music_music_list_view_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_music_list_view_get_instance_private (MusicMusicListView* self)
{
	return G_STRUCT_MEMBER_P (self, MusicMusicListView_private_offset);
}

MusicMusicListView*
music_music_list_view_construct (GType object_type,
                                 MusicViewWrapper* view_wrapper,
                                 MusicTreeViewSetup* tvs)
{
	MusicMusicListView * self = NULL;
	g_return_val_if_fail (view_wrapper != NULL, NULL);
	g_return_val_if_fail (tvs != NULL, NULL);
	self = (MusicMusicListView*) g_object_new (object_type, "parent-wrapper", view_wrapper, "tvs", tvs, NULL);
	return self;
}

MusicMusicListView*
music_music_list_view_new (MusicViewWrapper* view_wrapper,
                           MusicTreeViewSetup* tvs)
{
	return music_music_list_view_construct (MUSIC_TYPE_MUSIC_LIST_VIEW, view_wrapper, tvs);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
	g_atomic_int_inc (&_data23_->_ref_count_);
	return _data23_;
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
		MusicMusicListView* self;
		self = _data23_->self;
		_g_object_unref0 (_data23_->menu_item);
		_g_object_unref0 (_data23_->tvc);
		_g_object_unref0 (self);
		g_slice_free (Block23Data, _data23_);
	}
}

static void
_music_music_list_view_columns_autosize_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self)
{
	music_music_list_view_columns_autosize ((MusicMusicListView*) self);
}

static void
__lambda62_ (Block23Data* _data23_)
{
	MusicMusicListView* self;
	GtkCheckMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data23_->self;
	_tmp0_ = _data23_->menu_item;
	_tmp1_ = gtk_check_menu_item_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	gtk_tree_view_column_set_visible (_data23_->tvc, _tmp2_);
	music_music_list_view_columns_autosize (self);
}

static void
___lambda62__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                          gpointer self)
{
	__lambda62_ (self);
}

static void
music_music_list_view_add_column_chooser_menu_item (MusicMusicListView* self,
                                                    GtkTreeViewColumn* tvc,
                                                    MusicListColumn type)
{
	Block23Data* _data23_;
	GtkTreeViewColumn* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	MusicViewWrapperHint _tmp3_;
	MusicViewWrapperHint _tmp4_;
	GtkMenu* _tmp5_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GtkCheckMenuItem* _tmp17_;
	GtkCheckMenuItem* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GtkMenu* _tmp21_;
	GtkCheckMenuItem* _tmp22_;
	GtkMenu* _tmp23_;
	GtkCheckMenuItem* _tmp24_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tvc != NULL);
	_data23_ = g_slice_new0 (Block23Data);
	_data23_->_ref_count_ = 1;
	_data23_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (tvc);
	_g_object_unref0 (_data23_->tvc);
	_data23_->tvc = _tmp0_;
	if (type == MUSIC_LIST_COLUMN_TITLE) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = type == MUSIC_LIST_COLUMN_ICON;
	}
	if (_tmp1_) {
		block23_data_unref (_data23_);
		_data23_ = NULL;
		return;
	}
	_tmp3_ = music_generic_list_get_hint ((MusicGenericList*) self);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == MUSIC_VIEW_WRAPPER_HINT_MUSIC) {
		_tmp2_ = type == MUSIC_LIST_COLUMN_NUMBER;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		block23_data_unref (_data23_);
		_data23_ = NULL;
		return;
	}
	_tmp5_ = self->column_chooser_menu;
	if (_tmp5_ == NULL) {
		GtkMenuItem* _tmp6_;
		GtkMenuItem* _tmp7_;
		GtkMenu* _tmp8_;
		GtkMenu* _tmp9_;
		GtkMenuItem* _tmp10_;
		GtkMenu* _tmp11_;
		GtkSeparatorMenuItem* _tmp12_;
		GtkSeparatorMenuItem* _tmp13_;
		GtkMenu* _tmp14_;
		_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Autosize Columns"));
		g_object_ref_sink (_tmp6_);
		_g_object_unref0 (self->priv->autosize_menu_item);
		self->priv->autosize_menu_item = _tmp6_;
		_tmp7_ = self->priv->autosize_menu_item;
		g_signal_connect_object (_tmp7_, "activate", (GCallback) _music_music_list_view_columns_autosize_gtk_menu_item_activate, self, 0);
		_tmp8_ = (GtkMenu*) gtk_menu_new ();
		g_object_ref_sink (_tmp8_);
		_g_object_unref0 (self->column_chooser_menu);
		self->column_chooser_menu = _tmp8_;
		_tmp9_ = self->column_chooser_menu;
		_tmp10_ = self->priv->autosize_menu_item;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp9_, _tmp10_);
		_tmp11_ = self->column_chooser_menu;
		_tmp12_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
		g_object_ref_sink (_tmp12_);
		_tmp13_ = _tmp12_;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp11_, (GtkMenuItem*) _tmp13_);
		_g_object_unref0 (_tmp13_);
		_tmp14_ = self->column_chooser_menu;
		gtk_widget_show_all ((GtkWidget*) _tmp14_);
	}
	_tmp15_ = gtk_tree_view_column_get_title (_data23_->tvc);
	_tmp16_ = _tmp15_;
	_tmp17_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_tmp16_);
	g_object_ref_sink (_tmp17_);
	_data23_->menu_item = _tmp17_;
	_tmp18_ = _data23_->menu_item;
	_tmp19_ = gtk_tree_view_column_get_visible (_data23_->tvc);
	_tmp20_ = _tmp19_;
	gtk_check_menu_item_set_active (_tmp18_, _tmp20_);
	_tmp21_ = self->column_chooser_menu;
	_tmp22_ = _data23_->menu_item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp21_, (GtkMenuItem*) _tmp22_);
	_tmp23_ = self->column_chooser_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp23_);
	_tmp24_ = _data23_->menu_item;
	g_signal_connect_data (_tmp24_, "toggled", (GCallback) ___lambda62__gtk_check_menu_item_toggled, block23_data_ref (_data23_), (GClosureNotify) block23_data_unref, 0);
	block23_data_unref (_data23_);
	_data23_ = NULL;
}

void
music_music_list_view_add_media (MusicMusicListView* self,
                                 GeeCollection* to_add)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_add != NULL);
	_tmp0_ = ((MusicGenericList*) self)->table;
	gee_array_list_add_all (_tmp0_, to_add);
	music_generic_list_resort ((MusicGenericList*) self);
}

void
music_music_list_view_remove_media (MusicMusicListView* self,
                                    GeeCollection* to_remove)
{
	GeeArrayList* new_table = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_remove != NULL);
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	new_table = _tmp0_;
	{
		GeeArrayList* _m_list = NULL;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _m_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _m_index = 0;
		_tmp1_ = ((MusicGenericList*) self)->table;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_m_list = _tmp2_;
		_tmp3_ = _m_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_m_size = _tmp5_;
		_m_index = -1;
		while (TRUE) {
			MusicMedia* m = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			MusicMedia* _tmp8_;
			_m_index = _m_index + 1;
			if (!(_m_index < _m_size)) {
				break;
			}
			_tmp6_ = _m_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _m_index);
			m = (MusicMedia*) _tmp7_;
			_tmp8_ = m;
			if (!gee_collection_contains (to_remove, _tmp8_)) {
				GeeArrayList* _tmp9_;
				MusicMedia* _tmp10_;
				_tmp9_ = new_table;
				_tmp10_ = m;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp10_);
			}
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_list);
	}
	_tmp11_ = new_table;
	music_generic_list_set_table ((MusicGenericList*) self, _tmp11_, FALSE);
	_g_object_unref0 (new_table);
}

static gboolean
music_music_list_view_real_button_press_event (GtkWidget* base,
                                               GdkEventButton* event)
{
	MusicMusicListView * self;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	gboolean result = FALSE;
	self = (MusicMusicListView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->window;
	_tmp1_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
	if (_tmp0_ != _tmp1_) {
		result = GTK_WIDGET_CLASS (music_music_list_view_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_GENERIC_LIST, MusicGenericList), event);
		return result;
	}
	if (music_music_list_view_check_selection_event (self, event)) {
		GTK_WIDGET_CLASS (music_music_list_view_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_GENERIC_LIST, MusicGenericList), event);
	}
	if (event->button == ((guint) GDK_BUTTON_SECONDARY)) {
		MusicMediaMenu* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		_tmp2_ = self->priv->_media_action_menu;
		_tmp3_ = music_generic_list_get_selected_medias ((MusicGenericList*) self);
		_tmp4_ = _tmp3_;
		music_media_menu_popup_media_menu (_tmp2_, _tmp4_);
		_g_object_unref0 (_tmp4_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

/**
     * Checks whether a Gdk.EventButton resulting in a selection change should be sent
     * to the default handler or not. This is useful to prevent the default handler from
     * destroying the user's previous selection in case there was a multiple selection.
     *
     * @param event the Gdk.EventButton to check
     * @return //true// if the event should be passed to the default handler; false otherwise.
     */
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static gboolean
music_music_list_view_check_selection_event (MusicMusicListView* self,
                                             GdkEventButton* event)
{
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GdkModifierType _tmp3_;
	GdkModifierType _tmp4_;
	GtkTreePath* path = NULL;
	GtkTreeViewColumn* column = NULL;
	gint cell_x = 0;
	gint cell_y = 0;
	GtkTreePath* _tmp7_ = NULL;
	GtkTreeViewColumn* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gboolean _tmp11_;
	GtkTreeViewColumn* _tmp12_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->window;
	_tmp1_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
	_vala_return_val_if_fail (_tmp0_ == _tmp1_, "event.window == get_bin_window ()", FALSE);
	_tmp3_ = event->state;
	_tmp4_ = event->state;
	if ((_tmp3_ & GDK_CONTROL_MASK) == _tmp4_) {
		_tmp2_ = TRUE;
	} else {
		GdkModifierType _tmp5_;
		GdkModifierType _tmp6_;
		_tmp5_ = event->state;
		_tmp6_ = event->state;
		_tmp2_ = (_tmp5_ & GDK_SHIFT_MASK) == _tmp6_;
	}
	if (_tmp2_) {
		result = TRUE;
		return result;
	}
	_tmp11_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, (gint) event->x, (gint) event->y, &_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
	__vala_GtkTreePath_free0 (path);
	path = _tmp7_;
	_g_object_unref0 (column);
	_tmp12_ = _g_object_ref0 (_tmp8_);
	column = _tmp12_;
	cell_x = _tmp9_;
	cell_y = _tmp10_;
	if (_tmp11_) {
		GtkTreeSelection* selection = NULL;
		GtkTreeSelection* _tmp13_;
		GtkTreeSelection* _tmp14_;
		gboolean _tmp15_ = FALSE;
		GtkTreeSelection* _tmp16_;
		_tmp13_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
		_tmp14_ = _g_object_ref0 (_tmp13_);
		selection = _tmp14_;
		_tmp16_ = selection;
		if (gtk_tree_selection_count_selected_rows (_tmp16_) > 1) {
			GtkTreeSelection* _tmp17_;
			GtkTreePath* _tmp18_;
			_tmp17_ = selection;
			_tmp18_ = path;
			_tmp15_ = gtk_tree_selection_path_is_selected (_tmp17_, _tmp18_);
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			result = FALSE;
			_g_object_unref0 (selection);
			_g_object_unref0 (column);
			__vala_GtkTreePath_free0 (path);
			return result;
		}
		_g_object_unref0 (selection);
	}
	result = TRUE;
	_g_object_unref0 (column);
	__vala_GtkTreePath_free0 (path);
	return result;
}

static void
music_music_list_view_columns_autosize (MusicMusicListView* self)
{
	g_return_if_fail (self != NULL);
	music_music_list_view_reset_column_widths (self);
	gtk_tree_view_columns_autosize ((GtkTreeView*) G_TYPE_CHECK_INSTANCE_CAST (self, MUSIC_TYPE_GENERIC_LIST, MusicGenericList));
}

static gboolean
music_music_list_view_view_click_release (MusicMusicListView* self,
                                          GtkWidget* sender,
                                          GdkEventButton* event)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (sender != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	if (((MusicGenericList*) self)->dragging) {
		_tmp0_ = event->button == ((guint) 1);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		((MusicGenericList*) self)->dragging = FALSE;
		result = TRUE;
		return result;
	} else {
		GdkModifierType _tmp1_;
		GdkModifierType _tmp2_;
		_tmp1_ = event->state;
		_tmp2_ = event->state;
		if (((_tmp1_ & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) | ((_tmp2_ & GDK_CONTROL_MASK) == GDK_CONTROL_MASK)) {
			result = TRUE;
			return result;
		} else {
			GtkTreePath* path = NULL;
			GtkTreeViewColumn* tvc = NULL;
			gint cell_x = 0;
			gint cell_y = 0;
			gint x = 0;
			gint y = 0;
			GtkTreePath* _tmp3_ = NULL;
			GtkTreeViewColumn* _tmp4_ = NULL;
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gboolean _tmp7_;
			GtkTreeViewColumn* _tmp8_;
			GtkTreeSelection* _tmp9_;
			GtkTreeSelection* _tmp10_;
			GtkTreePath* _tmp11_;
			x = (gint) event->x;
			y = (gint) event->y;
			_tmp7_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, x, y, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
			__vala_GtkTreePath_free0 (path);
			path = _tmp3_;
			_g_object_unref0 (tvc);
			_tmp8_ = _g_object_ref0 (_tmp4_);
			tvc = _tmp8_;
			cell_x = _tmp5_;
			cell_y = _tmp6_;
			if (!_tmp7_) {
				result = FALSE;
				_g_object_unref0 (tvc);
				__vala_GtkTreePath_free0 (path);
				return result;
			}
			_tmp9_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
			gtk_tree_selection_unselect_all (_tmp9_);
			_tmp10_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
			_tmp11_ = path;
			gtk_tree_selection_select_path (_tmp10_, _tmp11_);
			result = FALSE;
			_g_object_unref0 (tvc);
			__vala_GtkTreePath_free0 (path);
			return result;
		}
	}
}

static gboolean
music_music_list_view_view_header_click (MusicMusicListView* self,
                                         GdkEventButton* e,
                                         gboolean is_selector_col)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	if (e->button == ((guint) GDK_BUTTON_SECONDARY)) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = is_selector_col;
	}
	if (_tmp0_) {
		GtkMenu* _tmp1_;
		_tmp1_ = self->column_chooser_menu;
		gtk_menu_popup_at_pointer (_tmp1_, (GdkEvent*) e);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
	g_atomic_int_inc (&_data24_->_ref_count_);
	return _data24_;
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
		MusicMusicListView* self;
		self = _data24_->self;
		_g_object_unref0 (_data24_->selected_media);
		_g_object_unref0 (self);
		g_slice_free (Block24Data, _data24_);
	}
}

static void
___lambda63_ (Block24Data* _data24_,
              gboolean delete_files)
{
	MusicMusicListView* self;
	MusicViewWrapper* _tmp0_;
	MusicViewWrapper* _tmp1_;
	MusicLibrary* _tmp2_;
	MusicLibrary* _tmp3_;
	GeeCollection* _tmp4_;
	self = _data24_->self;
	_tmp0_ = music_generic_list_get_parent_wrapper ((MusicGenericList*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_view_wrapper_get_library (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _data24_->selected_media;
	music_library_remove_medias (_tmp3_, _tmp4_, delete_files);
}

static void
____lambda63__music_remove_files_dialog_remove_media (MusicRemoveFilesDialog* _sender,
                                                      gboolean response,
                                                      gpointer self)
{
	___lambda63_ (self, response);
}

static void
music_music_list_view_real_media_remove_clicked (MusicGenericList* base)
{
	MusicMusicListView * self;
	Block24Data* _data24_;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	MusicViewWrapperHint _tmp5_;
	MusicViewWrapperHint _tmp6_;
	self = (MusicMusicListView*) base;
	_data24_ = g_slice_new0 (Block24Data);
	_data24_->_ref_count_ = 1;
	_data24_->self = g_object_ref (self);
	_tmp0_ = music_generic_list_get_selected_medias ((MusicGenericList*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_collection_get_read_only_view (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp1_);
	_data24_->selected_media = _tmp4_;
	_tmp5_ = music_generic_list_get_hint ((MusicGenericList*) self);
	_tmp6_ = _tmp5_;
	switch (_tmp6_) {
		case MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST:
		case MUSIC_VIEW_WRAPPER_HINT_MUSIC:
		{
			MusicRemoveFilesDialog* dialog = NULL;
			GeeCollection* _tmp7_;
			MusicRemoveFilesDialog* _tmp8_;
			MusicRemoveFilesDialog* _tmp9_;
			_tmp7_ = _data24_->selected_media;
			_tmp8_ = music_remove_files_dialog_new (_tmp7_);
			g_object_ref_sink (_tmp8_);
			dialog = _tmp8_;
			_tmp9_ = dialog;
			g_signal_connect_data (_tmp9_, "remove-media", (GCallback) ____lambda63__music_remove_files_dialog_remove_media, block24_data_ref (_data24_), (GClosureNotify) block24_data_unref, 0);
			_g_object_unref0 (dialog);
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
		{
			MusicDeviceViewWrapper* dvw = NULL;
			MusicViewWrapper* _tmp10_;
			MusicViewWrapper* _tmp11_;
			MusicDeviceViewWrapper* _tmp12_;
			MusicDeviceViewWrapper* _tmp13_;
			MusicLibrary* _tmp14_;
			MusicLibrary* _tmp15_;
			GeeCollection* _tmp16_;
			_tmp10_ = music_generic_list_get_parent_wrapper ((MusicGenericList*) self);
			_tmp11_ = _tmp10_;
			_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
			dvw = _tmp12_;
			_tmp13_ = dvw;
			_tmp14_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = _data24_->selected_media;
			music_library_remove_medias (_tmp15_, _tmp16_, TRUE);
			_g_object_unref0 (dvw);
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
		{
			MusicPlaylist* _tmp17_;
			MusicPlaylist* _tmp18_;
			GeeCollection* _tmp19_;
			_tmp17_ = music_generic_list_get_playlist ((MusicGenericList*) self);
			_tmp18_ = _tmp17_;
			_tmp19_ = _data24_->selected_media;
			music_playlist_remove_medias (_tmp18_, _tmp19_);
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_QUEUE:
		{
			MusicPlaybackManager* _tmp20_;
			MusicPlaybackManager* _tmp21_;
			GeeCollection* _tmp22_;
			_tmp20_ = music_app_get_player ();
			_tmp21_ = _tmp20_;
			_tmp22_ = _data24_->selected_media;
			music_playback_manager_unqueue_media (_tmp21_, _tmp22_);
			break;
		}
		default:
		break;
	}
	block24_data_unref (_data24_);
	_data24_ = NULL;
}

static void
_vala_array_add14 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
music_music_list_view_real_on_drag_data_get (MusicMusicListView* self,
                                             GdkDragContext* context,
                                             GtkSelectionData* selection_data,
                                             guint info,
                                             guint time_)
{
	gchar** uris = NULL;
	gint uris_length1;
	gint _uris_size_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	uris = NULL;
	uris_length1 = 0;
	_uris_size_ = uris_length1;
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		_tmp0_ = music_generic_list_get_selected_medias ((MusicGenericList*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_m_it = _tmp3_;
		while (TRUE) {
			GeeIterator* _tmp4_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MusicMedia* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar** _tmp11_;
			gint _tmp11__length1;
			MusicMedia* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp4_ = _m_it;
			if (!gee_iterator_next (_tmp4_)) {
				break;
			}
			_tmp5_ = _m_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			m = (MusicMedia*) _tmp6_;
			_tmp7_ = m;
			_tmp8_ = music_media_get_uri (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = _tmp9_;
			g_debug ("MusicListView.vala:231: adding %s", _tmp10_);
			_g_free0 (_tmp10_);
			_tmp11_ = uris;
			_tmp11__length1 = uris_length1;
			_tmp12_ = m;
			_tmp13_ = music_media_get_uri (_tmp12_);
			_tmp14_ = _tmp13_;
			_vala_array_add14 (&uris, &uris_length1, &_uris_size_, _tmp14_);
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp15_ = uris;
	_tmp15__length1 = uris_length1;
	if (_tmp15_ != NULL) {
		gchar** _tmp16_;
		gint _tmp16__length1;
		_tmp16_ = uris;
		_tmp16__length1 = uris_length1;
		gtk_selection_data_set_uris (selection_data, _tmp16_);
	}
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
}

void
music_music_list_view_on_drag_data_get (MusicMusicListView* self,
                                        GdkDragContext* context,
                                        GtkSelectionData* selection_data,
                                        guint info,
                                        guint time_)
{
	g_return_if_fail (self != NULL);
	MUSIC_MUSIC_LIST_VIEW_GET_CLASS (self)->on_drag_data_get (self, context, selection_data, info, time_);
}

static void
music_music_list_view_reset_column_widths (MusicMusicListView* self)
{
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_tree_view_get_columns ((GtkTreeView*) self);
	{
		GList* column_collection = NULL;
		GList* column_it = NULL;
		column_collection = _tmp0_;
		for (column_it = column_collection; column_it != NULL; column_it = column_it->next) {
			GtkTreeViewColumn* column = NULL;
			column = (GtkTreeViewColumn*) column_it->data;
			{
				GtkTreeViewColumn* _tmp1_;
				gint _tmp2_;
				gint _tmp3_;
				_tmp1_ = column;
				_tmp2_ = gtk_tree_view_column_get_min_width (_tmp1_);
				_tmp3_ = _tmp2_;
				if (_tmp3_ > 0) {
					GtkTreeViewColumn* _tmp4_;
					GtkTreeViewColumn* _tmp5_;
					gint _tmp6_;
					gint _tmp7_;
					_tmp4_ = column;
					_tmp5_ = column;
					_tmp6_ = gtk_tree_view_column_get_min_width (_tmp5_);
					_tmp7_ = _tmp6_;
					gtk_tree_view_column_set_fixed_width (_tmp4_, _tmp7_);
				}
			}
		}
		(column_collection == NULL) ? NULL : (column_collection = (g_list_free (column_collection), NULL));
	}
}

/**
     * Compares the two given objects based on the sort column.
     */
gint
music_music_list_view_view_compare_func (MusicMusicListView* self,
                                         gint column,
                                         GtkSortType dir,
                                         MusicMedia* media_a,
                                         MusicMedia* media_b,
                                         gint a_pos,
                                         gint b_pos)
{
	MusicPlaylist* _tmp0_;
	MusicPlaylist* _tmp1_;
	MusicPlaybackManager* _tmp2_;
	MusicPlaybackManager* _tmp3_;
	MusicStaticPlaylist* _tmp4_;
	gint order = 0;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gboolean _tmp59_ = FALSE;
	gboolean _tmp66_ = FALSE;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (media_a != NULL, 0);
	g_return_val_if_fail (media_b != NULL, 0);
	_tmp0_ = music_generic_list_get_playlist ((MusicGenericList*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_app_get_player ();
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_->queue_playlist;
	if (_tmp1_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, MUSIC_TYPE_PLAYLIST, MusicPlaylist)) {
		result = a_pos - b_pos;
		return result;
	}
	order = 0;
	if (column >= 0) {
		_tmp5_ = column < ((gint) MUSIC_LIST_COLUMN_N_COLUMNS);
	} else {
		_tmp5_ = FALSE;
	}
	g_return_val_if_fail (_tmp5_, order);
	switch (column) {
		case MUSIC_LIST_COLUMN_NUMBER:
		{
			order = music_compare_standard (a_pos, b_pos);
			break;
		}
		case MUSIC_LIST_COLUMN_TITLE:
		{
			order = music_compare_titles (media_a, media_b);
			break;
		}
		case MUSIC_LIST_COLUMN_LENGTH:
		{
			guint _tmp6_;
			guint _tmp7_;
			guint _tmp8_;
			guint _tmp9_;
			_tmp6_ = music_media_get_length (media_a);
			_tmp7_ = _tmp6_;
			_tmp8_ = music_media_get_length (media_b);
			_tmp9_ = _tmp8_;
			order = music_compare_standard_unsigned (_tmp7_, _tmp9_);
			if (order == 0) {
				music_compare_titles (media_a, media_b);
			}
			break;
		}
		case MUSIC_LIST_COLUMN_ARTIST:
		{
			order = music_compare_artists (media_a, media_b);
			break;
		}
		case MUSIC_LIST_COLUMN_ALBUM:
		{
			order = music_compare_albums (media_a, media_b);
			break;
		}
		case MUSIC_LIST_COLUMN_TRACK:
		case MUSIC_LIST_COLUMN_ALBUM_ARTIST:
		{
			order = music_compare_album_artists (media_a, media_b);
			break;
		}
		case MUSIC_LIST_COLUMN_COMPOSER:
		{
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			_tmp10_ = music_media_get_display_composer (media_a);
			_tmp11_ = _tmp10_;
			_tmp12_ = music_media_get_display_composer (media_b);
			_tmp13_ = _tmp12_;
			order = music_string_compare (_tmp11_, _tmp13_);
			_g_free0 (_tmp13_);
			_g_free0 (_tmp11_);
			break;
		}
		case MUSIC_LIST_COLUMN_GROUPING:
		{
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			_tmp14_ = music_media_get_grouping (media_a);
			_tmp15_ = _tmp14_;
			_tmp16_ = music_media_get_grouping (media_b);
			_tmp17_ = _tmp16_;
			order = music_string_compare (_tmp15_, _tmp17_);
			break;
		}
		case MUSIC_LIST_COLUMN_GENRE:
		{
			order = music_compare_genres (media_a, media_b);
			break;
		}
		case MUSIC_LIST_COLUMN_YEAR:
		{
			guint _tmp18_;
			guint _tmp19_;
			guint _tmp20_;
			guint _tmp21_;
			_tmp18_ = music_media_get_year (media_a);
			_tmp19_ = _tmp18_;
			_tmp20_ = music_media_get_year (media_b);
			_tmp21_ = _tmp20_;
			order = music_compare_standard_unsigned (_tmp19_, _tmp21_);
			break;
		}
		case MUSIC_LIST_COLUMN_BITRATE:
		{
			guint _tmp22_;
			guint _tmp23_;
			guint _tmp24_;
			guint _tmp25_;
			_tmp22_ = music_media_get_bitrate (media_a);
			_tmp23_ = _tmp22_;
			_tmp24_ = music_media_get_bitrate (media_b);
			_tmp25_ = _tmp24_;
			order = music_compare_standard_unsigned (_tmp23_, _tmp25_);
			break;
		}
		case MUSIC_LIST_COLUMN_RATING:
		{
			guint _tmp26_;
			guint _tmp27_;
			guint _tmp28_;
			guint _tmp29_;
			_tmp26_ = music_media_get_rating (media_a);
			_tmp27_ = _tmp26_;
			_tmp28_ = music_media_get_rating (media_b);
			_tmp29_ = _tmp28_;
			order = music_compare_standard_unsigned (_tmp27_, _tmp29_);
			break;
		}
		case MUSIC_LIST_COLUMN_PLAY_COUNT:
		{
			guint _tmp30_;
			guint _tmp31_;
			guint _tmp32_;
			guint _tmp33_;
			_tmp30_ = music_media_get_play_count (media_a);
			_tmp31_ = _tmp30_;
			_tmp32_ = music_media_get_play_count (media_b);
			_tmp33_ = _tmp32_;
			order = music_compare_standard_unsigned (_tmp31_, _tmp33_);
			break;
		}
		case MUSIC_LIST_COLUMN_SKIP_COUNT:
		{
			guint _tmp34_;
			guint _tmp35_;
			guint _tmp36_;
			guint _tmp37_;
			_tmp34_ = music_media_get_skip_count (media_a);
			_tmp35_ = _tmp34_;
			_tmp36_ = music_media_get_skip_count (media_b);
			_tmp37_ = _tmp36_;
			order = music_compare_standard_unsigned (_tmp35_, _tmp37_);
			break;
		}
		case MUSIC_LIST_COLUMN_DATE_ADDED:
		{
			guint _tmp38_;
			guint _tmp39_;
			guint _tmp40_;
			guint _tmp41_;
			_tmp38_ = music_media_get_date_added (media_a);
			_tmp39_ = _tmp38_;
			_tmp40_ = music_media_get_date_added (media_b);
			_tmp41_ = _tmp40_;
			order = music_compare_standard_unsigned (_tmp39_, _tmp41_);
			break;
		}
		case MUSIC_LIST_COLUMN_LAST_PLAYED:
		{
			guint _tmp42_;
			guint _tmp43_;
			guint _tmp44_;
			guint _tmp45_;
			_tmp42_ = music_media_get_last_played (media_a);
			_tmp43_ = _tmp42_;
			_tmp44_ = music_media_get_last_played (media_b);
			_tmp45_ = _tmp44_;
			order = music_compare_standard_unsigned (_tmp43_, _tmp45_);
			break;
		}
		case MUSIC_LIST_COLUMN_BPM:
		{
			guint _tmp46_;
			guint _tmp47_;
			guint _tmp48_;
			guint _tmp49_;
			_tmp46_ = music_media_get_bpm (media_a);
			_tmp47_ = _tmp46_;
			_tmp48_ = music_media_get_bpm (media_b);
			_tmp49_ = _tmp48_;
			order = music_compare_standard_unsigned (_tmp47_, _tmp49_);
			break;
		}
		case MUSIC_LIST_COLUMN_FILE_SIZE:
		{
			guint64 _tmp50_;
			guint64 _tmp51_;
			guint64 _tmp52_;
			guint64 _tmp53_;
			_tmp50_ = music_media_get_file_size (media_a);
			_tmp51_ = _tmp50_;
			_tmp52_ = music_media_get_file_size (media_b);
			_tmp53_ = _tmp52_;
			order = music_compare_standard_64 ((gint64) _tmp51_, (gint64) _tmp53_);
			break;
		}
		case MUSIC_LIST_COLUMN_FILE_LOCATION:
		{
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			_tmp54_ = music_media_get_display_location (media_a);
			_tmp55_ = _tmp54_;
			_tmp56_ = music_media_get_display_location (media_b);
			_tmp57_ = _tmp56_;
			order = music_string_compare (_tmp55_, _tmp57_);
			_g_free0 (_tmp57_);
			_g_free0 (_tmp55_);
			break;
		}
		default:
		break;
	}
	if (order == 0) {
		_tmp59_ = column != ((gint) MUSIC_LIST_COLUMN_GENRE);
	} else {
		_tmp59_ = FALSE;
	}
	if (_tmp59_) {
		_tmp58_ = column != ((gint) MUSIC_LIST_COLUMN_ARTIST);
	} else {
		_tmp58_ = FALSE;
	}
	if (_tmp58_) {
		order = music_compare_titles (media_a, media_b);
	}
	if (order == 0) {
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		gchar* _tmp65_;
		_tmp60_ = music_media_get_uri (media_a);
		_tmp61_ = _tmp60_;
		_tmp62_ = _tmp61_;
		_tmp63_ = music_media_get_uri (media_b);
		_tmp64_ = _tmp63_;
		_tmp65_ = _tmp64_;
		order = music_string_compare (_tmp62_, _tmp65_);
		_g_free0 (_tmp65_);
		_g_free0 (_tmp62_);
	}
	if (dir == GTK_SORT_DESCENDING) {
		_tmp66_ = order != 0;
	} else {
		_tmp66_ = FALSE;
	}
	if (_tmp66_) {
		gint _tmp67_ = 0;
		if (order > 0) {
			_tmp67_ = -1;
		} else {
			_tmp67_ = 1;
		}
		order = _tmp67_;
	}
	result = order;
	return result;
}

GValue*
music_music_list_view_view_value_func (MusicMusicListView* self,
                                       gint row,
                                       gint column,
                                       GObject* o)
{
	MusicMedia* m = NULL;
	MusicMedia* _tmp0_;
	MusicListColumn list_column = 0;
	GValue* _tmp1_;
	GValue* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (o != NULL, NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (o, MUSIC_TYPE_MEDIA) ? ((MusicMedia*) o) : NULL);
	m = _tmp0_;
	g_return_val_if_fail (m != NULL, NULL);
	list_column = (MusicListColumn) column;
	_tmp1_ = music_list_column_get_value_for_media (list_column, m, row);
	result = _tmp1_;
	_g_object_unref0 (m);
	return result;
}

static void
_music_cell_data_function_helper_icon_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                      GtkCellRenderer* cell,
                                                                      GtkTreeModel* tree_model,
                                                                      GtkTreeIter* iter,
                                                                      gpointer self)
{
	music_cell_data_function_helper_icon_func ((MusicCellDataFunctionHelper*) self, cell_layout, cell, tree_model, iter);
}

static void
_music_cell_data_function_helper_spinner_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                         GtkCellRenderer* cell,
                                                                         GtkTreeModel* tree_model,
                                                                         GtkTreeIter* iter,
                                                                         gpointer self)
{
	music_cell_data_function_helper_spinner_func ((MusicCellDataFunctionHelper*) self, cell_layout, cell, tree_model, iter);
}

static void
_music_cell_data_function_helper_bitrate_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                         GtkCellRenderer* cell,
                                                                         GtkTreeModel* tree_model,
                                                                         GtkTreeIter* iter,
                                                                         gpointer self)
{
	music_cell_data_function_helper_bitrate_func (cell_layout, cell, tree_model, iter);
}

static void
_vala_array_add15 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_music_cell_data_function_helper_length_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
	music_cell_data_function_helper_length_func (cell_layout, cell, tree_model, iter);
}

static void
_vala_array_add16 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_music_cell_data_function_helper_date_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                      GtkCellRenderer* cell,
                                                                      GtkTreeModel* tree_model,
                                                                      GtkTreeIter* iter,
                                                                      gpointer self)
{
	music_cell_data_function_helper_date_func (cell_layout, cell, tree_model, iter);
}

static void
_vala_array_add17 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add18 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_music_generic_list_on_rating_cell_changed_music_rating_cell_renderer_rating_changed (MusicRatingCellRenderer* _sender,
                                                                                      gint new_rating,
                                                                                      GtkWidget* widget,
                                                                                      const gchar* path,
                                                                                      gpointer self)
{
	music_generic_list_on_rating_cell_changed ((MusicGenericList*) self, new_rating, widget, path);
}

static void
_music_cell_data_function_helper_rating_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
	music_cell_data_function_helper_rating_func (cell_layout, cell, tree_model, iter);
}

static void
_music_cell_data_function_helper_number_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
	music_cell_data_function_helper_number_func (cell_layout, cell, tree_model, iter);
}

static void
_vala_array_add19 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_music_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self)
{
	music_cell_data_function_helper_intelligent_func (cell_layout, cell, tree_model, iter);
}

static void
_vala_array_add20 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add21 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_music_cell_data_function_helper_string_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
	music_cell_data_function_helper_string_func (cell_layout, cell, tree_model, iter);
}

static void
_vala_array_add22 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add23 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_music_cell_data_function_helper_file_size_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                           GtkCellRenderer* cell,
                                                                           GtkTreeModel* tree_model,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self)
{
	music_cell_data_function_helper_file_size_func (cell_layout, cell, tree_model, iter);
}

static void
_vala_array_add24 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gboolean
___lambda64_ (MusicMusicListView* self,
              GdkEventButton* e)
{
	gboolean result = FALSE;
	g_return_val_if_fail (e != NULL, FALSE);
	result = music_music_list_view_view_header_click (self, e, TRUE);
	return result;
}

static gboolean
____lambda64__gtk_widget_button_press_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda64_ ((MusicMusicListView*) self, event);
	return result;
}

static gboolean
___lambda65_ (MusicMusicListView* self,
              GdkEventButton* e)
{
	gboolean result = FALSE;
	g_return_val_if_fail (e != NULL, FALSE);
	result = music_music_list_view_view_header_click (self, e, FALSE);
	return result;
}

static gboolean
____lambda65__gtk_widget_button_press_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda65_ ((MusicMusicListView*) self, event);
	return result;
}

static void
music_music_list_view_real_add_column (MusicGenericList* base,
                                       GtkTreeViewColumn* tvc,
                                       MusicListColumn type)
{
	MusicMusicListView * self;
	gboolean column_resizable = FALSE;
	gboolean column_reorderable = FALSE;
	gint column_width = 0;
	gint insert_index = 0;
	gchar** test_strings = NULL;
	gchar** _tmp0_;
	gint test_strings_length1;
	gint _test_strings_size_;
	GtkCellRenderer* renderer = NULL;
	GtkCellRenderer* _tmp66_;
	gboolean _tmp73_ = FALSE;
	gboolean sortable = FALSE;
	gint _tmp74_ = 0;
	GtkWidget* header_button = NULL;
	GtkWidget* _tmp75_;
	GtkWidget* _tmp76_;
	gboolean _tmp77_;
	gboolean _tmp78_;
	gint _tmp89_;
	gint _tmp90_;
	self = (MusicMusicListView*) base;
	g_return_if_fail (tvc != NULL);
	gtk_tree_view_column_set_sizing (tvc, GTK_TREE_VIEW_COLUMN_FIXED);
	column_resizable = TRUE;
	column_reorderable = TRUE;
	column_width = -1;
	insert_index = -1;
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	test_strings = _tmp0_;
	test_strings_length1 = 0;
	_test_strings_size_ = test_strings_length1;
	renderer = NULL;
	switch (type) {
		case MUSIC_LIST_COLUMN_ICON:
		{
			GtkCellRendererPixbuf* icon_renderer = NULL;
			GtkCellRendererPixbuf* _tmp1_;
			GtkCellRendererSpinner* spinner_renderer = NULL;
			GtkCellRendererSpinner* _tmp2_;
			GtkCellRendererPixbuf* _tmp3_;
			GtkCellRendererSpinner* _tmp4_;
			gint width = 0;
			gint height = 0;
			GtkCellRendererPixbuf* _tmp5_;
			guint _tmp6_;
			guint _tmp7_;
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			GtkCellRendererPixbuf* _tmp10_;
			MusicCellDataFunctionHelper* _tmp11_;
			GtkCellRendererSpinner* _tmp12_;
			MusicCellDataFunctionHelper* _tmp13_;
			GtkCellRendererSpinner* _tmp14_;
			GtkCellRendererPixbuf* _tmp15_;
			GtkCellRenderer* _tmp16_;
			insert_index = (gint) type;
			column_reorderable = FALSE;
			column_resizable = FALSE;
			_tmp1_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
			g_object_ref_sink (_tmp1_);
			icon_renderer = _tmp1_;
			_tmp2_ = (GtkCellRendererSpinner*) gtk_cell_renderer_spinner_new ();
			g_object_ref_sink (_tmp2_);
			spinner_renderer = _tmp2_;
			_tmp3_ = icon_renderer;
			_tmp4_ = spinner_renderer;
			g_object_set (_tmp4_, "size", GTK_ICON_SIZE_MENU, NULL);
			g_object_set (_tmp3_, "stock-size", (guint) GTK_ICON_SIZE_MENU, NULL);
			_tmp5_ = icon_renderer;
			g_object_get (_tmp5_, "stock-size", &_tmp6_, NULL);
			_tmp7_ = _tmp6_;
			gtk_icon_size_lookup ((GtkIconSize) _tmp7_, &_tmp8_, &_tmp9_);
			width = _tmp8_;
			height = _tmp9_;
			column_width = MAX (width, height) + 7;
			_tmp10_ = icon_renderer;
			_tmp11_ = ((MusicGenericList*) self)->cell_data_helper;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp10_, _music_cell_data_function_helper_icon_func_gtk_cell_layout_data_func, music_cell_data_function_helper_ref (_tmp11_), music_cell_data_function_helper_unref);
			_tmp12_ = spinner_renderer;
			_tmp13_ = ((MusicGenericList*) self)->cell_data_helper;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp12_, _music_cell_data_function_helper_spinner_func_gtk_cell_layout_data_func, music_cell_data_function_helper_ref (_tmp13_), music_cell_data_function_helper_unref);
			_tmp14_ = spinner_renderer;
			gtk_cell_layout_pack_start ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp14_, TRUE);
			_tmp15_ = icon_renderer;
			_tmp16_ = _g_object_ref0 ((GtkCellRenderer*) _tmp15_);
			_g_object_unref0 (renderer);
			renderer = _tmp16_;
			_g_object_unref0 (spinner_renderer);
			_g_object_unref0 (icon_renderer);
			break;
		}
		case MUSIC_LIST_COLUMN_BITRATE:
		{
			GtkCellRendererText* _tmp17_;
			GtkCellRenderer* _tmp18_;
			gchar** _tmp19_;
			gint _tmp19__length1;
			gchar* _tmp20_;
			_tmp17_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
			g_object_ref_sink (_tmp17_);
			_g_object_unref0 (renderer);
			renderer = (GtkCellRenderer*) _tmp17_;
			_tmp18_ = renderer;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp18_, _music_cell_data_function_helper_bitrate_func_gtk_cell_layout_data_func, NULL, NULL);
			column_resizable = FALSE;
			_tmp19_ = test_strings;
			_tmp19__length1 = test_strings_length1;
			_tmp20_ = g_strdup (_ ("1234 kbps"));
			_vala_array_add15 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp20_);
			break;
		}
		case MUSIC_LIST_COLUMN_LENGTH:
		{
			GtkCellRendererText* _tmp21_;
			GtkCellRenderer* _tmp22_;
			gchar** _tmp23_;
			gint _tmp23__length1;
			gchar* _tmp24_;
			_tmp21_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
			g_object_ref_sink (_tmp21_);
			_g_object_unref0 (renderer);
			renderer = (GtkCellRenderer*) _tmp21_;
			_tmp22_ = renderer;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp22_, _music_cell_data_function_helper_length_func_gtk_cell_layout_data_func, NULL, NULL);
			column_resizable = FALSE;
			_tmp23_ = test_strings;
			_tmp23__length1 = test_strings_length1;
			_tmp24_ = g_strdup ("0000:00");
			_vala_array_add16 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp24_);
			break;
		}
		case MUSIC_LIST_COLUMN_DATE_ADDED:
		case MUSIC_LIST_COLUMN_LAST_PLAYED:
		{
			GtkCellRendererText* _tmp25_;
			GtkCellRenderer* _tmp26_;
			gchar** _tmp27_;
			gint _tmp27__length1;
			gchar* _tmp28_;
			gchar** _tmp29_;
			gint _tmp29__length1;
			gchar* _tmp30_;
			_tmp25_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
			g_object_ref_sink (_tmp25_);
			_g_object_unref0 (renderer);
			renderer = (GtkCellRenderer*) _tmp25_;
			_tmp26_ = renderer;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp26_, _music_cell_data_function_helper_date_func_gtk_cell_layout_data_func, NULL, NULL);
			_tmp27_ = test_strings;
			_tmp27__length1 = test_strings_length1;
			_tmp28_ = music_cell_data_function_helper_get_date_string ((guint) 1324512000);
			_vala_array_add17 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp28_);
			_tmp29_ = test_strings;
			_tmp29__length1 = test_strings_length1;
			_tmp30_ = g_strdup (_ ("Never"));
			_vala_array_add18 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp30_);
			break;
		}
		case MUSIC_LIST_COLUMN_RATING:
		{
			MusicRatingCellRenderer* rating_renderer = NULL;
			MusicRatingCellRenderer* _tmp31_;
			MusicRatingCellRenderer* _tmp32_;
			MusicRatingCellRenderer* _tmp33_;
			GtkCellRenderer* _tmp34_;
			MusicRatingCellRenderer* _tmp35_;
			MusicRatingCellRenderer* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
			_tmp31_ = music_rating_cell_renderer_new (GTK_ICON_SIZE_MENU);
			g_object_ref_sink (_tmp31_);
			rating_renderer = _tmp31_;
			_tmp32_ = rating_renderer;
			g_signal_connect_object (_tmp32_, "rating-changed", (GCallback) _music_generic_list_on_rating_cell_changed_music_rating_cell_renderer_rating_changed, (MusicGenericList*) self, 0);
			_tmp33_ = rating_renderer;
			_tmp34_ = _g_object_ref0 ((GtkCellRenderer*) _tmp33_);
			_g_object_unref0 (renderer);
			renderer = _tmp34_;
			_tmp35_ = rating_renderer;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp35_, _music_cell_data_function_helper_rating_func_gtk_cell_layout_data_func, NULL, NULL);
			column_resizable = FALSE;
			_tmp36_ = rating_renderer;
			g_object_get ((GtkCellRenderer*) _tmp36_, "width", &_tmp37_, NULL);
			_tmp38_ = _tmp37_;
			column_width = _tmp38_ + 5;
			_g_object_unref0 (rating_renderer);
			break;
		}
		case MUSIC_LIST_COLUMN_NUMBER:
		{
			GtkCellRendererText* text_renderer = NULL;
			GtkCellRendererText* _tmp39_;
			GtkCellRendererText* _tmp40_;
			GtkCellRendererText* _tmp41_;
			GtkCellRenderer* _tmp42_;
			GtkCellRenderer* _tmp43_;
			gchar** _tmp44_;
			gint _tmp44__length1;
			gchar* _tmp45_;
			_tmp39_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
			g_object_ref_sink (_tmp39_);
			text_renderer = _tmp39_;
			_tmp40_ = text_renderer;
			g_object_set (_tmp40_, "style", PANGO_STYLE_ITALIC, NULL);
			_tmp41_ = text_renderer;
			_tmp42_ = _g_object_ref0 ((GtkCellRenderer*) _tmp41_);
			_g_object_unref0 (renderer);
			renderer = _tmp42_;
			_tmp43_ = renderer;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp43_, _music_cell_data_function_helper_number_func_gtk_cell_layout_data_func, NULL, NULL);
			column_resizable = FALSE;
			_tmp44_ = test_strings;
			_tmp44__length1 = test_strings_length1;
			_tmp45_ = g_strdup ("00000");
			_vala_array_add19 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp45_);
			_g_object_unref0 (text_renderer);
			break;
		}
		case MUSIC_LIST_COLUMN_YEAR:
		{
			GtkCellRendererText* _tmp46_;
			GtkCellRenderer* _tmp47_;
			gchar** _tmp48_;
			gint _tmp48__length1;
			gchar* _tmp49_;
			_tmp46_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
			g_object_ref_sink (_tmp46_);
			_g_object_unref0 (renderer);
			renderer = (GtkCellRenderer*) _tmp46_;
			_tmp47_ = renderer;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp47_, _music_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func, NULL, NULL);
			column_resizable = FALSE;
			_tmp48_ = test_strings;
			_tmp48__length1 = test_strings_length1;
			_tmp49_ = g_strdup ("0000");
			_vala_array_add20 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp49_);
			break;
		}
		case MUSIC_LIST_COLUMN_TRACK:
		case MUSIC_LIST_COLUMN_PLAY_COUNT:
		case MUSIC_LIST_COLUMN_SKIP_COUNT:
		{
			GtkCellRendererText* _tmp50_;
			GtkCellRenderer* _tmp51_;
			gchar** _tmp52_;
			gint _tmp52__length1;
			gchar* _tmp53_;
			_tmp50_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
			g_object_ref_sink (_tmp50_);
			_g_object_unref0 (renderer);
			renderer = (GtkCellRenderer*) _tmp50_;
			_tmp51_ = renderer;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp51_, _music_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func, NULL, NULL);
			column_resizable = FALSE;
			_tmp52_ = test_strings;
			_tmp52__length1 = test_strings_length1;
			_tmp53_ = g_strdup ("9999");
			_vala_array_add21 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp53_);
			break;
		}
		case MUSIC_LIST_COLUMN_ALBUM:
		case MUSIC_LIST_COLUMN_TITLE:
		case MUSIC_LIST_COLUMN_ARTIST:
		case MUSIC_LIST_COLUMN_ALBUM_ARTIST:
		case MUSIC_LIST_COLUMN_COMPOSER:
		case MUSIC_LIST_COLUMN_GENRE:
		case MUSIC_LIST_COLUMN_GROUPING:
		case MUSIC_LIST_COLUMN_FILE_LOCATION:
		{
			GtkCellRendererText* _tmp54_;
			GtkCellRenderer* _tmp55_;
			gchar** _tmp56_;
			gint _tmp56__length1;
			gchar* _tmp57_;
			_tmp54_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
			g_object_ref_sink (_tmp54_);
			_g_object_unref0 (renderer);
			renderer = (GtkCellRenderer*) _tmp54_;
			_tmp55_ = renderer;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp55_, _music_cell_data_function_helper_string_func_gtk_cell_layout_data_func, NULL, NULL);
			_tmp56_ = test_strings;
			_tmp56__length1 = test_strings_length1;
			_tmp57_ = g_strdup (_ ("Sample List String"));
			_vala_array_add22 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp57_);
			break;
		}
		case MUSIC_LIST_COLUMN_BPM:
		{
			GtkCellRendererText* _tmp58_;
			GtkCellRenderer* _tmp59_;
			gchar** _tmp60_;
			gint _tmp60__length1;
			gchar* _tmp61_;
			_tmp58_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
			g_object_ref_sink (_tmp58_);
			_g_object_unref0 (renderer);
			renderer = (GtkCellRenderer*) _tmp58_;
			_tmp59_ = renderer;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp59_, _music_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func, NULL, NULL);
			column_resizable = FALSE;
			_tmp60_ = test_strings;
			_tmp60__length1 = test_strings_length1;
			_tmp61_ = g_strdup ("9999");
			_vala_array_add23 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp61_);
			break;
		}
		case MUSIC_LIST_COLUMN_FILE_SIZE:
		{
			GtkCellRendererText* _tmp62_;
			GtkCellRenderer* _tmp63_;
			gchar** _tmp64_;
			gint _tmp64__length1;
			gchar* _tmp65_;
			_tmp62_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
			g_object_ref_sink (_tmp62_);
			_g_object_unref0 (renderer);
			renderer = (GtkCellRenderer*) _tmp62_;
			_tmp63_ = renderer;
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp63_, _music_cell_data_function_helper_file_size_func_gtk_cell_layout_data_func, NULL, NULL);
			_tmp64_ = test_strings;
			_tmp64__length1 = test_strings_length1;
			_tmp65_ = g_format_size_full ((guint64) ((1024 * 1024) * 932), G_FORMAT_SIZE_DEFAULT);
			_vala_array_add24 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp65_);
			break;
		}
		default:
		{
			g_return_if_reached ();
		}
	}
	_tmp66_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) tvc, _tmp66_, TRUE);
	gtk_tree_view_insert_column ((GtkTreeView*) self, tvc, insert_index);
	if (column_width > 0) {
		gtk_tree_view_column_set_fixed_width (tvc, column_width);
	} else {
		GtkCellRenderer* _tmp67_;
		_tmp67_ = renderer;
		if (_tmp67_ != NULL) {
			GtkCellRendererText* text_renderer = NULL;
			GtkCellRenderer* _tmp68_;
			GtkCellRendererText* _tmp69_;
			GtkCellRendererText* _tmp70_;
			_tmp68_ = renderer;
			_tmp69_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp68_, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) _tmp68_) : NULL);
			text_renderer = _tmp69_;
			_tmp70_ = text_renderer;
			if (_tmp70_ != NULL) {
				GtkCellRendererText* _tmp71_;
				gchar** _tmp72_;
				gint _tmp72__length1;
				_tmp71_ = text_renderer;
				_tmp72_ = test_strings;
				_tmp72__length1 = test_strings_length1;
				music_generic_list_set_fixed_column_width ((MusicGenericList*) self, (GtkWidget*) self, tvc, _tmp71_, _tmp72_, (gint) _tmp72__length1, 5);
			}
			_g_object_unref0 (text_renderer);
		}
	}
	gtk_tree_view_column_set_reorderable (tvc, FALSE);
	gtk_tree_view_column_set_clickable (tvc, TRUE);
	gtk_tree_view_column_set_resizable (tvc, column_resizable);
	gtk_tree_view_column_set_expand (tvc, column_resizable);
	if (type != MUSIC_LIST_COLUMN_NUMBER) {
		_tmp73_ = type != MUSIC_LIST_COLUMN_ICON;
	} else {
		_tmp73_ = FALSE;
	}
	sortable = _tmp73_;
	if (sortable) {
		_tmp74_ = (gint) type;
	} else {
		_tmp74_ = -1;
	}
	gtk_tree_view_column_set_sort_column_id (tvc, _tmp74_);
	gtk_tree_view_column_set_sort_indicator (tvc, sortable);
	_tmp75_ = gtk_tree_view_column_get_button (tvc);
	_tmp76_ = _g_object_ref0 (_tmp75_);
	header_button = _tmp76_;
	_tmp77_ = gtk_tree_view_get_headers_visible ((GtkTreeView*) self);
	_tmp78_ = _tmp77_;
	if (_tmp78_) {
		GtkRequisition natural_size = {0};
		GtkWidget* _tmp79_;
		GtkRequisition _tmp80_ = {0};
		GtkRequisition _tmp81_;
		gint _tmp82_;
		gint _tmp83_;
		gboolean _tmp85_;
		gboolean _tmp86_;
		_tmp79_ = header_button;
		gtk_widget_get_preferred_size (_tmp79_, NULL, &_tmp80_);
		natural_size = _tmp80_;
		_tmp81_ = natural_size;
		_tmp82_ = gtk_tree_view_column_get_fixed_width (tvc);
		_tmp83_ = _tmp82_;
		if (_tmp81_.width > _tmp83_) {
			GtkRequisition _tmp84_;
			_tmp84_ = natural_size;
			gtk_tree_view_column_set_fixed_width (tvc, _tmp84_.width);
		}
		_tmp85_ = gtk_tree_view_column_get_sort_indicator (tvc);
		_tmp86_ = _tmp85_;
		if (_tmp86_) {
			gint _tmp87_;
			gint _tmp88_;
			_tmp87_ = gtk_tree_view_column_get_fixed_width (tvc);
			_tmp88_ = _tmp87_;
			gtk_tree_view_column_set_fixed_width (tvc, _tmp88_ + 5);
		}
	}
	_tmp89_ = gtk_tree_view_column_get_fixed_width (tvc);
	_tmp90_ = _tmp89_;
	gtk_tree_view_column_set_min_width (tvc, _tmp90_);
	music_music_list_view_add_column_chooser_menu_item (self, tvc, type);
	if (type == MUSIC_LIST_COLUMN_ICON) {
		GtkWidget* _tmp91_;
		_tmp91_ = header_button;
		g_signal_connect_object (_tmp91_, "button-press-event", (GCallback) ____lambda64__gtk_widget_button_press_event, self, 0);
	} else {
		GtkWidget* _tmp92_;
		_tmp92_ = header_button;
		g_signal_connect_object (_tmp92_, "button-press-event", (GCallback) ____lambda65__gtk_widget_button_press_event, self, 0);
	}
	_g_object_unref0 (header_button);
	_g_object_unref0 (renderer);
	test_strings = (_vala_array_free (test_strings, test_strings_length1, (GDestroyNotify) g_free), NULL);
}

MusicMediaMenu*
music_music_list_view_get_media_action_menu (MusicMusicListView* self)
{
	MusicMediaMenu* result;
	MusicMediaMenu* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_media_action_menu;
	result = _tmp0_;
	return result;
}

static void
music_music_list_view_set_media_action_menu (MusicMusicListView* self,
                                             MusicMediaMenu* value)
{
	g_return_if_fail (self != NULL);
	if (music_music_list_view_get_media_action_menu (self) != value) {
		MusicMediaMenu* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_media_action_menu);
		self->priv->_media_action_menu = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_music_list_view_properties[MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY]);
	}
}

static GValue*
_music_music_list_view_view_value_func_music_fast_model_value_return_func (gint row,
                                                                           gint column,
                                                                           GObject* o,
                                                                           gpointer self)
{
	GValue* result;
	result = music_music_list_view_view_value_func ((MusicMusicListView*) self, row, column, o);
	return result;
}

static gint
_music_music_list_view_view_compare_func_music_generic_list_sort_compare_func (gint sort_column_id,
                                                                               GtkSortType sort_direction,
                                                                               MusicMedia* a,
                                                                               MusicMedia* b,
                                                                               gint index_a,
                                                                               gint index_b,
                                                                               gpointer self)
{
	gint result;
	result = music_music_list_view_view_compare_func ((MusicMusicListView*) self, sort_column_id, sort_direction, a, b, index_a, index_b);
	return result;
}

static gboolean
_music_music_list_view_view_click_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self)
{
	gboolean result;
	result = music_music_list_view_view_click_release ((MusicMusicListView*) self, _sender, event);
	return result;
}

static GObject *
music_music_list_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicMusicListView * self;
	MusicMediaMenu* _tmp0_;
	MusicMediaMenu* _tmp1_;
	MusicMediaMenu* _tmp2_;
	MusicPlaylist* _tmp3_;
	MusicPlaylist* _tmp4_;
	MusicPlaybackManager* _tmp5_;
	MusicPlaybackManager* _tmp6_;
	MusicStaticPlaylist* _tmp7_;
	parent_class = G_OBJECT_CLASS (music_music_list_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView);
	gtk_tree_view_set_headers_clickable ((GtkTreeView*) self, TRUE);
	gtk_tree_view_set_headers_visible ((GtkTreeView*) self, TRUE);
	music_generic_list_set_value_func ((MusicGenericList*) self, _music_music_list_view_view_value_func_music_fast_model_value_return_func, self);
	music_generic_list_set_compare_func ((MusicGenericList*) self, _music_music_list_view_view_compare_func_music_generic_list_sort_compare_func, self);
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) _music_music_list_view_view_click_release_gtk_widget_button_release_event, self, 0);
	_tmp0_ = music_media_menu_new ((MusicGenericList*) self);
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	music_music_list_view_set_media_action_menu (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = self->priv->_media_action_menu;
	gtk_menu_attach_to_widget ((GtkMenu*) _tmp2_, (GtkWidget*) self, NULL);
	_tmp3_ = music_generic_list_get_playlist ((MusicGenericList*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = music_app_get_player ();
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_->queue_playlist;
	gtk_tree_view_set_headers_clickable ((GtkTreeView*) self, _tmp4_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, MUSIC_TYPE_PLAYLIST, MusicPlaylist));
	return obj;
}

static void
music_music_list_view_class_init (MusicMusicListViewClass * klass,
                                  gpointer klass_data)
{
	music_music_list_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicMusicListView_private_offset);
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) music_music_list_view_real_button_press_event;
	((MusicGenericListClass *) klass)->media_remove_clicked = (void (*) (MusicGenericList*)) music_music_list_view_real_media_remove_clicked;
	((MusicMusicListViewClass *) klass)->on_drag_data_get = (void (*) (MusicMusicListView*, GdkDragContext*, GtkSelectionData*, guint, guint)) music_music_list_view_real_on_drag_data_get;
	((MusicGenericListClass *) klass)->add_column = (void (*) (MusicGenericList*, GtkTreeViewColumn*, MusicListColumn)) music_music_list_view_real_add_column;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_music_list_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_music_list_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_music_list_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_music_list_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY, music_music_list_view_properties[MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY] = g_param_spec_object ("media-action-menu", "media-action-menu", "media-action-menu", MUSIC_TYPE_MEDIA_MENU, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
music_music_list_view_instance_init (MusicMusicListView * self,
                                     gpointer klass)
{
	self->priv = music_music_list_view_get_instance_private (self);
}

static void
music_music_list_view_finalize (GObject * obj)
{
	MusicMusicListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView);
	_g_object_unref0 (self->priv->_media_action_menu);
	_g_object_unref0 (self->column_chooser_menu);
	_g_object_unref0 (self->priv->autosize_menu_item);
	G_OBJECT_CLASS (music_music_list_view_parent_class)->finalize (obj);
}

GType
music_music_list_view_get_type (void)
{
	static volatile gsize music_music_list_view_type_id__volatile = 0;
	if (g_once_init_enter (&music_music_list_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicMusicListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_music_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMusicListView), 0, (GInstanceInitFunc) music_music_list_view_instance_init, NULL };
		GType music_music_list_view_type_id;
		music_music_list_view_type_id = g_type_register_static (MUSIC_TYPE_GENERIC_LIST, "MusicMusicListView", &g_define_type_info, 0);
		MusicMusicListView_private_offset = g_type_add_instance_private (music_music_list_view_type_id, sizeof (MusicMusicListViewPrivate));
		g_once_init_leave (&music_music_list_view_type_id__volatile, music_music_list_view_type_id);
	}
	return music_music_list_view_type_id__volatile;
}

static void
_vala_music_music_list_view_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	MusicMusicListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView);
	switch (property_id) {
		case MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY:
		g_value_set_object (value, music_music_list_view_get_media_action_menu (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_music_list_view_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	MusicMusicListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView);
	switch (property_id) {
		case MUSIC_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY:
		music_music_list_view_set_media_action_menu (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

