/* FastGrid.c generated by valac 0.44.11, the Vala compiler
 * generated from FastGrid.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <cairo.h>
#include <float.h>
#include <math.h>

#define MUSIC_TYPE_FAST_GRID (music_fast_grid_get_type ())
#define MUSIC_FAST_GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_FAST_GRID, MusicFastGrid))
#define MUSIC_FAST_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_FAST_GRID, MusicFastGridClass))
#define MUSIC_IS_FAST_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_FAST_GRID))
#define MUSIC_IS_FAST_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_FAST_GRID))
#define MUSIC_FAST_GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_FAST_GRID, MusicFastGridClass))

typedef struct _MusicFastGrid MusicFastGrid;
typedef struct _MusicFastGridClass MusicFastGridClass;
typedef struct _MusicFastGridPrivate MusicFastGridPrivate;
typedef void (*MusicFastGridViewSearchFunc) (GeeHashMap* showing, gpointer user_data);
typedef gint (*MusicFastGridSortCompareFunc) (GObject* a, GObject* b, gpointer user_data);

#define MUSIC_TYPE_FAST_GRID_MODEL (music_fast_grid_model_get_type ())
#define MUSIC_FAST_GRID_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_FAST_GRID_MODEL, MusicFastGridModel))
#define MUSIC_FAST_GRID_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_FAST_GRID_MODEL, MusicFastGridModelClass))
#define MUSIC_IS_FAST_GRID_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_FAST_GRID_MODEL))
#define MUSIC_IS_FAST_GRID_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_FAST_GRID_MODEL))
#define MUSIC_FAST_GRID_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_FAST_GRID_MODEL, MusicFastGridModelClass))

typedef struct _MusicFastGridModel MusicFastGridModel;
typedef struct _MusicFastGridModelClass MusicFastGridModelClass;
enum  {
	MUSIC_FAST_GRID_0_PROPERTY,
	MUSIC_FAST_GRID_NUM_PROPERTIES
};
static GParamSpec* music_fast_grid_properties[MUSIC_FAST_GRID_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MUSIC_WIDGETS_TYPE_TILE_RENDERER (music_widgets_tile_renderer_get_type ())
#define MUSIC_WIDGETS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRenderer))
#define MUSIC_WIDGETS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRendererClass))
#define MUSIC_WIDGETS_IS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_WIDGETS_TYPE_TILE_RENDERER))
#define MUSIC_WIDGETS_IS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_WIDGETS_TYPE_TILE_RENDERER))
#define MUSIC_WIDGETS_TILE_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRendererClass))

typedef struct _MusicWidgetsTileRenderer MusicWidgetsTileRenderer;
typedef struct _MusicWidgetsTileRendererClass MusicWidgetsTileRendererClass;

struct _MusicFastGrid {
	GtkIconView parent_instance;
	MusicFastGridPrivate * priv;
	gboolean research_needed;
};

struct _MusicFastGridClass {
	GtkIconViewClass parent_class;
};

struct _MusicFastGridPrivate {
	MusicFastGridViewSearchFunc _search_func;
	gpointer _search_func_target;
	MusicFastGridSortCompareFunc _compare_func;
	gpointer _compare_func_target;
	GtkCellRenderer* cell_renderer;
	MusicFastGridModel* fm;
	GeeHashMap* table;
	GeeHashMap* showing;
};

static gint MusicFastGrid_private_offset;
static gpointer music_fast_grid_parent_class = NULL;

GType music_fast_grid_get_type (void) G_GNUC_CONST;
GType music_fast_grid_model_get_type (void) G_GNUC_CONST;
GeeMap* music_fast_grid_get_table (MusicFastGrid* self);
GeeMap* music_fast_grid_get_visible_table (MusicFastGrid* self);
GObject* music_fast_grid_get_object_from_index (MusicFastGrid* self,
                                                gint index);
void music_fast_grid_set_table (MusicFastGrid* self,
                                GeeHashMap* new_table,
                                gboolean do_resort);
static void music_fast_grid_resort (MusicFastGrid* self);
void music_fast_grid_do_search (MusicFastGrid* self);
void music_fast_grid_remove_objects (MusicFastGrid* self,
                                     GeeCollection* objects);
void music_fast_grid_add_objects (MusicFastGrid* self,
                                  GeeCollection* objects);
MusicFastGridViewSearchFunc music_fast_grid_get_search_func (MusicFastGrid* self,
                                                             gpointer* result_target);
void music_fast_grid_model_set_table (MusicFastGridModel* self,
                                      GeeHashMap* table);
void music_fast_grid_model_remove (MusicFastGridModel* self,
                                   GtkTreeIter* iter);
void music_fast_grid_model_append (MusicFastGridModel* self,
                                   GtkTreeIter* iter);
static void music_fast_grid_quicksort (MusicFastGrid* self,
                                gint start,
                                gint end);
static void music_fast_grid_swap (MusicFastGrid* self,
                           gint a,
                           gint b);
MusicFastGridSortCompareFunc music_fast_grid_get_compare_func (MusicFastGrid* self,
                                                               gpointer* result_target);
static void music_fast_grid_real_size_allocate (GtkWidget* base,
                                         GtkAllocation* alloc);
MusicFastGrid* music_fast_grid_new (void);
MusicFastGrid* music_fast_grid_construct (GType object_type);
void music_fast_grid_set_search_func (MusicFastGrid* self,
                                      MusicFastGridViewSearchFunc value,
                                      gpointer value_target);
void music_fast_grid_set_compare_func (MusicFastGrid* self,
                                       MusicFastGridSortCompareFunc value,
                                       gpointer value_target);
static GObject * music_fast_grid_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
MusicFastGridModel* music_fast_grid_model_new (void);
MusicFastGridModel* music_fast_grid_model_construct (GType object_type);
MusicWidgetsTileRenderer* music_widgets_tile_renderer_new (void);
MusicWidgetsTileRenderer* music_widgets_tile_renderer_construct (GType object_type);
GType music_widgets_tile_renderer_get_type (void) G_GNUC_CONST;
static void music_fast_grid_finalize (GObject * obj);
static void _vala_music_fast_grid_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_music_fast_grid_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
music_fast_grid_get_instance_private (MusicFastGrid* self)
{
	return G_STRUCT_MEMBER_P (self, MusicFastGrid_private_offset);
}

/** Should not be manipulated by client */
GeeMap*
music_fast_grid_get_table (MusicFastGrid* self)
{
	GeeHashMap* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->table;
	_tmp1_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

/** Should not be manipulated by client */
GeeMap*
music_fast_grid_get_visible_table (MusicFastGrid* self)
{
	GeeHashMap* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->showing;
	_tmp1_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

GObject*
music_fast_grid_get_object_from_index (MusicFastGrid* self,
                                       gint index)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GObject* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->showing;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) index));
	result = (GObject*) _tmp1_;
	return result;
}

void
music_fast_grid_set_table (MusicFastGrid* self,
                           GeeHashMap* new_table,
                           gboolean do_resort)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (new_table != NULL);
	_tmp0_ = self->priv->table;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
	_tmp1_ = self->priv->table;
	gee_map_set_all ((GeeMap*) _tmp1_, (GeeMap*) new_table);
	if (do_resort) {
		music_fast_grid_resort (self);
	} else {
		music_fast_grid_do_search (self);
	}
}

void
music_fast_grid_remove_objects (MusicFastGrid* self,
                                GeeCollection* objects)
{
	GeeHashMap* to_remove = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp20_;
	GeeHashMap* _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (objects != NULL);
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	to_remove = _tmp0_;
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
		_tmp1_ = self->priv->table;
		_tmp2_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
		_tmp6_ = _tmp5_;
		_g_object_unref0 (_tmp4_);
		_entry_it = _tmp6_;
		while (TRUE) {
			GeeIterator* _tmp7_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GeeMapEntry* _tmp10_;
			gconstpointer _tmp11_;
			GObject* _tmp12_;
			_tmp7_ = _entry_it;
			if (!gee_iterator_next (_tmp7_)) {
				break;
			}
			_tmp8_ = _entry_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			entry = (GeeMapEntry*) _tmp9_;
			_tmp10_ = entry;
			_tmp11_ = gee_map_entry_get_value (_tmp10_);
			_tmp12_ = _tmp11_;
			if (gee_collection_contains (objects, (GObject*) _tmp12_)) {
				GeeHashMap* _tmp13_;
				GeeMapEntry* _tmp14_;
				gconstpointer _tmp15_;
				gint _tmp16_;
				GeeMapEntry* _tmp17_;
				gconstpointer _tmp18_;
				GObject* _tmp19_;
				_tmp13_ = to_remove;
				_tmp14_ = entry;
				_tmp15_ = gee_map_entry_get_key (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = entry;
				_tmp18_ = gee_map_entry_get_value (_tmp17_);
				_tmp19_ = _tmp18_;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, (gpointer) ((gintptr) ((gint) ((gintptr) _tmp16_))), (GObject*) _tmp19_);
			}
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	_tmp20_ = self->priv->table;
	_tmp21_ = to_remove;
	gee_map_unset_all ((GeeMap*) _tmp20_, (GeeMap*) _tmp21_);
	music_fast_grid_do_search (self);
	_g_object_unref0 (to_remove);
}

void
music_fast_grid_add_objects (MusicFastGrid* self,
                             GeeCollection* objects)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (objects != NULL);
	{
		GeeIterator* _o_it = NULL;
		GeeIterator* _tmp0_;
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) objects);
		_o_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_;
			GObject* o = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GeeHashMap* _tmp4_;
			GeeHashMap* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GObject* _tmp8_;
			_tmp1_ = _o_it;
			if (!gee_iterator_next (_tmp1_)) {
				break;
			}
			_tmp2_ = _o_it;
			_tmp3_ = gee_iterator_get (_tmp2_);
			o = (GObject*) _tmp3_;
			_tmp4_ = self->priv->table;
			_tmp5_ = self->priv->table;
			_tmp6_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp5_);
			_tmp7_ = _tmp6_;
			_tmp8_ = o;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) _tmp7_), _tmp8_);
			_g_object_unref0 (o);
		}
		_g_object_unref0 (_o_it);
	}
	music_fast_grid_resort (self);
}

void
music_fast_grid_do_search (MusicFastGrid* self)
{
	gboolean _tmp0_ = FALSE;
	MusicFastGridViewSearchFunc _tmp1_ = NULL;
	gpointer _tmp1__target = NULL;
	MusicFastGridViewSearchFunc _tmp2_;
	gpointer _tmp2__target;
	gint old_size = 0;
	GeeHashMap* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeHashMap* _tmp6_;
	MusicFastGridViewSearchFunc _tmp7_ = NULL;
	gpointer _tmp7__target = NULL;
	MusicFastGridViewSearchFunc _tmp8_;
	gpointer _tmp8__target;
	GeeHashMap* _tmp9_;
	GeeHashMap* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp1_ = music_fast_grid_get_search_func (self, &_tmp1__target);
	_tmp2_ = _tmp1_;
	_tmp2__target = _tmp1__target;
	if (_tmp2_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->research_needed == FALSE;
	}
	if (_tmp0_) {
		return;
	}
	self->research_needed = FALSE;
	_tmp3_ = self->priv->showing;
	_tmp4_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp3_);
	_tmp5_ = _tmp4_;
	old_size = _tmp5_;
	_tmp6_ = self->priv->showing;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp6_);
	_tmp7_ = music_fast_grid_get_search_func (self, &_tmp7__target);
	_tmp8_ = _tmp7_;
	_tmp8__target = _tmp7__target;
	_tmp9_ = self->priv->showing;
	_tmp8_ (_tmp9_, _tmp8__target);
	_tmp10_ = self->priv->showing;
	_tmp11_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp10_);
	_tmp12_ = _tmp11_;
	if (_tmp12_ == old_size) {
		MusicFastGridModel* _tmp13_;
		GeeHashMap* _tmp14_;
		_tmp13_ = self->priv->fm;
		_tmp14_ = self->priv->showing;
		music_fast_grid_model_set_table (_tmp13_, _tmp14_);
		gtk_widget_queue_draw ((GtkWidget*) self);
	} else {
		if (old_size == 0) {
			MusicFastGridModel* _tmp15_;
			GeeHashMap* _tmp16_;
			MusicFastGridModel* _tmp17_;
			gtk_icon_view_set_model ((GtkIconView*) self, NULL);
			_tmp15_ = self->priv->fm;
			_tmp16_ = self->priv->showing;
			music_fast_grid_model_set_table (_tmp15_, _tmp16_);
			_tmp17_ = self->priv->fm;
			gtk_icon_view_set_model ((GtkIconView*) self, (GtkTreeModel*) _tmp17_);
		} else {
			GeeHashMap* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			_tmp18_ = self->priv->showing;
			_tmp19_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp18_);
			_tmp20_ = _tmp19_;
			if (old_size > _tmp20_) {
				MusicFastGridModel* _tmp30_;
				GeeHashMap* _tmp31_;
				while (TRUE) {
					MusicFastGridModel* _tmp21_;
					GeeHashMap* _tmp22_;
					gint _tmp23_;
					gint _tmp24_;
					GtkTreeIter iter = {0};
					MusicFastGridModel* _tmp25_;
					MusicFastGridModel* _tmp26_;
					GtkTreeIter _tmp27_ = {0};
					MusicFastGridModel* _tmp28_;
					GtkTreeIter _tmp29_;
					_tmp21_ = self->priv->fm;
					_tmp22_ = self->priv->showing;
					_tmp23_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp22_);
					_tmp24_ = _tmp23_;
					if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp21_, NULL) > _tmp24_)) {
						break;
					}
					_tmp25_ = self->priv->fm;
					_tmp26_ = self->priv->fm;
					gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp25_, &_tmp27_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp26_, NULL) - 1);
					iter = _tmp27_;
					_tmp28_ = self->priv->fm;
					_tmp29_ = iter;
					music_fast_grid_model_remove (_tmp28_, &_tmp29_);
				}
				_tmp30_ = self->priv->fm;
				_tmp31_ = self->priv->showing;
				music_fast_grid_model_set_table (_tmp30_, _tmp31_);
				gtk_widget_queue_draw ((GtkWidget*) self);
			} else {
				GeeHashMap* _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				_tmp32_ = self->priv->showing;
				_tmp33_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp32_);
				_tmp34_ = _tmp33_;
				if (_tmp34_ > old_size) {
					GtkTreeIter iter = {0};
					MusicFastGridModel* _tmp41_;
					GeeHashMap* _tmp42_;
					while (TRUE) {
						MusicFastGridModel* _tmp35_;
						GeeHashMap* _tmp36_;
						gint _tmp37_;
						gint _tmp38_;
						MusicFastGridModel* _tmp39_;
						GtkTreeIter _tmp40_ = {0};
						_tmp35_ = self->priv->fm;
						_tmp36_ = self->priv->showing;
						_tmp37_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp36_);
						_tmp38_ = _tmp37_;
						if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp35_, NULL) < _tmp38_)) {
							break;
						}
						_tmp39_ = self->priv->fm;
						music_fast_grid_model_append (_tmp39_, &_tmp40_);
						iter = _tmp40_;
					}
					_tmp41_ = self->priv->fm;
					_tmp42_ = self->priv->showing;
					music_fast_grid_model_set_table (_tmp41_, _tmp42_);
					gtk_widget_queue_draw ((GtkWidget*) self);
				}
			}
		}
	}
}

static void
music_fast_grid_resort (MusicFastGrid* self)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->table;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	music_fast_grid_quicksort (self, 0, _tmp2_ - 1);
	music_fast_grid_do_search (self);
}

static void
music_fast_grid_swap (MusicFastGrid* self,
                      gint a,
                      gint b)
{
	GObject* temp = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
	GObject* _tmp5_;
	GeeHashMap* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->table;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) a));
	temp = (GObject*) _tmp1_;
	_tmp2_ = self->priv->table;
	_tmp3_ = self->priv->table;
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) b));
	_tmp5_ = (GObject*) _tmp4_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) a), _tmp5_);
	_g_object_unref0 (_tmp5_);
	_tmp6_ = self->priv->table;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, (gpointer) ((gintptr) b), temp);
	_g_object_unref0 (temp);
}

static void
music_fast_grid_quicksort (MusicFastGrid* self,
                           gint start,
                           gint end)
{
	GObject* pivot = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gint i = 0;
	gint j = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->table;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) ((start + end) / 2)));
	pivot = (GObject*) _tmp1_;
	i = start;
	j = end;
	while (TRUE) {
		if (!(i <= j)) {
			break;
		}
		while (TRUE) {
			gboolean _tmp2_ = FALSE;
			if (i < end) {
				MusicFastGridSortCompareFunc _tmp3_ = NULL;
				gpointer _tmp3__target = NULL;
				MusicFastGridSortCompareFunc _tmp4_;
				gpointer _tmp4__target;
				GeeHashMap* _tmp5_;
				gpointer _tmp6_;
				GObject* _tmp7_;
				GObject* _tmp8_;
				_tmp3_ = music_fast_grid_get_compare_func (self, &_tmp3__target);
				_tmp4_ = _tmp3_;
				_tmp4__target = _tmp3__target;
				_tmp5_ = self->priv->table;
				_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) i));
				_tmp7_ = (GObject*) _tmp6_;
				_tmp8_ = pivot;
				_tmp2_ = _tmp4_ (_tmp7_, _tmp8_, _tmp4__target) < 0;
				_g_object_unref0 (_tmp7_);
			} else {
				_tmp2_ = FALSE;
			}
			if (!_tmp2_) {
				break;
			}
			i = i + 1;
		}
		while (TRUE) {
			gboolean _tmp9_ = FALSE;
			if (j > start) {
				MusicFastGridSortCompareFunc _tmp10_ = NULL;
				gpointer _tmp10__target = NULL;
				MusicFastGridSortCompareFunc _tmp11_;
				gpointer _tmp11__target;
				GeeHashMap* _tmp12_;
				gpointer _tmp13_;
				GObject* _tmp14_;
				GObject* _tmp15_;
				_tmp10_ = music_fast_grid_get_compare_func (self, &_tmp10__target);
				_tmp11_ = _tmp10_;
				_tmp11__target = _tmp10__target;
				_tmp12_ = self->priv->table;
				_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, (gpointer) ((gintptr) j));
				_tmp14_ = (GObject*) _tmp13_;
				_tmp15_ = pivot;
				_tmp9_ = _tmp11_ (_tmp14_, _tmp15_, _tmp11__target) > 0;
				_g_object_unref0 (_tmp14_);
			} else {
				_tmp9_ = FALSE;
			}
			if (!_tmp9_) {
				break;
			}
			j = j - 1;
		}
		if (i <= j) {
			music_fast_grid_swap (self, i, j);
			i = i + 1;
			j = j - 1;
		}
	}
	if (start < j) {
		music_fast_grid_quicksort (self, start, j);
	}
	if (i < end) {
		music_fast_grid_quicksort (self, i, end);
	}
	_g_object_unref0 (pivot);
}

static void
music_fast_grid_real_size_allocate (GtkWidget* base,
                                    GtkAllocation* alloc)
{
	MusicFastGrid * self;
	GtkRequisition minimum_size = {0};
	GtkRequisition natural_size = {0};
	GtkCellRenderer* _tmp0_;
	GtkRequisition _tmp1_ = {0};
	GtkRequisition _tmp2_ = {0};
	gint item_width = 0;
	GtkRequisition _tmp3_;
	gint total_width = 0;
	GtkAllocation _tmp5_;
	gdouble num = 0.0;
	gint _tmp6_;
	gint _tmp7_;
	gdouble denom = 0.0;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GtkAllocation _tmp14_;
	self = (MusicFastGrid*) base;
	g_return_if_fail (alloc != NULL);
	_tmp0_ = self->priv->cell_renderer;
	gtk_cell_renderer_get_preferred_size (_tmp0_, (GtkWidget*) self, &_tmp1_, &_tmp2_);
	minimum_size = _tmp1_;
	natural_size = _tmp2_;
	_tmp3_ = minimum_size;
	item_width = _tmp3_.width;
	if (item_width <= 0) {
		GtkAllocation _tmp4_;
		_tmp4_ = *alloc;
		GTK_WIDGET_CLASS (music_fast_grid_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_icon_view_get_type (), GtkIconView), &_tmp4_);
	}
	_tmp5_ = *alloc;
	total_width = _tmp5_.width;
	_tmp6_ = gtk_icon_view_get_margin ((GtkIconView*) self);
	_tmp7_ = _tmp6_;
	num = (gdouble) (total_width - (2 * _tmp7_));
	denom = (gdouble) item_width;
	gtk_icon_view_set_columns ((GtkIconView*) self, (gint) (num / denom));
	_tmp8_ = gtk_icon_view_get_columns ((GtkIconView*) self);
	_tmp9_ = _tmp8_;
	_tmp10_ = gtk_icon_view_get_margin ((GtkIconView*) self);
	_tmp11_ = _tmp10_;
	num = (gdouble) ((total_width - (_tmp9_ * item_width)) - (2 * _tmp11_));
	_tmp12_ = gtk_icon_view_get_columns ((GtkIconView*) self);
	_tmp13_ = _tmp12_;
	denom = (gdouble) (_tmp13_ - 1);
	gtk_icon_view_set_column_spacing ((GtkIconView*) self, (gint) (num / denom));
	_tmp14_ = *alloc;
	GTK_WIDGET_CLASS (music_fast_grid_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_icon_view_get_type (), GtkIconView), &_tmp14_);
}

MusicFastGrid*
music_fast_grid_construct (GType object_type)
{
	MusicFastGrid * self = NULL;
	self = (MusicFastGrid*) g_object_new (object_type, NULL);
	return self;
}

MusicFastGrid*
music_fast_grid_new (void)
{
	return music_fast_grid_construct (MUSIC_TYPE_FAST_GRID);
}

MusicFastGridViewSearchFunc
music_fast_grid_get_search_func (MusicFastGrid* self,
                                 gpointer* result_target)
{
	MusicFastGridViewSearchFunc result;
	MusicFastGridViewSearchFunc _tmp0_;
	gpointer _tmp0__target;
	MusicFastGridViewSearchFunc _tmp1_;
	gpointer _tmp1__target;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_search_func;
	_tmp0__target = self->priv->_search_func_target;
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	*result_target = _tmp1__target;
	result = _tmp1_;
	return result;
}

void
music_fast_grid_set_search_func (MusicFastGrid* self,
                                 MusicFastGridViewSearchFunc value,
                                 gpointer value_target)
{
	g_return_if_fail (self != NULL);
	self->priv->_search_func = value;
	self->priv->_search_func_target = value_target;
}

MusicFastGridSortCompareFunc
music_fast_grid_get_compare_func (MusicFastGrid* self,
                                  gpointer* result_target)
{
	MusicFastGridSortCompareFunc result;
	MusicFastGridSortCompareFunc _tmp0_;
	gpointer _tmp0__target;
	MusicFastGridSortCompareFunc _tmp1_;
	gpointer _tmp1__target;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_compare_func;
	_tmp0__target = self->priv->_compare_func_target;
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	*result_target = _tmp1__target;
	result = _tmp1_;
	return result;
}

void
music_fast_grid_set_compare_func (MusicFastGrid* self,
                                  MusicFastGridSortCompareFunc value,
                                  gpointer value_target)
{
	g_return_if_fail (self != NULL);
	self->priv->_compare_func = value;
	self->priv->_compare_func_target = value_target;
}

static GObject *
music_fast_grid_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicFastGrid * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	MusicFastGridModel* _tmp2_;
	GeeHashMap* _tmp3_;
	MusicFastGridModel* _tmp4_;
	MusicWidgetsTileRenderer* _tmp5_;
	GtkCellRenderer* _tmp6_;
	GtkCellRenderer* _tmp7_;
	parent_class = G_OBJECT_CLASS (music_fast_grid_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_FAST_GRID, MusicFastGrid);
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->table);
	self->priv->table = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->showing);
	self->priv->showing = _tmp1_;
	_tmp2_ = music_fast_grid_model_new ();
	_g_object_unref0 (self->priv->fm);
	self->priv->fm = _tmp2_;
	_tmp3_ = self->priv->table;
	music_fast_grid_set_table (self, _tmp3_, TRUE);
	_tmp4_ = self->priv->fm;
	gtk_icon_view_set_model ((GtkIconView*) self, (GtkTreeModel*) _tmp4_);
	_tmp5_ = music_widgets_tile_renderer_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->cell_renderer);
	self->priv->cell_renderer = (GtkCellRenderer*) _tmp5_;
	_tmp6_ = self->priv->cell_renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) self, _tmp6_, FALSE);
	gtk_icon_view_set_activate_on_single_click ((GtkIconView*) self, FALSE);
	_tmp7_ = self->priv->cell_renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) self, _tmp7_, "album", 0);
	gtk_icon_view_set_tooltip_column ((GtkIconView*) self, 1);
	gtk_icon_view_set_item_padding ((GtkIconView*) self, 0);
	gtk_icon_view_set_margin ((GtkIconView*) self, 24);
	return obj;
}

static void
music_fast_grid_class_init (MusicFastGridClass * klass,
                            gpointer klass_data)
{
	music_fast_grid_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicFastGrid_private_offset);
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) music_fast_grid_real_size_allocate;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_fast_grid_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_fast_grid_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_fast_grid_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_fast_grid_finalize;
}

static void
music_fast_grid_instance_init (MusicFastGrid * self,
                               gpointer klass)
{
	self->priv = music_fast_grid_get_instance_private (self);
	self->research_needed = FALSE;
}

static void
music_fast_grid_finalize (GObject * obj)
{
	MusicFastGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_FAST_GRID, MusicFastGrid);
	_g_object_unref0 (self->priv->cell_renderer);
	_g_object_unref0 (self->priv->fm);
	_g_object_unref0 (self->priv->table);
	_g_object_unref0 (self->priv->showing);
	G_OBJECT_CLASS (music_fast_grid_parent_class)->finalize (obj);
}

GType
music_fast_grid_get_type (void)
{
	static volatile gsize music_fast_grid_type_id__volatile = 0;
	if (g_once_init_enter (&music_fast_grid_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicFastGridClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_fast_grid_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicFastGrid), 0, (GInstanceInitFunc) music_fast_grid_instance_init, NULL };
		GType music_fast_grid_type_id;
		music_fast_grid_type_id = g_type_register_static (gtk_icon_view_get_type (), "MusicFastGrid", &g_define_type_info, 0);
		MusicFastGrid_private_offset = g_type_add_instance_private (music_fast_grid_type_id, sizeof (MusicFastGridPrivate));
		g_once_init_leave (&music_fast_grid_type_id__volatile, music_fast_grid_type_id);
	}
	return music_fast_grid_type_id__volatile;
}

static void
_vala_music_fast_grid_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	MusicFastGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_FAST_GRID, MusicFastGrid);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_fast_grid_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	MusicFastGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_FAST_GRID, MusicFastGrid);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

