/* ColumnBrowser.c generated by valac 0.44.11, the Vala compiler
 * generated from ColumnBrowser.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define MUSIC_TYPE_COLUMN_BROWSER (music_column_browser_get_type ())
#define MUSIC_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser))
#define MUSIC_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowserClass))
#define MUSIC_IS_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_COLUMN_BROWSER))
#define MUSIC_IS_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_COLUMN_BROWSER))
#define MUSIC_COLUMN_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowserClass))

typedef struct _MusicColumnBrowser MusicColumnBrowser;
typedef struct _MusicColumnBrowserClass MusicColumnBrowserClass;
typedef struct _MusicColumnBrowserPrivate MusicColumnBrowserPrivate;
typedef enum  {
	MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC,
	MUSIC_COLUMN_BROWSER_POSITION_LEFT,
	MUSIC_COLUMN_BROWSER_POSITION_TOP
} MusicColumnBrowserPosition;

#define MUSIC_COLUMN_BROWSER_TYPE_POSITION (music_column_browser_position_get_type ())

#define MUSIC_TYPE_VIEW_WRAPPER (music_view_wrapper_get_type ())
#define MUSIC_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper))
#define MUSIC_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))
#define MUSIC_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))

typedef struct _MusicViewWrapper MusicViewWrapper;
typedef struct _MusicViewWrapperClass MusicViewWrapperClass;

#define MUSIC_TYPE_BROWSER_COLUMN (music_browser_column_get_type ())
#define MUSIC_BROWSER_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumn))
#define MUSIC_BROWSER_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumnClass))
#define MUSIC_IS_BROWSER_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_BROWSER_COLUMN))
#define MUSIC_IS_BROWSER_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_BROWSER_COLUMN))
#define MUSIC_BROWSER_COLUMN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_BROWSER_COLUMN, MusicBrowserColumnClass))

typedef struct _MusicBrowserColumn MusicBrowserColumn;
typedef struct _MusicBrowserColumnClass MusicBrowserColumnClass;
enum  {
	MUSIC_COLUMN_BROWSER_0_PROPERTY,
	MUSIC_COLUMN_BROWSER_POSITION_PROPERTY,
	MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY,
	MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY,
	MUSIC_COLUMN_BROWSER_FILTERED_PROPERTY,
	MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY,
	MUSIC_COLUMN_BROWSER_INITIALIZED_PROPERTY,
	MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY,
	MUSIC_COLUMN_BROWSER_NUM_PROPERTIES
};
static GParamSpec* music_column_browser_properties[MUSIC_COLUMN_BROWSER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	MUSIC_BROWSER_COLUMN_CATEGORY_RATING,
	MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING,
	MUSIC_BROWSER_COLUMN_CATEGORY_YEAR,
	MUSIC_BROWSER_COLUMN_CATEGORY_GENRE,
	MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER,
	MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST,
	MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM,
	MUSIC_BROWSER_COLUMN_CATEGORY_N_CATEGORIES
} MusicBrowserColumnCategory;

#define MUSIC_BROWSER_COLUMN_TYPE_CATEGORY (music_browser_column_category_get_type ())
typedef struct _Block22Data Block22Data;

#define MUSIC_TYPE_LIST_VIEW (music_list_view_get_type ())
#define MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIST_VIEW, MusicListView))
#define MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIST_VIEW, MusicListViewClass))
#define MUSIC_IS_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIST_VIEW))
#define MUSIC_IS_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIST_VIEW))
#define MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIST_VIEW, MusicListViewClass))

typedef struct _MusicListView MusicListView;
typedef struct _MusicListViewClass MusicListViewClass;

#define MUSIC_TYPE_GENERIC_LIST (music_generic_list_get_type ())
#define MUSIC_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericList))
#define MUSIC_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))
#define MUSIC_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))

typedef struct _MusicGenericList MusicGenericList;
typedef struct _MusicGenericListClass MusicGenericListClass;

#define MUSIC_TYPE_MUSIC_LIST_VIEW (music_music_list_view_get_type ())
#define MUSIC_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView))
#define MUSIC_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))
#define MUSIC_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))

typedef struct _MusicMusicListView MusicMusicListView;
typedef struct _MusicMusicListViewClass MusicMusicListViewClass;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MUSIC_COLUMN_BROWSER_CHANGED_SIGNAL,
	MUSIC_COLUMN_BROWSER_POSITION_CHANGED_SIGNAL,
	MUSIC_COLUMN_BROWSER_NUM_SIGNALS
};
static guint music_column_browser_signals[MUSIC_COLUMN_BROWSER_NUM_SIGNALS] = {0};

struct _MusicColumnBrowser {
	GtkGrid parent_instance;
	MusicColumnBrowserPrivate * priv;
};

struct _MusicColumnBrowserClass {
	GtkGridClass parent_class;
};

struct _MusicColumnBrowserPrivate {
	MusicColumnBrowserPosition _position;
	MusicColumnBrowserPosition _actual_position;
	MusicViewWrapper* _view_wrapper;
	GeeTreeSet* _columns;
	GeeLinkedList* media;
	GeeCollection* search_results;
	GtkMenu* column_chooser_menu;
	GtkRadioMenuItem* top_menu_item;
	GtkRadioMenuItem* left_menu_item;
	GtkRadioMenuItem* automatic_menu_item;
};

struct _Block22Data {
	int _ref_count_;
	MusicColumnBrowser* self;
	MusicBrowserColumn* column;
};

static gint MusicColumnBrowser_private_offset;
static gpointer music_column_browser_parent_class = NULL;

GType music_column_browser_get_type (void) G_GNUC_CONST;
GType music_column_browser_position_get_type (void) G_GNUC_CONST;
GType music_view_wrapper_get_type (void) G_GNUC_CONST;
GType music_browser_column_get_type (void) G_GNUC_CONST;
MusicColumnBrowser* music_column_browser_new (MusicViewWrapper* view_wrapper);
MusicColumnBrowser* music_column_browser_construct (GType object_type,
                                                    MusicViewWrapper* view_wrapper);
void music_column_browser_reset_filters (MusicColumnBrowser* self);
GeeTreeSet* music_column_browser_get_columns (MusicColumnBrowser* self);
void music_browser_column_select_first_item (MusicBrowserColumn* self);
GType music_browser_column_category_get_type (void) G_GNUC_CONST;
MusicBrowserColumn* music_column_browser_add_column (MusicColumnBrowser* self,
                                                     MusicBrowserColumnCategory type);
static Block22Data* block22_data_ref (Block22Data* _data22_);
static void block22_data_unref (void * _userdata_);
MusicBrowserColumn* music_browser_column_new (MusicColumnBrowser* miller_parent,
                                              MusicBrowserColumnCategory category);
MusicBrowserColumn* music_browser_column_construct (GType object_type,
                                                    MusicColumnBrowser* miller_parent,
                                                    MusicBrowserColumnCategory category);
static void music_column_browser_column_selection_changed (MusicColumnBrowser* self,
                                                    MusicBrowserColumnCategory category,
                                                    const gchar* val);
static void _music_column_browser_column_selection_changed_music_browser_column_selection_changed (MusicBrowserColumn* _sender,
                                                                                            MusicBrowserColumnCategory type,
                                                                                            const gchar* val,
                                                                                            gpointer self);
static void __lambda66_ (Block22Data* _data22_);
static void ___lambda66__music_browser_column_reset_requested (MusicBrowserColumn* _sender,
                                                        gpointer self);
GtkCheckMenuItem* music_browser_column_get_menu_item (MusicBrowserColumn* self);
static void music_column_browser_column_row_activated (MusicColumnBrowser* self);
static void _music_column_browser_column_row_activated_music_browser_column_row_activated (MusicBrowserColumn* _sender,
                                                                                    const gchar* text,
                                                                                    gpointer self);
static void music_column_browser_column_header_clicked (MusicColumnBrowser* self,
                                                 GdkEventButton* e);
static void _music_column_browser_column_header_clicked_music_browser_column_header_clicked (MusicBrowserColumn* _sender,
                                                                                      GdkEventButton* e,
                                                                                      gpointer self);
static void music_column_browser_update_column_separators (MusicColumnBrowser* self);
static void _music_column_browser_update_column_separators_music_browser_column_visibility_changed (MusicBrowserColumn* _sender,
                                                                                             gboolean visible,
                                                                                             gpointer self);
void music_column_browser_set_media (MusicColumnBrowser* self,
                                     GeeCollection* media);
MusicBrowserColumnCategory music_browser_column_category_first (void);
static void music_column_browser_populate_columns (MusicColumnBrowser* self,
                                            MusicBrowserColumnCategory category,
                                            gboolean inclusive);
MusicViewWrapper* music_column_browser_get_view_wrapper (MusicColumnBrowser* self);
void music_view_wrapper_play_first_media (MusicViewWrapper* self,
                                          gboolean* force);
static void music_column_browser_update_search_results (MusicColumnBrowser* self,
                                                 MusicBrowserColumnCategory parent_category);
GType music_list_view_get_type (void) G_GNUC_CONST;
MusicListView* music_view_wrapper_get_list_view (MusicViewWrapper* self);
GType music_generic_list_get_type (void) G_GNUC_CONST;
GType music_music_list_view_get_type (void) G_GNUC_CONST;
MusicMusicListView* music_list_view_get_list_view (MusicListView* self);
void music_generic_list_set_research_needed (MusicGenericList* self,
                                             gboolean value);
static void music_column_browser_get_filters (MusicColumnBrowser* self,
                                       MusicBrowserColumnCategory parent_category,
                                       gint* rating,
                                       gint* year,
                                       gchar* * genre,
                                       gchar* * album_artist,
                                       gchar* * album,
                                       gchar* * grouping,
                                       gchar* * composer);
MusicBrowserColumnCategory music_browser_column_get_category (MusicBrowserColumn* self);
gchar* music_browser_column_get_selected (MusicBrowserColumn* self);
void music_column_browser_fill_column (MusicColumnBrowser* self,
                                       MusicBrowserColumn* column);
void music_browser_column_populate (MusicBrowserColumn* self,
                                    GeeHashSet* items);
gboolean music_column_browser_match_media (MusicColumnBrowser* self,
                                           MusicMedia* m);
MusicBrowserColumnCategory music_browser_column_category_last (void);
GeeTreeSet* music_column_browser_get_visible_columns (MusicColumnBrowser* self);
void music_browser_column_set_show_separator (MusicBrowserColumn* self,
                                              gboolean value);
static void music_column_browser_save_current_state (MusicColumnBrowser* self);
static void _vala_array_add5 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
GSettings* music_app_get_saved_state (void);
MusicColumnBrowserPosition music_column_browser_get_position (MusicColumnBrowser* self);
void music_column_browser_set_position (MusicColumnBrowser* self,
                                        MusicColumnBrowserPosition value);
MusicColumnBrowserPosition music_column_browser_get_actual_position (MusicColumnBrowser* self);
void music_column_browser_set_actual_position (MusicColumnBrowser* self,
                                               MusicColumnBrowserPosition value);
static void music_column_browser_set_view_wrapper (MusicColumnBrowser* self,
                                            MusicViewWrapper* value);
gboolean music_column_browser_get_filtered (MusicColumnBrowser* self);
gboolean music_browser_column_get_first_item_selected (MusicBrowserColumn* self);
gboolean music_browser_column_get_visible (MusicBrowserColumn* self);
void music_column_browser_set_visible_columns (MusicColumnBrowser* self,
                                               GeeTreeSet* value);
void music_browser_column_set_visible (MusicBrowserColumn* self,
                                       gboolean value);
gboolean music_column_browser_get_initialized (MusicColumnBrowser* self);
static void music_column_browser_set_columns (MusicColumnBrowser* self,
                                       GeeTreeSet* value);
static GObject * music_column_browser_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void _vala_array_add6 (MusicBrowserColumnCategory* * array,
                       int* length,
                       int* size,
                       MusicBrowserColumnCategory value);
static void _vala_array_add7 (MusicBrowserColumnCategory* * array,
                       int* length,
                       int* size,
                       MusicBrowserColumnCategory value);
static void _vala_array_add8 (MusicBrowserColumnCategory* * array,
                       int* length,
                       int* size,
                       MusicBrowserColumnCategory value);
static void _vala_array_add9 (MusicBrowserColumnCategory* * array,
                       int* length,
                       int* size,
                       MusicBrowserColumnCategory value);
static void _vala_array_add10 (MusicBrowserColumnCategory* * array,
                        int* length,
                        int* size,
                        MusicBrowserColumnCategory value);
static void _vala_array_add11 (MusicBrowserColumnCategory* * array,
                        int* length,
                        int* size,
                        MusicBrowserColumnCategory value);
static void _vala_array_add12 (MusicBrowserColumnCategory* * array,
                        int* length,
                        int* size,
                        MusicBrowserColumnCategory value);
static void _music_column_browser___lambda67_ (MusicColumnBrowser* self);
static void __music_column_browser___lambda67__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static void _music_column_browser___lambda68_ (MusicColumnBrowser* self);
static void __music_column_browser___lambda68__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static void _music_column_browser___lambda69_ (MusicColumnBrowser* self);
static void __music_column_browser___lambda69__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static void _music_column_browser_save_current_state_gtk_widget_destroy (GtkWidget* _sender,
                                                                  gpointer self);
static void music_column_browser_finalize (GObject * obj);
static void _vala_music_column_browser_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_music_column_browser_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
music_column_browser_get_instance_private (MusicColumnBrowser* self)
{
	return G_STRUCT_MEMBER_P (self, MusicColumnBrowser_private_offset);
}

GType
music_column_browser_position_get_type (void)
{
	static volatile gsize music_column_browser_position_type_id__volatile = 0;
	if (g_once_init_enter (&music_column_browser_position_type_id__volatile)) {
		static const GEnumValue values[] = {{MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC, "MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC", "automatic"}, {MUSIC_COLUMN_BROWSER_POSITION_LEFT, "MUSIC_COLUMN_BROWSER_POSITION_LEFT", "left"}, {MUSIC_COLUMN_BROWSER_POSITION_TOP, "MUSIC_COLUMN_BROWSER_POSITION_TOP", "top"}, {0, NULL, NULL}};
		GType music_column_browser_position_type_id;
		music_column_browser_position_type_id = g_enum_register_static ("MusicColumnBrowserPosition", values);
		g_once_init_leave (&music_column_browser_position_type_id__volatile, music_column_browser_position_type_id);
	}
	return music_column_browser_position_type_id__volatile;
}

MusicColumnBrowser*
music_column_browser_construct (GType object_type,
                                MusicViewWrapper* view_wrapper)
{
	MusicColumnBrowser * self = NULL;
	g_return_val_if_fail (view_wrapper != NULL, NULL);
	self = (MusicColumnBrowser*) g_object_new (object_type, "view-wrapper", view_wrapper, NULL);
	return self;
}

MusicColumnBrowser*
music_column_browser_new (MusicViewWrapper* view_wrapper)
{
	return music_column_browser_construct (MUSIC_TYPE_COLUMN_BROWSER, view_wrapper);
}

void
music_column_browser_reset_filters (MusicColumnBrowser* self)
{
	g_return_if_fail (self != NULL);
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
		_tmp0_ = self->priv->_columns;
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
		_col_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicBrowserColumn* _tmp5_;
			_tmp2_ = _col_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _col_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			col = (MusicBrowserColumn*) _tmp4_;
			_tmp5_ = col;
			music_browser_column_select_first_item (_tmp5_);
			_g_object_unref0 (col);
		}
		_g_object_unref0 (_col_it);
	}
}

static Block22Data*
block22_data_ref (Block22Data* _data22_)
{
	g_atomic_int_inc (&_data22_->_ref_count_);
	return _data22_;
}

static void
block22_data_unref (void * _userdata_)
{
	Block22Data* _data22_;
	_data22_ = (Block22Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data22_->_ref_count_)) {
		MusicColumnBrowser* self;
		self = _data22_->self;
		_g_object_unref0 (_data22_->column);
		_g_object_unref0 (self);
		g_slice_free (Block22Data, _data22_);
	}
}

static void
_music_column_browser_column_selection_changed_music_browser_column_selection_changed (MusicBrowserColumn* _sender,
                                                                                       MusicBrowserColumnCategory type,
                                                                                       const gchar* val,
                                                                                       gpointer self)
{
	music_column_browser_column_selection_changed ((MusicColumnBrowser*) self, type, val);
}

static void
__lambda66_ (Block22Data* _data22_)
{
	MusicColumnBrowser* self;
	self = _data22_->self;
	music_browser_column_select_first_item (_data22_->column);
}

static void
___lambda66__music_browser_column_reset_requested (MusicBrowserColumn* _sender,
                                                   gpointer self)
{
	__lambda66_ (self);
}

static void
_music_column_browser_column_row_activated_music_browser_column_row_activated (MusicBrowserColumn* _sender,
                                                                               const gchar* text,
                                                                               gpointer self)
{
	music_column_browser_column_row_activated ((MusicColumnBrowser*) self);
}

static void
_music_column_browser_column_header_clicked_music_browser_column_header_clicked (MusicBrowserColumn* _sender,
                                                                                 GdkEventButton* e,
                                                                                 gpointer self)
{
	music_column_browser_column_header_clicked ((MusicColumnBrowser*) self, e);
}

static void
_music_column_browser_update_column_separators_music_browser_column_visibility_changed (MusicBrowserColumn* _sender,
                                                                                        gboolean visible,
                                                                                        gpointer self)
{
	music_column_browser_update_column_separators ((MusicColumnBrowser*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

MusicBrowserColumn*
music_column_browser_add_column (MusicColumnBrowser* self,
                                 MusicBrowserColumnCategory type)
{
	Block22Data* _data22_;
	MusicBrowserColumn* _tmp0_;
	GeeTreeSet* _tmp1_;
	GtkMenu* _tmp2_;
	GtkCheckMenuItem* _tmp3_;
	GtkCheckMenuItem* _tmp4_;
	MusicBrowserColumn* _tmp5_;
	MusicBrowserColumn* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_data22_ = g_slice_new0 (Block22Data);
	_data22_->_ref_count_ = 1;
	_data22_->self = g_object_ref (self);
	_tmp0_ = music_browser_column_new (self, type);
	g_object_ref_sink (_tmp0_);
	_data22_->column = _tmp0_;
	g_signal_connect_object (_data22_->column, "selection-changed", (GCallback) _music_column_browser_column_selection_changed_music_browser_column_selection_changed, self, G_CONNECT_AFTER);
	gtk_widget_set_size_request ((GtkWidget*) _data22_->column, 60, 100);
	g_signal_connect_data (_data22_->column, "reset-requested", (GCallback) ___lambda66__music_browser_column_reset_requested, block22_data_ref (_data22_), (GClosureNotify) block22_data_unref, 0);
	_tmp1_ = self->priv->_columns;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _data22_->column);
	gtk_widget_set_vexpand ((GtkWidget*) _data22_->column, TRUE);
	gtk_widget_set_hexpand ((GtkWidget*) _data22_->column, TRUE);
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _data22_->column, (gint) type, 0, 1, 1);
	_tmp2_ = self->priv->column_chooser_menu;
	_tmp3_ = music_browser_column_get_menu_item (_data22_->column);
	_tmp4_ = _tmp3_;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp2_, (GtkMenuItem*) _tmp4_);
	g_signal_connect_object (_data22_->column, "row-activated", (GCallback) _music_column_browser_column_row_activated_music_browser_column_row_activated, self, 0);
	g_signal_connect_object (_data22_->column, "header-clicked", (GCallback) _music_column_browser_column_header_clicked_music_browser_column_header_clicked, self, 0);
	g_signal_connect_object (_data22_->column, "visibility-changed", (GCallback) _music_column_browser_update_column_separators_music_browser_column_visibility_changed, self, 0);
	_tmp5_ = _g_object_ref0 (_data22_->column);
	result = _tmp5_;
	block22_data_unref (_data22_);
	_data22_ = NULL;
	return result;
}

void
music_column_browser_set_media (MusicColumnBrowser* self,
                                GeeCollection* media)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	MusicBrowserColumnCategory highest_category = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (media != NULL);
	_tmp0_ = self->priv->media;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	_tmp1_ = self->priv->media;
	gee_collection_add_all ((GeeCollection*) _tmp1_, media);
	_tmp2_ = self->priv->search_results;
	gee_collection_clear (_tmp2_);
	_tmp3_ = self->priv->search_results;
	gee_collection_add_all (_tmp3_, media);
	highest_category = music_browser_column_category_first ();
	music_column_browser_populate_columns (self, highest_category, TRUE);
	g_signal_emit (self, music_column_browser_signals[MUSIC_COLUMN_BROWSER_CHANGED_SIGNAL], 0);
}

static void
music_column_browser_column_row_activated (MusicColumnBrowser* self)
{
	MusicViewWrapper* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_view_wrapper;
	_tmp1_ = FALSE;
	music_view_wrapper_play_first_media (_tmp0_, &_tmp1_);
}

static void
music_column_browser_column_selection_changed (MusicColumnBrowser* self,
                                               MusicBrowserColumnCategory category,
                                               const gchar* val)
{
	MusicViewWrapper* _tmp0_;
	MusicListView* _tmp1_;
	MusicListView* _tmp2_;
	MusicMusicListView* _tmp3_;
	MusicMusicListView* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (val != NULL);
	music_column_browser_update_search_results (self, category);
	_tmp0_ = self->priv->_view_wrapper;
	_tmp1_ = music_view_wrapper_get_list_view (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = music_list_view_get_list_view (_tmp2_);
	_tmp4_ = _tmp3_;
	music_generic_list_set_research_needed ((MusicGenericList*) _tmp4_, TRUE);
	music_column_browser_populate_columns (self, category, FALSE);
	g_signal_emit (self, music_column_browser_signals[MUSIC_COLUMN_BROWSER_CHANGED_SIGNAL], 0);
}

static void
music_column_browser_update_search_results (MusicColumnBrowser* self,
                                            MusicBrowserColumnCategory parent_category)
{
	gint rating = 0;
	gint year = 0;
	gchar* genre = NULL;
	gchar* album_artist = NULL;
	gchar* album = NULL;
	gchar* grouping = NULL;
	gchar* composer = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GeeLinkedList* _tmp7_;
	GeeCollection* _tmp8_ = NULL;
	g_return_if_fail (self != NULL);
	music_column_browser_get_filters (self, parent_category, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
	rating = _tmp0_;
	year = _tmp1_;
	_g_free0 (genre);
	genre = _tmp2_;
	_g_free0 (album_artist);
	album_artist = _tmp3_;
	_g_free0 (album);
	album = _tmp4_;
	_g_free0 (grouping);
	grouping = _tmp5_;
	_g_free0 (composer);
	composer = _tmp6_;
	_tmp7_ = self->priv->media;
	music_search_search_in_media_list ((GeeCollection*) _tmp7_, &_tmp8_, album_artist, album, genre, grouping, composer, year, rating, NULL);
	_g_object_unref0 (self->priv->search_results);
	self->priv->search_results = _tmp8_;
	_g_free0 (composer);
	_g_free0 (grouping);
	_g_free0 (album);
	_g_free0 (album_artist);
	_g_free0 (genre);
}

static void
music_column_browser_get_filters (MusicColumnBrowser* self,
                                  MusicBrowserColumnCategory parent_category,
                                  gint* rating,
                                  gint* year,
                                  gchar* * genre,
                                  gchar* * album_artist,
                                  gchar* * album,
                                  gchar* * grouping,
                                  gchar* * composer)
{
	gint _vala_rating = 0;
	gint _vala_year = 0;
	gchar* _vala_genre = NULL;
	gchar* _vala_album_artist = NULL;
	gchar* _vala_album = NULL;
	gchar* _vala_grouping = NULL;
	gchar* _vala_composer = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_vala_rating = -1;
	_vala_year = -1;
	_tmp0_ = g_strdup ("");
	_g_free0 (_vala_genre);
	_vala_genre = _tmp0_;
	_tmp1_ = g_strdup ("");
	_g_free0 (_vala_album_artist);
	_vala_album_artist = _tmp1_;
	_tmp2_ = g_strdup ("");
	_g_free0 (_vala_album);
	_vala_album = _tmp2_;
	_tmp3_ = g_strdup ("");
	_g_free0 (_vala_grouping);
	_vala_grouping = _tmp3_;
	_tmp4_ = g_strdup ("");
	_g_free0 (_vala_composer);
	_vala_composer = _tmp4_;
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp5_;
		GeeIterator* _tmp6_;
		_tmp5_ = self->priv->_columns;
		_tmp6_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp5_);
		_col_it = _tmp6_;
		while (TRUE) {
			GeeIterator* _tmp7_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			MusicBrowserColumn* _tmp10_;
			MusicBrowserColumnCategory _tmp11_;
			MusicBrowserColumnCategory _tmp12_;
			_tmp7_ = _col_it;
			if (!gee_iterator_next (_tmp7_)) {
				break;
			}
			_tmp8_ = _col_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			col = (MusicBrowserColumn*) _tmp9_;
			_tmp10_ = col;
			_tmp11_ = music_browser_column_get_category (_tmp10_);
			_tmp12_ = _tmp11_;
			if (_tmp12_ <= parent_category) {
				gchar* selected = NULL;
				MusicBrowserColumn* _tmp13_;
				gchar* _tmp14_;
				MusicBrowserColumn* _tmp15_;
				MusicBrowserColumnCategory _tmp16_;
				MusicBrowserColumnCategory _tmp17_;
				_tmp13_ = col;
				_tmp14_ = music_browser_column_get_selected (_tmp13_);
				selected = _tmp14_;
				_tmp15_ = col;
				_tmp16_ = music_browser_column_get_category (_tmp15_);
				_tmp17_ = _tmp16_;
				switch (_tmp17_) {
					case MUSIC_BROWSER_COLUMN_CATEGORY_GENRE:
					{
						const gchar* _tmp18_;
						gchar* _tmp19_;
						_tmp18_ = selected;
						_tmp19_ = g_strdup (_tmp18_);
						_g_free0 (_vala_genre);
						_vala_genre = _tmp19_;
						break;
					}
					case MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST:
					{
						const gchar* _tmp20_;
						gchar* _tmp21_;
						_tmp20_ = selected;
						_tmp21_ = g_strdup (_tmp20_);
						_g_free0 (_vala_album_artist);
						_vala_album_artist = _tmp21_;
						break;
					}
					case MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM:
					{
						const gchar* _tmp22_;
						gchar* _tmp23_;
						_tmp22_ = selected;
						_tmp23_ = g_strdup (_tmp22_);
						_g_free0 (_vala_album);
						_vala_album = _tmp23_;
						break;
					}
					case MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING:
					{
						const gchar* _tmp24_;
						gchar* _tmp25_;
						_tmp24_ = selected;
						_tmp25_ = g_strdup (_tmp24_);
						_g_free0 (_vala_grouping);
						_vala_grouping = _tmp25_;
						break;
					}
					case MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER:
					{
						const gchar* _tmp26_;
						gchar* _tmp27_;
						_tmp26_ = selected;
						_tmp27_ = g_strdup (_tmp26_);
						_g_free0 (_vala_composer);
						_vala_composer = _tmp27_;
						break;
					}
					case MUSIC_BROWSER_COLUMN_CATEGORY_YEAR:
					{
						gint _tmp28_ = 0;
						const gchar* _tmp29_;
						_tmp29_ = selected;
						if (music_string_is_empty (_tmp29_, FALSE)) {
							_tmp28_ = -1;
						} else {
							const gchar* _tmp30_;
							_tmp30_ = selected;
							_tmp28_ = (gint) music_string_uint_from_string (_tmp30_);
						}
						_vala_year = _tmp28_;
						break;
					}
					case MUSIC_BROWSER_COLUMN_CATEGORY_RATING:
					{
						gint _tmp31_ = 0;
						const gchar* _tmp32_;
						_tmp32_ = selected;
						if (music_string_is_empty (_tmp32_, FALSE)) {
							_tmp31_ = -1;
						} else {
							const gchar* _tmp33_;
							_tmp33_ = selected;
							_tmp31_ = (gint) music_string_uint_from_string (_tmp33_);
						}
						_vala_rating = _tmp31_;
						break;
					}
					default:
					{
						g_assert_not_reached ();
					}
				}
				_g_free0 (selected);
			}
			_g_object_unref0 (col);
		}
		_g_object_unref0 (_col_it);
	}
	if (rating) {
		*rating = _vala_rating;
	}
	if (year) {
		*year = _vala_year;
	}
	if (genre) {
		*genre = _vala_genre;
	} else {
		_g_free0 (_vala_genre);
	}
	if (album_artist) {
		*album_artist = _vala_album_artist;
	} else {
		_g_free0 (_vala_album_artist);
	}
	if (album) {
		*album = _vala_album;
	} else {
		_g_free0 (_vala_album);
	}
	if (grouping) {
		*grouping = _vala_grouping;
	} else {
		_g_free0 (_vala_grouping);
	}
	if (composer) {
		*composer = _vala_composer;
	} else {
		_g_free0 (_vala_composer);
	}
}

static void
music_column_browser_populate_columns (MusicColumnBrowser* self,
                                       MusicBrowserColumnCategory category,
                                       gboolean inclusive)
{
	g_return_if_fail (self != NULL);
	{
		GeeIterator* _column_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
		_tmp0_ = self->priv->_columns;
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
		_column_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicBrowserColumn* column = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicBrowserColumn* _tmp5_;
			MusicBrowserColumnCategory _tmp6_;
			MusicBrowserColumnCategory _tmp7_;
			gboolean _tmp8_ = FALSE;
			MusicBrowserColumn* _tmp9_;
			MusicBrowserColumnCategory _tmp10_;
			MusicBrowserColumnCategory _tmp11_;
			MusicBrowserColumn* _tmp12_;
			_tmp2_ = _column_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _column_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			column = (MusicBrowserColumn*) _tmp4_;
			_tmp5_ = column;
			_tmp6_ = music_browser_column_get_category (_tmp5_);
			_tmp7_ = _tmp6_;
			if (_tmp7_ < category) {
				_g_object_unref0 (column);
				continue;
			}
			_tmp9_ = column;
			_tmp10_ = music_browser_column_get_category (_tmp9_);
			_tmp11_ = _tmp10_;
			if (_tmp11_ == category) {
				_tmp8_ = !inclusive;
			} else {
				_tmp8_ = FALSE;
			}
			if (_tmp8_) {
				_g_object_unref0 (column);
				continue;
			}
			_tmp12_ = column;
			music_column_browser_fill_column (self, _tmp12_);
			_g_object_unref0 (column);
		}
		_g_object_unref0 (_column_it);
	}
}

void
music_column_browser_fill_column (MusicColumnBrowser* self,
                                  MusicBrowserColumn* column)
{
	GeeHashSet* column_set = NULL;
	GeeHashSet* _tmp0_;
	MusicBrowserColumnCategory _tmp1_;
	MusicBrowserColumnCategory _tmp2_;
	GeeHashSet* _tmp92_;
	MusicBrowserColumnCategory _tmp93_;
	MusicBrowserColumnCategory _tmp94_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (column != NULL);
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	column_set = _tmp0_;
	_tmp1_ = music_browser_column_get_category (column);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case MUSIC_BROWSER_COLUMN_CATEGORY_GENRE:
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp3_;
				GeeIterator* _tmp4_;
				_tmp3_ = self->priv->search_results;
				_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
				_m_it = _tmp4_;
				while (TRUE) {
					GeeIterator* _tmp5_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
					gchar* genre = NULL;
					MusicMedia* _tmp8_;
					gchar* _tmp9_;
					GeeHashSet* _tmp10_;
					const gchar* _tmp11_;
					_tmp5_ = _m_it;
					if (!gee_iterator_next (_tmp5_)) {
						break;
					}
					_tmp6_ = _m_it;
					_tmp7_ = gee_iterator_get (_tmp6_);
					m = (MusicMedia*) _tmp7_;
					_tmp8_ = m;
					_tmp9_ = music_media_get_display_genre (_tmp8_);
					genre = _tmp9_;
					_tmp10_ = column_set;
					_tmp11_ = genre;
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp10_, _tmp11_)) {
						GeeHashSet* _tmp12_;
						const gchar* _tmp13_;
						_tmp12_ = column_set;
						_tmp13_ = genre;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
					}
					_g_free0 (genre);
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST:
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp14_;
				GeeIterator* _tmp15_;
				_tmp14_ = self->priv->search_results;
				_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
				_m_it = _tmp15_;
				while (TRUE) {
					GeeIterator* _tmp16_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
					gchar* artist = NULL;
					MusicMedia* _tmp19_;
					gchar* _tmp20_;
					GeeHashSet* _tmp21_;
					const gchar* _tmp22_;
					_tmp16_ = _m_it;
					if (!gee_iterator_next (_tmp16_)) {
						break;
					}
					_tmp17_ = _m_it;
					_tmp18_ = gee_iterator_get (_tmp17_);
					m = (MusicMedia*) _tmp18_;
					_tmp19_ = m;
					_tmp20_ = music_media_get_display_album_artist (_tmp19_, TRUE);
					artist = _tmp20_;
					_tmp21_ = column_set;
					_tmp22_ = artist;
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp21_, _tmp22_)) {
						GeeHashSet* _tmp23_;
						const gchar* _tmp24_;
						_tmp23_ = column_set;
						_tmp24_ = artist;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
					}
					_g_free0 (artist);
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING:
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp25_;
				GeeIterator* _tmp26_;
				_tmp25_ = self->priv->search_results;
				_tmp26_ = gee_iterable_iterator ((GeeIterable*) _tmp25_);
				_m_it = _tmp26_;
				while (TRUE) {
					GeeIterator* _tmp27_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp28_;
					gpointer _tmp29_;
					gchar* grouping = NULL;
					MusicMedia* _tmp30_;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gchar* _tmp33_;
					gboolean _tmp34_ = FALSE;
					const gchar* _tmp35_;
					_tmp27_ = _m_it;
					if (!gee_iterator_next (_tmp27_)) {
						break;
					}
					_tmp28_ = _m_it;
					_tmp29_ = gee_iterator_get (_tmp28_);
					m = (MusicMedia*) _tmp29_;
					_tmp30_ = m;
					_tmp31_ = music_media_get_grouping (_tmp30_);
					_tmp32_ = _tmp31_;
					_tmp33_ = g_strdup (_tmp32_);
					grouping = _tmp33_;
					_tmp35_ = grouping;
					if (!music_string_is_empty (_tmp35_, FALSE)) {
						GeeHashSet* _tmp36_;
						const gchar* _tmp37_;
						_tmp36_ = column_set;
						_tmp37_ = grouping;
						_tmp34_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp36_, _tmp37_);
					} else {
						_tmp34_ = FALSE;
					}
					if (_tmp34_) {
						GeeHashSet* _tmp38_;
						const gchar* _tmp39_;
						_tmp38_ = column_set;
						_tmp39_ = grouping;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, _tmp39_);
					}
					_g_free0 (grouping);
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER:
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp40_;
				GeeIterator* _tmp41_;
				_tmp40_ = self->priv->search_results;
				_tmp41_ = gee_iterable_iterator ((GeeIterable*) _tmp40_);
				_m_it = _tmp41_;
				while (TRUE) {
					GeeIterator* _tmp42_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp43_;
					gpointer _tmp44_;
					gchar* composer = NULL;
					MusicMedia* _tmp45_;
					gchar* _tmp46_;
					GeeHashSet* _tmp47_;
					const gchar* _tmp48_;
					_tmp42_ = _m_it;
					if (!gee_iterator_next (_tmp42_)) {
						break;
					}
					_tmp43_ = _m_it;
					_tmp44_ = gee_iterator_get (_tmp43_);
					m = (MusicMedia*) _tmp44_;
					_tmp45_ = m;
					_tmp46_ = music_media_get_display_composer (_tmp45_);
					composer = _tmp46_;
					_tmp47_ = column_set;
					_tmp48_ = composer;
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp47_, _tmp48_)) {
						GeeHashSet* _tmp49_;
						const gchar* _tmp50_;
						_tmp49_ = column_set;
						_tmp50_ = composer;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp49_, _tmp50_);
					}
					_g_free0 (composer);
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM:
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp51_;
				GeeIterator* _tmp52_;
				_tmp51_ = self->priv->search_results;
				_tmp52_ = gee_iterable_iterator ((GeeIterable*) _tmp51_);
				_m_it = _tmp52_;
				while (TRUE) {
					GeeIterator* _tmp53_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp54_;
					gpointer _tmp55_;
					gchar* album = NULL;
					MusicMedia* _tmp56_;
					gchar* _tmp57_;
					GeeHashSet* _tmp58_;
					const gchar* _tmp59_;
					_tmp53_ = _m_it;
					if (!gee_iterator_next (_tmp53_)) {
						break;
					}
					_tmp54_ = _m_it;
					_tmp55_ = gee_iterator_get (_tmp54_);
					m = (MusicMedia*) _tmp55_;
					_tmp56_ = m;
					_tmp57_ = music_media_get_display_album (_tmp56_);
					album = _tmp57_;
					_tmp58_ = column_set;
					_tmp59_ = album;
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp58_, _tmp59_)) {
						GeeHashSet* _tmp60_;
						const gchar* _tmp61_;
						_tmp60_ = column_set;
						_tmp61_ = album;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp60_, _tmp61_);
					}
					_g_free0 (album);
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_YEAR:
		{
			GeeHashSet* numeric_set = NULL;
			GeeHashSet* _tmp62_;
			_tmp62_ = gee_hash_set_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
			numeric_set = _tmp62_;
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp63_;
				GeeIterator* _tmp64_;
				_tmp63_ = self->priv->search_results;
				_tmp64_ = gee_iterable_iterator ((GeeIterable*) _tmp63_);
				_m_it = _tmp64_;
				while (TRUE) {
					GeeIterator* _tmp65_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp66_;
					gpointer _tmp67_;
					guint year = 0U;
					MusicMedia* _tmp68_;
					guint _tmp69_;
					guint _tmp70_;
					gboolean _tmp71_ = FALSE;
					_tmp65_ = _m_it;
					if (!gee_iterator_next (_tmp65_)) {
						break;
					}
					_tmp66_ = _m_it;
					_tmp67_ = gee_iterator_get (_tmp66_);
					m = (MusicMedia*) _tmp67_;
					_tmp68_ = m;
					_tmp69_ = music_media_get_year (_tmp68_);
					_tmp70_ = _tmp69_;
					year = _tmp70_;
					if (year > ((guint) 0)) {
						GeeHashSet* _tmp72_;
						_tmp72_ = numeric_set;
						_tmp71_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp72_, (gpointer) ((guintptr) year));
					} else {
						_tmp71_ = FALSE;
					}
					if (_tmp71_) {
						GeeHashSet* _tmp73_;
						GeeHashSet* _tmp74_;
						gchar* _tmp75_;
						gchar* _tmp76_;
						_tmp73_ = numeric_set;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp73_, (gpointer) ((guintptr) year));
						_tmp74_ = column_set;
						_tmp75_ = g_strdup_printf ("%u", year);
						_tmp76_ = _tmp75_;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp74_, _tmp76_);
						_g_free0 (_tmp76_);
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
			_g_object_unref0 (numeric_set);
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_RATING:
		{
			GeeHashSet* numeric_set = NULL;
			GeeHashSet* _tmp77_;
			_tmp77_ = gee_hash_set_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
			numeric_set = _tmp77_;
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp78_;
				GeeIterator* _tmp79_;
				_tmp78_ = self->priv->search_results;
				_tmp79_ = gee_iterable_iterator ((GeeIterable*) _tmp78_);
				_m_it = _tmp79_;
				while (TRUE) {
					GeeIterator* _tmp80_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp81_;
					gpointer _tmp82_;
					guint rating = 0U;
					MusicMedia* _tmp83_;
					guint _tmp84_;
					guint _tmp85_;
					GeeHashSet* _tmp86_;
					_tmp80_ = _m_it;
					if (!gee_iterator_next (_tmp80_)) {
						break;
					}
					_tmp81_ = _m_it;
					_tmp82_ = gee_iterator_get (_tmp81_);
					m = (MusicMedia*) _tmp82_;
					_tmp83_ = m;
					_tmp84_ = music_media_get_rating (_tmp83_);
					_tmp85_ = _tmp84_;
					rating = _tmp85_;
					_tmp86_ = numeric_set;
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp86_, (gpointer) ((guintptr) rating))) {
						GeeHashSet* _tmp87_;
						gchar* rating_str = NULL;
						GeeHashSet* _tmp90_;
						const gchar* _tmp91_;
						_tmp87_ = numeric_set;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp87_, (gpointer) ((guintptr) rating));
						if (rating < ((guint) 1)) {
							gchar* _tmp88_;
							_tmp88_ = g_strdup (_ ("Unrated"));
							_g_free0 (rating_str);
							rating_str = _tmp88_;
						} else {
							gchar* _tmp89_;
							_tmp89_ = g_strdup_printf (ngettext ("%u Star", "%u Stars", (gulong) rating), rating);
							_g_free0 (rating_str);
							rating_str = _tmp89_;
						}
						_tmp90_ = column_set;
						_tmp91_ = rating_str;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp90_, _tmp91_);
						_g_free0 (rating_str);
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
			_g_object_unref0 (numeric_set);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_tmp92_ = column_set;
	music_browser_column_populate (column, _tmp92_);
	_tmp93_ = music_browser_column_get_category (column);
	_tmp94_ = _tmp93_;
	music_column_browser_update_search_results (self, _tmp94_);
	_g_object_unref0 (column_set);
}

gboolean
music_column_browser_match_media (MusicColumnBrowser* self,
                                  MusicMedia* m)
{
	gint rating = 0;
	gint year = 0;
	gchar* genre = NULL;
	gchar* album_artist = NULL;
	gchar* album = NULL;
	gchar* grouping = NULL;
	gchar* composer = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (m != NULL, FALSE);
	music_column_browser_get_filters (self, music_browser_column_category_last (), &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
	rating = _tmp0_;
	year = _tmp1_;
	_g_free0 (genre);
	genre = _tmp2_;
	_g_free0 (album_artist);
	album_artist = _tmp3_;
	_g_free0 (album);
	album = _tmp4_;
	_g_free0 (grouping);
	grouping = _tmp5_;
	_g_free0 (composer);
	composer = _tmp6_;
	result = music_search_match_fields_to_media (m, album_artist, album, genre, grouping, composer, year, rating);
	_g_free0 (composer);
	_g_free0 (grouping);
	_g_free0 (album);
	_g_free0 (album_artist);
	_g_free0 (genre);
	return result;
}

static void
music_column_browser_update_column_separators (MusicColumnBrowser* self)
{
	guint n_visible_columns = 0U;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	guint _tmp5_;
	MusicBrowserColumnCategory first_col = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_column_browser_get_visible_columns (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = (guint) _tmp4_;
	_g_object_unref0 (_tmp2_);
	n_visible_columns = _tmp5_;
	first_col = music_browser_column_category_first ();
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp6_;
		GeeTreeSet* _tmp7_;
		GeeTreeSet* _tmp8_;
		GeeIterator* _tmp9_;
		GeeIterator* _tmp10_;
		_tmp6_ = music_column_browser_get_visible_columns (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = _tmp7_;
		_tmp9_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp8_);
		_tmp10_ = _tmp9_;
		_g_object_unref0 (_tmp8_);
		_col_it = _tmp10_;
		while (TRUE) {
			GeeIterator* _tmp11_;
			MusicBrowserColumnCategory col = 0;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			MusicBrowserColumnCategory _tmp14_;
			MusicBrowserColumnCategory _tmp15_;
			_tmp11_ = _col_it;
			if (!gee_iterator_next (_tmp11_)) {
				break;
			}
			_tmp12_ = _col_it;
			_tmp13_ = gee_iterator_get (_tmp12_);
			col = (MusicBrowserColumnCategory) ((gintptr) _tmp13_);
			_tmp14_ = col;
			_tmp15_ = first_col;
			if (_tmp14_ > _tmp15_) {
				MusicBrowserColumnCategory _tmp16_;
				_tmp16_ = col;
				first_col = _tmp16_;
			}
		}
		_g_object_unref0 (_col_it);
	}
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp17_;
		GeeIterator* _tmp18_;
		_tmp17_ = self->priv->_columns;
		_tmp18_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp17_);
		_col_it = _tmp18_;
		while (TRUE) {
			GeeIterator* _tmp19_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			gboolean _tmp22_ = FALSE;
			MusicBrowserColumn* _tmp23_;
			MusicBrowserColumnCategory _tmp24_;
			MusicBrowserColumnCategory _tmp25_;
			MusicBrowserColumnCategory _tmp26_;
			MusicBrowserColumn* _tmp27_;
			_tmp19_ = _col_it;
			if (!gee_iterator_next (_tmp19_)) {
				break;
			}
			_tmp20_ = _col_it;
			_tmp21_ = gee_iterator_get (_tmp20_);
			col = (MusicBrowserColumn*) _tmp21_;
			_tmp23_ = col;
			_tmp24_ = music_browser_column_get_category (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = first_col;
			if (_tmp25_ != _tmp26_) {
				_tmp22_ = n_visible_columns > ((guint) 1);
			} else {
				_tmp22_ = FALSE;
			}
			_tmp27_ = col;
			music_browser_column_set_show_separator (_tmp27_, _tmp22_);
			_g_object_unref0 (col);
		}
		_g_object_unref0 (_col_it);
	}
}

static void
music_column_browser_column_header_clicked (MusicColumnBrowser* self,
                                            GdkEventButton* e)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (e != NULL);
	if (e->button == ((guint) GDK_BUTTON_SECONDARY)) {
		GtkMenu* _tmp0_;
		_tmp0_ = self->priv->column_chooser_menu;
		gtk_menu_popup_at_pointer (_tmp0_, (GdkEvent*) e);
	}
}

static void
_vala_array_add5 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
music_column_browser_save_current_state (MusicColumnBrowser* self)
{
	gchar** visible_categories = NULL;
	gchar** _tmp0_;
	gint visible_categories_length1;
	gint _visible_categories_size_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	GSettings* _tmp15_;
	GSettings* _tmp16_;
	MusicColumnBrowserPosition _tmp17_;
	MusicColumnBrowserPosition _tmp18_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	visible_categories = _tmp0_;
	visible_categories_length1 = 0;
	_visible_categories_size_ = visible_categories_length1;
	{
		GeeIterator* _col_cat_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeTreeSet* _tmp2_;
		GeeTreeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp1_ = music_column_browser_get_visible_columns (self);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_col_cat_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			MusicBrowserColumnCategory col_cat = 0;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			gchar** _tmp9_;
			gint _tmp9__length1;
			MusicBrowserColumnCategory _tmp10_;
			gchar* _tmp11_;
			_tmp6_ = _col_cat_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _col_cat_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			col_cat = (MusicBrowserColumnCategory) ((gintptr) _tmp8_);
			_tmp9_ = visible_categories;
			_tmp9__length1 = visible_categories_length1;
			_tmp10_ = col_cat;
			_tmp11_ = g_strdup_printf ("%i", (gint) _tmp10_);
			_vala_array_add5 (&visible_categories, &visible_categories_length1, &_visible_categories_size_, _tmp11_);
		}
		_g_object_unref0 (_col_cat_it);
	}
	_tmp12_ = music_app_get_saved_state ();
	_tmp13_ = _tmp12_;
	_tmp14_ = visible_categories;
	_tmp14__length1 = visible_categories_length1;
	g_settings_set_strv (_tmp13_, "column-browser-visible-columns", _tmp14_);
	_tmp15_ = music_app_get_saved_state ();
	_tmp16_ = _tmp15_;
	_tmp17_ = music_column_browser_get_position (self);
	_tmp18_ = _tmp17_;
	g_settings_set_int (_tmp16_, "column-browser-position", (gint) _tmp18_);
	visible_categories = (_vala_array_free (visible_categories, visible_categories_length1, (GDestroyNotify) g_free), NULL);
}

MusicColumnBrowserPosition
music_column_browser_get_position (MusicColumnBrowser* self)
{
	MusicColumnBrowserPosition result;
	MusicColumnBrowserPosition _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_position;
	result = _tmp0_;
	return result;
}

void
music_column_browser_set_position (MusicColumnBrowser* self,
                                   MusicColumnBrowserPosition value)
{
	MusicColumnBrowserPosition _tmp0_;
	MusicColumnBrowserPosition _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_position = value;
	_tmp0_ = self->priv->_position;
	g_signal_emit (self, music_column_browser_signals[MUSIC_COLUMN_BROWSER_POSITION_CHANGED_SIGNAL], 0, _tmp0_);
	_tmp1_ = self->priv->_position;
	switch (_tmp1_) {
		case MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC:
		{
			GtkRadioMenuItem* _tmp2_;
			_tmp2_ = self->priv->automatic_menu_item;
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp2_, TRUE);
			break;
		}
		case MUSIC_COLUMN_BROWSER_POSITION_LEFT:
		{
			GtkRadioMenuItem* _tmp3_;
			_tmp3_ = self->priv->left_menu_item;
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp3_, TRUE);
			break;
		}
		case MUSIC_COLUMN_BROWSER_POSITION_TOP:
		{
			GtkRadioMenuItem* _tmp4_;
			_tmp4_ = self->priv->top_menu_item;
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp4_, TRUE);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	g_object_notify_by_pspec ((GObject *) self, music_column_browser_properties[MUSIC_COLUMN_BROWSER_POSITION_PROPERTY]);
}

MusicColumnBrowserPosition
music_column_browser_get_actual_position (MusicColumnBrowser* self)
{
	MusicColumnBrowserPosition result;
	MusicColumnBrowserPosition _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_actual_position;
	result = _tmp0_;
	return result;
}

void
music_column_browser_set_actual_position (MusicColumnBrowser* self,
                                          MusicColumnBrowserPosition value)
{
	g_return_if_fail (self != NULL);
	if (music_column_browser_get_actual_position (self) != value) {
		self->priv->_actual_position = value;
		g_object_notify_by_pspec ((GObject *) self, music_column_browser_properties[MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY]);
	}
}

MusicViewWrapper*
music_column_browser_get_view_wrapper (MusicColumnBrowser* self)
{
	MusicViewWrapper* result;
	MusicViewWrapper* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view_wrapper;
	result = _tmp0_;
	return result;
}

static void
music_column_browser_set_view_wrapper (MusicColumnBrowser* self,
                                       MusicViewWrapper* value)
{
	g_return_if_fail (self != NULL);
	if (music_column_browser_get_view_wrapper (self) != value) {
		MusicViewWrapper* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_view_wrapper);
		self->priv->_view_wrapper = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_column_browser_properties[MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY]);
	}
}

gboolean
music_column_browser_get_filtered (MusicColumnBrowser* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
		_tmp0_ = self->priv->_columns;
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
		_col_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicBrowserColumn* col = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicBrowserColumn* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
			_tmp2_ = _col_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _col_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			col = (MusicBrowserColumn*) _tmp4_;
			_tmp5_ = col;
			_tmp6_ = music_browser_column_get_first_item_selected (_tmp5_);
			_tmp7_ = _tmp6_;
			if (!_tmp7_) {
				result = TRUE;
				_g_object_unref0 (col);
				_g_object_unref0 (_col_it);
				return result;
			}
			_g_object_unref0 (col);
		}
		_g_object_unref0 (_col_it);
	}
	result = FALSE;
	return result;
}

GeeTreeSet*
music_column_browser_get_visible_columns (MusicColumnBrowser* self)
{
	GeeTreeSet* result;
	GeeTreeSet* visible_columns = NULL;
	GeeTreeSet* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_tree_set_new (MUSIC_BROWSER_COLUMN_TYPE_CATEGORY, NULL, NULL, NULL, NULL, NULL);
	visible_columns = _tmp0_;
	{
		GeeIterator* _column_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeIterator* _tmp2_;
		_tmp1_ = self->priv->_columns;
		_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
		_column_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			MusicBrowserColumn* column = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			MusicBrowserColumn* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
			_tmp3_ = _column_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _column_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			column = (MusicBrowserColumn*) _tmp5_;
			_tmp6_ = column;
			_tmp7_ = music_browser_column_get_visible (_tmp6_);
			_tmp8_ = _tmp7_;
			if (_tmp8_) {
				GeeTreeSet* _tmp9_;
				MusicBrowserColumn* _tmp10_;
				MusicBrowserColumnCategory _tmp11_;
				MusicBrowserColumnCategory _tmp12_;
				_tmp9_ = visible_columns;
				_tmp10_ = column;
				_tmp11_ = music_browser_column_get_category (_tmp10_);
				_tmp12_ = _tmp11_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (gpointer) ((gintptr) _tmp12_));
			}
			_g_object_unref0 (column);
		}
		_g_object_unref0 (_column_it);
	}
	result = visible_columns;
	return result;
}

void
music_column_browser_set_visible_columns (MusicColumnBrowser* self,
                                          GeeTreeSet* value)
{
	gboolean no_column_enabled = FALSE;
	g_return_if_fail (self != NULL);
	no_column_enabled = TRUE;
	{
		GeeIterator* _column_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
		_tmp0_ = self->priv->_columns;
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
		_column_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicBrowserColumn* column = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean column_visible = FALSE;
			MusicBrowserColumn* _tmp13_;
			_tmp2_ = _column_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _column_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			column = (MusicBrowserColumn*) _tmp4_;
			column_visible = FALSE;
			{
				GeeIterator* _category_it = NULL;
				GeeIterator* _tmp5_;
				_tmp5_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) value);
				_category_it = _tmp5_;
				while (TRUE) {
					GeeIterator* _tmp6_;
					MusicBrowserColumnCategory category = 0;
					GeeIterator* _tmp7_;
					gpointer _tmp8_;
					MusicBrowserColumn* _tmp9_;
					MusicBrowserColumnCategory _tmp10_;
					MusicBrowserColumnCategory _tmp11_;
					MusicBrowserColumnCategory _tmp12_;
					_tmp6_ = _category_it;
					if (!gee_iterator_next (_tmp6_)) {
						break;
					}
					_tmp7_ = _category_it;
					_tmp8_ = gee_iterator_get (_tmp7_);
					category = (MusicBrowserColumnCategory) ((gintptr) _tmp8_);
					_tmp9_ = column;
					_tmp10_ = music_browser_column_get_category (_tmp9_);
					_tmp11_ = _tmp10_;
					_tmp12_ = category;
					if (_tmp11_ == _tmp12_) {
						column_visible = TRUE;
						break;
					}
				}
				_g_object_unref0 (_category_it);
			}
			_tmp13_ = column;
			music_browser_column_set_visible (_tmp13_, column_visible);
			if (column_visible) {
				no_column_enabled = FALSE;
			}
			_g_object_unref0 (column);
		}
		_g_object_unref0 (_column_it);
	}
	if (no_column_enabled) {
		MusicBrowserColumn* col = NULL;
		GeeTreeSet* _tmp14_;
		gpointer _tmp15_;
		MusicBrowserColumn* _tmp16_;
		_tmp14_ = self->priv->_columns;
		_tmp15_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _tmp14_);
		col = (MusicBrowserColumn*) _tmp15_;
		_tmp16_ = col;
		if (_tmp16_ != NULL) {
			MusicBrowserColumn* _tmp17_;
			_tmp17_ = col;
			music_browser_column_set_visible (_tmp17_, TRUE);
		}
		_g_object_unref0 (col);
	}
	g_object_notify_by_pspec ((GObject *) self, music_column_browser_properties[MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY]);
}

gboolean
music_column_browser_get_initialized (MusicColumnBrowser* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GeeLinkedList* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->media;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GeeCollection* _tmp2_;
		_tmp2_ = self->priv->search_results;
		_tmp0_ = _tmp2_ == NULL;
	}
	result = _tmp0_;
	return result;
}

GeeTreeSet*
music_column_browser_get_columns (MusicColumnBrowser* self)
{
	GeeTreeSet* result;
	GeeTreeSet* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_columns;
	result = _tmp0_;
	return result;
}

static void
music_column_browser_set_columns (MusicColumnBrowser* self,
                                  GeeTreeSet* value)
{
	g_return_if_fail (self != NULL);
	if (music_column_browser_get_columns (self) != value) {
		GeeTreeSet* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_columns);
		self->priv->_columns = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_column_browser_properties[MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY]);
	}
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
_vala_array_add6 (MusicBrowserColumnCategory* * array,
                  int* length,
                  int* size,
                  MusicBrowserColumnCategory value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_vala_array_add7 (MusicBrowserColumnCategory* * array,
                  int* length,
                  int* size,
                  MusicBrowserColumnCategory value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_vala_array_add8 (MusicBrowserColumnCategory* * array,
                  int* length,
                  int* size,
                  MusicBrowserColumnCategory value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_vala_array_add9 (MusicBrowserColumnCategory* * array,
                  int* length,
                  int* size,
                  MusicBrowserColumnCategory value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_vala_array_add10 (MusicBrowserColumnCategory* * array,
                   int* length,
                   int* size,
                   MusicBrowserColumnCategory value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_vala_array_add11 (MusicBrowserColumnCategory* * array,
                   int* length,
                   int* size,
                   MusicBrowserColumnCategory value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_vala_array_add12 (MusicBrowserColumnCategory* * array,
                   int* length,
                   int* size,
                   MusicBrowserColumnCategory value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (MusicBrowserColumnCategory, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_music_column_browser___lambda67_ (MusicColumnBrowser* self)
{
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->automatic_menu_item;
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		music_column_browser_set_position (self, MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC);
	}
}

static void
__music_column_browser___lambda67__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
	_music_column_browser___lambda67_ ((MusicColumnBrowser*) self);
}

static void
_music_column_browser___lambda68_ (MusicColumnBrowser* self)
{
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->left_menu_item;
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		music_column_browser_set_position (self, MUSIC_COLUMN_BROWSER_POSITION_LEFT);
	}
}

static void
__music_column_browser___lambda68__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
	_music_column_browser___lambda68_ ((MusicColumnBrowser*) self);
}

static void
_music_column_browser___lambda69_ (MusicColumnBrowser* self)
{
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->top_menu_item;
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		music_column_browser_set_position (self, MUSIC_COLUMN_BROWSER_POSITION_TOP);
	}
}

static void
__music_column_browser___lambda69__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
	_music_column_browser___lambda69_ ((MusicColumnBrowser*) self);
}

static void
_music_column_browser_save_current_state_gtk_widget_destroy (GtkWidget* _sender,
                                                             gpointer self)
{
	music_column_browser_save_current_state ((MusicColumnBrowser*) self);
}

static GObject *
music_column_browser_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicColumnBrowser * self;
	GSList* _tmp0_;
	GtkRadioMenuItem* _tmp1_;
	GtkRadioMenuItem* _tmp2_;
	GSList* _tmp3_;
	GtkRadioMenuItem* _tmp4_;
	GtkRadioMenuItem* _tmp5_;
	GSList* _tmp6_;
	GtkRadioMenuItem* _tmp7_;
	GtkMenu* _tmp8_;
	MusicBrowserColumnCategory* categories = NULL;
	MusicBrowserColumnCategory* _tmp9_;
	gint categories_length1;
	gint _categories_size_;
	MusicBrowserColumnCategory* _tmp10_;
	gint _tmp10__length1;
	MusicBrowserColumnCategory* _tmp11_;
	gint _tmp11__length1;
	MusicBrowserColumnCategory* _tmp12_;
	gint _tmp12__length1;
	MusicBrowserColumnCategory* _tmp13_;
	gint _tmp13__length1;
	MusicBrowserColumnCategory* _tmp14_;
	gint _tmp14__length1;
	MusicBrowserColumnCategory* _tmp15_;
	gint _tmp15__length1;
	MusicBrowserColumnCategory* _tmp16_;
	gint _tmp16__length1;
	GeeTreeSet* _tmp17_;
	GeeTreeSet* _tmp18_;
	MusicBrowserColumnCategory* _tmp19_;
	gint _tmp19__length1;
	GeeTreeSet* visible_categories = NULL;
	GeeTreeSet* _tmp23_;
	GSettings* _tmp24_;
	GSettings* _tmp25_;
	gchar** _tmp26_;
	gchar** _tmp27_;
	GeeTreeSet* _tmp31_;
	GtkMenu* _tmp32_;
	GtkSeparatorMenuItem* _tmp33_;
	GtkSeparatorMenuItem* _tmp34_;
	GtkMenu* _tmp35_;
	GtkRadioMenuItem* _tmp36_;
	GtkMenu* _tmp37_;
	GtkRadioMenuItem* _tmp38_;
	GtkMenu* _tmp39_;
	GtkRadioMenuItem* _tmp40_;
	GtkMenu* _tmp41_;
	GSettings* _tmp42_;
	GSettings* _tmp43_;
	GtkRadioMenuItem* _tmp44_;
	GtkRadioMenuItem* _tmp45_;
	GtkRadioMenuItem* _tmp46_;
	parent_class = G_OBJECT_CLASS (music_column_browser_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser);
	_tmp0_ = NULL;
	_tmp1_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_label (_tmp0_, _ ("Automatic"));
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->automatic_menu_item);
	self->priv->automatic_menu_item = _tmp1_;
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_object_unref0_ (_tmp0_), NULL));
	_tmp2_ = self->priv->automatic_menu_item;
	_tmp3_ = gtk_radio_menu_item_get_group (_tmp2_);
	_tmp4_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_label (_tmp3_, _ ("On Left"));
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->left_menu_item);
	self->priv->left_menu_item = _tmp4_;
	_tmp5_ = self->priv->left_menu_item;
	_tmp6_ = gtk_radio_menu_item_get_group (_tmp5_);
	_tmp7_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_label (_tmp6_, _ ("On Top"));
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->top_menu_item);
	self->priv->top_menu_item = _tmp7_;
	_tmp8_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->column_chooser_menu);
	self->priv->column_chooser_menu = _tmp8_;
	_tmp9_ = g_new0 (MusicBrowserColumnCategory, 0);
	categories = _tmp9_;
	categories_length1 = 0;
	_categories_size_ = categories_length1;
	_tmp10_ = categories;
	_tmp10__length1 = categories_length1;
	_vala_array_add6 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_RATING);
	_tmp11_ = categories;
	_tmp11__length1 = categories_length1;
	_vala_array_add7 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING);
	_tmp12_ = categories;
	_tmp12__length1 = categories_length1;
	_vala_array_add8 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_YEAR);
	_tmp13_ = categories;
	_tmp13__length1 = categories_length1;
	_vala_array_add9 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_GENRE);
	_tmp14_ = categories;
	_tmp14__length1 = categories_length1;
	_vala_array_add10 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER);
	_tmp15_ = categories;
	_tmp15__length1 = categories_length1;
	_vala_array_add11 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST);
	_tmp16_ = categories;
	_tmp16__length1 = categories_length1;
	_vala_array_add12 (&categories, &categories_length1, &_categories_size_, MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM);
	_tmp17_ = gee_tree_set_new (MUSIC_TYPE_BROWSER_COLUMN, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_tmp18_ = _tmp17_;
	music_column_browser_set_columns (self, _tmp18_);
	_g_object_unref0 (_tmp18_);
	_tmp19_ = categories;
	_tmp19__length1 = categories_length1;
	{
		MusicBrowserColumnCategory* category_collection = NULL;
		gint category_collection_length1 = 0;
		gint _category_collection_size_ = 0;
		gint category_it = 0;
		category_collection = _tmp19_;
		category_collection_length1 = _tmp19__length1;
		for (category_it = 0; category_it < category_collection_length1; category_it = category_it + 1) {
			MusicBrowserColumnCategory category = 0;
			category = category_collection[category_it];
			{
				MusicBrowserColumnCategory _tmp20_;
				MusicBrowserColumn* _tmp21_;
				MusicBrowserColumn* _tmp22_;
				_tmp20_ = category;
				_tmp21_ = music_column_browser_add_column (self, _tmp20_);
				_tmp22_ = _tmp21_;
				_g_object_unref0 (_tmp22_);
			}
		}
	}
	_tmp23_ = gee_tree_set_new (MUSIC_BROWSER_COLUMN_TYPE_CATEGORY, NULL, NULL, NULL, NULL, NULL);
	visible_categories = _tmp23_;
	_tmp24_ = music_app_get_saved_state ();
	_tmp25_ = _tmp24_;
	_tmp27_ = _tmp26_ = g_settings_get_strv (_tmp25_, "column-browser-visible-columns");
	{
		gchar** col_n_collection = NULL;
		gint col_n_collection_length1 = 0;
		gint _col_n_collection_size_ = 0;
		gint col_n_it = 0;
		col_n_collection = _tmp27_;
		col_n_collection_length1 = _vala_array_length (_tmp26_);
		for (col_n_it = 0; col_n_it < col_n_collection_length1; col_n_it = col_n_it + 1) {
			gchar* _tmp28_;
			gchar* col_n = NULL;
			_tmp28_ = g_strdup (col_n_collection[col_n_it]);
			col_n = _tmp28_;
			{
				GeeTreeSet* _tmp29_;
				const gchar* _tmp30_;
				_tmp29_ = visible_categories;
				_tmp30_ = col_n;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, (gpointer) ((gintptr) ((MusicBrowserColumnCategory) atoi (_tmp30_))));
				_g_free0 (col_n);
			}
		}
		col_n_collection = (_vala_array_free (col_n_collection, col_n_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp31_ = visible_categories;
	music_column_browser_set_visible_columns (self, _tmp31_);
	_tmp32_ = self->priv->column_chooser_menu;
	_tmp33_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp33_);
	_tmp34_ = _tmp33_;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp32_, (GtkMenuItem*) _tmp34_);
	_g_object_unref0 (_tmp34_);
	_tmp35_ = self->priv->column_chooser_menu;
	_tmp36_ = self->priv->automatic_menu_item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp35_, (GtkMenuItem*) _tmp36_);
	_tmp37_ = self->priv->column_chooser_menu;
	_tmp38_ = self->priv->top_menu_item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp37_, (GtkMenuItem*) _tmp38_);
	_tmp39_ = self->priv->column_chooser_menu;
	_tmp40_ = self->priv->left_menu_item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp39_, (GtkMenuItem*) _tmp40_);
	_tmp41_ = self->priv->column_chooser_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp41_);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
	_tmp42_ = music_app_get_saved_state ();
	_tmp43_ = _tmp42_;
	music_column_browser_set_position (self, (MusicColumnBrowserPosition) g_settings_get_int (_tmp43_, "column-browser-position"));
	_tmp44_ = self->priv->automatic_menu_item;
	g_signal_connect_object ((GtkCheckMenuItem*) _tmp44_, "toggled", (GCallback) __music_column_browser___lambda67__gtk_check_menu_item_toggled, self, 0);
	_tmp45_ = self->priv->left_menu_item;
	g_signal_connect_object ((GtkCheckMenuItem*) _tmp45_, "toggled", (GCallback) __music_column_browser___lambda68__gtk_check_menu_item_toggled, self, 0);
	_tmp46_ = self->priv->top_menu_item;
	g_signal_connect_object ((GtkCheckMenuItem*) _tmp46_, "toggled", (GCallback) __music_column_browser___lambda69__gtk_check_menu_item_toggled, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) _music_column_browser_save_current_state_gtk_widget_destroy, self, 0);
	_g_object_unref0 (visible_categories);
	categories = (g_free (categories), NULL);
	return obj;
}

static void
music_column_browser_class_init (MusicColumnBrowserClass * klass,
                                 gpointer klass_data)
{
	music_column_browser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicColumnBrowser_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_column_browser_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_column_browser_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_column_browser_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_column_browser_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_POSITION_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_POSITION_PROPERTY] = g_param_spec_enum ("position", "position", "position", MUSIC_COLUMN_BROWSER_TYPE_POSITION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY] = g_param_spec_enum ("actual-position", "actual-position", "actual-position", MUSIC_COLUMN_BROWSER_TYPE_POSITION, MUSIC_COLUMN_BROWSER_POSITION_LEFT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY] = g_param_spec_object ("view-wrapper", "view-wrapper", "view-wrapper", MUSIC_TYPE_VIEW_WRAPPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	     * Whether the columns are filtered or not based on the current selection.
	     * Although 'media.size == search_results.size' would produce a similar result,
	     * here we want to know if the "All ..." filter is selected in every column.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_FILTERED_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_FILTERED_PROPERTY] = g_param_spec_boolean ("filtered", "filtered", "filtered", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY] = g_param_spec_object ("visible-columns", "visible-columns", "visible-columns", GEE_TYPE_TREE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_INITIALIZED_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_INITIALIZED_PROPERTY] = g_param_spec_boolean ("initialized", "initialized", "initialized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY, music_column_browser_properties[MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY] = g_param_spec_object ("columns", "columns", "columns", GEE_TYPE_TREE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	music_column_browser_signals[MUSIC_COLUMN_BROWSER_CHANGED_SIGNAL] = g_signal_new ("changed", MUSIC_TYPE_COLUMN_BROWSER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_column_browser_signals[MUSIC_COLUMN_BROWSER_POSITION_CHANGED_SIGNAL] = g_signal_new ("position-changed", MUSIC_TYPE_COLUMN_BROWSER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, MUSIC_COLUMN_BROWSER_TYPE_POSITION);
}

static void
music_column_browser_instance_init (MusicColumnBrowser * self,
                                    gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	self->priv = music_column_browser_get_instance_private (self);
	self->priv->_position = MUSIC_COLUMN_BROWSER_POSITION_AUTOMATIC;
	self->priv->_actual_position = MUSIC_COLUMN_BROWSER_POSITION_LEFT;
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->media = _tmp0_;
	_tmp1_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->search_results = (GeeCollection*) _tmp1_;
}

static void
music_column_browser_finalize (GObject * obj)
{
	MusicColumnBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser);
	_g_object_unref0 (self->priv->_view_wrapper);
	_g_object_unref0 (self->priv->_columns);
	_g_object_unref0 (self->priv->media);
	_g_object_unref0 (self->priv->search_results);
	_g_object_unref0 (self->priv->column_chooser_menu);
	_g_object_unref0 (self->priv->top_menu_item);
	_g_object_unref0 (self->priv->left_menu_item);
	_g_object_unref0 (self->priv->automatic_menu_item);
	G_OBJECT_CLASS (music_column_browser_parent_class)->finalize (obj);
}

GType
music_column_browser_get_type (void)
{
	static volatile gsize music_column_browser_type_id__volatile = 0;
	if (g_once_init_enter (&music_column_browser_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicColumnBrowserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_column_browser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicColumnBrowser), 0, (GInstanceInitFunc) music_column_browser_instance_init, NULL };
		GType music_column_browser_type_id;
		music_column_browser_type_id = g_type_register_static (gtk_grid_get_type (), "MusicColumnBrowser", &g_define_type_info, 0);
		MusicColumnBrowser_private_offset = g_type_add_instance_private (music_column_browser_type_id, sizeof (MusicColumnBrowserPrivate));
		g_once_init_leave (&music_column_browser_type_id__volatile, music_column_browser_type_id);
	}
	return music_column_browser_type_id__volatile;
}

static void
_vala_music_column_browser_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	MusicColumnBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser);
	switch (property_id) {
		case MUSIC_COLUMN_BROWSER_POSITION_PROPERTY:
		g_value_set_enum (value, music_column_browser_get_position (self));
		break;
		case MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY:
		g_value_set_enum (value, music_column_browser_get_actual_position (self));
		break;
		case MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY:
		g_value_set_object (value, music_column_browser_get_view_wrapper (self));
		break;
		case MUSIC_COLUMN_BROWSER_FILTERED_PROPERTY:
		g_value_set_boolean (value, music_column_browser_get_filtered (self));
		break;
		case MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY:
		g_value_take_object (value, music_column_browser_get_visible_columns (self));
		break;
		case MUSIC_COLUMN_BROWSER_INITIALIZED_PROPERTY:
		g_value_set_boolean (value, music_column_browser_get_initialized (self));
		break;
		case MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY:
		g_value_set_object (value, music_column_browser_get_columns (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_column_browser_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	MusicColumnBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser);
	switch (property_id) {
		case MUSIC_COLUMN_BROWSER_POSITION_PROPERTY:
		music_column_browser_set_position (self, g_value_get_enum (value));
		break;
		case MUSIC_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY:
		music_column_browser_set_actual_position (self, g_value_get_enum (value));
		break;
		case MUSIC_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY:
		music_column_browser_set_view_wrapper (self, g_value_get_object (value));
		break;
		case MUSIC_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY:
		music_column_browser_set_visible_columns (self, g_value_get_object (value));
		break;
		case MUSIC_COLUMN_BROWSER_COLUMNS_PROPERTY:
		music_column_browser_set_columns (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

