/* PresetList.c generated by valac 0.44.11, the Vala compiler
 * generated from PresetList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <gee.h>

#define MUSIC_TYPE_PRESET_LIST (music_preset_list_get_type ())
#define MUSIC_PRESET_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PRESET_LIST, MusicPresetList))
#define MUSIC_PRESET_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PRESET_LIST, MusicPresetListClass))
#define MUSIC_IS_PRESET_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PRESET_LIST))
#define MUSIC_IS_PRESET_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PRESET_LIST))
#define MUSIC_PRESET_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PRESET_LIST, MusicPresetListClass))

typedef struct _MusicPresetList MusicPresetList;
typedef struct _MusicPresetListClass MusicPresetListClass;
typedef struct _MusicPresetListPrivate MusicPresetListPrivate;
enum  {
	MUSIC_PRESET_LIST_0_PROPERTY,
	MUSIC_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY,
	MUSIC_PRESET_LIST_NUM_PROPERTIES
};
static GParamSpec* music_preset_list_properties[MUSIC_PRESET_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MUSIC_PRESET_LIST_PRESET_SELECTED_SIGNAL,
	MUSIC_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL,
	MUSIC_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL,
	MUSIC_PRESET_LIST_NUM_SIGNALS
};
static guint music_preset_list_signals[MUSIC_PRESET_LIST_NUM_SIGNALS] = {0};

struct _MusicPresetList {
	GtkComboBox parent_instance;
	MusicPresetListPrivate * priv;
	MusicEqualizerPreset* last_selected_preset;
};

struct _MusicPresetListClass {
	GtkComboBoxClass parent_class;
	void (*list_selection_change) (MusicPresetList* self);
};

struct _MusicPresetListPrivate {
	gint _ncustompresets;
	gboolean modifying_list;
	gboolean automatic_selected;
	GtkListStore* store;
};

static gint MusicPresetList_private_offset;
static gpointer music_preset_list_parent_class = NULL;
static gchar* music_preset_list_automatic_mode;
static gchar* music_preset_list_automatic_mode = NULL;
static gchar* music_preset_list_delete_preset;
static gchar* music_preset_list_delete_preset = NULL;

GType music_preset_list_get_type (void) G_GNUC_CONST;
#define MUSIC_PRESET_LIST_SEPARATOR_NAME "<separator_item_unique_name>"
MusicPresetList* music_preset_list_new (void);
MusicPresetList* music_preset_list_construct (GType object_type);
static void music_preset_list_set_ncustompresets (MusicPresetList* self,
                                           gint value);
static gboolean __lambda20_ (MusicPresetList* self,
                      GtkTreeModel* model,
                      GtkTreeIter* iter);
static gboolean ___lambda20__gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                        GtkTreeIter* iter,
                                                        gpointer self);
void music_preset_list_list_selection_change (MusicPresetList* self);
static void _music_preset_list_list_selection_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self);
void music_preset_list_add_separator (MusicPresetList* self);
void music_preset_list_add_preset (MusicPresetList* self,
                                   MusicEqualizerPreset* ep);
static gint music_preset_list_get_ncustompresets (MusicPresetList* self);
void music_preset_list_remove_current_preset (MusicPresetList* self);
static void music_preset_list_remove_separator_item (MusicPresetList* self,
                                              gint index);
void music_preset_list_select_automatic_preset (MusicPresetList* self);
static void music_preset_list_real_list_selection_change (MusicPresetList* self);
static void music_preset_list_add_delete_preset_option (MusicPresetList* self);
static void music_preset_list_remove_delete_option (MusicPresetList* self);
void music_preset_list_select_preset (MusicPresetList* self,
                                      const gchar* preset_name);
MusicEqualizerPreset* music_preset_list_get_selected_preset (MusicPresetList* self);
GeeCollection* music_preset_list_get_presets (MusicPresetList* self);
gboolean music_preset_list_get_automatic_chosen (MusicPresetList* self);
static void music_preset_list_finalize (GObject * obj);
static void _vala_music_preset_list_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_music_preset_list_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
music_preset_list_get_instance_private (MusicPresetList* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPresetList_private_offset);
}

static gboolean
__lambda20_ (MusicPresetList* self,
             GtkTreeModel* model,
             GtkTreeIter* iter)
{
	gchar* content = NULL;
	gchar* _tmp0_;
	GtkTreeIter _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = g_strdup ("");
	content = _tmp0_;
	_tmp1_ = *iter;
	gtk_tree_model_get (model, &_tmp1_, 1, &_tmp2_, -1);
	_g_free0 (content);
	content = _tmp2_;
	_tmp3_ = content;
	result = g_strcmp0 (_tmp3_, MUSIC_PRESET_LIST_SEPARATOR_NAME) == 0;
	_g_free0 (content);
	return result;
}

static gboolean
___lambda20__gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                               GtkTreeIter* iter,
                                               gpointer self)
{
	gboolean result;
	result = __lambda20_ ((MusicPresetList*) self, model, iter);
	return result;
}

static void
_music_preset_list_list_selection_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self)
{
	music_preset_list_list_selection_change ((MusicPresetList*) self);
}

MusicPresetList*
music_preset_list_construct (GType object_type)
{
	MusicPresetList * self = NULL;
	GtkListStore* _tmp0_;
	GtkListStore* _tmp1_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	self = (MusicPresetList*) g_object_new (object_type, NULL);
	music_preset_list_set_ncustompresets (self, 0);
	self->priv->modifying_list = FALSE;
	self->priv->automatic_selected = FALSE;
	_tmp0_ = gtk_list_store_new (2, G_TYPE_OBJECT, G_TYPE_STRING, -1);
	_g_object_unref0 (self->priv->store);
	self->priv->store = _tmp0_;
	_tmp1_ = self->priv->store;
	gtk_combo_box_set_model ((GtkComboBox*) self, (GtkTreeModel*) _tmp1_);
	gtk_combo_box_set_id_column ((GtkComboBox*) self, 1);
	gtk_combo_box_set_row_separator_func ((GtkComboBox*) self, ___lambda20__gtk_tree_view_row_separator_func, g_object_ref (self), g_object_unref);
	_tmp2_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp2_);
	cell = _tmp2_;
	g_object_set (cell, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
	gtk_cell_layout_pack_start ((GtkCellLayout*) self, (GtkCellRenderer*) cell, TRUE);
	gtk_cell_layout_add_attribute ((GtkCellLayout*) self, (GtkCellRenderer*) cell, "text", 1);
	g_signal_connect_object ((GtkComboBox*) self, "changed", (GCallback) _music_preset_list_list_selection_change_gtk_combo_box_changed, self, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp3_ = self->priv->store;
	gtk_list_store_clear (_tmp3_);
	_tmp4_ = self->priv->store;
	gtk_list_store_append (_tmp4_, &_tmp5_);
	iter = _tmp5_;
	_tmp6_ = self->priv->store;
	_tmp7_ = iter;
	_tmp8_ = music_preset_list_automatic_mode;
	gtk_list_store_set (_tmp6_, &_tmp7_, 0, NULL, 1, _tmp8_, -1);
	music_preset_list_add_separator (self);
	_g_object_unref0 (cell);
	return self;
}

MusicPresetList*
music_preset_list_new (void)
{
	return music_preset_list_construct (MUSIC_TYPE_PRESET_LIST);
}

void
music_preset_list_add_separator (MusicPresetList* self)
{
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->store;
	gtk_list_store_append (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	_tmp2_ = self->priv->store;
	_tmp3_ = iter;
	gtk_list_store_set (_tmp2_, &_tmp3_, 0, NULL, 1, MUSIC_PRESET_LIST_SEPARATOR_NAME, -1);
}

void
music_preset_list_add_preset (MusicPresetList* self,
                              MusicEqualizerPreset* ep)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GtkTreeIter _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ep != NULL);
	self->priv->modifying_list = TRUE;
	_tmp0_ = music_equalizer_preset_get_is_default (ep);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		gint _tmp2_;
		gint _tmp3_;
		_tmp2_ = self->priv->_ncustompresets;
		if (_tmp2_ < 1) {
			music_preset_list_add_separator (self);
		}
		_tmp3_ = self->priv->_ncustompresets;
		music_preset_list_set_ncustompresets (self, _tmp3_ + 1);
	}
	_tmp4_ = self->priv->store;
	gtk_list_store_append (_tmp4_, &_tmp5_);
	iter = _tmp5_;
	_tmp6_ = self->priv->store;
	_tmp7_ = iter;
	_tmp8_ = music_equalizer_preset_get_name (ep);
	_tmp9_ = _tmp8_;
	gtk_list_store_set (_tmp6_, &_tmp7_, 0, ep, 1, _tmp9_, -1);
	self->priv->modifying_list = FALSE;
	self->priv->automatic_selected = FALSE;
	_tmp10_ = iter;
	gtk_combo_box_set_active_iter ((GtkComboBox*) self, &_tmp10_);
}

void
music_preset_list_remove_current_preset (MusicPresetList* self)
{
	GtkTreeIter iter = {0};
	gint _tmp21_;
	g_return_if_fail (self != NULL);
	self->priv->modifying_list = TRUE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GtkListStore* _tmp1_;
				gchar* _tmp2_;
				gchar* _tmp3_;
				GtkTreeIter _tmp4_ = {0};
				gboolean _tmp5_;
				gboolean _tmp6_;
				GObject* o = NULL;
				GtkListStore* _tmp7_;
				GtkTreeIter _tmp8_;
				GObject* _tmp9_ = NULL;
				gboolean _tmp10_ = FALSE;
				gboolean _tmp11_ = FALSE;
				GObject* _tmp12_;
				if (!_tmp0_) {
					i = i + 1;
				}
				_tmp0_ = FALSE;
				_tmp1_ = self->priv->store;
				_tmp2_ = g_strdup_printf ("%i", i);
				_tmp3_ = _tmp2_;
				_tmp5_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp1_, &_tmp4_, _tmp3_);
				iter = _tmp4_;
				_tmp6_ = !_tmp5_;
				_g_free0 (_tmp3_);
				if (_tmp6_) {
					break;
				}
				_tmp7_ = self->priv->store;
				_tmp8_ = iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp7_, &_tmp8_, 0, &_tmp9_, -1);
				_g_object_unref0 (o);
				o = _tmp9_;
				_tmp12_ = o;
				if (_tmp12_ != NULL) {
					GObject* _tmp13_;
					_tmp13_ = o;
					_tmp11_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, MUSIC_TYPE_EQUALIZER_PRESET);
				} else {
					_tmp11_ = FALSE;
				}
				if (_tmp11_) {
					GObject* _tmp14_;
					MusicEqualizerPreset* _tmp15_;
					_tmp14_ = o;
					_tmp15_ = self->last_selected_preset;
					_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset) == _tmp15_;
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					GObject* _tmp16_;
					gboolean _tmp17_;
					gboolean _tmp18_;
					_tmp16_ = o;
					_tmp17_ = music_equalizer_preset_get_is_default (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset));
					_tmp18_ = _tmp17_;
					if (!_tmp18_) {
						gint _tmp19_;
						GtkListStore* _tmp20_;
						_tmp19_ = self->priv->_ncustompresets;
						music_preset_list_set_ncustompresets (self, _tmp19_ - 1);
						_tmp20_ = self->priv->store;
						gtk_list_store_remove (_tmp20_, &iter);
						_g_object_unref0 (o);
						break;
					}
				}
				_g_object_unref0 (o);
			}
		}
	}
	_tmp21_ = self->priv->_ncustompresets;
	if (_tmp21_ < 1) {
		music_preset_list_remove_separator_item (self, -1);
	}
	self->priv->modifying_list = FALSE;
	music_preset_list_select_automatic_preset (self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_preset_list_real_list_selection_change (MusicPresetList* self)
{
	GtkTreeIter it = {0};
	GtkTreeIter _tmp0_ = {0};
	GObject* o = NULL;
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_;
	GObject* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GObject* _tmp5_;
	gchar* option = NULL;
	GtkListStore* _tmp13_;
	GtkTreeIter _tmp14_;
	gchar* _tmp15_ = NULL;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	if (self->priv->modifying_list) {
		return;
	}
	gtk_combo_box_get_active_iter ((GtkComboBox*) self, &_tmp0_);
	it = _tmp0_;
	_tmp1_ = self->priv->store;
	_tmp2_ = it;
	gtk_tree_model_get ((GtkTreeModel*) _tmp1_, &_tmp2_, 0, &_tmp3_, -1);
	_g_object_unref0 (o);
	o = _tmp3_;
	_tmp5_ = o;
	if (_tmp5_ != NULL) {
		GObject* _tmp6_;
		_tmp6_ = o;
		_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, MUSIC_TYPE_EQUALIZER_PRESET);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GObject* _tmp7_;
		MusicEqualizerPreset* _tmp8_;
		GObject* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
		GObject* _tmp12_;
		_tmp7_ = o;
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp7_) : NULL);
		_g_object_unref0 (self->last_selected_preset);
		self->last_selected_preset = _tmp8_;
		_tmp9_ = o;
		_tmp10_ = music_equalizer_preset_get_is_default (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp9_) : NULL);
		_tmp11_ = _tmp10_;
		if (!_tmp11_) {
			music_preset_list_add_delete_preset_option (self);
		} else {
			music_preset_list_remove_delete_option (self);
		}
		self->priv->automatic_selected = FALSE;
		_tmp12_ = o;
		g_signal_emit (self, music_preset_list_signals[MUSIC_PRESET_LIST_PRESET_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp12_) : NULL);
		_g_object_unref0 (o);
		return;
	}
	_tmp13_ = self->priv->store;
	_tmp14_ = it;
	gtk_tree_model_get ((GtkTreeModel*) _tmp13_, &_tmp14_, 1, &_tmp15_, -1);
	_g_free0 (option);
	option = _tmp15_;
	_tmp16_ = option;
	_tmp17_ = music_preset_list_automatic_mode;
	if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
		self->priv->automatic_selected = TRUE;
		music_preset_list_remove_delete_option (self);
		g_signal_emit (self, music_preset_list_signals[MUSIC_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL], 0);
	} else {
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		_tmp18_ = option;
		_tmp19_ = music_preset_list_delete_preset;
		if (g_strcmp0 (_tmp18_, _tmp19_) == 0) {
			g_signal_emit (self, music_preset_list_signals[MUSIC_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL], 0);
		}
	}
	_g_free0 (option);
	_g_object_unref0 (o);
}

void
music_preset_list_list_selection_change (MusicPresetList* self)
{
	g_return_if_fail (self != NULL);
	MUSIC_PRESET_LIST_GET_CLASS (self)->list_selection_change (self);
}

void
music_preset_list_select_automatic_preset (MusicPresetList* self)
{
	g_return_if_fail (self != NULL);
	self->priv->automatic_selected = TRUE;
	g_signal_emit (self, music_preset_list_signals[MUSIC_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL], 0);
	gtk_combo_box_set_active ((GtkComboBox*) self, 0);
}

void
music_preset_list_select_preset (MusicPresetList* self,
                                 const gchar* preset_name)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (preset_name == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (preset_name);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_ < 1;
	}
	if (!_tmp0_) {
		GtkTreeIter iter = {0};
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					GtkListStore* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
					GtkTreeIter _tmp7_ = {0};
					gboolean _tmp8_;
					gboolean _tmp9_;
					GObject* o = NULL;
					GtkListStore* _tmp10_;
					GtkTreeIter _tmp11_;
					GObject* _tmp12_ = NULL;
					gboolean _tmp13_ = FALSE;
					gboolean _tmp14_ = FALSE;
					GObject* _tmp15_;
					if (!_tmp3_) {
						i = i + 1;
					}
					_tmp3_ = FALSE;
					_tmp4_ = self->priv->store;
					_tmp5_ = g_strdup_printf ("%i", i);
					_tmp6_ = _tmp5_;
					_tmp8_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp4_, &_tmp7_, _tmp6_);
					iter = _tmp7_;
					_tmp9_ = !_tmp8_;
					_g_free0 (_tmp6_);
					if (_tmp9_) {
						break;
					}
					_tmp10_ = self->priv->store;
					_tmp11_ = iter;
					gtk_tree_model_get ((GtkTreeModel*) _tmp10_, &_tmp11_, 0, &_tmp12_, -1);
					_g_object_unref0 (o);
					o = _tmp12_;
					_tmp15_ = o;
					if (_tmp15_ != NULL) {
						GObject* _tmp16_;
						_tmp16_ = o;
						_tmp14_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, MUSIC_TYPE_EQUALIZER_PRESET);
					} else {
						_tmp14_ = FALSE;
					}
					if (_tmp14_) {
						GObject* _tmp17_;
						const gchar* _tmp18_;
						const gchar* _tmp19_;
						_tmp17_ = o;
						_tmp18_ = music_equalizer_preset_get_name (G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp17_) : NULL);
						_tmp19_ = _tmp18_;
						_tmp13_ = g_strcmp0 (_tmp19_, preset_name) == 0;
					} else {
						_tmp13_ = FALSE;
					}
					if (_tmp13_) {
						GtkTreeIter _tmp20_;
						GObject* _tmp21_;
						_tmp20_ = iter;
						gtk_combo_box_set_active_iter ((GtkComboBox*) self, &_tmp20_);
						self->priv->automatic_selected = FALSE;
						_tmp21_ = o;
						g_signal_emit (self, music_preset_list_signals[MUSIC_PRESET_LIST_PRESET_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp21_) : NULL);
						_g_object_unref0 (o);
						return;
					}
					_g_object_unref0 (o);
				}
			}
		}
	}
	music_preset_list_select_automatic_preset (self);
}

MusicEqualizerPreset*
music_preset_list_get_selected_preset (MusicPresetList* self)
{
	GtkTreeIter it = {0};
	GtkTreeIter _tmp0_ = {0};
	GObject* o = NULL;
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_;
	GObject* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GObject* _tmp5_;
	MusicEqualizerPreset* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	gtk_combo_box_get_active_iter ((GtkComboBox*) self, &_tmp0_);
	it = _tmp0_;
	_tmp1_ = self->priv->store;
	_tmp2_ = it;
	gtk_tree_model_get ((GtkTreeModel*) _tmp1_, &_tmp2_, 0, &_tmp3_, -1);
	_g_object_unref0 (o);
	o = _tmp3_;
	_tmp5_ = o;
	if (_tmp5_ != NULL) {
		GObject* _tmp6_;
		_tmp6_ = o;
		_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, MUSIC_TYPE_EQUALIZER_PRESET);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GObject* _tmp7_;
		MusicEqualizerPreset* _tmp8_;
		_tmp7_ = o;
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp7_) : NULL);
		result = _tmp8_;
		_g_object_unref0 (o);
		return result;
	} else {
		result = NULL;
		_g_object_unref0 (o);
		return result;
	}
	_g_object_unref0 (o);
}

GeeCollection*
music_preset_list_get_presets (MusicPresetList* self)
{
	GeeLinkedList* rv = NULL;
	GeeLinkedList* _tmp0_;
	GtkTreeIter iter = {0};
	GeeCollection* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_EQUALIZER_PRESET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	rv = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				GtkListStore* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				GtkTreeIter _tmp5_ = {0};
				gboolean _tmp6_;
				gboolean _tmp7_;
				GObject* o = NULL;
				GtkListStore* _tmp8_;
				GtkTreeIter _tmp9_;
				GObject* _tmp10_ = NULL;
				gboolean _tmp11_ = FALSE;
				GObject* _tmp12_;
				if (!_tmp1_) {
					i = i + 1;
				}
				_tmp1_ = FALSE;
				_tmp2_ = self->priv->store;
				_tmp3_ = g_strdup_printf ("%i", i);
				_tmp4_ = _tmp3_;
				_tmp6_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp5_, _tmp4_);
				iter = _tmp5_;
				_tmp7_ = !_tmp6_;
				_g_free0 (_tmp4_);
				if (_tmp7_) {
					break;
				}
				_tmp8_ = self->priv->store;
				_tmp9_ = iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp8_, &_tmp9_, 0, &_tmp10_, -1);
				_g_object_unref0 (o);
				o = _tmp10_;
				_tmp12_ = o;
				if (_tmp12_ != NULL) {
					GObject* _tmp13_;
					_tmp13_ = o;
					_tmp11_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, MUSIC_TYPE_EQUALIZER_PRESET);
				} else {
					_tmp11_ = FALSE;
				}
				if (_tmp11_) {
					GeeLinkedList* _tmp14_;
					GObject* _tmp15_;
					_tmp14_ = rv;
					_tmp15_ = o;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, MUSIC_TYPE_EQUALIZER_PRESET) ? ((MusicEqualizerPreset*) _tmp15_) : NULL);
				}
				_g_object_unref0 (o);
			}
		}
	}
	result = (GeeCollection*) rv;
	return result;
}

static void
music_preset_list_remove_delete_option (MusicPresetList* self)
{
	GtkTreeIter iter = {0};
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GtkListStore* _tmp1_;
				gchar* _tmp2_;
				gchar* _tmp3_;
				GtkTreeIter _tmp4_ = {0};
				gboolean _tmp5_;
				gboolean _tmp6_;
				gchar* text = NULL;
				GtkListStore* _tmp7_;
				GtkTreeIter _tmp8_;
				gchar* _tmp9_ = NULL;
				gboolean _tmp10_ = FALSE;
				const gchar* _tmp11_;
				if (!_tmp0_) {
					i = i + 1;
				}
				_tmp0_ = FALSE;
				_tmp1_ = self->priv->store;
				_tmp2_ = g_strdup_printf ("%i", i);
				_tmp3_ = _tmp2_;
				_tmp5_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp1_, &_tmp4_, _tmp3_);
				iter = _tmp4_;
				_tmp6_ = !_tmp5_;
				_g_free0 (_tmp3_);
				if (_tmp6_) {
					break;
				}
				_tmp7_ = self->priv->store;
				_tmp8_ = iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp7_, &_tmp8_, 1, &_tmp9_, -1);
				_g_free0 (text);
				text = _tmp9_;
				_tmp11_ = text;
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					_tmp12_ = text;
					_tmp13_ = music_preset_list_delete_preset;
					_tmp10_ = g_strcmp0 (_tmp12_, _tmp13_) == 0;
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					GtkListStore* _tmp14_;
					_tmp14_ = self->priv->store;
					gtk_list_store_remove (_tmp14_, &iter);
					music_preset_list_remove_separator_item (self, 1);
				}
				_g_free0 (text);
			}
		}
	}
}

static void
music_preset_list_remove_separator_item (MusicPresetList* self,
                                         gint index)
{
	gint count = 0;
	gint nitems = 0;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	g_return_if_fail (self != NULL);
	count = 0;
	_tmp0_ = self->priv->store;
	nitems = gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp0_, NULL);
	{
		gint i = 0;
		i = nitems - 1;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				GtkListStore* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				GtkTreeIter _tmp5_ = {0};
				gboolean _tmp6_;
				gboolean _tmp7_;
				gint _tmp8_;
				gchar* text = NULL;
				GtkListStore* _tmp9_;
				GtkTreeIter _tmp10_;
				gchar* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
				if (!_tmp1_) {
					i = i - 1;
				}
				_tmp1_ = FALSE;
				_tmp2_ = self->priv->store;
				_tmp3_ = g_strdup_printf ("%i", i);
				_tmp4_ = _tmp3_;
				_tmp6_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp5_, _tmp4_);
				iter = _tmp5_;
				_tmp7_ = !_tmp6_;
				_g_free0 (_tmp4_);
				if (_tmp7_) {
					break;
				}
				_tmp8_ = count;
				count = _tmp8_ + 1;
				_tmp9_ = self->priv->store;
				_tmp10_ = iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 1, &_tmp11_, -1);
				_g_free0 (text);
				text = _tmp11_;
				if ((nitems - index) == count) {
					_tmp14_ = TRUE;
				} else {
					_tmp14_ = index == -1;
				}
				if (_tmp14_) {
					const gchar* _tmp15_;
					_tmp15_ = text;
					_tmp13_ = _tmp15_ != NULL;
				} else {
					_tmp13_ = FALSE;
				}
				if (_tmp13_) {
					const gchar* _tmp16_;
					_tmp16_ = text;
					_tmp12_ = g_strcmp0 (_tmp16_, MUSIC_PRESET_LIST_SEPARATOR_NAME) == 0;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					GtkListStore* _tmp17_;
					_tmp17_ = self->priv->store;
					gtk_list_store_remove (_tmp17_, &iter);
					_g_free0 (text);
					break;
				}
				_g_free0 (text);
			}
		}
	}
}

static void
music_preset_list_add_delete_preset_option (MusicPresetList* self)
{
	gboolean already_added = FALSE;
	GtkTreeIter last_iter = {0};
	GtkTreeIter new_iter = {0};
	GtkListStore* _tmp21_;
	GtkTreeIter _tmp22_;
	GtkTreeIter _tmp23_ = {0};
	GtkListStore* _tmp24_;
	GtkTreeIter _tmp25_;
	const gchar* _tmp26_;
	GtkTreeIter _tmp27_;
	GtkListStore* _tmp28_;
	GtkTreeIter _tmp29_;
	GtkTreeIter _tmp30_ = {0};
	GtkListStore* _tmp31_;
	GtkTreeIter _tmp32_;
	g_return_if_fail (self != NULL);
	already_added = FALSE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GtkListStore* _tmp1_;
				gchar* _tmp2_;
				gchar* _tmp3_;
				GtkTreeIter _tmp4_ = {0};
				gboolean _tmp5_;
				gboolean _tmp6_;
				gchar* text = NULL;
				GtkListStore* _tmp7_;
				GtkTreeIter _tmp8_;
				gchar* _tmp9_ = NULL;
				gboolean _tmp10_ = FALSE;
				const gchar* _tmp11_;
				if (!_tmp0_) {
					i = i + 1;
				}
				_tmp0_ = FALSE;
				_tmp1_ = self->priv->store;
				_tmp2_ = g_strdup_printf ("%i", i);
				_tmp3_ = _tmp2_;
				_tmp5_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp1_, &_tmp4_, _tmp3_);
				last_iter = _tmp4_;
				_tmp6_ = !_tmp5_;
				_g_free0 (_tmp3_);
				if (_tmp6_) {
					break;
				}
				_tmp7_ = self->priv->store;
				_tmp8_ = last_iter;
				gtk_tree_model_get ((GtkTreeModel*) _tmp7_, &_tmp8_, 1, &_tmp9_, -1);
				_g_free0 (text);
				text = _tmp9_;
				_tmp11_ = text;
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					_tmp12_ = text;
					_tmp10_ = g_strcmp0 (_tmp12_, MUSIC_PRESET_LIST_SEPARATOR_NAME) == 0;
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					GtkTreeIter _tmp13_;
					GtkListStore* _tmp14_;
					gboolean _tmp15_;
					_tmp13_ = last_iter;
					new_iter = _tmp13_;
					_tmp14_ = self->priv->store;
					_tmp15_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp14_, &new_iter);
					if (_tmp15_) {
						GtkListStore* _tmp16_;
						GtkTreeIter _tmp17_;
						gchar* _tmp18_ = NULL;
						const gchar* _tmp19_;
						const gchar* _tmp20_;
						_tmp16_ = self->priv->store;
						_tmp17_ = new_iter;
						gtk_tree_model_get ((GtkTreeModel*) _tmp16_, &_tmp17_, 1, &_tmp18_, -1);
						_g_free0 (text);
						text = _tmp18_;
						_tmp19_ = text;
						_tmp20_ = music_preset_list_delete_preset;
						already_added = g_strcmp0 (_tmp19_, _tmp20_) == 0;
					}
					_g_free0 (text);
					break;
				}
				_g_free0 (text);
			}
		}
	}
	if (already_added) {
		return;
	}
	_tmp21_ = self->priv->store;
	_tmp22_ = last_iter;
	gtk_list_store_insert_after (_tmp21_, &_tmp23_, &_tmp22_);
	new_iter = _tmp23_;
	_tmp24_ = self->priv->store;
	_tmp25_ = new_iter;
	_tmp26_ = music_preset_list_delete_preset;
	gtk_list_store_set (_tmp24_, &_tmp25_, 0, NULL, 1, _tmp26_, -1);
	_tmp27_ = new_iter;
	last_iter = _tmp27_;
	_tmp28_ = self->priv->store;
	_tmp29_ = last_iter;
	gtk_list_store_insert_after (_tmp28_, &_tmp30_, &_tmp29_);
	new_iter = _tmp30_;
	_tmp31_ = self->priv->store;
	_tmp32_ = new_iter;
	gtk_list_store_set (_tmp31_, &_tmp32_, 0, NULL, 1, MUSIC_PRESET_LIST_SEPARATOR_NAME, -1);
}

gboolean
music_preset_list_get_automatic_chosen (MusicPresetList* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->automatic_selected;
	return result;
}

static gint
music_preset_list_get_ncustompresets (MusicPresetList* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_ncustompresets;
	return result;
}

static void
music_preset_list_set_ncustompresets (MusicPresetList* self,
                                      gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_ncustompresets = value;
}

static void
music_preset_list_class_init (MusicPresetListClass * klass,
                              gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	music_preset_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPresetList_private_offset);
	((MusicPresetListClass *) klass)->list_selection_change = (void (*) (MusicPresetList*)) music_preset_list_real_list_selection_change;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_preset_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_preset_list_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_preset_list_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY, music_preset_list_properties[MUSIC_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY] = g_param_spec_boolean ("automatic-chosen", "automatic-chosen", "automatic-chosen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	music_preset_list_signals[MUSIC_PRESET_LIST_PRESET_SELECTED_SIGNAL] = g_signal_new ("preset-selected", MUSIC_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_EQUALIZER_PRESET);
	music_preset_list_signals[MUSIC_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL] = g_signal_new ("automatic-preset-chosen", MUSIC_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_preset_list_signals[MUSIC_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL] = g_signal_new ("delete-preset-chosen", MUSIC_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = g_strdup (_ ("Automatic"));
	music_preset_list_automatic_mode = _tmp0_;
	_tmp1_ = g_strdup (_ ("Delete Current"));
	music_preset_list_delete_preset = _tmp1_;
}

static void
music_preset_list_instance_init (MusicPresetList * self,
                                 gpointer klass)
{
	self->priv = music_preset_list_get_instance_private (self);
}

static void
music_preset_list_finalize (GObject * obj)
{
	MusicPresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PRESET_LIST, MusicPresetList);
	_g_object_unref0 (self->last_selected_preset);
	_g_object_unref0 (self->priv->store);
	G_OBJECT_CLASS (music_preset_list_parent_class)->finalize (obj);
}

GType
music_preset_list_get_type (void)
{
	static volatile gsize music_preset_list_type_id__volatile = 0;
	if (g_once_init_enter (&music_preset_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicPresetListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_preset_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPresetList), 0, (GInstanceInitFunc) music_preset_list_instance_init, NULL };
		GType music_preset_list_type_id;
		music_preset_list_type_id = g_type_register_static (gtk_combo_box_get_type (), "MusicPresetList", &g_define_type_info, 0);
		MusicPresetList_private_offset = g_type_add_instance_private (music_preset_list_type_id, sizeof (MusicPresetListPrivate));
		g_once_init_leave (&music_preset_list_type_id__volatile, music_preset_list_type_id);
	}
	return music_preset_list_type_id__volatile;
}

static void
_vala_music_preset_list_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	MusicPresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PRESET_LIST, MusicPresetList);
	switch (property_id) {
		case MUSIC_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY:
		g_value_set_boolean (value, music_preset_list_get_automatic_chosen (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_preset_list_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	MusicPresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PRESET_LIST, MusicPresetList);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

