/* RatingCellRenderer.c generated by valac 0.44.11, the Vala compiler
 * generated from RatingCellRenderer.vala, do not modify */

/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Lucas Baudin <xapantu@gmail.com>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>

#define MUSIC_TYPE_RATING_CELL_RENDERER (music_rating_cell_renderer_get_type ())
#define MUSIC_RATING_CELL_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRenderer))
#define MUSIC_RATING_CELL_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRendererClass))
#define MUSIC_IS_RATING_CELL_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_RATING_CELL_RENDERER))
#define MUSIC_IS_RATING_CELL_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_RATING_CELL_RENDERER))
#define MUSIC_RATING_CELL_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRendererClass))

typedef struct _MusicRatingCellRenderer MusicRatingCellRenderer;
typedef struct _MusicRatingCellRendererClass MusicRatingCellRendererClass;
typedef struct _MusicRatingCellRendererPrivate MusicRatingCellRendererPrivate;

#define MUSIC_RATING_WIDGET_TYPE_RENDERER (music_rating_widget_renderer_get_type ())
#define MUSIC_RATING_WIDGET_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_RATING_WIDGET_TYPE_RENDERER, MusicRatingWidgetRenderer))
#define MUSIC_RATING_WIDGET_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_RATING_WIDGET_TYPE_RENDERER, MusicRatingWidgetRendererClass))
#define MUSIC_RATING_WIDGET_IS_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_RATING_WIDGET_TYPE_RENDERER))
#define MUSIC_RATING_WIDGET_IS_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_RATING_WIDGET_TYPE_RENDERER))
#define MUSIC_RATING_WIDGET_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_RATING_WIDGET_TYPE_RENDERER, MusicRatingWidgetRendererClass))

typedef struct _MusicRatingWidgetRenderer MusicRatingWidgetRenderer;
typedef struct _MusicRatingWidgetRendererClass MusicRatingWidgetRendererClass;
enum  {
	MUSIC_RATING_CELL_RENDERER_0_PROPERTY,
	MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY,
	MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY,
	MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY,
	MUSIC_RATING_CELL_RENDERER_NUM_PROPERTIES
};
static GParamSpec* music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MUSIC_RATING_CELL_RENDERER_RATING_CHANGED_SIGNAL,
	MUSIC_RATING_CELL_RENDERER_NUM_SIGNALS
};
static guint music_rating_cell_renderer_signals[MUSIC_RATING_CELL_RENDERER_NUM_SIGNALS] = {0};

struct _MusicRatingCellRenderer {
	GtkCellRendererPixbuf parent_instance;
	MusicRatingCellRendererPrivate * priv;
};

struct _MusicRatingCellRendererClass {
	GtkCellRendererPixbufClass parent_class;
};

struct _MusicRatingCellRendererPrivate {
	MusicRatingWidgetRenderer* renderer;
	guint _rating;
};

static gint MusicRatingCellRenderer_private_offset;
static gpointer music_rating_cell_renderer_parent_class = NULL;

GType music_rating_cell_renderer_get_type (void) G_GNUC_CONST;
GType music_rating_widget_renderer_get_type (void) G_GNUC_CONST;
MusicRatingCellRenderer* music_rating_cell_renderer_new (GtkIconSize icon_size);
MusicRatingCellRenderer* music_rating_cell_renderer_construct (GType object_type,
                                                               GtkIconSize icon_size);
MusicRatingWidgetRenderer* music_rating_widget_renderer_new (GtkIconSize icon_size,
                                                             gboolean symbolic,
                                                             GtkStyleContext* context);
MusicRatingWidgetRenderer* music_rating_widget_renderer_construct (GType object_type,
                                                                   GtkIconSize icon_size,
                                                                   gboolean symbolic,
                                                                   GtkStyleContext* context);
void music_rating_widget_renderer_set_delayed_render_mode (MusicRatingWidgetRenderer* self,
                                                           gboolean value);
void music_rating_cell_renderer_set_rating (MusicRatingCellRenderer* self,
                                            guint value);
static void music_rating_cell_renderer_update_pixbuf (MusicRatingCellRenderer* self);
GdkPixbuf* music_rating_widget_renderer_get_canvas (MusicRatingWidgetRenderer* self);
static void music_rating_cell_renderer_real_render (GtkCellRenderer* base,
                                             cairo_t* ctx,
                                             GtkWidget* widget,
                                             GdkRectangle* background_area,
                                             GdkRectangle* cell_area,
                                             GtkCellRendererState flags);
gint music_rating_cell_renderer_get_n_stars (MusicRatingCellRenderer* self);
guint music_rating_cell_renderer_get_rating (MusicRatingCellRenderer* self);
void music_rating_cell_renderer_set_n_stars (MusicRatingCellRenderer* self,
                                             gint value);
void music_rating_widget_renderer_set_style_context (MusicRatingWidgetRenderer* self,
                                                     GtkStyleContext* value);
static gboolean music_rating_cell_renderer_real_activate (GtkCellRenderer* base,
                                                   GdkEvent* event,
                                                   GtkWidget* widget,
                                                   const gchar* path,
                                                   GdkRectangle* background_area,
                                                   GdkRectangle* cell_area,
                                                   GtkCellRendererState flags);
gint music_rating_widget_renderer_get_new_rating (MusicRatingWidgetRenderer* self,
                                                  gdouble x);
gint music_rating_cell_renderer_get_star_spacing (MusicRatingCellRenderer* self);
gint music_rating_widget_renderer_get_star_spacing (MusicRatingWidgetRenderer* self);
void music_rating_cell_renderer_set_star_spacing (MusicRatingCellRenderer* self,
                                                  gint value);
void music_rating_widget_renderer_set_star_spacing (MusicRatingWidgetRenderer* self,
                                                    gint value);
void music_rating_widget_renderer_set_rating (MusicRatingWidgetRenderer* self,
                                              guint value);
gint music_rating_widget_renderer_get_n_stars (MusicRatingWidgetRenderer* self);
void music_rating_widget_renderer_set_n_stars (MusicRatingWidgetRenderer* self,
                                               gint value);
static void g_cclosure_user_marshal_VOID__INT_OBJECT_STRING (GClosure * closure,
                                                      GValue * return_value,
                                                      guint n_param_values,
                                                      const GValue * param_values,
                                                      gpointer invocation_hint,
                                                      gpointer marshal_data);
static void music_rating_cell_renderer_finalize (GObject * obj);
static void _vala_music_rating_cell_renderer_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_music_rating_cell_renderer_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
music_rating_cell_renderer_get_instance_private (MusicRatingCellRenderer* self)
{
	return G_STRUCT_MEMBER_P (self, MusicRatingCellRenderer_private_offset);
}

MusicRatingCellRenderer*
music_rating_cell_renderer_construct (GType object_type,
                                      GtkIconSize icon_size)
{
	MusicRatingCellRenderer * self = NULL;
	MusicRatingWidgetRenderer* _tmp0_;
	MusicRatingWidgetRenderer* _tmp1_;
	MusicRatingWidgetRenderer* _tmp2_;
	self = (MusicRatingCellRenderer*) g_object_new (object_type, NULL);
	g_object_set ((GtkCellRenderer*) self, "xalign", 0.0f, NULL);
	g_object_set ((GtkCellRenderer*) self, "mode", GTK_CELL_RENDERER_MODE_ACTIVATABLE, NULL);
	_tmp0_ = music_rating_widget_renderer_new (icon_size, TRUE, NULL);
	_g_object_unref0 (self->priv->renderer);
	self->priv->renderer = _tmp0_;
	_tmp1_ = self->priv->renderer;
	music_rating_widget_renderer_set_delayed_render_mode (_tmp1_, TRUE);
	music_rating_cell_renderer_set_rating (self, (guint) 1);
	_tmp2_ = self->priv->renderer;
	g_signal_emit_by_name (_tmp2_, "render");
	music_rating_cell_renderer_update_pixbuf (self);
	return self;
}

MusicRatingCellRenderer*
music_rating_cell_renderer_new (GtkIconSize icon_size)
{
	return music_rating_cell_renderer_construct (MUSIC_TYPE_RATING_CELL_RENDERER, icon_size);
}

static void
music_rating_cell_renderer_update_pixbuf (MusicRatingCellRenderer* self)
{
	MusicRatingWidgetRenderer* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkPixbuf* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->renderer;
	_tmp1_ = music_rating_widget_renderer_get_canvas (_tmp0_);
	_tmp2_ = _tmp1_;
	g_object_set ((GtkCellRendererPixbuf*) self, "pixbuf", _tmp2_, NULL);
	g_object_get ((GtkCellRendererPixbuf*) self, "pixbuf", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	_tmp6_ = gdk_pixbuf_get_width (_tmp5_);
	_tmp7_ = _tmp6_;
	g_object_get ((GtkCellRendererPixbuf*) self, "pixbuf", &_tmp8_, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = _tmp9_;
	_tmp11_ = gdk_pixbuf_get_height (_tmp10_);
	_tmp12_ = _tmp11_;
	gtk_cell_renderer_set_fixed_size ((GtkCellRenderer*) self, _tmp7_, _tmp12_);
	_g_object_unref0 (_tmp10_);
	_g_object_unref0 (_tmp5_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_rating_cell_renderer_real_render (GtkCellRenderer* base,
                                        cairo_t* ctx,
                                        GtkWidget* widget,
                                        GdkRectangle* background_area,
                                        GdkRectangle* cell_area,
                                        GtkCellRendererState flags)
{
	MusicRatingCellRenderer * self;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags state = 0U;
	GtkStyleContext* _tmp2_;
	gint old_n_stars = 0;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	MusicRatingWidgetRenderer* _tmp19_;
	GtkStyleContext* _tmp20_;
	MusicRatingWidgetRenderer* _tmp21_;
	GdkRectangle _tmp22_;
	GdkRectangle _tmp23_;
	self = (MusicRatingCellRenderer*) base;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (background_area != NULL);
	g_return_if_fail (cell_area != NULL);
	_tmp0_ = gtk_widget_get_style_context (widget);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	style_context = _tmp1_;
	_tmp2_ = style_context;
	state = gtk_style_context_get_state (_tmp2_);
	_tmp3_ = music_rating_cell_renderer_get_n_stars (self);
	_tmp4_ = _tmp3_;
	old_n_stars = _tmp4_;
	if (self->priv->_rating == ((guint) 0)) {
		GtkStateFlags _tmp7_;
		GtkStateFlags _tmp8_;
		_tmp7_ = state;
		_tmp8_ = state;
		_tmp6_ = (_tmp7_ & GTK_STATE_FLAG_SELECTED) != _tmp8_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GtkStateFlags _tmp9_;
		GtkStateFlags _tmp10_;
		_tmp9_ = state;
		_tmp10_ = state;
		_tmp5_ = (_tmp9_ & GTK_STATE_FLAG_PRELIGHT) != _tmp10_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		_g_object_unref0 (style_context);
		return;
	}
	if (((guint) 0) < self->priv->_rating) {
		GtkStateFlags _tmp13_;
		GtkStateFlags _tmp14_;
		_tmp13_ = state;
		_tmp14_ = state;
		_tmp12_ = (_tmp13_ & GTK_STATE_FLAG_SELECTED) != _tmp14_;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		GtkStateFlags _tmp15_;
		GtkStateFlags _tmp16_;
		_tmp15_ = state;
		_tmp16_ = state;
		_tmp11_ = (_tmp15_ & GTK_STATE_FLAG_PRELIGHT) != _tmp16_;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		guint _tmp17_;
		guint _tmp18_;
		_tmp17_ = music_rating_cell_renderer_get_rating (self);
		_tmp18_ = _tmp17_;
		music_rating_cell_renderer_set_n_stars (self, (gint) _tmp18_);
	}
	_tmp19_ = self->priv->renderer;
	_tmp20_ = style_context;
	music_rating_widget_renderer_set_style_context (_tmp19_, _tmp20_);
	_tmp21_ = self->priv->renderer;
	g_signal_emit_by_name (_tmp21_, "render");
	music_rating_cell_renderer_update_pixbuf (self);
	_tmp22_ = *background_area;
	_tmp23_ = *cell_area;
	GTK_CELL_RENDERER_CLASS (music_rating_cell_renderer_parent_class)->render ((GtkCellRenderer*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_cell_renderer_pixbuf_get_type (), GtkCellRendererPixbuf), ctx, widget, &_tmp22_, &_tmp23_, flags);
	music_rating_cell_renderer_set_n_stars (self, old_n_stars);
	_g_object_unref0 (style_context);
}

static gboolean
music_rating_cell_renderer_real_activate (GtkCellRenderer* base,
                                          GdkEvent* event,
                                          GtkWidget* widget,
                                          const gchar* path,
                                          GdkRectangle* background_area,
                                          GdkRectangle* cell_area,
                                          GtkCellRendererState flags)
{
	MusicRatingCellRenderer * self;
	gint old_rating = 0;
	guint _tmp0_;
	guint _tmp1_;
	gint new_rating = 0;
	MusicRatingWidgetRenderer* _tmp2_;
	GdkEventButton* _tmp3_;
	GdkEventButton* _tmp4_;
	GdkRectangle _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean result = FALSE;
	self = (MusicRatingCellRenderer*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (background_area != NULL, FALSE);
	g_return_val_if_fail (cell_area != NULL, FALSE);
	_tmp0_ = music_rating_cell_renderer_get_rating (self);
	_tmp1_ = _tmp0_;
	old_rating = (gint) _tmp1_;
	_tmp2_ = self->priv->renderer;
	_tmp3_ = (GdkEventButton *) (event);
	_tmp4_ = _tmp3_;
	_tmp5_ = *cell_area;
	new_rating = music_rating_widget_renderer_get_new_rating (_tmp2_, _tmp4_->x - _tmp5_.x);
	if (new_rating == old_rating) {
		_tmp6_ = new_rating > 0;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		gint _tmp7_;
		_tmp7_ = new_rating;
		new_rating = _tmp7_ - 1;
	}
	g_signal_emit (self, music_rating_cell_renderer_signals[MUSIC_RATING_CELL_RENDERER_RATING_CHANGED_SIGNAL], 0, new_rating, widget, path);
	result = TRUE;
	return result;
}

gint
music_rating_cell_renderer_get_star_spacing (MusicRatingCellRenderer* self)
{
	gint result;
	MusicRatingWidgetRenderer* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->renderer;
	_tmp1_ = music_rating_widget_renderer_get_star_spacing (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
music_rating_cell_renderer_set_star_spacing (MusicRatingCellRenderer* self,
                                             gint value)
{
	MusicRatingWidgetRenderer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->renderer;
	music_rating_widget_renderer_set_star_spacing (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY]);
}

guint
music_rating_cell_renderer_get_rating (MusicRatingCellRenderer* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_rating;
	return result;
}

void
music_rating_cell_renderer_set_rating (MusicRatingCellRenderer* self,
                                       guint value)
{
	MusicRatingWidgetRenderer* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_rating = value;
	_tmp0_ = self->priv->renderer;
	music_rating_widget_renderer_set_rating (_tmp0_, self->priv->_rating);
	g_object_notify_by_pspec ((GObject *) self, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY]);
}

gint
music_rating_cell_renderer_get_n_stars (MusicRatingCellRenderer* self)
{
	gint result;
	MusicRatingWidgetRenderer* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->renderer;
	_tmp1_ = music_rating_widget_renderer_get_n_stars (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
music_rating_cell_renderer_set_n_stars (MusicRatingCellRenderer* self,
                                        gint value)
{
	MusicRatingWidgetRenderer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->renderer;
	music_rating_widget_renderer_set_n_stars (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY]);
}

static void
g_cclosure_user_marshal_VOID__INT_OBJECT_STRING (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_OBJECT_STRING) (gpointer data1, gint arg_1, gpointer arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__INT_OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_object (param_values + 2), g_value_get_string (param_values + 3), data2);
}

static void
music_rating_cell_renderer_class_init (MusicRatingCellRendererClass * klass,
                                       gpointer klass_data)
{
	music_rating_cell_renderer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicRatingCellRenderer_private_offset);
	((GtkCellRendererClass *) klass)->render = (void (*) (GtkCellRenderer*, cairo_t*, GtkWidget*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) music_rating_cell_renderer_real_render;
	((GtkCellRendererClass *) klass)->activate = (gboolean (*) (GtkCellRenderer*, GdkEvent*, GtkWidget*, const gchar*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) music_rating_cell_renderer_real_activate;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_rating_cell_renderer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_rating_cell_renderer_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_rating_cell_renderer_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY] = g_param_spec_int ("star-spacing", "star-spacing", "star-spacing", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY] = g_param_spec_uint ("rating", "rating", "rating", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY, music_rating_cell_renderer_properties[MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY] = g_param_spec_int ("n-stars", "n-stars", "n-stars", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The rating was set. It is only emmited when the rating changes by activating the renderer.
	     */
	music_rating_cell_renderer_signals[MUSIC_RATING_CELL_RENDERER_RATING_CHANGED_SIGNAL] = g_signal_new ("rating-changed", MUSIC_TYPE_RATING_CELL_RENDERER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_OBJECT_STRING, G_TYPE_NONE, 3, G_TYPE_INT, gtk_widget_get_type (), G_TYPE_STRING);
}

static void
music_rating_cell_renderer_instance_init (MusicRatingCellRenderer * self,
                                          gpointer klass)
{
	self->priv = music_rating_cell_renderer_get_instance_private (self);
	self->priv->_rating = (guint) 0;
}

static void
music_rating_cell_renderer_finalize (GObject * obj)
{
	MusicRatingCellRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRenderer);
	_g_object_unref0 (self->priv->renderer);
	G_OBJECT_CLASS (music_rating_cell_renderer_parent_class)->finalize (obj);
}

/**
 * This class makes setting the rating from a cell possible. Unlike the other widgets,
 * it only allows doing so by clicking over a star.
 *
 * When the rating changes by activating (i.e. clicking) the cell renderer, it doesn't re-draw itself
 * automatically and/or apply the new rating right away, since there could be client code wanting
 * to check the new value. Instead, it passes the responsability off to the rating_changed signal handler.
 * That signal handler *must* take care of setting the new rating on the proper cell, and only then
 * the new value will take effect.
 */
GType
music_rating_cell_renderer_get_type (void)
{
	static volatile gsize music_rating_cell_renderer_type_id__volatile = 0;
	if (g_once_init_enter (&music_rating_cell_renderer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicRatingCellRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_rating_cell_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicRatingCellRenderer), 0, (GInstanceInitFunc) music_rating_cell_renderer_instance_init, NULL };
		GType music_rating_cell_renderer_type_id;
		music_rating_cell_renderer_type_id = g_type_register_static (gtk_cell_renderer_pixbuf_get_type (), "MusicRatingCellRenderer", &g_define_type_info, 0);
		MusicRatingCellRenderer_private_offset = g_type_add_instance_private (music_rating_cell_renderer_type_id, sizeof (MusicRatingCellRendererPrivate));
		g_once_init_leave (&music_rating_cell_renderer_type_id__volatile, music_rating_cell_renderer_type_id);
	}
	return music_rating_cell_renderer_type_id__volatile;
}

static void
_vala_music_rating_cell_renderer_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	MusicRatingCellRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRenderer);
	switch (property_id) {
		case MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY:
		g_value_set_int (value, music_rating_cell_renderer_get_star_spacing (self));
		break;
		case MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY:
		g_value_set_uint (value, music_rating_cell_renderer_get_rating (self));
		break;
		case MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY:
		g_value_set_int (value, music_rating_cell_renderer_get_n_stars (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_rating_cell_renderer_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	MusicRatingCellRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRenderer);
	switch (property_id) {
		case MUSIC_RATING_CELL_RENDERER_STAR_SPACING_PROPERTY:
		music_rating_cell_renderer_set_star_spacing (self, g_value_get_int (value));
		break;
		case MUSIC_RATING_CELL_RENDERER_RATING_PROPERTY:
		music_rating_cell_renderer_set_rating (self, g_value_get_uint (value));
		break;
		case MUSIC_RATING_CELL_RENDERER_N_STARS_PROPERTY:
		music_rating_cell_renderer_set_n_stars (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

