/* CDDA.c generated by valac 0.44.11, the Vala compiler
 * generated from CDDA.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include "io.elementary.music-core.h"

#define MUSIC_TYPE_CDDA (music_cdda_get_type ())
#define MUSIC_CDDA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_CDDA, MusicCDDA))
#define MUSIC_CDDA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_CDDA, MusicCDDAClass))
#define MUSIC_IS_CDDA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_CDDA))
#define MUSIC_IS_CDDA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_CDDA))
#define MUSIC_CDDA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_CDDA, MusicCDDAClass))

typedef struct _MusicCDDA MusicCDDA;
typedef struct _MusicCDDAClass MusicCDDAClass;
typedef struct _MusicCDDAPrivate MusicCDDAPrivate;
enum  {
	MUSIC_CDDA_0_PROPERTY,
	MUSIC_CDDA_NUM_PROPERTIES
};
static GParamSpec* music_cdda_properties[MUSIC_CDDA_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MusicCDDA {
	GObject parent_instance;
	MusicCDDAPrivate * priv;
};

struct _MusicCDDAClass {
	GObjectClass parent_class;
};

static gpointer music_cdda_parent_class = NULL;
static GType music_cdda_type_id = 0;

GType music_cdda_register_type (GTypeModule * module);
GType music_cdda_get_type (void) G_GNUC_CONST;
#define MUSIC_CDDA_FILE_ATTRIBUTE_TITLE "xattr::org.gnome.audio.title"
#define MUSIC_CDDA_FILE_ATTRIBUTE_ARTIST "xattr::org.gnome.audio.artist"
#define MUSIC_CDDA_FILE_ATTRIBUTE_GENRE "xattr::org.gnome.audio.genre"
#define MUSIC_CDDA_FILE_ATTRIBUTE_DURATION "xattr::org.gnome.audio.duration"
GeeLinkedList* music_cdda_get_media_list (GFile* device_file);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
MusicCDDA* music_cdda_new (void);
MusicCDDA* music_cdda_construct (GType object_type);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add3 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add4 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add5 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result = NULL;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len = len + _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len = len + (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp19_ = res;
		_tmp20_ = str_array[0];
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
		ptr = _tmp21_;
		{
			gboolean _tmp22_ = FALSE;
			i = 1;
			_tmp22_ = TRUE;
			while (TRUE) {
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp24_ = ptr;
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
				ptr = _tmp25_;
				_tmp27_ = str_array[i];
				if (_tmp27_ != NULL) {
					const gchar* _tmp28_;
					_tmp28_ = str_array[i];
					_tmp26_ = (const gchar*) _tmp28_;
				} else {
					_tmp26_ = "";
				}
				_tmp29_ = ptr;
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
				ptr = _tmp30_;
			}
		}
		_tmp31_ = res;
		res = NULL;
		result = (gchar*) _tmp31_;
		return result;
	} else {
		gchar* _tmp32_;
		_tmp32_ = g_strdup ("");
		result = _tmp32_;
		return result;
	}
}

static void
_vala_array_add6 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

GeeLinkedList*
music_cdda_get_media_list (GFile* device_file)
{
	GeeLinkedList* rv = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeLinkedList* result = NULL;
	g_return_val_if_fail (device_file != NULL, NULL);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	rv = _tmp0_;
	{
		gchar** query_attributes = NULL;
		gchar** _tmp1_;
		gint query_attributes_length1;
		gint _query_attributes_size_;
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar* _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gchar* _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		gchar* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		gchar* _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		gchar* _tmp11_;
		GFileInfo* device_info = NULL;
		gchar** _tmp12_;
		gint _tmp12__length1;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GFileInfo* _tmp15_;
		GFileInfo* _tmp16_;
		GFileInfo* _tmp17_;
		gchar* album_name = NULL;
		GFileInfo* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* album_artist = NULL;
		GFileInfo* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* album_genre = NULL;
		GFileInfo* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		gboolean valid_album_artist = FALSE;
		const gchar* _tmp30_;
		gboolean valid_album_name = FALSE;
		const gchar* _tmp31_;
		gboolean valid_album_genre = FALSE;
		const gchar* _tmp32_;
		gchar** _tmp33_;
		gint _tmp33__length1;
		gchar* _tmp34_;
		GFileEnumerator* enumerator = NULL;
		gchar** _tmp35_;
		gint _tmp35__length1;
		gchar* _tmp36_;
		gchar* _tmp37_;
		GFileEnumerator* _tmp38_;
		GFileEnumerator* _tmp39_;
		gint index = 0;
		GFileInfo* track_info = NULL;
		_tmp1_ = g_new0 (gchar*, 0 + 1);
		query_attributes = _tmp1_;
		query_attributes_length1 = 0;
		_query_attributes_size_ = query_attributes_length1;
		_tmp2_ = query_attributes;
		_tmp2__length1 = query_attributes_length1;
		_tmp3_ = g_strdup (MUSIC_CDDA_FILE_ATTRIBUTE_TITLE);
		_vala_array_add1 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp3_);
		_tmp4_ = query_attributes;
		_tmp4__length1 = query_attributes_length1;
		_tmp5_ = g_strdup (MUSIC_CDDA_FILE_ATTRIBUTE_ARTIST);
		_vala_array_add2 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp5_);
		_tmp6_ = query_attributes;
		_tmp6__length1 = query_attributes_length1;
		_tmp7_ = g_strdup (MUSIC_CDDA_FILE_ATTRIBUTE_GENRE);
		_vala_array_add3 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp7_);
		_tmp8_ = query_attributes;
		_tmp8__length1 = query_attributes_length1;
		_tmp9_ = g_strdup (MUSIC_CDDA_FILE_ATTRIBUTE_DURATION);
		_vala_array_add4 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp9_);
		_tmp10_ = query_attributes;
		_tmp10__length1 = query_attributes_length1;
		_tmp11_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME);
		_vala_array_add5 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp11_);
		_tmp12_ = query_attributes;
		_tmp12__length1 = query_attributes_length1;
		_tmp13_ = _vala_g_strjoinv (",", _tmp12_, (gint) _tmp12__length1);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_file_query_info (device_file, _tmp14_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
		_tmp16_ = _tmp15_;
		_g_free0 (_tmp14_);
		device_info = _tmp16_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
			goto __catch0_g_error;
		}
		_tmp17_ = device_info;
		if (_tmp17_ == NULL) {
			g_warning ("CDDA.vala:53: Could not query device attributes");
			result = rv;
			_g_object_unref0 (device_info);
			query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
			return result;
		}
		_tmp18_ = device_info;
		_tmp19_ = g_file_info_get_attribute_string (_tmp18_, MUSIC_CDDA_FILE_ATTRIBUTE_TITLE);
		_tmp20_ = g_strdup (_tmp19_);
		album_name = _tmp20_;
		_tmp21_ = device_info;
		_tmp22_ = g_file_info_get_attribute_string (_tmp21_, MUSIC_CDDA_FILE_ATTRIBUTE_ARTIST);
		_tmp23_ = g_strdup (_tmp22_);
		album_artist = _tmp23_;
		_tmp24_ = device_info;
		_tmp25_ = g_file_info_get_attribute_string (_tmp24_, MUSIC_CDDA_FILE_ATTRIBUTE_GENRE);
		_tmp26_ = g_strdup (_tmp25_);
		album_genre = _tmp26_;
		_tmp27_ = album_name;
		g_message ("CDDA.vala:61: CD ALBUM_NAME: %s", _tmp27_);
		_tmp28_ = album_artist;
		g_message ("CDDA.vala:62: CD ALBUM_ARTIST: %s", _tmp28_);
		_tmp29_ = album_genre;
		g_message ("CDDA.vala:63: CD ALBUM_GENRE: %s", _tmp29_);
		_tmp30_ = album_artist;
		valid_album_artist = music_media_is_valid_string_field (_tmp30_);
		_tmp31_ = album_name;
		valid_album_name = music_media_is_valid_string_field (_tmp31_);
		_tmp32_ = album_genre;
		valid_album_genre = music_media_is_valid_string_field (_tmp32_);
		_tmp33_ = query_attributes;
		_tmp33__length1 = query_attributes_length1;
		_tmp34_ = g_strdup (MUSIC_CDDA_FILE_ATTRIBUTE_DURATION);
		_vala_array_add6 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp34_);
		_tmp35_ = query_attributes;
		_tmp35__length1 = query_attributes_length1;
		_tmp36_ = _vala_g_strjoinv (",", _tmp35_, (gint) _tmp35__length1);
		_tmp37_ = _tmp36_;
		_tmp38_ = g_file_enumerate_children (device_file, _tmp37_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
		_tmp39_ = _tmp38_;
		_g_free0 (_tmp37_);
		enumerator = _tmp39_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (album_genre);
			_g_free0 (album_artist);
			_g_free0 (album_name);
			_g_object_unref0 (device_info);
			query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
			goto __catch0_g_error;
		}
		index = 1;
		{
			GFileInfo* _tmp40_ = NULL;
			GFileEnumerator* _tmp41_;
			GFileInfo* _tmp42_;
			GFileInfo* _tmp43_;
			gboolean _tmp44_ = FALSE;
			_tmp41_ = enumerator;
			_tmp42_ = g_file_enumerator_next_file (_tmp41_, NULL, &_inner_error0_);
			_tmp40_ = _tmp42_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (track_info);
				_g_object_unref0 (enumerator);
				_g_free0 (album_genre);
				_g_free0 (album_artist);
				_g_free0 (album_name);
				_g_object_unref0 (device_info);
				query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
				goto __catch0_g_error;
			}
			_tmp43_ = _tmp40_;
			_tmp40_ = NULL;
			_g_object_unref0 (track_info);
			track_info = _tmp43_;
			_tmp44_ = TRUE;
			while (TRUE) {
				GFileInfo* _tmp49_;
				MusicMedia* s = NULL;
				GFileEnumerator* _tmp50_;
				GFile* _tmp51_;
				gchar* _tmp52_;
				gchar* _tmp53_;
				GFileInfo* _tmp54_;
				const gchar* _tmp55_;
				gchar* _tmp56_;
				gchar* _tmp57_;
				MusicMedia* _tmp58_;
				MusicMedia* _tmp59_;
				MusicMedia* _tmp60_;
				gchar* title = NULL;
				GFileInfo* _tmp67_;
				const gchar* _tmp68_;
				gchar* _tmp69_;
				gchar* artist = NULL;
				GFileInfo* _tmp70_;
				const gchar* _tmp71_;
				gchar* _tmp72_;
				gchar* genre = NULL;
				GFileInfo* _tmp73_;
				const gchar* _tmp74_;
				gchar* _tmp75_;
				guint64 length = 0ULL;
				GFileInfo* _tmp76_;
				MusicMedia* _tmp77_;
				gchar* _tmp78_;
				gchar* _tmp79_;
				gchar* _tmp80_;
				const gchar* _tmp81_;
				const gchar* _tmp82_;
				const gchar* _tmp83_;
				gchar* _tmp84_;
				gchar* _tmp85_;
				MusicMedia* _tmp86_;
				MusicMedia* _tmp87_;
				const gchar* _tmp88_;
				const gchar* _tmp91_;
				const gchar* _tmp94_;
				GeeLinkedList* _tmp97_;
				MusicMedia* _tmp98_;
				gint _tmp99_;
				if (!_tmp44_) {
					GFileInfo* _tmp45_ = NULL;
					GFileEnumerator* _tmp46_;
					GFileInfo* _tmp47_;
					GFileInfo* _tmp48_;
					_tmp46_ = enumerator;
					_tmp47_ = g_file_enumerator_next_file (_tmp46_, NULL, &_inner_error0_);
					_tmp45_ = _tmp47_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (_tmp40_);
						_g_object_unref0 (track_info);
						_g_object_unref0 (enumerator);
						_g_free0 (album_genre);
						_g_free0 (album_artist);
						_g_free0 (album_name);
						_g_object_unref0 (device_info);
						query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
						goto __catch0_g_error;
					}
					_tmp48_ = _tmp45_;
					_tmp45_ = NULL;
					_g_object_unref0 (track_info);
					track_info = _tmp48_;
					_g_object_unref0 (_tmp45_);
				}
				_tmp44_ = FALSE;
				_tmp49_ = track_info;
				if (!(_tmp49_ != NULL)) {
					break;
				}
				_tmp50_ = enumerator;
				_tmp51_ = g_file_enumerator_get_container (_tmp50_);
				_tmp52_ = g_file_get_uri (_tmp51_);
				_tmp53_ = _tmp52_;
				_tmp54_ = track_info;
				_tmp55_ = g_file_info_get_name (_tmp54_);
				_tmp56_ = g_strconcat (_tmp53_, _tmp55_, NULL);
				_tmp57_ = _tmp56_;
				_tmp58_ = music_media_new (_tmp57_);
				_tmp59_ = _tmp58_;
				_g_free0 (_tmp57_);
				_g_free0 (_tmp53_);
				s = _tmp59_;
				_tmp60_ = s;
				music_media_set_is_temporary (_tmp60_, TRUE);
				if (valid_album_artist) {
					MusicMedia* _tmp61_;
					const gchar* _tmp62_;
					_tmp61_ = s;
					_tmp62_ = album_artist;
					music_media_set_album_artist (_tmp61_, _tmp62_);
				}
				if (valid_album_name) {
					MusicMedia* _tmp63_;
					const gchar* _tmp64_;
					_tmp63_ = s;
					_tmp64_ = album_name;
					music_media_set_album (_tmp63_, _tmp64_);
				}
				if (valid_album_genre) {
					MusicMedia* _tmp65_;
					const gchar* _tmp66_;
					_tmp65_ = s;
					_tmp66_ = album_genre;
					music_media_set_genre (_tmp65_, _tmp66_);
				}
				_tmp67_ = track_info;
				_tmp68_ = g_file_info_get_attribute_string (_tmp67_, MUSIC_CDDA_FILE_ATTRIBUTE_TITLE);
				_tmp69_ = g_strdup (_tmp68_);
				title = _tmp69_;
				_tmp70_ = track_info;
				_tmp71_ = g_file_info_get_attribute_string (_tmp70_, MUSIC_CDDA_FILE_ATTRIBUTE_ARTIST);
				_tmp72_ = g_strdup (_tmp71_);
				artist = _tmp72_;
				_tmp73_ = track_info;
				_tmp74_ = g_file_info_get_attribute_string (_tmp73_, MUSIC_CDDA_FILE_ATTRIBUTE_GENRE);
				_tmp75_ = g_strdup (_tmp74_);
				genre = _tmp75_;
				_tmp76_ = track_info;
				length = g_file_info_get_attribute_uint64 (_tmp76_, MUSIC_CDDA_FILE_ATTRIBUTE_DURATION);
				g_debug ("CDDA.vala:101: TRACK #%d\t:", index);
				_tmp77_ = s;
				_tmp78_ = music_media_get_uri (_tmp77_);
				_tmp79_ = _tmp78_;
				_tmp80_ = _tmp79_;
				g_debug ("CDDA.vala:102:   - TRACK_URI:      %s", _tmp80_);
				_g_free0 (_tmp80_);
				_tmp81_ = title;
				g_debug ("CDDA.vala:103:   - TRACK_TITLE:    %s", _tmp81_);
				_tmp82_ = artist;
				g_debug ("CDDA.vala:104:   - TRACK_ARTIST:   %s", _tmp82_);
				_tmp83_ = genre;
				g_debug ("CDDA.vala:105:   - TRACK_GENRE:    %s", _tmp83_);
				_tmp84_ = g_strdup_printf ("%" G_GUINT64_FORMAT, length);
				_tmp85_ = _tmp84_;
				g_debug ("CDDA.vala:106:   - TRACK_DURATION: %s secs\n", _tmp85_);
				_g_free0 (_tmp85_);
				_tmp86_ = s;
				music_media_set_track (_tmp86_, (guint) index);
				_tmp87_ = s;
				music_media_set_length (_tmp87_, (guint) (length * MUSIC_TIME_UTILS_MILI_INV));
				_tmp88_ = title;
				if (music_media_is_valid_string_field (_tmp88_)) {
					MusicMedia* _tmp89_;
					const gchar* _tmp90_;
					_tmp89_ = s;
					_tmp90_ = title;
					music_media_set_title (_tmp89_, _tmp90_);
				}
				_tmp91_ = artist;
				if (music_media_is_valid_string_field (_tmp91_)) {
					MusicMedia* _tmp92_;
					const gchar* _tmp93_;
					_tmp92_ = s;
					_tmp93_ = artist;
					music_media_set_artist (_tmp92_, _tmp93_);
				}
				_tmp94_ = genre;
				if (music_media_is_valid_string_field (_tmp94_)) {
					MusicMedia* _tmp95_;
					const gchar* _tmp96_;
					_tmp95_ = s;
					_tmp96_ = genre;
					music_media_set_genre (_tmp95_, _tmp96_);
				}
				_tmp97_ = rv;
				_tmp98_ = s;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp97_, _tmp98_);
				_tmp99_ = index;
				index = _tmp99_ + 1;
				_g_free0 (genre);
				_g_free0 (artist);
				_g_free0 (title);
				_g_object_unref0 (s);
			}
			_g_object_unref0 (_tmp40_);
		}
		_g_object_unref0 (track_info);
		_g_object_unref0 (enumerator);
		_g_free0 (album_genre);
		_g_free0 (album_artist);
		_g_free0 (album_name);
		_g_object_unref0 (device_info);
		query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp100_;
		const gchar* _tmp101_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp100_ = err;
		_tmp101_ = _tmp100_->message;
		g_warning ("CDDA.vala:136: Could not enumerate CD tracks or access album info: %s", _tmp101_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (rv);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = rv;
	return result;
}

MusicCDDA*
music_cdda_construct (GType object_type)
{
	MusicCDDA * self = NULL;
	self = (MusicCDDA*) g_object_new (object_type, NULL);
	return self;
}

MusicCDDA*
music_cdda_new (void)
{
	return music_cdda_construct (MUSIC_TYPE_CDDA);
}

static void
music_cdda_class_init (MusicCDDAClass * klass,
                       gpointer klass_data)
{
	music_cdda_parent_class = g_type_class_peek_parent (klass);
}

static void
music_cdda_instance_init (MusicCDDA * self,
                          gpointer klass)
{
}

GType
music_cdda_get_type (void)
{
	return music_cdda_type_id;
}

GType
music_cdda_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicCDDAClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_cdda_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicCDDA), 0, (GInstanceInitFunc) music_cdda_instance_init, NULL };
	music_cdda_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicCDDA", &g_define_type_info, 0);
	return music_cdda_type_id;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

