/* CDPlayer.c generated by valac 0.44.11, the Vala compiler
 * generated from CDPlayer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gst/gst.h>
#include <glib.h>
#include "music-lib.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gee.h>
#include <gst/pbutils/pbutils.h>
#include <gtk/gtk.h>

#define MUSIC_PLUGINS_TYPE_CD_PLAYER (music_plugins_cd_player_get_type ())
#define MUSIC_PLUGINS_CD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_PLUGINS_TYPE_CD_PLAYER, MusicPluginsCDPlayer))
#define MUSIC_PLUGINS_CD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_PLUGINS_TYPE_CD_PLAYER, MusicPluginsCDPlayerClass))
#define MUSIC_PLUGINS_IS_CD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_PLUGINS_TYPE_CD_PLAYER))
#define MUSIC_PLUGINS_IS_CD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_PLUGINS_TYPE_CD_PLAYER))
#define MUSIC_PLUGINS_CD_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_PLUGINS_TYPE_CD_PLAYER, MusicPluginsCDPlayerClass))

typedef struct _MusicPluginsCDPlayer MusicPluginsCDPlayer;
typedef struct _MusicPluginsCDPlayerClass MusicPluginsCDPlayerClass;
typedef struct _MusicPluginsCDPlayerPrivate MusicPluginsCDPlayerPrivate;
enum  {
	MUSIC_PLUGINS_CD_PLAYER_0_PROPERTY,
	MUSIC_PLUGINS_CD_PLAYER_NUM_PROPERTIES
};
static GParamSpec* music_plugins_cd_player_properties[MUSIC_PLUGINS_CD_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))

struct _MusicPluginsCDPlayer {
	GObject parent_instance;
	MusicPluginsCDPlayerPrivate * priv;
	MusicPipeline* pipe;
	GstElement* playbin2;
	gboolean first_start;
};

struct _MusicPluginsCDPlayerClass {
	GObjectClass parent_class;
};

struct _MusicPluginsCDPlayerPrivate {
	MusicInstallGstreamerPluginsDialog* dialog;
	gchar* device;
	gdouble volume;
};

static gint MusicPluginsCDPlayer_private_offset;
static gpointer music_plugins_cd_player_parent_class = NULL;
static MusicPlaybackIface * music_plugins_cd_player_music_playback_parent_iface = NULL;
static GType music_plugins_cd_player_type_id = 0;

GType music_plugins_cd_player_register_type (GTypeModule * module);
GType music_plugins_cd_player_get_type (void) G_GNUC_CONST;
MusicPluginsCDPlayer* music_plugins_cd_player_new (GMount* mount);
MusicPluginsCDPlayer* music_plugins_cd_player_construct (GType object_type,
                                                         GMount* mount);
gboolean music_plugins_cd_player_initialize (MusicPluginsCDPlayer* self);
void music_plugins_cd_player_pipe_source_setup (MusicPluginsCDPlayer* self,
                                                GstElement* playbin,
                                                GstElement* source);
static void _music_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_ (GstElement* _sender,
                                                                        GstElement* source,
                                                                        gpointer self);
gulong _dynamic_source_setup1_connect (gpointer obj,
                                       const char * signal_name,
                                       GCallback handler,
                                       gpointer data);
static gboolean music_plugins_cd_player_bus_callback (MusicPluginsCDPlayer* self,
                                               GstBus* bus,
                                               GstMessage* message);
static gboolean _music_plugins_cd_player_bus_callback_gst_bus_func (GstBus* bus,
                                                             GstMessage* message,
                                                             gpointer self);
static gboolean _music_playback_update_position_gsource_func (gpointer self);
static GeeCollection* music_plugins_cd_player_real_get_supported_uri (MusicPlayback* base);
static gboolean music_plugins_cd_player_real_update_position (MusicPlayback* base);
static void music_plugins_cd_player_real_play (MusicPlayback* base);
static void music_plugins_cd_player_real_pause (MusicPlayback* base);
static void music_plugins_cd_player_real_set_state (MusicPlayback* base,
                                             GstState s);
static void music_plugins_cd_player_real_set_media (MusicPlayback* base,
                                             MusicMedia* media);
static void music_plugins_cd_player_real_set_position (MusicPlayback* base,
                                                gint64 pos);
static gint64 music_plugins_cd_player_real_get_position (MusicPlayback* base);
static gint64 music_plugins_cd_player_real_get_duration (MusicPlayback* base);
static void music_plugins_cd_player_real_set_volume (MusicPlayback* base,
                                              gdouble val);
static gdouble music_plugins_cd_player_real_get_volume (MusicPlayback* base);
static void music_plugins_cd_player_real_enable_equalizer (MusicPlayback* base);
static void music_plugins_cd_player_real_disable_equalizer (MusicPlayback* base);
static void music_plugins_cd_player_real_set_equalizer_gain (MusicPlayback* base,
                                                      gint index,
                                                      gint val);
static void music_plugins_cd_player_finalize (GObject * obj);

static inline gpointer
music_plugins_cd_player_get_instance_private (MusicPluginsCDPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsCDPlayer_private_offset);
}

MusicPluginsCDPlayer*
music_plugins_cd_player_construct (GType object_type,
                                   GMount* mount)
{
	MusicPluginsCDPlayer * self = NULL;
	GVolume* _tmp0_;
	GVolume* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (mount != NULL, NULL);
	self = (MusicPluginsCDPlayer*) g_object_new (object_type, NULL);
	_tmp0_ = g_mount_get_volume (mount);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_volume_get_identifier (_tmp1_, G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE);
	_g_free0 (self->priv->device);
	self->priv->device = _tmp2_;
	_g_object_unref0 (_tmp1_);
	music_plugins_cd_player_initialize (self);
	return self;
}

MusicPluginsCDPlayer*
music_plugins_cd_player_new (GMount* mount)
{
	return music_plugins_cd_player_construct (MUSIC_PLUGINS_TYPE_CD_PLAYER, mount);
}

static void
_music_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_ (GstElement* _sender,
                                                                   GstElement* source,
                                                                   gpointer self)
{
	music_plugins_cd_player_pipe_source_setup ((MusicPluginsCDPlayer*) self, _sender, source);
}

gulong
_dynamic_source_setup1_connect (gpointer obj,
                                const char * signal_name,
                                GCallback handler,
                                gpointer data)
{
	return g_signal_connect_object (obj, signal_name, handler, data, 0);
}

static gboolean
_music_plugins_cd_player_bus_callback_gst_bus_func (GstBus* bus,
                                                    GstMessage* message,
                                                    gpointer self)
{
	gboolean result;
	result = music_plugins_cd_player_bus_callback ((MusicPluginsCDPlayer*) self, bus, message);
	return result;
}

static gboolean
_music_playback_update_position_gsource_func (gpointer self)
{
	gboolean result;
	result = music_playback_update_position ((MusicPlayback*) self);
	return result;
}

gboolean
music_plugins_cd_player_initialize (MusicPluginsCDPlayer* self)
{
	MusicPipeline* _tmp0_;
	MusicPipeline* _tmp1_;
	GstElement* _tmp2_;
	GstElement* _tmp3_;
	MusicPipeline* _tmp4_;
	GstElement* _tmp5_;
	MusicPipeline* _tmp6_;
	GstBus* _tmp7_;
	MusicPipeline* _tmp8_;
	GstBus* _tmp9_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = music_pipeline_new ();
	_g_object_unref0 (self->pipe);
	self->pipe = _tmp0_;
	_tmp1_ = self->pipe;
	_tmp2_ = _tmp1_->playbin;
	self->playbin2 = _tmp2_;
	_tmp3_ = self->playbin2;
	_dynamic_source_setup1_connect (_tmp3_, "source-setup", (GCallback) _music_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_, self);
	_tmp4_ = self->pipe;
	_tmp5_ = _tmp4_->playbin;
	g_object_set ((GObject*) _tmp5_, "uri", "cdda://1", NULL);
	_tmp6_ = self->pipe;
	_tmp7_ = _tmp6_->bus;
	gst_bus_add_signal_watch_full (_tmp7_, G_PRIORITY_DEFAULT);
	_tmp8_ = self->pipe;
	_tmp9_ = _tmp8_->bus;
	gst_bus_add_watch_full (_tmp9_, G_PRIORITY_DEFAULT, _music_plugins_cd_player_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _music_playback_update_position_gsource_func, g_object_ref ((MusicPlayback*) self), g_object_unref);
	result = TRUE;
	return result;
}

void
music_plugins_cd_player_pipe_source_setup (MusicPluginsCDPlayer* self,
                                           GstElement* playbin,
                                           GstElement* source)
{
	const gchar* _tmp0_;
	GObjectClass* _tmp1_;
	GParamSpec* _tmp2_;
	GObjectClass* _tmp3_;
	GParamSpec* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (playbin != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = self->priv->device;
	g_object_set ((GObject*) source, "device", _tmp0_, NULL);
	_tmp1_ = G_OBJECT_GET_CLASS ((GObject*) source);
	_tmp2_ = g_object_class_find_property (_tmp1_, "paranoia-mode");
	if (_tmp2_ != NULL) {
		g_object_set ((GObject*) source, "paranoia-mode", 0, NULL);
	}
	_tmp3_ = G_OBJECT_GET_CLASS ((GObject*) source);
	_tmp4_ = g_object_class_find_property (_tmp3_, "read-speed");
	if (_tmp4_ != NULL) {
		g_object_set ((GObject*) source, "read-speed", 2, NULL);
	}
}

static GeeCollection*
music_plugins_cd_player_real_get_supported_uri (MusicPlayback* base)
{
	MusicPluginsCDPlayer * self;
	GeeLinkedList* uris = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* result = NULL;
	self = (MusicPluginsCDPlayer*) base;
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	uris = _tmp0_;
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "cdda://");
	result = (GeeCollection*) uris;
	return result;
}

static gboolean
music_plugins_cd_player_real_update_position (MusicPlayback* base)
{
	MusicPluginsCDPlayer * self;
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	self = (MusicPluginsCDPlayer*) base;
	if (self->first_start) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp1_ = FALSE;
		MusicPlaybackManager* _tmp2_;
		MusicPlaybackManager* _tmp3_;
		MusicMedia* _tmp4_;
		MusicMedia* _tmp5_;
		_tmp2_ = music_app_get_player ();
		_tmp3_ = _tmp2_;
		_tmp4_ = music_playback_manager_get_current_media (_tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_ != NULL) {
			MusicPlaybackManager* _tmp6_;
			MusicPlaybackManager* _tmp7_;
			MusicMedia* _tmp8_;
			MusicMedia* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			_tmp6_ = music_app_get_player ();
			_tmp7_ = _tmp6_;
			_tmp8_ = music_playback_manager_get_current_media (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = music_media_get_resume_pos (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp1_ = music_playback_get_position ((MusicPlayback*) self) >= (((gint64) (_tmp11_ - 1)) * 1000000000);
		} else {
			_tmp1_ = FALSE;
		}
		_tmp0_ = _tmp1_;
	}
	if (_tmp0_) {
		self->first_start = FALSE;
		g_signal_emit_by_name ((MusicPlayback*) self, "current-position-update", music_playback_get_position ((MusicPlayback*) self));
	} else {
		MusicPlaybackManager* _tmp12_;
		MusicPlaybackManager* _tmp13_;
		MusicMedia* _tmp14_;
		MusicMedia* _tmp15_;
		_tmp12_ = music_app_get_player ();
		_tmp13_ = _tmp12_;
		_tmp14_ = music_playback_manager_get_current_media (_tmp13_);
		_tmp15_ = _tmp14_;
		if (_tmp15_ != NULL) {
			MusicPipeline* _tmp16_;
			GstElement* _tmp17_;
			MusicPlaybackManager* _tmp18_;
			MusicPlaybackManager* _tmp19_;
			MusicMedia* _tmp20_;
			MusicMedia* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			_tmp16_ = self->pipe;
			_tmp17_ = _tmp16_->playbin;
			_tmp18_ = music_app_get_player ();
			_tmp19_ = _tmp18_;
			_tmp20_ = music_playback_manager_get_current_media (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = music_media_get_resume_pos (_tmp21_);
			_tmp23_ = _tmp22_;
			gst_element_seek_simple (_tmp17_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp23_) * 1000000000);
		}
	}
	result = TRUE;
	return result;
}

static void
music_plugins_cd_player_real_play (MusicPlayback* base)
{
	MusicPluginsCDPlayer * self;
	self = (MusicPluginsCDPlayer*) base;
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PLAYING);
}

static void
music_plugins_cd_player_real_pause (MusicPlayback* base)
{
	MusicPluginsCDPlayer * self;
	self = (MusicPluginsCDPlayer*) base;
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PAUSED);
}

static void
music_plugins_cd_player_real_set_state (MusicPlayback* base,
                                        GstState s)
{
	MusicPluginsCDPlayer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (MusicPluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_set_state (_tmp1_, s);
}

static void
music_plugins_cd_player_real_set_media (MusicPlayback* base,
                                        MusicMedia* media)
{
	MusicPluginsCDPlayer * self;
	guint _tmp0_;
	guint _tmp1_;
	MusicPipeline* _tmp2_;
	GstElement* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	MusicPlaybackManager* _tmp8_;
	MusicPlaybackManager* _tmp9_;
	MusicMedia* _tmp10_;
	MusicMedia* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	MusicPipeline* _tmp14_;
	GstElement* _tmp15_;
	MusicPlaybackManager* _tmp16_;
	MusicPlaybackManager* _tmp17_;
	MusicMedia* _tmp18_;
	MusicMedia* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	self = (MusicPluginsCDPlayer*) base;
	g_return_if_fail (media != NULL);
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_READY);
	_tmp0_ = music_media_get_track (media);
	_tmp1_ = _tmp0_;
	g_debug ("CDPlayer.vala:103: set track number to %u\n", _tmp1_);
	_tmp2_ = self->pipe;
	_tmp3_ = _tmp2_->playbin;
	_tmp4_ = music_media_get_track (media);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup_printf ("cdda://%u", _tmp5_);
	_tmp7_ = _tmp6_;
	g_object_set ((GObject*) _tmp3_, "uri", _tmp7_, NULL);
	_g_free0 (_tmp7_);
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PLAYING);
	_tmp8_ = music_app_get_player ();
	_tmp9_ = _tmp8_;
	_tmp10_ = music_playback_manager_get_current_media (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = music_media_get_resume_pos (_tmp11_);
	_tmp13_ = _tmp12_;
	g_debug ("CDPlayer.vala:108: setURI seeking to %d\n", _tmp13_);
	_tmp14_ = self->pipe;
	_tmp15_ = _tmp14_->playbin;
	_tmp16_ = music_app_get_player ();
	_tmp17_ = _tmp16_;
	_tmp18_ = music_playback_manager_get_current_media (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = music_media_get_resume_pos (_tmp19_);
	_tmp21_ = _tmp20_;
	gst_element_seek_simple (_tmp15_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp21_) * 1000000000);
	music_playback_play ((MusicPlayback*) self);
}

static void
music_plugins_cd_player_real_set_position (MusicPlayback* base,
                                           gint64 pos)
{
	MusicPluginsCDPlayer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (MusicPluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_seek (_tmp1_, 1.0, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, GST_SEEK_TYPE_SET, pos, GST_SEEK_TYPE_NONE, music_playback_get_duration ((MusicPlayback*) self));
}

static gint64
music_plugins_cd_player_real_get_position (MusicPlayback* base)
{
	MusicPluginsCDPlayer * self;
	gint64 rv = 0LL;
	GstFormat f = 0;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gint64 result = 0LL;
	self = (MusicPluginsCDPlayer*) base;
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_query_position (_tmp1_, f, &_tmp2_);
	rv = _tmp2_;
	result = rv;
	return result;
}

static gint64
music_plugins_cd_player_real_get_duration (MusicPlayback* base)
{
	MusicPluginsCDPlayer * self;
	gint64 rv = 0LL;
	GstFormat f = 0;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gint64 result = 0LL;
	self = (MusicPluginsCDPlayer*) base;
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_query_duration (_tmp1_, f, &_tmp2_);
	rv = _tmp2_;
	result = rv;
	return result;
}

static void
music_plugins_cd_player_real_set_volume (MusicPlayback* base,
                                         gdouble val)
{
	MusicPluginsCDPlayer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (MusicPluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->playbin;
	g_object_set ((GObject*) _tmp1_, "volume", val, NULL);
	self->priv->volume = val;
}

static gdouble
music_plugins_cd_player_real_get_volume (MusicPlayback* base)
{
	MusicPluginsCDPlayer * self;
	gdouble result = 0.0;
	self = (MusicPluginsCDPlayer*) base;
	result = self->priv->volume;
	return result;
}

static void
music_plugins_cd_player_real_enable_equalizer (MusicPlayback* base)
{
	MusicPluginsCDPlayer * self;
	MusicPipeline* _tmp0_;
	self = (MusicPluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	music_pipeline_enable_equalizer (_tmp0_);
}

static void
music_plugins_cd_player_real_disable_equalizer (MusicPlayback* base)
{
	MusicPluginsCDPlayer * self;
	MusicPipeline* _tmp0_;
	self = (MusicPluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	music_pipeline_disable_equalizer (_tmp0_);
}

static void
music_plugins_cd_player_real_set_equalizer_gain (MusicPlayback* base,
                                                 gint index,
                                                 gint val)
{
	MusicPluginsCDPlayer * self;
	MusicPipeline* _tmp0_;
	MusicEqualizer* _tmp1_;
	self = (MusicPluginsCDPlayer*) base;
	_tmp0_ = self->pipe;
	_tmp1_ = _tmp0_->eq;
	music_equalizer_set_gain (_tmp1_, index, (gdouble) val);
}

static gboolean
music_plugins_cd_player_bus_callback (MusicPluginsCDPlayer* self,
                                      GstBus* bus,
                                      GstMessage* message)
{
	GstMessageType _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bus != NULL, FALSE);
	g_return_val_if_fail (message != NULL, FALSE);
	_tmp0_ = message->type;
	switch (_tmp0_) {
		case GST_MESSAGE_ERROR:
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp1_ = NULL;
			gchar* _tmp2_ = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			gst_message_parse_error (message, &_tmp1_, &_tmp2_);
			_g_error_free0 (err);
			err = _tmp1_;
			_g_free0 (debug);
			debug = _tmp2_;
			_tmp3_ = err;
			_tmp4_ = _tmp3_->message;
			g_warning ("CDPlayer.vala:171: Error: %s\n", _tmp4_);
			g_signal_emit_by_name ((MusicPlayback*) self, "error-occured");
			_g_free0 (debug);
			_g_error_free0 (err);
			break;
		}
		case GST_MESSAGE_ELEMENT:
		{
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			GstStructure* _tmp7_;
			_tmp7_ = gst_message_get_structure (message);
			if (_tmp7_ != NULL) {
				_tmp6_ = gst_is_missing_plugin_message (message);
			} else {
				_tmp6_ = FALSE;
			}
			if (_tmp6_) {
				gboolean _tmp8_ = FALSE;
				MusicInstallGstreamerPluginsDialog* _tmp9_;
				_tmp9_ = self->priv->dialog;
				if (_tmp9_ == NULL) {
					_tmp8_ = TRUE;
				} else {
					MusicInstallGstreamerPluginsDialog* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
					_tmp10_ = self->priv->dialog;
					_tmp11_ = gtk_widget_get_visible ((GtkWidget*) _tmp10_);
					_tmp12_ = _tmp11_;
					_tmp8_ = !_tmp12_;
				}
				_tmp5_ = _tmp8_;
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				MusicInstallGstreamerPluginsDialog* _tmp13_;
				_tmp13_ = music_install_gstreamer_plugins_dialog_new (message);
				g_object_ref_sink (_tmp13_);
				_g_object_unref0 (self->priv->dialog);
				self->priv->dialog = _tmp13_;
			}
			break;
		}
		case GST_MESSAGE_EOS:
		{
			g_signal_emit_by_name ((MusicPlayback*) self, "end-of-stream");
			break;
		}
		case GST_MESSAGE_STATE_CHANGED:
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp14_ = 0;
			GstState _tmp15_ = 0;
			GstState _tmp16_ = 0;
			GstState _tmp17_;
			gst_message_parse_state_changed (message, &_tmp14_, &_tmp15_, &_tmp16_);
			oldstate = _tmp14_;
			newstate = _tmp15_;
			pending = _tmp16_;
			_tmp17_ = newstate;
			if (_tmp17_ != GST_STATE_PLAYING) {
				break;
			}
			break;
		}
		case GST_MESSAGE_TAG:
		{
			GstTagList* tag_list = NULL;
			GstTagList* _tmp18_ = NULL;
			GstTagList* _tmp19_;
			gst_message_parse_tag (message, &_tmp18_);
			_gst_tag_list_unref0 (tag_list);
			tag_list = _tmp18_;
			_tmp19_ = tag_list;
			if (_tmp19_ != NULL) {
				GstTagList* _tmp20_;
				_tmp20_ = tag_list;
				if (gst_tag_list_get_tag_size (_tmp20_, GST_TAG_TITLE) > ((guint) 0)) {
					gchar* title = NULL;
					gchar* _tmp21_;
					GstTagList* _tmp22_;
					gchar* _tmp23_ = NULL;
					MusicNotificationManager* _tmp24_;
					MusicNotificationManager* _tmp25_;
					MusicPlaybackManager* _tmp26_;
					MusicPlaybackManager* _tmp27_;
					MusicMedia* _tmp28_;
					MusicMedia* _tmp29_;
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					const gchar* _tmp34_;
					gchar* _tmp35_;
					gchar* _tmp36_;
					_tmp21_ = g_strdup ("");
					title = _tmp21_;
					_tmp22_ = tag_list;
					gst_tag_list_get_string (_tmp22_, GST_TAG_TITLE, &_tmp23_);
					_g_free0 (title);
					title = _tmp23_;
					_tmp24_ = music_notification_manager_get_default ();
					_tmp25_ = _tmp24_;
					_tmp26_ = music_app_get_player ();
					_tmp27_ = _tmp26_;
					_tmp28_ = music_playback_manager_get_current_media (_tmp27_);
					_tmp29_ = _tmp28_;
					_tmp30_ = music_media_get_album_artist (_tmp29_);
					_tmp31_ = _tmp30_;
					_tmp32_ = g_strconcat (_tmp31_, "\n", NULL);
					_tmp33_ = _tmp32_;
					_tmp34_ = title;
					_tmp35_ = g_strconcat (_tmp33_, _tmp34_, NULL);
					_tmp36_ = _tmp35_;
					g_signal_emit_by_name (_tmp25_, "update-track", _tmp36_);
					_g_free0 (_tmp36_);
					_g_free0 (_tmp33_);
					_g_object_unref0 (_tmp25_);
					_g_free0 (title);
				}
			}
			_gst_tag_list_unref0 (tag_list);
			break;
		}
		default:
		{
			break;
		}
	}
	result = TRUE;
	return result;
}

static void
music_plugins_cd_player_class_init (MusicPluginsCDPlayerClass * klass,
                                    gpointer klass_data)
{
	music_plugins_cd_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPluginsCDPlayer_private_offset);
	G_OBJECT_CLASS (klass)->finalize = music_plugins_cd_player_finalize;
}

static void
music_plugins_cd_player_music_playback_interface_init (MusicPlaybackIface * iface,
                                                       gpointer iface_data)
{
	music_plugins_cd_player_music_playback_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_supported_uri = (GeeCollection* (*) (MusicPlayback*)) music_plugins_cd_player_real_get_supported_uri;
	iface->update_position = (gboolean (*) (MusicPlayback*)) music_plugins_cd_player_real_update_position;
	iface->play = (void (*) (MusicPlayback*)) music_plugins_cd_player_real_play;
	iface->pause = (void (*) (MusicPlayback*)) music_plugins_cd_player_real_pause;
	iface->set_state = (void (*) (MusicPlayback*, GstState)) music_plugins_cd_player_real_set_state;
	iface->set_media = (void (*) (MusicPlayback*, MusicMedia*)) music_plugins_cd_player_real_set_media;
	iface->set_position = (void (*) (MusicPlayback*, gint64)) music_plugins_cd_player_real_set_position;
	iface->get_position = (gint64 (*) (MusicPlayback*)) music_plugins_cd_player_real_get_position;
	iface->get_duration = (gint64 (*) (MusicPlayback*)) music_plugins_cd_player_real_get_duration;
	iface->set_volume = (void (*) (MusicPlayback*, gdouble)) music_plugins_cd_player_real_set_volume;
	iface->get_volume = (gdouble (*) (MusicPlayback*)) music_plugins_cd_player_real_get_volume;
	iface->enable_equalizer = (void (*) (MusicPlayback*)) music_plugins_cd_player_real_enable_equalizer;
	iface->disable_equalizer = (void (*) (MusicPlayback*)) music_plugins_cd_player_real_disable_equalizer;
	iface->set_equalizer_gain = (void (*) (MusicPlayback*, gint, gint)) music_plugins_cd_player_real_set_equalizer_gain;
}

static void
music_plugins_cd_player_instance_init (MusicPluginsCDPlayer * self,
                                       gpointer klass)
{
	self->priv = music_plugins_cd_player_get_instance_private (self);
	self->first_start = TRUE;
	self->priv->volume = (gdouble) 1;
}

static void
music_plugins_cd_player_finalize (GObject * obj)
{
	MusicPluginsCDPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_CD_PLAYER, MusicPluginsCDPlayer);
	_g_object_unref0 (self->priv->dialog);
	_g_free0 (self->priv->device);
	_g_object_unref0 (self->pipe);
	G_OBJECT_CLASS (music_plugins_cd_player_parent_class)->finalize (obj);
}

GType
music_plugins_cd_player_get_type (void)
{
	return music_plugins_cd_player_type_id;
}

GType
music_plugins_cd_player_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsCDPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_cd_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsCDPlayer), 0, (GInstanceInitFunc) music_plugins_cd_player_instance_init, NULL };
	static const GInterfaceInfo music_playback_info = { (GInterfaceInitFunc) music_plugins_cd_player_music_playback_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	music_plugins_cd_player_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicPluginsCDPlayer", &g_define_type_info, 0);
	g_type_module_add_interface (module, music_plugins_cd_player_type_id, MUSIC_TYPE_PLAYBACK, &music_playback_info);
	MusicPluginsCDPlayer_private_offset = sizeof (MusicPluginsCDPlayerPrivate);
	return music_plugins_cd_player_type_id;
}

