/* CDRipper.c generated by valac 0.44.11, the Vala compiler
 * generated from CDRipper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gst/gst.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define MUSIC_TYPE_CD_RIPPER (music_cd_ripper_get_type ())
#define MUSIC_CD_RIPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_CD_RIPPER, MusicCDRipper))
#define MUSIC_CD_RIPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_CD_RIPPER, MusicCDRipperClass))
#define MUSIC_IS_CD_RIPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_CD_RIPPER))
#define MUSIC_IS_CD_RIPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_CD_RIPPER))
#define MUSIC_CD_RIPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_CD_RIPPER, MusicCDRipperClass))

typedef struct _MusicCDRipper MusicCDRipper;
typedef struct _MusicCDRipperClass MusicCDRipperClass;
typedef struct _MusicCDRipperPrivate MusicCDRipperPrivate;
enum  {
	MUSIC_CD_RIPPER_0_PROPERTY,
	MUSIC_CD_RIPPER_NUM_PROPERTIES
};
static GParamSpec* music_cd_ripper_properties[MUSIC_CD_RIPPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	MUSIC_CD_RIPPER_MEDIA_RIPPED_SIGNAL,
	MUSIC_CD_RIPPER_PROGRESS_NOTIFICATION_SIGNAL,
	MUSIC_CD_RIPPER_ERROR_SIGNAL,
	MUSIC_CD_RIPPER_NUM_SIGNALS
};
static guint music_cd_ripper_signals[MUSIC_CD_RIPPER_NUM_SIGNALS] = {0};

struct _MusicCDRipper {
	GObject parent_instance;
	MusicCDRipperPrivate * priv;
	GstPipeline* pipeline;
	GstElement* src;
	GstElement* queue;
	GstElement* filter;
	GstElement* sink;
	gint track_count;
	gint track_index;
};

struct _MusicCDRipperClass {
	GObjectClass parent_class;
};

struct _MusicCDRipperPrivate {
	MusicMedia* current_media;
	gchar* _device;
	GstFormat _format;
};

static gint MusicCDRipper_private_offset;
static gpointer music_cd_ripper_parent_class = NULL;
static GType music_cd_ripper_type_id = 0;

GType music_cd_ripper_register_type (GTypeModule * module);
GType music_cd_ripper_get_type (void) G_GNUC_CONST;
MusicCDRipper* music_cd_ripper_new (GMount* mount,
                                    gint count);
MusicCDRipper* music_cd_ripper_construct (GType object_type,
                                          GMount* mount,
                                          gint count);
gboolean music_cd_ripper_initialize (MusicCDRipper* self);
static gboolean music_cd_ripper_bus_callback (MusicCDRipper* self,
                                       GstBus* bus,
                                       GstMessage* message);
static gboolean _music_cd_ripper_bus_callback_gst_bus_func (GstBus* bus,
                                                     GstMessage* message,
                                                     gpointer self);
gboolean music_cd_ripper_do_position_update (MusicCDRipper* self);
static gboolean _music_cd_ripper_do_position_update_gsource_func (gpointer self);
gint64 music_cd_ripper_get_position (MusicCDRipper* self);
gint64 music_cd_ripper_get_duration (MusicCDRipper* self);
static inline const gchar* _dynamic_get_location0 (GstElement* obj);
void music_cd_ripper_rip_media (MusicCDRipper* self,
                                guint track,
                                MusicMedia* s);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void music_cd_ripper_finalize (GObject * obj);

static inline gpointer
music_cd_ripper_get_instance_private (MusicCDRipper* self)
{
	return G_STRUCT_MEMBER_P (self, MusicCDRipper_private_offset);
}

MusicCDRipper*
music_cd_ripper_construct (GType object_type,
                           GMount* mount,
                           gint count)
{
	MusicCDRipper * self = NULL;
	GVolume* _tmp0_;
	GVolume* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (mount != NULL, NULL);
	self = (MusicCDRipper*) g_object_new (object_type, NULL);
	_tmp0_ = g_mount_get_volume (mount);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_volume_get_identifier (_tmp1_, G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE);
	_g_free0 (self->priv->_device);
	self->priv->_device = _tmp2_;
	_g_object_unref0 (_tmp1_);
	self->track_count = count;
	return self;
}

MusicCDRipper*
music_cd_ripper_new (GMount* mount,
                     gint count)
{
	return music_cd_ripper_construct (MUSIC_TYPE_CD_RIPPER, mount, count);
}

static gboolean
_music_cd_ripper_bus_callback_gst_bus_func (GstBus* bus,
                                            GstMessage* message,
                                            gpointer self)
{
	gboolean result;
	result = music_cd_ripper_bus_callback ((MusicCDRipper*) self, bus, message);
	return result;
}

static gboolean
_music_cd_ripper_do_position_update_gsource_func (gpointer self)
{
	gboolean result;
	result = music_cd_ripper_do_position_update ((MusicCDRipper*) self);
	return result;
}

gboolean
music_cd_ripper_initialize (MusicCDRipper* self)
{
	GstPipeline* _tmp0_;
	GstElement* src = NULL;
	GstElement* _tmp7_;
	const gchar* _tmp8_;
	GValue _tmp9_ = {0};
	GstElement* _tmp10_;
	GstElement* _tmp11_;
	GstElement* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GstElement* _tmp16_;
	GstElement* _tmp20_;
	GObjectClass* _tmp21_;
	GParamSpec* _tmp22_;
	GstElement* _tmp25_;
	GObjectClass* _tmp26_;
	GParamSpec* _tmp27_;
	GstElement* _tmp30_;
	GstPipeline* _tmp31_;
	GstElement* _tmp32_;
	GstElement* _tmp33_;
	GstElement* _tmp34_;
	GstElement* _tmp35_;
	GstElement* _tmp36_;
	GstElement* _tmp37_;
	GstElement* _tmp38_;
	GstElement* _tmp39_;
	GstPipeline* _tmp40_;
	GstBus* _tmp41_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = (GstPipeline*) gst_pipeline_new ("pipeline");
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->pipeline);
	self->pipeline = _tmp0_;
	src = NULL;
	{
		GstElement* _tmp1_ = NULL;
		GstElement* _tmp2_;
		GstElement* _tmp3_;
		_tmp2_ = gst_element_make_from_uri (GST_URI_SRC, "cdda://", NULL, &_inner_error0_);
		_tmp1_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp3_ = _tmp1_;
		_tmp1_ = NULL;
		if (_tmp3_ != NULL) {
			g_object_ref_sink (_tmp3_);
		}
		_g_object_unref0 (src);
		src = _tmp3_;
		_g_object_unref0 (_tmp1_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_warning ("CDRipper.vala:58: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp6_ = FALSE;
		_g_object_unref0 (src);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp6_;
	}
	_tmp7_ = src;
	_tmp8_ = self->priv->_device;
	g_value_init (&_tmp9_, G_TYPE_STRING);
	g_value_set_string (&_tmp9_, _tmp8_);
	g_object_set_property ((GObject*) _tmp7_, "device", &_tmp9_);
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
	_tmp10_ = gst_element_factory_make ("queue", "queue");
	if (_tmp10_ != NULL) {
		g_object_ref_sink (_tmp10_);
	}
	_g_object_unref0 (self->queue);
	self->queue = _tmp10_;
	_tmp11_ = gst_element_factory_make ("lamemp3enc", "lamemp3enc");
	if (_tmp11_ != NULL) {
		g_object_ref_sink (_tmp11_);
	}
	_g_object_unref0 (self->filter);
	self->filter = _tmp11_;
	_tmp12_ = gst_element_factory_make ("filesink", "filesink");
	if (_tmp12_ != NULL) {
		g_object_ref_sink (_tmp12_);
	}
	_g_object_unref0 (self->sink);
	self->sink = _tmp12_;
	_tmp16_ = src;
	if (_tmp16_ == NULL) {
		_tmp15_ = TRUE;
	} else {
		GstElement* _tmp17_;
		_tmp17_ = self->queue;
		_tmp15_ = _tmp17_ == NULL;
	}
	if (_tmp15_) {
		_tmp14_ = TRUE;
	} else {
		GstElement* _tmp18_;
		_tmp18_ = self->filter;
		_tmp14_ = _tmp18_ == NULL;
	}
	if (_tmp14_) {
		_tmp13_ = TRUE;
	} else {
		GstElement* _tmp19_;
		_tmp19_ = self->sink;
		_tmp13_ = _tmp19_ == NULL;
	}
	if (_tmp13_) {
		g_critical ("CDRipper.vala:67: Could not create GST Elements for ripping.\n");
		result = FALSE;
		_g_object_unref0 (src);
		return result;
	}
	_tmp20_ = src;
	_tmp21_ = G_OBJECT_GET_CLASS ((GObject*) _tmp20_);
	_tmp22_ = g_object_class_find_property (_tmp21_, "paranoia-mode");
	if (_tmp22_ != NULL) {
		GstElement* _tmp23_;
		GValue _tmp24_ = {0};
		_tmp23_ = src;
		g_value_init (&_tmp24_, G_TYPE_INT);
		g_value_set_int (&_tmp24_, 0xff);
		g_object_set_property ((GObject*) _tmp23_, "paranoia-mode", &_tmp24_);
		G_IS_VALUE (&_tmp24_) ? (g_value_unset (&_tmp24_), NULL) : NULL;
	}
	_tmp25_ = src;
	_tmp26_ = G_OBJECT_GET_CLASS ((GObject*) _tmp25_);
	_tmp27_ = g_object_class_find_property (_tmp26_, "read-speed");
	if (_tmp27_ != NULL) {
		GstElement* _tmp28_;
		GValue _tmp29_ = {0};
		_tmp28_ = src;
		g_value_init (&_tmp29_, G_TYPE_INT);
		g_value_set_int (&_tmp29_, 0xffff);
		g_object_set_property ((GObject*) _tmp28_, "read-speed", &_tmp29_);
		G_IS_VALUE (&_tmp29_) ? (g_value_unset (&_tmp29_), NULL) : NULL;
	}
	_tmp30_ = self->queue;
	g_object_set ((GObject*) _tmp30_, "max-size-time", 120 * GST_SECOND, NULL);
	self->priv->_format = gst_format_get_by_nick ("track");
	_tmp31_ = self->pipeline;
	_tmp32_ = src;
	_tmp33_ = self->queue;
	_tmp34_ = self->filter;
	_tmp35_ = self->sink;
	gst_bin_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gst_bin_get_type (), GstBin), _tmp32_, _tmp33_, _tmp34_, _tmp35_, NULL);
	_tmp36_ = src;
	_tmp37_ = self->queue;
	_tmp38_ = self->filter;
	_tmp39_ = self->sink;
	if (!gst_element_link_many (_tmp36_, _tmp37_, _tmp38_, _tmp39_, NULL)) {
		g_critical ("CDRipper.vala:88: CD Ripper link_many failed\n");
		result = FALSE;
		_g_object_unref0 (src);
		return result;
	}
	_tmp40_ = self->pipeline;
	_tmp41_ = ((GstElement*) _tmp40_)->bus;
	gst_bus_add_watch_full (_tmp41_, G_PRIORITY_DEFAULT, _music_cd_ripper_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _music_cd_ripper_do_position_update_gsource_func, g_object_ref (self), g_object_unref);
	result = TRUE;
	_g_object_unref0 (src);
	return result;
}

gboolean
music_cd_ripper_do_position_update (MusicCDRipper* self)
{
	gdouble track_position = 0.0;
	gdouble track_number = 0.0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	track_position = ((gdouble) music_cd_ripper_get_position (self)) / ((gdouble) music_cd_ripper_get_duration (self));
	track_number = ((gdouble) self->track_index) / ((gdouble) self->track_count);
	g_signal_emit (self, music_cd_ripper_signals[MUSIC_CD_RIPPER_PROGRESS_NOTIFICATION_SIGNAL], 0, track_position * track_number);
	if (music_cd_ripper_get_duration (self) <= ((gint64) 0)) {
		result = FALSE;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}

gint64
music_cd_ripper_get_position (MusicCDRipper* self)
{
	gint64 rv = 0LL;
	GstFormat f = 0;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	gint64 result = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->src;
	gst_element_query_position (_tmp0_, f, &_tmp1_);
	rv = _tmp1_;
	result = rv;
	return result;
}

gint64
music_cd_ripper_get_duration (MusicCDRipper* self)
{
	gint64 rv = 0LL;
	GstFormat f = 0;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	gint64 result = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->src;
	gst_element_query_duration (_tmp0_, f, &_tmp1_);
	rv = _tmp1_;
	result = rv;
	return result;
}

static inline const gchar*
_dynamic_get_location0 (GstElement* obj)
{
	const gchar* result;
	g_object_get (obj, "location", &result, NULL);
	return result;
}

static gboolean
music_cd_ripper_bus_callback (MusicCDRipper* self,
                              GstBus* bus,
                              GstMessage* message)
{
	GstMessageType _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bus != NULL, FALSE);
	g_return_val_if_fail (message != NULL, FALSE);
	_tmp0_ = message->type;
	switch (_tmp0_) {
		case GST_MESSAGE_ERROR:
		{
			g_signal_emit (self, music_cd_ripper_signals[MUSIC_CD_RIPPER_ERROR_SIGNAL], 0, "error", message);
			break;
		}
		case GST_MESSAGE_ELEMENT:
		{
			g_critical ("CDRipper.vala:154: missing element\n");
			g_signal_emit (self, music_cd_ripper_signals[MUSIC_CD_RIPPER_ERROR_SIGNAL], 0, "missing element", message);
			break;
		}
		case GST_MESSAGE_EOS:
		{
			GstPipeline* _tmp1_;
			MusicMedia* _tmp2_;
			GstElement* _tmp3_;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			GFile* _tmp6_;
			GFile* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			MusicMedia* _tmp10_;
			_tmp1_ = self->pipeline;
			gst_element_set_state ((GstElement*) _tmp1_, GST_STATE_NULL);
			_tmp2_ = self->priv->current_media;
			_tmp3_ = self->sink;
			_tmp4_ = _dynamic_get_location0 (_tmp3_);
			_tmp5_ = _tmp4_;
			_tmp6_ = g_file_new_for_path (_tmp5_);
			_tmp7_ = _tmp6_;
			_tmp8_ = g_file_get_uri (_tmp7_);
			_tmp9_ = _tmp8_;
			music_media_set_uri (_tmp2_, _tmp9_);
			_g_free0 (_tmp9_);
			_g_object_unref0 (_tmp7_);
			_tmp10_ = self->priv->current_media;
			g_signal_emit (self, music_cd_ripper_signals[MUSIC_CD_RIPPER_MEDIA_RIPPED_SIGNAL], 0, _tmp10_, TRUE);
			break;
		}
		default:
		{
			break;
		}
	}
	result = TRUE;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
music_cd_ripper_rip_media (MusicCDRipper* self,
                           guint track,
                           MusicMedia* s)
{
	GFile* f = NULL;
	GFile* _tmp0_;
	GstElement* _tmp1_;
	GstElement* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GstElement* _tmp6_;
	MusicMedia* _tmp7_;
	gint _tmp11_;
	MusicMedia* _tmp12_;
	MusicMedia* _tmp13_;
	GThemedIcon* _tmp14_;
	GThemedIcon* _tmp15_;
	GstPipeline* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (s != NULL);
	_tmp0_ = music_file_utils_get_new_destination (s);
	f = _tmp0_;
	_tmp1_ = self->sink;
	gst_element_set_state (_tmp1_, GST_STATE_NULL);
	_tmp2_ = self->sink;
	_tmp3_ = f;
	_tmp4_ = g_file_get_path (_tmp3_);
	_tmp5_ = _tmp4_;
	g_object_set ((GObject*) _tmp2_, "location", _tmp5_, NULL);
	_g_free0 (_tmp5_);
	_tmp6_ = self->src;
	g_object_set ((GObject*) _tmp6_, "track", track, NULL);
	_tmp7_ = self->priv->current_media;
	if (_tmp7_ != NULL) {
		MusicMedia* _tmp8_;
		GThemedIcon* _tmp9_;
		GThemedIcon* _tmp10_;
		_tmp8_ = self->priv->current_media;
		_tmp9_ = (GThemedIcon*) g_themed_icon_new ("process-completed-symbolic");
		_tmp10_ = _tmp9_;
		music_media_set_unique_status_image (_tmp8_, (GIcon*) _tmp10_);
		_g_object_unref0 (_tmp10_);
	}
	_tmp11_ = self->track_index;
	self->track_index = _tmp11_ + 1;
	_tmp12_ = _g_object_ref0 (s);
	_g_object_unref0 (self->priv->current_media);
	self->priv->current_media = _tmp12_;
	_tmp13_ = self->priv->current_media;
	_tmp14_ = (GThemedIcon*) g_themed_icon_new ("view-refresh-symbolic");
	_tmp15_ = _tmp14_;
	music_media_set_unique_status_image (_tmp13_, (GIcon*) _tmp15_);
	_g_object_unref0 (_tmp15_);
	_tmp16_ = self->pipeline;
	gst_element_set_state ((GstElement*) _tmp16_, GST_STATE_PLAYING);
	_g_object_unref0 (f);
}

static void
g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_POINTER) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_POINTER) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boxed (param_values + 2), data2);
}

static void
music_cd_ripper_class_init (MusicCDRipperClass * klass,
                            gpointer klass_data)
{
	music_cd_ripper_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicCDRipper_private_offset);
	G_OBJECT_CLASS (klass)->finalize = music_cd_ripper_finalize;
	music_cd_ripper_signals[MUSIC_CD_RIPPER_MEDIA_RIPPED_SIGNAL] = g_signal_new ("media-ripped", MUSIC_TYPE_CD_RIPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, MUSIC_TYPE_MEDIA, G_TYPE_BOOLEAN);
	music_cd_ripper_signals[MUSIC_CD_RIPPER_PROGRESS_NOTIFICATION_SIGNAL] = g_signal_new ("progress-notification", MUSIC_TYPE_CD_RIPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	music_cd_ripper_signals[MUSIC_CD_RIPPER_ERROR_SIGNAL] = g_signal_new ("error", MUSIC_TYPE_CD_RIPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_POINTER, G_TYPE_NONE, 2, G_TYPE_STRING, gst_message_get_type ());
}

static void
music_cd_ripper_instance_init (MusicCDRipper * self,
                               gpointer klass)
{
	self->priv = music_cd_ripper_get_instance_private (self);
}

static void
music_cd_ripper_finalize (GObject * obj)
{
	MusicCDRipper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_CD_RIPPER, MusicCDRipper);
	_g_object_unref0 (self->pipeline);
	_g_object_unref0 (self->src);
	_g_object_unref0 (self->queue);
	_g_object_unref0 (self->filter);
	_g_object_unref0 (self->sink);
	_g_object_unref0 (self->priv->current_media);
	_g_free0 (self->priv->_device);
	G_OBJECT_CLASS (music_cd_ripper_parent_class)->finalize (obj);
}

GType
music_cd_ripper_get_type (void)
{
	return music_cd_ripper_type_id;
}

GType
music_cd_ripper_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicCDRipperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_cd_ripper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicCDRipper), 0, (GInstanceInitFunc) music_cd_ripper_instance_init, NULL };
	music_cd_ripper_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicCDRipper", &g_define_type_info, 0);
	MusicCDRipper_private_offset = sizeof (MusicCDRipperPrivate);
	return music_cd_ripper_type_id;
}

