/* iPodLibrary.c generated by valac 0.44.11, the Vala compiler
 * generated from iPodLibrary.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <gpod/itdb.h>
#include <gee.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define MUSIC_PLUGINS_TYPE_IPOD_LIBRARY (music_plugins_ipod_library_get_type ())
#define MUSIC_PLUGINS_IPOD_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_PLUGINS_TYPE_IPOD_LIBRARY, MusicPluginsiPodLibrary))
#define MUSIC_PLUGINS_IPOD_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_PLUGINS_TYPE_IPOD_LIBRARY, MusicPluginsiPodLibraryClass))
#define MUSIC_PLUGINS_IS_IPOD_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_PLUGINS_TYPE_IPOD_LIBRARY))
#define MUSIC_PLUGINS_IS_IPOD_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_PLUGINS_TYPE_IPOD_LIBRARY))
#define MUSIC_PLUGINS_IPOD_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_PLUGINS_TYPE_IPOD_LIBRARY, MusicPluginsiPodLibraryClass))

typedef struct _MusicPluginsiPodLibrary MusicPluginsiPodLibrary;
typedef struct _MusicPluginsiPodLibraryClass MusicPluginsiPodLibraryClass;
typedef struct _MusicPluginsiPodLibraryPrivate MusicPluginsiPodLibraryPrivate;
enum  {
	MUSIC_PLUGINS_IPOD_LIBRARY_0_PROPERTY,
	MUSIC_PLUGINS_IPOD_LIBRARY_NUM_PROPERTIES
};
static GParamSpec* music_plugins_ipod_library_properties[MUSIC_PLUGINS_IPOD_LIBRARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
typedef struct _MusicPluginsIpodLibraryFinishInitializationAsyncData MusicPluginsIpodLibraryFinishInitializationAsyncData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _itdb_track_free0(var) ((var == NULL) ? NULL : (var = (itdb_track_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _MusicPluginsIpodLibraryAddMediasAsyncData MusicPluginsIpodLibraryAddMediasAsyncData;
typedef struct _MusicPluginsIpodLibraryRemoveMediasAsyncData MusicPluginsIpodLibraryRemoveMediasAsyncData;
typedef struct _Block2Data Block2Data;
#define _itdb_playlist_free0(var) ((var == NULL) ? NULL : (var = (itdb_playlist_free (var), NULL)))

struct _MusicPluginsiPodLibrary {
	MusicLibrary parent_instance;
	MusicPluginsiPodLibraryPrivate * priv;
};

struct _MusicPluginsiPodLibraryClass {
	MusicLibraryClass parent_class;
};

struct _MusicPluginsiPodLibraryPrivate {
	Itdb_iTunesDB* db;
	GeeHashMap* medias;
	GRecMutex __lock_medias;
	GeeLinkedList* searched_medias;
	GRecMutex __lock_searched_medias;
	GeeHashMap* playlists;
	GeeHashMap* smart_playlists;
	MusicDevice* device;
	gboolean operation_cancelled;
	gboolean is_doing_file_operations;
};

struct _Block1Data {
	int _ref_count_;
	MusicPluginsiPodLibrary* self;
	MusicPlaylist* playlist;
};

struct _MusicPluginsIpodLibraryFinishInitializationAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	MusicPluginsiPodLibrary* self;
	gint i;
	gboolean _tmp0_;
	Itdb_iTunesDB* _tmp1_;
	GList* _tmp2_;
	Itdb_Track* t;
	Itdb_iTunesDB* _tmp3_;
	GList* _tmp4_;
	gconstpointer _tmp5_;
	MusicMedia* m;
	MusicDevice* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	Itdb_Track* _tmp9_;
	MusicMedia* _tmp10_;
	MusicMedia* _tmp11_;
	gboolean _tmp12_;
	MusicMedia* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	GeeHashMap* _tmp16_;
	Itdb_Track* _tmp17_;
	MusicMedia* _tmp18_;
	GeeHashMap* _tmp19_;
	Itdb_Track* _tmp20_;
	MusicMedia* _tmp21_;
	Itdb_iTunesDB* _tmp22_;
	GList* _tmp23_;
	GList* p_collection;
	GList* p_it;
	Itdb_Playlist* p;
	Block1Data* _data1_;
	Itdb_Playlist* _tmp24_;
	GeeHashMap* _tmp25_;
	MusicPlaylist* _tmp26_;
	MusicPlaylist* _tmp27_;
	MusicPlaylist* _tmp28_;
	GeeHashMap* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	GeeHashMap* _tmp32_;
	Itdb_Playlist* _tmp33_;
	MusicPlaylist* _tmp34_;
	MusicPlaylist* _tmp35_;
	MusicPlaylist* _tmp36_;
	MusicPlaylist* _tmp37_;
	MusicPlaylist* _tmp38_;
	GeeHashMap* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	GeeHashMap* _tmp42_;
	Itdb_Playlist* _tmp43_;
	MusicPlaylist* _tmp44_;
};

struct _MusicPluginsIpodLibraryAddMediasAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	MusicPluginsiPodLibrary* self;
	GeeCollection* to_add;
	gboolean error_occurred;
	Itdb_iTunesDB* _tmp0_;
	gint total;
	gint _tmp1_;
	gint _tmp2_;
	gint index;
	GeeIterator* _m_it;
	GeeIterator* _tmp3_;
	GeeIterator* _tmp4_;
	MusicMedia* m;
	GeeIterator* _tmp5_;
	gpointer _tmp6_;
	MusicMedia* _tmp7_;
	MusicLibrariesManager* _tmp8_;
	MusicLibrariesManager* _tmp9_;
	gchar* _tmp10_;
	Itdb_iTunesDB* _tmp11_;
	GError* err;
	GError* _tmp12_;
	const gchar* _tmp13_;
	MusicLibrariesManager* _tmp14_;
	Itdb_iTunesDB* _tmp15_;
	MusicLibrariesManager* _tmp16_;
	gchar* _tmp17_;
	Itdb_iTunesDB* _tmp18_;
	GError* _vala1_err;
	GError* _tmp19_;
	const gchar* _tmp20_;
	Itdb_iTunesDB* _tmp21_;
	MusicLibrariesManager* _tmp22_;
	GError* _inner_error0_;
};

struct _MusicPluginsIpodLibraryRemoveMediasAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	MusicPluginsiPodLibrary* self;
	GeeCollection* list;
	gboolean error_occurred;
	gint total;
	gint _tmp0_;
	gint _tmp1_;
	gint index;
	Itdb_iTunesDB* _tmp2_;
	GeeHashMap* removed;
	GeeHashMap* _tmp3_;
	GeeIterator* _e_it;
	GeeHashMap* _tmp4_;
	GeeSet* _tmp5_;
	GeeSet* _tmp6_;
	GeeSet* _tmp7_;
	GeeIterator* _tmp8_;
	GeeIterator* _tmp9_;
	GeeIterator* _tmp10_;
	GeeMapEntry* e;
	GeeIterator* _tmp11_;
	gpointer _tmp12_;
	GeeIterator* _m_it;
	GeeIterator* _tmp13_;
	GeeIterator* _tmp14_;
	MusicMedia* m;
	GeeIterator* _tmp15_;
	gpointer _tmp16_;
	MusicMedia* _tmp17_;
	GeeMapEntry* _tmp18_;
	gconstpointer _tmp19_;
	MusicMedia* _tmp20_;
	Itdb_Track* t;
	GeeMapEntry* _tmp21_;
	gconstpointer _tmp22_;
	Itdb_Track* _tmp23_;
	Itdb_Track* _tmp24_;
	GeeHashMap* _tmp25_;
	Itdb_Track* _tmp26_;
	GeeMapEntry* _tmp27_;
	gconstpointer _tmp28_;
	MusicMedia* _tmp29_;
	MusicLibrariesManager* _tmp30_;
	GeeIterator* _track_it;
	GeeHashMap* _tmp31_;
	GeeSet* _tmp32_;
	GeeSet* _tmp33_;
	GeeSet* _tmp34_;
	GeeIterator* _tmp35_;
	GeeIterator* _tmp36_;
	GeeIterator* _tmp37_;
	Itdb_Track* track;
	GeeIterator* _tmp38_;
	gpointer _tmp39_;
	Itdb_Track* _tmp40_;
	GeeHashMap* _tmp41_;
	GeeHashMap* _tmp42_;
	MusicLibrariesManager* _tmp43_;
	gchar* _tmp44_;
	Itdb_iTunesDB* _tmp45_;
	GError* err;
	GError* _tmp46_;
	const gchar* _tmp47_;
	MusicLibrariesManager* _tmp48_;
	Itdb_iTunesDB* _tmp49_;
	MusicLibrariesManager* _tmp50_;
	gchar* _tmp51_;
	Itdb_iTunesDB* _tmp52_;
	GError* _vala1_err;
	GError* _tmp53_;
	const gchar* _tmp54_;
	Itdb_iTunesDB* _tmp55_;
	MusicLibrariesManager* _tmp56_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	MusicPluginsiPodLibrary* self;
	MusicStaticPlaylist* p;
};

static gint MusicPluginsiPodLibrary_private_offset;
static gpointer music_plugins_ipod_library_parent_class = NULL;
static GType music_plugins_ipod_library_type_id = 0;

GType music_plugins_ipod_library_register_type (GTypeModule * module);
GType music_plugins_ipod_library_get_type (void) G_GNUC_CONST;
MusicPluginsiPodLibrary* music_plugins_ipod_library_new (Itdb_iTunesDB* db,
                                                         MusicDevice* device);
MusicPluginsiPodLibrary* music_plugins_ipod_library_construct (GType object_type,
                                                               Itdb_iTunesDB* db,
                                                               MusicDevice* device);
static void __lambda4_ (MusicPluginsiPodLibrary* self);
static void ___lambda4__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                               gpointer self);
static void music_plugins_ipod_library_real_initialize_library (MusicLibrary* base);
static void music_plugins_ipod_library_finish_initialization_async_data_free (gpointer _data);
static void music_plugins_ipod_library_finish_initialization_async_async_ready_wrapper (GObject *source_object,
                                                                                 GAsyncResult *res,
                                                                                 void *user_data);
void music_plugins_ipod_library_finish_initialization_async (MusicPluginsiPodLibrary* self,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_);
void music_plugins_ipod_library_finish_initialization_finish (MusicPluginsiPodLibrary* self,
                                                              GAsyncResult* _res_);
static gboolean music_plugins_ipod_library_finish_initialization_async_co (MusicPluginsIpodLibraryFinishInitializationAsyncData* _data_);
MusicMedia* music_plugins_ipod_media_helper_media_from_track (const gchar* uri,
                                                              Itdb_Track* track);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
MusicPlaylist* music_plugins_ipod_playlist_helper_get_playlist_from_gpod_playlist (Itdb_Playlist* pl,
                                                                                   GeeHashMap* library);
static void _____lambda5_ (Block1Data* _data1_,
                    GeeCollection* list);
static void music_plugins_ipod_library_keep_playlist_synchronized (MusicPluginsiPodLibrary* self,
                                                            MusicStaticPlaylist* p,
                                                            GeeCollection* m,
                                                            gboolean to_add);
static void ______lambda5__music_playlist_media_added (MusicPlaylist* _sender,
                                                GeeCollection* media,
                                                gpointer self);
static void _____lambda6_ (Block1Data* _data1_,
                    GeeCollection* list);
static void ______lambda6__music_playlist_media_removed (MusicPlaylist* _sender,
                                                  GeeCollection* media,
                                                  gpointer self);
static gboolean __lambda7_ (MusicPluginsiPodLibrary* self);
static gboolean ___lambda7__gsource_func (gpointer self);
static void music_plugins_ipod_library_real_add_files_to_library (MusicLibrary* base,
                                                           GeeCollection* files);
static void music_plugins_ipod_library_real_search_medias (MusicLibrary* base,
                                                    const gchar* search);
static GeeCollection* music_plugins_ipod_library_real_get_search_result (MusicLibrary* base);
static GeeCollection* music_plugins_ipod_library_real_get_medias (MusicLibrary* base);
static GeeCollection* music_plugins_ipod_library_real_get_playlists (MusicLibrary* base);
static GeeCollection* music_plugins_ipod_library_real_get_smart_playlists (MusicLibrary* base);
static void music_plugins_ipod_library_real_add_media (MusicLibrary* base,
                                                MusicMedia* s);
Itdb_Track* music_plugins_ipod_media_helper_track_from_media (MusicMedia* m);
static void music_plugins_ipod_library_remove_media_from_ipod (MusicPluginsiPodLibrary* self,
                                                        Itdb_Track* t);
static void music_plugins_ipod_library_real_add_medias (MusicLibrary* base,
                                                 GeeCollection* list);
static gboolean _music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self);
static void music_plugins_ipod_library_add_medias_async (MusicPluginsiPodLibrary* self,
                                                  GeeCollection* to_add,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static void music_plugins_ipod_library_add_medias_finish (MusicPluginsiPodLibrary* self,
                                                   GAsyncResult* _res_);
static void music_plugins_ipod_library_add_medias_async_data_free (gpointer _data);
static void music_plugins_ipod_library_add_medias_async_async_ready_wrapper (GObject *source_object,
                                                                      GAsyncResult *res,
                                                                      void *user_data);
static gboolean music_plugins_ipod_library_add_medias_async_co (MusicPluginsIpodLibraryAddMediasAsyncData* _data_);
static gboolean __lambda8_ (MusicPluginsiPodLibrary* self);
static gboolean ___lambda8__gsource_func (gpointer self);
static MusicMedia* music_plugins_ipod_library_real_media_from_id (MusicLibrary* base,
                                                           gint64 id);
static GeeCollection* music_plugins_ipod_library_real_medias_from_ids (MusicLibrary* base,
                                                                GeeCollection* ids);
static GeeCollection* music_plugins_ipod_library_real_medias_from_uris (MusicLibrary* base,
                                                                 GeeCollection* uris);
static MusicMedia* music_plugins_ipod_library_real_find_media (MusicLibrary* base,
                                                        MusicMedia* to_find);
static MusicMedia* music_plugins_ipod_library_real_media_from_file (MusicLibrary* base,
                                                             GFile* file);
static MusicMedia* music_plugins_ipod_library_real_media_from_uri (MusicLibrary* base,
                                                            const gchar* uri);
static void music_plugins_ipod_library_real_update_media (MusicLibrary* base,
                                                   MusicMedia* s,
                                                   gboolean update_meta,
                                                   gboolean record_time);
static void music_plugins_ipod_library_real_update_medias (MusicLibrary* base,
                                                    GeeCollection* updates,
                                                    gboolean update_meta,
                                                    gboolean record_time);
static void music_plugins_ipod_library_real_remove_media (MusicLibrary* base,
                                                   MusicMedia* s,
                                                   gboolean trash);
static void music_plugins_ipod_library_real_remove_medias (MusicLibrary* base,
                                                    GeeCollection* to_remove,
                                                    gboolean trash);
static void music_plugins_ipod_library_remove_medias_async (MusicPluginsiPodLibrary* self,
                                                     GeeCollection* list,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static void music_plugins_ipod_library_remove_medias_finish (MusicPluginsiPodLibrary* self,
                                                      GAsyncResult* _res_);
static void music_plugins_ipod_library_remove_medias_async_data_free (gpointer _data);
static void music_plugins_ipod_library_remove_medias_async_async_ready_wrapper (GObject *source_object,
                                                                         GAsyncResult *res,
                                                                         void *user_data);
static gboolean music_plugins_ipod_library_remove_medias_async_co (MusicPluginsIpodLibraryRemoveMediasAsyncData* _data_);
static gboolean __lambda9_ (MusicPluginsiPodLibrary* self);
static gboolean ___lambda9__gsource_func (gpointer self);
static void music_plugins_ipod_library_real_add_smart_playlist (MusicLibrary* base,
                                                         MusicSmartPlaylist* p);
static gboolean music_plugins_ipod_library_real_support_smart_playlists (MusicLibrary* base);
static void music_plugins_ipod_library_real_remove_smart_playlist (MusicLibrary* base,
                                                            gint64 id);
static MusicSmartPlaylist* music_plugins_ipod_library_real_smart_playlist_from_id (MusicLibrary* base,
                                                                            gint64 id);
static MusicSmartPlaylist* music_plugins_ipod_library_real_smart_playlist_from_name (MusicLibrary* base,
                                                                              const gchar* name);
static gboolean music_plugins_ipod_library_real_support_playlists (MusicLibrary* base);
static void music_plugins_ipod_library_real_add_playlist (MusicLibrary* base,
                                                   MusicStaticPlaylist* p);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
Itdb_Playlist* music_plugins_ipod_playlist_helper_get_gpod_playlist_from_playlist (MusicPlaylist* pl,
                                                                                   GeeHashMap* library,
                                                                                   Itdb_iTunesDB* db);
static void __lambda10_ (Block2Data* _data2_,
                  GeeCollection* list);
static void ___lambda10__music_playlist_media_added (MusicPlaylist* _sender,
                                              GeeCollection* media,
                                              gpointer self);
static void __lambda11_ (Block2Data* _data2_,
                  GeeCollection* list);
static void ___lambda11__music_playlist_media_removed (MusicPlaylist* _sender,
                                                GeeCollection* media,
                                                gpointer self);
static void music_plugins_ipod_library_real_remove_playlist (MusicLibrary* base,
                                                      gint64 id);
GeeCollection* music_plugins_ipod_playlist_helper_get_gpod_tracks_from_medias (GeeCollection* medias,
                                                                               GeeHashMap* library);
static MusicStaticPlaylist* music_plugins_ipod_library_real_playlist_from_id (MusicLibrary* base,
                                                                       gint64 id);
static MusicStaticPlaylist* music_plugins_ipod_library_real_playlist_from_name (MusicLibrary* base,
                                                                         const gchar* name);
static gboolean music_plugins_ipod_library_real_start_file_operations (MusicLibrary* base,
                                                                const gchar* message);
static gboolean music_plugins_ipod_library_real_doing_file_operations (MusicLibrary* base);
static void music_plugins_ipod_library_real_finish_file_operations (MusicLibrary* base);
static void music_plugins_ipod_library_cleanup_files (MusicPluginsiPodLibrary* self,
                                               GFile* music_folder,
                                               GeeLinkedList* used_uris);
static void music_plugins_ipod_library_finalize (GObject * obj);

static inline gpointer
music_plugins_ipod_library_get_instance_private (MusicPluginsiPodLibrary* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsiPodLibrary_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda4_ (MusicPluginsiPodLibrary* self)
{
	self->priv->operation_cancelled = TRUE;
}

static void
___lambda4__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                          gpointer self)
{
	__lambda4_ ((MusicPluginsiPodLibrary*) self);
}

MusicPluginsiPodLibrary*
music_plugins_ipod_library_construct (GType object_type,
                                      Itdb_iTunesDB* db,
                                      MusicDevice* device)
{
	MusicPluginsiPodLibrary * self = NULL;
	MusicDevice* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeLinkedList* _tmp4_;
	MusicNotificationManager* _tmp5_;
	MusicNotificationManager* _tmp6_;
	g_return_val_if_fail (db != NULL, NULL);
	g_return_val_if_fail (device != NULL, NULL);
	self = (MusicPluginsiPodLibrary*) music_library_construct (object_type);
	self->priv->db = db;
	_tmp0_ = _g_object_ref0 (device);
	_g_object_unref0 (self->priv->device);
	self->priv->device = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_POINTER, NULL, NULL, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->medias);
	self->priv->medias = _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_POINTER, NULL, NULL, MUSIC_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->playlists);
	self->priv->playlists = _tmp2_;
	_tmp3_ = gee_hash_map_new (G_TYPE_POINTER, NULL, NULL, MUSIC_TYPE_SMART_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->smart_playlists);
	self->priv->smart_playlists = _tmp3_;
	_tmp4_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->searched_medias);
	self->priv->searched_medias = _tmp4_;
	_tmp5_ = music_notification_manager_get_default ();
	_tmp6_ = _tmp5_;
	g_signal_connect_object (_tmp6_, "progress-canceled", (GCallback) ___lambda4__music_notification_manager_progress_canceled, self, 0);
	_g_object_unref0 (_tmp6_);
	return self;
}

MusicPluginsiPodLibrary*
music_plugins_ipod_library_new (Itdb_iTunesDB* db,
                                MusicDevice* device)
{
	return music_plugins_ipod_library_construct (MUSIC_PLUGINS_TYPE_IPOD_LIBRARY, db, device);
}

static void
music_plugins_ipod_library_real_initialize_library (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	self = (MusicPluginsiPodLibrary*) base;
}

static void
music_plugins_ipod_library_finish_initialization_async_data_free (gpointer _data)
{
	MusicPluginsIpodLibraryFinishInitializationAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicPluginsIpodLibraryFinishInitializationAsyncData, _data_);
}

static void
music_plugins_ipod_library_finish_initialization_async_async_ready_wrapper (GObject *source_object,
                                                                            GAsyncResult *res,
                                                                            void *user_data)
{
	MusicPluginsIpodLibraryFinishInitializationAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}

void
music_plugins_ipod_library_finish_initialization_async (MusicPluginsiPodLibrary* self,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_)
{
	MusicPluginsIpodLibraryFinishInitializationAsyncData* _data_;
	MusicPluginsiPodLibrary* _tmp0_;
	_data_ = g_slice_new0 (MusicPluginsIpodLibraryFinishInitializationAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, music_plugins_ipod_library_finish_initialization_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, music_plugins_ipod_library_finish_initialization_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	music_plugins_ipod_library_finish_initialization_async_co (_data_);
}

void
music_plugins_ipod_library_finish_initialization_finish (MusicPluginsiPodLibrary* self,
                                                         GAsyncResult* _res_)
{
	MusicPluginsIpodLibraryFinishInitializationAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		MusicPluginsiPodLibrary* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->playlist);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
_____lambda5_ (Block1Data* _data1_,
               GeeCollection* list)
{
	MusicPluginsiPodLibrary* self;
	MusicPlaylist* _tmp0_;
	self = _data1_->self;
	g_return_if_fail (list != NULL);
	_tmp0_ = _data1_->playlist;
	music_plugins_ipod_library_keep_playlist_synchronized (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist), list, TRUE);
}

static void
______lambda5__music_playlist_media_added (MusicPlaylist* _sender,
                                           GeeCollection* media,
                                           gpointer self)
{
	_____lambda5_ (self, media);
}

static void
_____lambda6_ (Block1Data* _data1_,
               GeeCollection* list)
{
	MusicPluginsiPodLibrary* self;
	MusicPlaylist* _tmp0_;
	self = _data1_->self;
	g_return_if_fail (list != NULL);
	_tmp0_ = _data1_->playlist;
	music_plugins_ipod_library_keep_playlist_synchronized (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist), list, FALSE);
}

static void
______lambda6__music_playlist_media_removed (MusicPlaylist* _sender,
                                             GeeCollection* media,
                                             gpointer self)
{
	_____lambda6_ (self, media);
}

static gboolean
__lambda7_ (MusicPluginsiPodLibrary* self)
{
	MusicDevice* _tmp0_;
	MusicDevice* _tmp1_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->device;
	_tmp1_ = self->priv->device;
	g_signal_emit_by_name (_tmp0_, "initialized", _tmp1_);
	music_library_search_medias ((MusicLibrary*) self, "");
	result = FALSE;
	return result;
}

static gboolean
___lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda7_ ((MusicPluginsiPodLibrary*) self);
	return result;
}

static gboolean
music_plugins_ipod_library_finish_initialization_async_co (MusicPluginsIpodLibraryFinishInitializationAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->i = 0;
		{
			_data_->_tmp0_ = TRUE;
			while (TRUE) {
				if (!_data_->_tmp0_) {
					_data_->i = _data_->i + 1;
				}
				_data_->_tmp0_ = FALSE;
				_data_->_tmp1_ = _data_->self->priv->db;
				_data_->_tmp2_ = _data_->_tmp1_->tracks;
				if (!(((guint) _data_->i) < g_list_length (_data_->_tmp2_))) {
					break;
				}
				_data_->_tmp3_ = _data_->self->priv->db;
				_data_->_tmp4_ = _data_->_tmp3_->tracks;
				_data_->_tmp5_ = g_list_nth_data (_data_->_tmp4_, (guint) _data_->i);
				_data_->t = (Itdb_Track*) _data_->_tmp5_;
				_data_->_tmp6_ = _data_->self->priv->device;
				_data_->_tmp7_ = music_device_get_uri (_data_->_tmp6_);
				_data_->_tmp8_ = _data_->_tmp7_;
				_data_->_tmp9_ = _data_->t;
				_data_->_tmp10_ = music_plugins_ipod_media_helper_media_from_track (_data_->_tmp8_, _data_->_tmp9_);
				_data_->_tmp11_ = _data_->_tmp10_;
				_g_free0 (_data_->_tmp8_);
				_data_->m = _data_->_tmp11_;
				_data_->_tmp13_ = _data_->m;
				_data_->_tmp14_ = music_media_get_file_exists (_data_->_tmp13_);
				_data_->_tmp15_ = _data_->_tmp14_;
				if (_data_->_tmp15_) {
					_data_->_tmp16_ = _data_->self->priv->medias;
					_data_->_tmp17_ = _data_->t;
					_data_->_tmp18_ = _data_->m;
					_data_->_tmp12_ = !gee_abstract_map_has ((GeeAbstractMap*) _data_->_tmp16_, _data_->_tmp17_, _data_->_tmp18_);
				} else {
					_data_->_tmp12_ = FALSE;
				}
				if (_data_->_tmp12_) {
					_data_->_tmp19_ = _data_->self->priv->medias;
					_data_->_tmp20_ = _data_->t;
					_data_->_tmp21_ = _data_->m;
					gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp19_, _data_->_tmp20_, _data_->_tmp21_);
				}
				_g_object_unref0 (_data_->m);
			}
		}
	}
	_data_->_tmp22_ = _data_->self->priv->db;
	_data_->_tmp23_ = _data_->_tmp22_->playlists;
	{
		_data_->p_collection = _data_->_tmp23_;
		for (_data_->p_it = _data_->p_collection; _data_->p_it != NULL; _data_->p_it = _data_->p_it->next) {
			_data_->p = (Itdb_Playlist*) _data_->p_it->data;
			{
				_data_->_data1_ = g_slice_new0 (Block1Data);
				_data_->_data1_->_ref_count_ = 1;
				_data_->_data1_->self = g_object_ref (_data_->self);
				_data_->_tmp24_ = _data_->p;
				_data_->_tmp25_ = _data_->self->priv->medias;
				_data_->_tmp26_ = music_plugins_ipod_playlist_helper_get_playlist_from_gpod_playlist (_data_->_tmp24_, _data_->_tmp25_);
				_data_->_data1_->playlist = _data_->_tmp26_;
				_data_->_tmp27_ = _data_->_data1_->playlist;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp27_, MUSIC_TYPE_STATIC_PLAYLIST)) {
					_data_->_tmp28_ = _data_->_data1_->playlist;
					_data_->_tmp29_ = _data_->self->priv->playlists;
					_data_->_tmp30_ = gee_abstract_map_get_size ((GeeAbstractMap*) _data_->_tmp29_);
					_data_->_tmp31_ = _data_->_tmp30_;
					music_playlist_set_rowid (_data_->_tmp28_, (gint64) _data_->_tmp31_);
					_data_->_tmp32_ = _data_->self->priv->playlists;
					_data_->_tmp33_ = _data_->p;
					_data_->_tmp34_ = _data_->_data1_->playlist;
					gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp32_, _data_->_tmp33_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp34_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist));
					_data_->_tmp35_ = _data_->_data1_->playlist;
					g_signal_connect_data (_data_->_tmp35_, "media-added", (GCallback) ______lambda5__music_playlist_media_added, block1_data_ref (_data_->_data1_), (GClosureNotify) block1_data_unref, 0);
					_data_->_tmp36_ = _data_->_data1_->playlist;
					g_signal_connect_data (_data_->_tmp36_, "media-removed", (GCallback) ______lambda6__music_playlist_media_removed, block1_data_ref (_data_->_data1_), (GClosureNotify) block1_data_unref, 0);
				} else {
					_data_->_tmp37_ = _data_->_data1_->playlist;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp37_, MUSIC_TYPE_SMART_PLAYLIST)) {
						_data_->_tmp38_ = _data_->_data1_->playlist;
						_data_->_tmp39_ = _data_->self->priv->smart_playlists;
						_data_->_tmp40_ = gee_abstract_map_get_size ((GeeAbstractMap*) _data_->_tmp39_);
						_data_->_tmp41_ = _data_->_tmp40_;
						music_playlist_set_rowid (_data_->_tmp38_, (gint64) _data_->_tmp41_);
						_data_->_tmp42_ = _data_->self->priv->smart_playlists;
						_data_->_tmp43_ = _data_->p;
						_data_->_tmp44_ = _data_->_data1_->playlist;
						gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp42_, _data_->_tmp43_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp44_, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist));
					}
				}
				block1_data_unref (_data_->_data1_);
				_data_->_data1_ = NULL;
			}
		}
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda7__gsource_func, g_object_ref (_data_->self), g_object_unref);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!_data_->_task_complete_) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
music_plugins_ipod_library_real_add_files_to_library (MusicLibrary* base,
                                                      GeeCollection* files)
{
	MusicPluginsiPodLibrary * self;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_if_fail (files != NULL);
}

static void
music_plugins_ipod_library_real_search_medias (MusicLibrary* base,
                                               const gchar* search)
{
	MusicPluginsiPodLibrary * self;
	GError* _inner_error0_ = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_if_fail (search != NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->searched_medias;
		g_rec_mutex_lock (&self->priv->__lock_searched_medias);
		{
			GeeLinkedList* _tmp1_;
			gboolean _tmp2_ = FALSE;
			guint parsed_rating = 0U;
			gchar* parsed_search_string = NULL;
			guint _tmp9_ = 0U;
			gchar* _tmp10_ = NULL;
			gboolean rating_search = FALSE;
			_tmp1_ = self->priv->searched_medias;
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
			if (g_strcmp0 (search, "") == 0) {
				_tmp2_ = TRUE;
			} else {
				_tmp2_ = search == NULL;
			}
			if (_tmp2_) {
				GeeLinkedList* _tmp3_;
				GeeHashMap* _tmp4_;
				GeeCollection* _tmp5_;
				GeeCollection* _tmp6_;
				GeeCollection* _tmp7_;
				_tmp3_ = self->priv->searched_medias;
				_tmp4_ = self->priv->medias;
				_tmp5_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp4_);
				_tmp6_ = _tmp5_;
				_tmp7_ = _tmp6_;
				gee_collection_add_all ((GeeCollection*) _tmp3_, _tmp7_);
				_g_object_unref0 (_tmp7_);
				g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
				{
					GeeLinkedList* _tmp8_;
					_tmp8_ = self->priv->searched_medias;
					g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
				}
				return;
			}
			music_string_base_search_method (search, &_tmp9_, &_tmp10_);
			parsed_rating = _tmp9_;
			_g_free0 (parsed_search_string);
			parsed_search_string = _tmp10_;
			rating_search = parsed_rating > ((guint) 0);
			{
				GeeHashMap* _tmp11_;
				_tmp11_ = self->priv->medias;
				g_rec_mutex_lock (&self->priv->__lock_medias);
				{
					{
						GeeIterator* _m_it = NULL;
						GeeHashMap* _tmp12_;
						GeeCollection* _tmp13_;
						GeeCollection* _tmp14_;
						GeeCollection* _tmp15_;
						GeeIterator* _tmp16_;
						GeeIterator* _tmp17_;
						_tmp12_ = self->priv->medias;
						_tmp13_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp12_);
						_tmp14_ = _tmp13_;
						_tmp15_ = _tmp14_;
						_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
						_tmp17_ = _tmp16_;
						_g_object_unref0 (_tmp15_);
						_m_it = _tmp17_;
						while (TRUE) {
							GeeIterator* _tmp18_;
							MusicMedia* m = NULL;
							GeeIterator* _tmp19_;
							gpointer _tmp20_;
							_tmp18_ = _m_it;
							if (!gee_iterator_next (_tmp18_)) {
								break;
							}
							_tmp19_ = _m_it;
							_tmp20_ = gee_iterator_get (_tmp19_);
							m = (MusicMedia*) _tmp20_;
							if (rating_search) {
								MusicMedia* _tmp21_;
								guint _tmp22_;
								guint _tmp23_;
								_tmp21_ = m;
								_tmp22_ = music_media_get_rating (_tmp21_);
								_tmp23_ = _tmp22_;
								if (_tmp23_ == parsed_rating) {
									GeeLinkedList* _tmp24_;
									MusicMedia* _tmp25_;
									_tmp24_ = self->priv->searched_medias;
									_tmp25_ = m;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp25_);
								}
							} else {
								MusicMedia* _tmp26_;
								const gchar* _tmp27_;
								_tmp26_ = m;
								_tmp27_ = parsed_search_string;
								if (music_search_match_string_to_media (_tmp26_, _tmp27_)) {
									GeeLinkedList* _tmp28_;
									MusicMedia* _tmp29_;
									_tmp28_ = self->priv->searched_medias;
									_tmp29_ = m;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
								}
							}
							_g_object_unref0 (m);
						}
						_g_object_unref0 (_m_it);
					}
				}
				__finally5:
				{
					GeeHashMap* _tmp30_;
					_tmp30_ = self->priv->medias;
					g_rec_mutex_unlock (&self->priv->__lock_medias);
				}
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_free0 (parsed_search_string);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_g_free0 (parsed_search_string);
		}
		__finally4:
		{
			GeeLinkedList* _tmp31_;
			_tmp31_ = self->priv->searched_medias;
			g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
}

static GeeCollection*
music_plugins_ipod_library_real_get_search_result (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	_tmp0_ = self->priv->searched_medias;
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
	result = _tmp1_;
	return result;
}

static GeeCollection*
music_plugins_ipod_library_real_get_medias (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	_tmp0_ = self->priv->medias;
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

static GeeCollection*
music_plugins_ipod_library_real_get_playlists (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	_tmp0_ = self->priv->playlists;
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

static GeeCollection*
music_plugins_ipod_library_real_get_smart_playlists (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	_tmp0_ = self->priv->smart_playlists;
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch7_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch7_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally7;
	__catch7_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally7:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
music_plugins_ipod_library_real_add_media (MusicLibrary* base,
                                           MusicMedia* s)
{
	MusicPluginsiPodLibrary * self;
	Itdb_Track* t = NULL;
	Itdb_Track* _tmp0_;
	GIcon* icon = NULL;
	MusicAlbum* _tmp1_;
	MusicAlbum* _tmp2_;
	GIcon* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GIcon* _tmp6_;
	gchar* current_operation = NULL;
	gchar* _tmp16_;
	const gchar* _tmp17_ = NULL;
	Itdb_Track* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_ = NULL;
	Itdb_Track* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_ = NULL;
	MusicDevice* _tmp28_;
	gchar* _tmp29_;
	MusicLibrariesManager* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	Itdb_Track* _tmp34_;
	const gchar* _tmp35_;
	Itdb_Track* _tmp36_;
	const gchar* _tmp37_;
	Itdb_iTunesDB* _tmp38_;
	Itdb_Track* _tmp39_;
	Itdb_Track* added = NULL;
	Itdb_iTunesDB* _tmp40_;
	GList* _tmp41_;
	Itdb_iTunesDB* _tmp42_;
	GList* _tmp43_;
	gconstpointer _tmp44_;
	gboolean _tmp45_ = FALSE;
	Itdb_Track* _tmp46_;
	Itdb_Playlist* mpl = NULL;
	Itdb_iTunesDB* _tmp51_;
	Itdb_Playlist* _tmp52_;
	Itdb_Playlist* _tmp53_;
	Itdb_Track* _tmp54_;
	gboolean success = FALSE;
	GError* _inner_error0_ = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_if_fail (s != NULL);
	if (s == NULL) {
		return;
	}
	_tmp0_ = music_plugins_ipod_media_helper_track_from_media (s);
	t = _tmp0_;
	_tmp1_ = music_media_get_album_info (s);
	_tmp2_ = _tmp1_;
	_tmp3_ = music_album_get_cover_icon (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	icon = _tmp5_;
	_tmp6_ = icon;
	if (_tmp6_ != NULL) {
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp7_;
		GIcon* _tmp8_;
		GtkIconInfo* _tmp9_;
		_tmp7_ = gtk_icon_theme_get_default ();
		_tmp8_ = icon;
		_tmp9_ = gtk_icon_theme_lookup_by_gicon (_tmp7_, _tmp8_, 128, GTK_ICON_LOOKUP_GENERIC_FALLBACK);
		icon_info = _tmp9_;
		{
			GdkPixbuf* pixbuf = NULL;
			GtkIconInfo* _tmp10_;
			GdkPixbuf* _tmp11_;
			Itdb_Track* _tmp12_;
			GdkPixbuf* _tmp13_;
			_tmp10_ = icon_info;
			_tmp11_ = gtk_icon_info_load_icon (_tmp10_, &_inner_error0_);
			pixbuf = _tmp11_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch6_g_error;
			}
			_tmp12_ = t;
			_tmp13_ = pixbuf;
			itdb_track_set_thumbnails_from_pixbuf (_tmp12_, _tmp13_);
			_g_object_unref0 (pixbuf);
		}
		goto __finally6;
		__catch6_g_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp14_ = e;
			_tmp15_ = _tmp14_->message;
			g_critical ("iPodLibrary.vala:163: %s", _tmp15_);
			_g_error_free0 (e);
		}
		__finally6:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (icon_info);
			_g_object_unref0 (icon);
			_itdb_track_free0 (t);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_object_unref0 (icon_info);
	}
	_tmp16_ = g_strdup (_ ("Adding <b>$NAME</b> by <b>$ARTIST</b> to $DEVICE"));
	current_operation = _tmp16_;
	_tmp18_ = t;
	_tmp19_ = _tmp18_->title;
	_tmp17_ = _tmp19_;
	if (_tmp17_ == NULL) {
		_tmp17_ = "";
	}
	_tmp20_ = current_operation;
	_tmp21_ = string_replace (_tmp20_, "$NAME", _tmp17_);
	_g_free0 (current_operation);
	current_operation = _tmp21_;
	_tmp23_ = t;
	_tmp24_ = _tmp23_->artist;
	_tmp22_ = _tmp24_;
	if (_tmp22_ == NULL) {
		_tmp22_ = "";
	}
	_tmp25_ = current_operation;
	_tmp26_ = string_replace (_tmp25_, "$ARTIST", _tmp22_);
	_g_free0 (current_operation);
	current_operation = _tmp26_;
	_tmp28_ = self->priv->device;
	_tmp29_ = music_device_get_display_name (_tmp28_);
	_tmp27_ = _tmp29_;
	if (_tmp27_ == NULL) {
		gchar* _tmp30_;
		_tmp30_ = g_strdup ("");
		_g_free0 (_tmp27_);
		_tmp27_ = _tmp30_;
	}
	_tmp31_ = music_libraries_manager;
	_tmp32_ = current_operation;
	_tmp33_ = string_replace (_tmp32_, "$DEVICE", _tmp27_);
	_g_free0 (_tmp31_->current_operation);
	_tmp31_->current_operation = _tmp33_;
	_tmp34_ = t;
	_tmp35_ = _tmp34_->title;
	_tmp36_ = t;
	_tmp37_ = _tmp36_->artist;
	g_debug ("iPodLibrary.vala:171: Adding media %s by %s\n", _tmp35_, _tmp37_);
	_tmp38_ = self->priv->db;
	_tmp39_ = t;
	t = NULL;
	itdb_track_add (_tmp38_, _tmp39_, (gint32) -1);
	_tmp40_ = self->priv->db;
	_tmp41_ = _tmp40_->tracks;
	_tmp42_ = self->priv->db;
	_tmp43_ = _tmp42_->tracks;
	_tmp44_ = g_list_nth_data (_tmp41_, g_list_length (_tmp43_) - 1);
	added = (Itdb_Track*) _tmp44_;
	_tmp46_ = added;
	if (_tmp46_ == NULL) {
		_tmp45_ = TRUE;
	} else {
		Itdb_Track* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
		_tmp47_ = added;
		_tmp48_ = _tmp47_->title;
		_tmp49_ = music_media_get_title (s);
		_tmp50_ = _tmp49_;
		_tmp45_ = g_strcmp0 (_tmp48_, _tmp50_) != 0;
	}
	if (_tmp45_) {
		g_warning ("iPodLibrary.vala:176: Track was not properly appended. Returning.\n");
		_g_free0 (_tmp27_);
		_g_free0 (current_operation);
		_g_object_unref0 (icon);
		_itdb_track_free0 (t);
		return;
	}
	_tmp51_ = self->priv->db;
	_tmp52_ = itdb_playlist_mpl (_tmp51_);
	mpl = _tmp52_;
	_tmp53_ = mpl;
	_tmp54_ = added;
	itdb_playlist_add_track (_tmp53_, _tmp54_, (gint32) -1);
	success = FALSE;
	{
		gboolean _tmp55_ = FALSE;
		Itdb_Track* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		GFile* _tmp60_;
		GFile* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
		gboolean _tmp64_;
		Itdb_Track* _tmp65_;
		const gchar* _tmp66_;
		_tmp56_ = added;
		_tmp57_ = music_media_get_uri (s);
		_tmp58_ = _tmp57_;
		_tmp59_ = _tmp58_;
		_tmp60_ = g_file_new_for_uri (_tmp59_);
		_tmp61_ = _tmp60_;
		_tmp62_ = g_file_get_path (_tmp61_);
		_tmp63_ = _tmp62_;
		_tmp64_ = itdb_cp_track_to_ipod (_tmp56_, _tmp63_, &_inner_error0_);
		_g_free0 (_tmp63_);
		_g_object_unref0 (_tmp61_);
		_g_free0 (_tmp59_);
		_tmp55_ = _tmp64_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch8_g_error;
		}
		success = _tmp55_;
		_tmp65_ = added;
		_tmp66_ = _tmp65_->title;
		g_debug ("iPodLibrary.vala:186: Copied media %s to ipod\n", _tmp66_);
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp67_;
		const gchar* _tmp68_;
		GError* _tmp69_;
		const gchar* _tmp70_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp67_ = music_media_get_title (s);
		_tmp68_ = _tmp67_;
		_tmp69_ = err;
		_tmp70_ = _tmp69_->message;
		g_warning ("iPodLibrary.vala:188: Error adding/copying song %s to iPod: %s\n", _tmp68_, _tmp70_);
		_g_error_free0 (err);
	}
	__finally8:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (_tmp27_);
		_g_free0 (current_operation);
		_g_object_unref0 (icon);
		_itdb_track_free0 (t);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	if (success) {
		MusicMedia* on_ipod = NULL;
		MusicDevice* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
		Itdb_Track* _tmp74_;
		MusicMedia* _tmp75_;
		MusicMedia* _tmp76_;
		GeeHashMap* _tmp77_;
		Itdb_Track* _tmp78_;
		MusicMedia* _tmp79_;
		_tmp71_ = self->priv->device;
		_tmp72_ = music_device_get_uri (_tmp71_);
		_tmp73_ = _tmp72_;
		_tmp74_ = added;
		_tmp75_ = music_plugins_ipod_media_helper_media_from_track (_tmp73_, _tmp74_);
		_tmp76_ = _tmp75_;
		_g_free0 (_tmp73_);
		on_ipod = _tmp76_;
		_tmp77_ = self->priv->medias;
		_tmp78_ = added;
		_tmp79_ = on_ipod;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp77_, _tmp78_, _tmp79_);
		_g_object_unref0 (on_ipod);
	} else {
		Itdb_Track* _tmp80_;
		const gchar* _tmp81_;
		Itdb_Track* _tmp82_;
		_tmp80_ = added;
		_tmp81_ = _tmp80_->title;
		g_warning ("iPodLibrary.vala:195: Failed to copy track %s to iPod. Removing it fro" \
"m database.\n", _tmp81_);
		_tmp82_ = added;
		music_plugins_ipod_library_remove_media_from_ipod (self, _tmp82_);
	}
	_g_free0 (_tmp27_);
	_g_free0 (current_operation);
	_g_object_unref0 (icon);
	_itdb_track_free0 (t);
}

static gboolean
_music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = music_libraries_manager_do_progress_notification_with_timeout ((MusicLibrariesManager*) self);
	return result;
}

static void
music_plugins_ipod_library_real_add_medias (MusicLibrary* base,
                                            GeeCollection* list)
{
	MusicPluginsiPodLibrary * self;
	GeeLinkedList* new_list = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	gboolean fits = FALSE;
	MusicDevice* _tmp7_;
	GeeLinkedList* _tmp8_;
	MusicLibrariesManager* _tmp9_;
	MusicDevice* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	MusicLibrariesManager* _tmp14_;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_if_fail (list != NULL);
	if (self->priv->is_doing_file_operations) {
		g_warning ("iPodLibrary.vala:202: Tried to add when already syncing\n");
		return;
	}
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	new_list = _tmp0_;
	_tmp1_ = new_list;
	gee_collection_add_all ((GeeCollection*) _tmp1_, list);
	_tmp2_ = new_list;
	_tmp3_ = self->priv->medias;
	_tmp4_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	gee_collection_add_all ((GeeCollection*) _tmp2_, _tmp6_);
	_g_object_unref0 (_tmp6_);
	_tmp7_ = self->priv->device;
	_tmp8_ = new_list;
	fits = music_device_will_fit (_tmp7_, (GeeCollection*) _tmp8_);
	if (!fits) {
		g_warning ("iPodLibrary.vala:212: Tried to sync medias that will not fit\n");
		_g_object_unref0 (new_list);
		return;
	}
	_tmp9_ = music_libraries_manager;
	_tmp10_ = self->priv->device;
	_tmp11_ = music_device_get_display_name (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strdup_printf (_ ("Syncing <b>%s</b>…"), _tmp12_);
	_g_free0 (_tmp9_->current_operation);
	_tmp9_->current_operation = _tmp13_;
	_g_free0 (_tmp12_);
	self->priv->is_doing_file_operations = TRUE;
	_tmp14_ = music_libraries_manager;
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _music_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp14_), g_object_unref);
	music_plugins_ipod_library_add_medias_async (self, list, NULL, NULL);
	_g_object_unref0 (new_list);
}

static void
music_plugins_ipod_library_add_medias_async_data_free (gpointer _data)
{
	MusicPluginsIpodLibraryAddMediasAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->to_add);
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicPluginsIpodLibraryAddMediasAsyncData, _data_);
}

static void
music_plugins_ipod_library_add_medias_async_async_ready_wrapper (GObject *source_object,
                                                                 GAsyncResult *res,
                                                                 void *user_data)
{
	MusicPluginsIpodLibraryAddMediasAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}

static void
music_plugins_ipod_library_add_medias_async (MusicPluginsiPodLibrary* self,
                                             GeeCollection* to_add,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	MusicPluginsIpodLibraryAddMediasAsyncData* _data_;
	MusicPluginsiPodLibrary* _tmp0_;
	GeeCollection* _tmp1_;
	_data_ = g_slice_new0 (MusicPluginsIpodLibraryAddMediasAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, music_plugins_ipod_library_add_medias_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, music_plugins_ipod_library_add_medias_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (to_add);
	_g_object_unref0 (_data_->to_add);
	_data_->to_add = _tmp1_;
	music_plugins_ipod_library_add_medias_async_co (_data_);
}

static void
music_plugins_ipod_library_add_medias_finish (MusicPluginsiPodLibrary* self,
                                              GAsyncResult* _res_)
{
	MusicPluginsIpodLibraryAddMediasAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
__lambda8_ (MusicPluginsiPodLibrary* self)
{
	gboolean result = FALSE;
	self->priv->is_doing_file_operations = FALSE;
	g_signal_emit_by_name ((MusicLibrary*) self, "file-operations-done");
	self->priv->operation_cancelled = FALSE;
	result = FALSE;
	return result;
}

static gboolean
___lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda8_ ((MusicPluginsiPodLibrary*) self);
	return result;
}

static gboolean
music_plugins_ipod_library_add_medias_async_co (MusicPluginsIpodLibraryAddMediasAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->error_occurred = FALSE;
	_data_->_tmp0_ = _data_->self->priv->db;
	itdb_start_sync (_data_->_tmp0_);
	_data_->_tmp1_ = gee_collection_get_size (_data_->to_add);
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->total = _data_->_tmp2_;
	_data_->index = 0;
	{
		_data_->_tmp3_ = gee_iterable_iterator ((GeeIterable*) _data_->to_add);
		_data_->_m_it = _data_->_tmp3_;
		while (TRUE) {
			_data_->_tmp4_ = _data_->_m_it;
			if (!gee_iterator_next (_data_->_tmp4_)) {
				break;
			}
			_data_->_tmp5_ = _data_->_m_it;
			_data_->_tmp6_ = gee_iterator_get (_data_->_tmp5_);
			_data_->m = (MusicMedia*) _data_->_tmp6_;
			if (!_data_->self->priv->operation_cancelled) {
				_data_->_tmp7_ = _data_->m;
				music_library_add_media ((MusicLibrary*) _data_->self, _data_->_tmp7_);
				_data_->index = _data_->index + 1;
				_data_->_tmp8_ = music_libraries_manager;
				_data_->_tmp8_->progress = (gdouble) (_data_->index / _data_->total);
			}
			_g_object_unref0 (_data_->m);
		}
		_g_object_unref0 (_data_->_m_it);
	}
	if (!_data_->self->priv->operation_cancelled) {
		_data_->_tmp9_ = music_libraries_manager;
		_data_->_tmp10_ = g_strdup (_ ("Finishing sync process…"));
		_g_free0 (_data_->_tmp9_->current_operation);
		_data_->_tmp9_->current_operation = _data_->_tmp10_;
		{
			_data_->_tmp11_ = _data_->self->priv->db;
			itdb_write (_data_->_tmp11_, &_data_->_inner_error0_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch9_g_error;
			}
		}
		goto __finally9;
		__catch9_g_error:
		{
			_data_->err = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp12_ = _data_->err;
			_data_->_tmp13_ = _data_->_tmp12_->message;
			g_critical ("iPodLibrary.vala:242: Error when writing iPod database. iPod contents " \
"may be incorrect: %s\n", _data_->_tmp13_);
			_data_->error_occurred = TRUE;
			_data_->self->priv->operation_cancelled = TRUE;
			_g_error_free0 (_data_->err);
		}
		__finally9:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp14_ = music_libraries_manager;
		_data_->_tmp14_->progress = (gdouble) 1;
		_data_->_tmp15_ = _data_->self->priv->db;
		itdb_stop_sync (_data_->_tmp15_);
	} else {
		_data_->_tmp16_ = music_libraries_manager;
		_data_->_tmp17_ = g_strdup (_ ("Cancelling Sync…"));
		_g_free0 (_data_->_tmp16_->current_operation);
		_data_->_tmp16_->current_operation = _data_->_tmp17_;
		{
			_data_->_tmp18_ = _data_->self->priv->db;
			itdb_write (_data_->_tmp18_, &_data_->_inner_error0_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch10_g_error;
			}
		}
		goto __finally10;
		__catch10_g_error:
		{
			_data_->_vala1_err = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp19_ = _data_->_vala1_err;
			_data_->_tmp20_ = _data_->_tmp19_->message;
			g_critical ("iPodLibrary.vala:254: Error when writing iPod database. iPod contents " \
"may be incorrect: %s\n", _data_->_tmp20_);
			_g_error_free0 (_data_->_vala1_err);
		}
		__finally10:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp21_ = _data_->self->priv->db;
		itdb_stop_sync (_data_->_tmp21_);
		_data_->_tmp22_ = music_libraries_manager;
		_data_->_tmp22_->progress = (gdouble) 1;
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda8__gsource_func, g_object_ref (_data_->self), g_object_unref);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!_data_->_task_complete_) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static MusicMedia*
music_plugins_ipod_library_real_media_from_id (MusicLibrary* base,
                                               gint64 id)
{
	MusicPluginsiPodLibrary * self;
	MusicMedia* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	result = NULL;
	return result;
}

static GeeCollection*
music_plugins_ipod_library_real_medias_from_ids (MusicLibrary* base,
                                                 GeeCollection* ids)
{
	MusicPluginsiPodLibrary * self;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_val_if_fail (ids != NULL, NULL);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	media_collection = _tmp0_;
	{
		GeeHashMap* _tmp1_;
		_tmp1_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
				_tmp2_ = self->priv->medias;
				_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
				_tmp4_ = _tmp3_;
				_tmp5_ = _tmp4_;
				_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
				_tmp7_ = _tmp6_;
				_g_object_unref0 (_tmp5_);
				_m_it = _tmp7_;
				while (TRUE) {
					GeeIterator* _tmp8_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					MusicMedia* _tmp11_;
					gint64 _tmp12_;
					gint64 _tmp13_;
					GeeLinkedList* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					_tmp8_ = _m_it;
					if (!gee_iterator_next (_tmp8_)) {
						break;
					}
					_tmp9_ = _m_it;
					_tmp10_ = gee_iterator_get (_tmp9_);
					m = (MusicMedia*) _tmp10_;
					_tmp11_ = m;
					_tmp12_ = music_media_get_rowid (_tmp11_);
					_tmp13_ = _tmp12_;
					if (gee_collection_contains (ids, &_tmp13_)) {
						GeeLinkedList* _tmp14_;
						MusicMedia* _tmp15_;
						_tmp14_ = media_collection;
						_tmp15_ = m;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
					}
					_tmp16_ = media_collection;
					_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
					_tmp18_ = _tmp17_;
					_tmp19_ = gee_collection_get_size (ids);
					_tmp20_ = _tmp19_;
					if (_tmp18_ == _tmp20_) {
						_g_object_unref0 (m);
						break;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
		}
		__finally11:
		{
			GeeHashMap* _tmp21_;
			_tmp21_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (media_collection);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = (GeeCollection*) media_collection;
	return result;
}

static GeeCollection*
music_plugins_ipod_library_real_medias_from_uris (MusicLibrary* base,
                                                  GeeCollection* uris)
{
	MusicPluginsiPodLibrary * self;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_val_if_fail (uris != NULL, NULL);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	media_collection = _tmp0_;
	{
		GeeHashMap* _tmp1_;
		_tmp1_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
				_tmp2_ = self->priv->medias;
				_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
				_tmp4_ = _tmp3_;
				_tmp5_ = _tmp4_;
				_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
				_tmp7_ = _tmp6_;
				_g_object_unref0 (_tmp5_);
				_m_it = _tmp7_;
				while (TRUE) {
					GeeIterator* _tmp8_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					MusicMedia* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gboolean _tmp15_;
					GeeLinkedList* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					_tmp8_ = _m_it;
					if (!gee_iterator_next (_tmp8_)) {
						break;
					}
					_tmp9_ = _m_it;
					_tmp10_ = gee_iterator_get (_tmp9_);
					m = (MusicMedia*) _tmp10_;
					_tmp11_ = m;
					_tmp12_ = music_media_get_uri (_tmp11_);
					_tmp13_ = _tmp12_;
					_tmp14_ = _tmp13_;
					_tmp15_ = gee_collection_contains (uris, _tmp14_);
					_g_free0 (_tmp14_);
					if (_tmp15_) {
						GeeLinkedList* _tmp16_;
						MusicMedia* _tmp17_;
						_tmp16_ = media_collection;
						_tmp17_ = m;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
					}
					_tmp18_ = media_collection;
					_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
					_tmp20_ = _tmp19_;
					_tmp21_ = gee_collection_get_size (uris);
					_tmp22_ = _tmp21_;
					if (_tmp20_ == _tmp22_) {
						_g_object_unref0 (m);
						break;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
		}
		__finally12:
		{
			GeeHashMap* _tmp23_;
			_tmp23_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (media_collection);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = (GeeCollection*) media_collection;
	return result;
}

static MusicMedia*
music_plugins_ipod_library_real_find_media (MusicLibrary* base,
                                            MusicMedia* to_find)
{
	MusicPluginsiPodLibrary * self;
	MusicMedia* found = NULL;
	GError* _inner_error0_ = NULL;
	MusicMedia* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_val_if_fail (to_find != NULL, NULL);
	found = NULL;
	{
		GeeHashMap* _tmp0_;
		_tmp0_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp1_;
				GeeCollection* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeIterator* _tmp5_;
				GeeIterator* _tmp6_;
				_tmp1_ = self->priv->medias;
				_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
				_tmp3_ = _tmp2_;
				_tmp4_ = _tmp3_;
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
				_tmp6_ = _tmp5_;
				_g_object_unref0 (_tmp4_);
				_m_it = _tmp6_;
				while (TRUE) {
					GeeIterator* _tmp7_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					MusicMedia* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gboolean _tmp20_;
					_tmp7_ = _m_it;
					if (!gee_iterator_next (_tmp7_)) {
						break;
					}
					_tmp8_ = _m_it;
					_tmp9_ = gee_iterator_get (_tmp8_);
					m = (MusicMedia*) _tmp9_;
					_tmp11_ = music_media_get_title (to_find);
					_tmp12_ = _tmp11_;
					_tmp13_ = g_utf8_strdown (_tmp12_, (gssize) -1);
					_tmp14_ = _tmp13_;
					_tmp15_ = m;
					_tmp16_ = music_media_get_title (_tmp15_);
					_tmp17_ = _tmp16_;
					_tmp18_ = g_utf8_strdown (_tmp17_, (gssize) -1);
					_tmp19_ = _tmp18_;
					_tmp20_ = g_strcmp0 (_tmp14_, _tmp19_) == 0;
					_g_free0 (_tmp19_);
					_g_free0 (_tmp14_);
					if (_tmp20_) {
						const gchar* _tmp21_;
						const gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						MusicMedia* _tmp25_;
						const gchar* _tmp26_;
						const gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
						_tmp21_ = music_media_get_artist (to_find);
						_tmp22_ = _tmp21_;
						_tmp23_ = g_utf8_strdown (_tmp22_, (gssize) -1);
						_tmp24_ = _tmp23_;
						_tmp25_ = m;
						_tmp26_ = music_media_get_artist (_tmp25_);
						_tmp27_ = _tmp26_;
						_tmp28_ = g_utf8_strdown (_tmp27_, (gssize) -1);
						_tmp29_ = _tmp28_;
						_tmp10_ = g_strcmp0 (_tmp24_, _tmp29_) == 0;
						_g_free0 (_tmp29_);
						_g_free0 (_tmp24_);
					} else {
						_tmp10_ = FALSE;
					}
					if (_tmp10_) {
						MusicMedia* _tmp30_;
						MusicMedia* _tmp31_;
						_tmp30_ = m;
						_tmp31_ = _g_object_ref0 (_tmp30_);
						_g_object_unref0 (found);
						found = _tmp31_;
						_g_object_unref0 (m);
						break;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
		}
		__finally13:
		{
			GeeHashMap* _tmp32_;
			_tmp32_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (found);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = found;
	return result;
}

static MusicMedia*
music_plugins_ipod_library_real_media_from_file (MusicLibrary* base,
                                                 GFile* file)
{
	MusicPluginsiPodLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_val_if_fail (file != NULL, NULL);
	{
		GeeHashMap* _tmp0_;
		_tmp0_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp1_;
				GeeCollection* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeIterator* _tmp5_;
				GeeIterator* _tmp6_;
				_tmp1_ = self->priv->medias;
				_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
				_tmp3_ = _tmp2_;
				_tmp4_ = _tmp3_;
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
				_tmp6_ = _tmp5_;
				_g_object_unref0 (_tmp4_);
				_m_it = _tmp6_;
				while (TRUE) {
					GeeIterator* _tmp7_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					MusicMedia* _tmp11_;
					_tmp7_ = _m_it;
					if (!gee_iterator_next (_tmp7_)) {
						break;
					}
					_tmp8_ = _m_it;
					_tmp9_ = gee_iterator_get (_tmp8_);
					m = (MusicMedia*) _tmp9_;
					_tmp11_ = m;
					if (_tmp11_ != NULL) {
						MusicMedia* _tmp12_;
						GFile* _tmp13_;
						GFile* _tmp14_;
						_tmp12_ = m;
						_tmp13_ = music_media_get_file (_tmp12_);
						_tmp14_ = _tmp13_;
						_tmp10_ = g_file_equal (_tmp14_, file);
					} else {
						_tmp10_ = FALSE;
					}
					if (_tmp10_) {
						result = m;
						_g_object_unref0 (_m_it);
						{
							GeeHashMap* _tmp15_;
							_tmp15_ = self->priv->medias;
							g_rec_mutex_unlock (&self->priv->__lock_medias);
						}
						return result;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
		}
		__finally14:
		{
			GeeHashMap* _tmp16_;
			_tmp16_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = NULL;
	return result;
}

static MusicMedia*
music_plugins_ipod_library_real_media_from_uri (MusicLibrary* base,
                                                const gchar* uri)
{
	MusicPluginsiPodLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_val_if_fail (uri != NULL, NULL);
	{
		GeeHashMap* _tmp0_;
		_tmp0_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp1_;
				GeeCollection* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeIterator* _tmp5_;
				GeeIterator* _tmp6_;
				_tmp1_ = self->priv->medias;
				_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
				_tmp3_ = _tmp2_;
				_tmp4_ = _tmp3_;
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
				_tmp6_ = _tmp5_;
				_g_object_unref0 (_tmp4_);
				_m_it = _tmp6_;
				while (TRUE) {
					GeeIterator* _tmp7_;
					MusicMedia* m = NULL;
					GeeIterator* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					MusicMedia* _tmp11_;
					_tmp7_ = _m_it;
					if (!gee_iterator_next (_tmp7_)) {
						break;
					}
					_tmp8_ = _m_it;
					_tmp9_ = gee_iterator_get (_tmp8_);
					m = (MusicMedia*) _tmp9_;
					_tmp11_ = m;
					if (_tmp11_ != NULL) {
						MusicMedia* _tmp12_;
						gchar* _tmp13_;
						gchar* _tmp14_;
						gchar* _tmp15_;
						_tmp12_ = m;
						_tmp13_ = music_media_get_uri (_tmp12_);
						_tmp14_ = _tmp13_;
						_tmp15_ = _tmp14_;
						_tmp10_ = g_strcmp0 (_tmp15_, uri) == 0;
						_g_free0 (_tmp15_);
					} else {
						_tmp10_ = FALSE;
					}
					if (_tmp10_) {
						result = m;
						_g_object_unref0 (_m_it);
						{
							GeeHashMap* _tmp16_;
							_tmp16_ = self->priv->medias;
							g_rec_mutex_unlock (&self->priv->__lock_medias);
						}
						return result;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
		}
		__finally15:
		{
			GeeHashMap* _tmp17_;
			_tmp17_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = NULL;
	return result;
}

static void
music_plugins_ipod_library_real_update_media (MusicLibrary* base,
                                              MusicMedia* s,
                                              gboolean update_meta,
                                              gboolean record_time)
{
	MusicPluginsiPodLibrary * self;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_if_fail (s != NULL);
}

static void
music_plugins_ipod_library_real_update_medias (MusicLibrary* base,
                                               GeeCollection* updates,
                                               gboolean update_meta,
                                               gboolean record_time)
{
	MusicPluginsiPodLibrary * self;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_if_fail (updates != NULL);
}

static void
music_plugins_ipod_library_real_remove_media (MusicLibrary* base,
                                              MusicMedia* s,
                                              gboolean trash)
{
	MusicPluginsiPodLibrary * self;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_if_fail (s != NULL);
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	list = _tmp0_;
	gee_abstract_collection_add ((GeeAbstractCollection*) list, s);
	music_library_remove_medias ((MusicLibrary*) self, (GeeCollection*) list, trash);
	_g_object_unref0 (list);
}

static void
music_plugins_ipod_library_real_remove_medias (MusicLibrary* base,
                                               GeeCollection* to_remove,
                                               gboolean trash)
{
	MusicPluginsiPodLibrary * self;
	MusicLibrariesManager* _tmp0_;
	MusicDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	MusicLibrariesManager* _tmp5_;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_if_fail (to_remove != NULL);
	if (self->priv->is_doing_file_operations) {
		g_warning ("iPodLibrary.vala:361: Tried to add when already syncing\n");
		return;
	}
	_tmp0_ = music_libraries_manager;
	_tmp1_ = self->priv->device;
	_tmp2_ = music_device_get_display_name (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup_printf (_ ("Removing from <b>%s</b>…"), _tmp3_);
	_g_free0 (_tmp0_->current_operation);
	_tmp0_->current_operation = _tmp4_;
	_g_free0 (_tmp3_);
	self->priv->is_doing_file_operations = TRUE;
	_tmp5_ = music_libraries_manager;
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _music_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp5_), g_object_unref);
	music_plugins_ipod_library_remove_medias_async (self, to_remove, NULL, NULL);
	return;
}

static void
music_plugins_ipod_library_remove_medias_async_data_free (gpointer _data)
{
	MusicPluginsIpodLibraryRemoveMediasAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->list);
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicPluginsIpodLibraryRemoveMediasAsyncData, _data_);
}

static void
music_plugins_ipod_library_remove_medias_async_async_ready_wrapper (GObject *source_object,
                                                                    GAsyncResult *res,
                                                                    void *user_data)
{
	MusicPluginsIpodLibraryRemoveMediasAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}

static void
music_plugins_ipod_library_remove_medias_async (MusicPluginsiPodLibrary* self,
                                                GeeCollection* list,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	MusicPluginsIpodLibraryRemoveMediasAsyncData* _data_;
	MusicPluginsiPodLibrary* _tmp0_;
	GeeCollection* _tmp1_;
	_data_ = g_slice_new0 (MusicPluginsIpodLibraryRemoveMediasAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, music_plugins_ipod_library_remove_medias_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, music_plugins_ipod_library_remove_medias_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (list);
	_g_object_unref0 (_data_->list);
	_data_->list = _tmp1_;
	music_plugins_ipod_library_remove_medias_async_co (_data_);
}

static void
music_plugins_ipod_library_remove_medias_finish (MusicPluginsiPodLibrary* self,
                                                 GAsyncResult* _res_)
{
	MusicPluginsIpodLibraryRemoveMediasAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
__lambda9_ (MusicPluginsiPodLibrary* self)
{
	gboolean result = FALSE;
	self->priv->is_doing_file_operations = FALSE;
	g_signal_emit_by_name ((MusicLibrary*) self, "file-operations-done");
	result = FALSE;
	return result;
}

static gboolean
___lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda9_ ((MusicPluginsiPodLibrary*) self);
	return result;
}

static gboolean
music_plugins_ipod_library_remove_medias_async_co (MusicPluginsIpodLibraryRemoveMediasAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->error_occurred = FALSE;
	_data_->_tmp0_ = gee_collection_get_size (_data_->list);
	_data_->_tmp1_ = _data_->_tmp0_;
	_data_->total = _data_->_tmp1_;
	_data_->index = 0;
	_data_->_tmp2_ = _data_->self->priv->db;
	itdb_start_sync (_data_->_tmp2_);
	_data_->_tmp3_ = gee_hash_map_new (G_TYPE_POINTER, NULL, NULL, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_data_->removed = _data_->_tmp3_;
	{
		_data_->_tmp4_ = _data_->self->priv->medias;
		_data_->_tmp5_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _data_->_tmp4_);
		_data_->_tmp6_ = _data_->_tmp5_;
		_data_->_tmp7_ = _data_->_tmp6_;
		_data_->_tmp8_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp7_);
		_data_->_tmp9_ = _data_->_tmp8_;
		_g_object_unref0 (_data_->_tmp7_);
		_data_->_e_it = _data_->_tmp9_;
		while (TRUE) {
			_data_->_tmp10_ = _data_->_e_it;
			if (!gee_iterator_next (_data_->_tmp10_)) {
				break;
			}
			_data_->_tmp11_ = _data_->_e_it;
			_data_->_tmp12_ = gee_iterator_get (_data_->_tmp11_);
			_data_->e = (GeeMapEntry*) _data_->_tmp12_;
			{
				_data_->_tmp13_ = gee_iterable_iterator ((GeeIterable*) _data_->list);
				_data_->_m_it = _data_->_tmp13_;
				while (TRUE) {
					_data_->_tmp14_ = _data_->_m_it;
					if (!gee_iterator_next (_data_->_tmp14_)) {
						break;
					}
					_data_->_tmp15_ = _data_->_m_it;
					_data_->_tmp16_ = gee_iterator_get (_data_->_tmp15_);
					_data_->m = (MusicMedia*) _data_->_tmp16_;
					if (!_data_->self->priv->operation_cancelled) {
						_data_->_tmp17_ = _data_->m;
						_data_->_tmp18_ = _data_->e;
						_data_->_tmp19_ = gee_map_entry_get_value (_data_->_tmp18_);
						_data_->_tmp20_ = _data_->_tmp19_;
						if (_data_->_tmp17_ == ((MusicMedia*) _data_->_tmp20_)) {
							_data_->_tmp21_ = _data_->e;
							_data_->_tmp22_ = gee_map_entry_get_key (_data_->_tmp21_);
							_data_->_tmp23_ = _data_->_tmp22_;
							_data_->t = (Itdb_Track*) _data_->_tmp23_;
							_data_->_tmp24_ = _data_->t;
							if (_data_->_tmp24_ != NULL) {
								_data_->_tmp25_ = _data_->removed;
								_data_->_tmp26_ = _data_->t;
								_data_->_tmp27_ = _data_->e;
								_data_->_tmp28_ = gee_map_entry_get_value (_data_->_tmp27_);
								_data_->_tmp29_ = _data_->_tmp28_;
								gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp25_, _data_->_tmp26_, (MusicMedia*) _data_->_tmp29_);
							}
						}
					}
					_g_object_unref0 (_data_->m);
				}
				_g_object_unref0 (_data_->_m_it);
			}
			_data_->index = _data_->index + 1;
			_data_->_tmp30_ = music_libraries_manager;
			_data_->_tmp30_->progress = (gdouble) (_data_->index / _data_->total);
			_g_object_unref0 (_data_->e);
		}
		_g_object_unref0 (_data_->_e_it);
	}
	{
		_data_->_tmp31_ = _data_->removed;
		_data_->_tmp32_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _data_->_tmp31_);
		_data_->_tmp33_ = _data_->_tmp32_;
		_data_->_tmp34_ = _data_->_tmp33_;
		_data_->_tmp35_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp34_);
		_data_->_tmp36_ = _data_->_tmp35_;
		_g_object_unref0 (_data_->_tmp34_);
		_data_->_track_it = _data_->_tmp36_;
		while (TRUE) {
			_data_->_tmp37_ = _data_->_track_it;
			if (!gee_iterator_next (_data_->_tmp37_)) {
				break;
			}
			_data_->_tmp38_ = _data_->_track_it;
			_data_->_tmp39_ = gee_iterator_get (_data_->_tmp38_);
			_data_->track = (Itdb_Track*) _data_->_tmp39_;
			_data_->_tmp40_ = _data_->track;
			music_plugins_ipod_library_remove_media_from_ipod (_data_->self, _data_->_tmp40_);
		}
		_g_object_unref0 (_data_->_track_it);
	}
	_data_->_tmp41_ = _data_->self->priv->medias;
	_data_->_tmp42_ = _data_->removed;
	gee_map_unset_all ((GeeMap*) _data_->_tmp41_, (GeeMap*) _data_->_tmp42_);
	if (!_data_->self->priv->operation_cancelled) {
		_data_->_tmp43_ = music_libraries_manager;
		_data_->_tmp44_ = g_strdup (_ ("Finishing sync process…"));
		_g_free0 (_data_->_tmp43_->current_operation);
		_data_->_tmp43_->current_operation = _data_->_tmp44_;
		{
			_data_->_tmp45_ = _data_->self->priv->db;
			itdb_write (_data_->_tmp45_, &_data_->_inner_error0_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch16_g_error;
			}
		}
		goto __finally16;
		__catch16_g_error:
		{
			_data_->err = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp46_ = _data_->err;
			_data_->_tmp47_ = _data_->_tmp46_->message;
			g_critical ("iPodLibrary.vala:408: Error when writing iPod database. iPod contents " \
"may be incorrect: %s", _data_->_tmp47_);
			_data_->error_occurred = TRUE;
			_data_->self->priv->operation_cancelled = TRUE;
			_g_error_free0 (_data_->err);
		}
		__finally16:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_object_unref0 (_data_->removed);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp48_ = music_libraries_manager;
		_data_->_tmp48_->progress = (gdouble) 1;
		_data_->_tmp49_ = _data_->self->priv->db;
		itdb_stop_sync (_data_->_tmp49_);
	} else {
		_data_->_tmp50_ = music_libraries_manager;
		_data_->_tmp51_ = g_strdup (_ ("Cancelling Sync…"));
		_g_free0 (_data_->_tmp50_->current_operation);
		_data_->_tmp50_->current_operation = _data_->_tmp51_;
		{
			_data_->_tmp52_ = _data_->self->priv->db;
			itdb_write (_data_->_tmp52_, &_data_->_inner_error0_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch17_g_error;
			}
		}
		goto __finally17;
		__catch17_g_error:
		{
			_data_->_vala1_err = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp53_ = _data_->_vala1_err;
			_data_->_tmp54_ = _data_->_tmp53_->message;
			g_critical ("iPodLibrary.vala:420: Error when writing iPod database. iPod contents " \
"may be incorrect: %s", _data_->_tmp54_);
			_g_error_free0 (_data_->_vala1_err);
		}
		__finally17:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_object_unref0 (_data_->removed);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp55_ = _data_->self->priv->db;
		itdb_stop_sync (_data_->_tmp55_);
		_data_->_tmp56_ = music_libraries_manager;
		_data_->_tmp56_->progress = (gdouble) 1;
		_data_->self->priv->operation_cancelled = FALSE;
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda9__gsource_func, g_object_ref (_data_->self), g_object_unref);
	_g_object_unref0 (_data_->removed);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!_data_->_task_complete_) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
music_plugins_ipod_library_real_add_smart_playlist (MusicLibrary* base,
                                                    MusicSmartPlaylist* p)
{
	MusicPluginsiPodLibrary * self;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_if_fail (p != NULL);
}

static gboolean
music_plugins_ipod_library_real_support_smart_playlists (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	gboolean result = FALSE;
	self = (MusicPluginsiPodLibrary*) base;
	result = FALSE;
	return result;
}

static void
music_plugins_ipod_library_real_remove_smart_playlist (MusicLibrary* base,
                                                       gint64 id)
{
	MusicPluginsiPodLibrary * self;
	self = (MusicPluginsiPodLibrary*) base;
}

static MusicSmartPlaylist*
music_plugins_ipod_library_real_smart_playlist_from_id (MusicLibrary* base,
                                                        gint64 id)
{
	MusicPluginsiPodLibrary * self;
	MusicSmartPlaylist* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	result = NULL;
	return result;
}

static MusicSmartPlaylist*
music_plugins_ipod_library_real_smart_playlist_from_name (MusicLibrary* base,
                                                          const gchar* name)
{
	MusicPluginsiPodLibrary * self;
	MusicSmartPlaylist* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_val_if_fail (name != NULL, NULL);
	result = NULL;
	return result;
}

static gboolean
music_plugins_ipod_library_real_support_playlists (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	gboolean result = FALSE;
	self = (MusicPluginsiPodLibrary*) base;
	result = TRUE;
	return result;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		MusicPluginsiPodLibrary* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->p);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
__lambda10_ (Block2Data* _data2_,
             GeeCollection* list)
{
	MusicPluginsiPodLibrary* self;
	self = _data2_->self;
	g_return_if_fail (list != NULL);
	music_plugins_ipod_library_keep_playlist_synchronized (self, _data2_->p, list, TRUE);
}

static void
___lambda10__music_playlist_media_added (MusicPlaylist* _sender,
                                         GeeCollection* media,
                                         gpointer self)
{
	__lambda10_ (self, media);
}

static void
__lambda11_ (Block2Data* _data2_,
             GeeCollection* list)
{
	MusicPluginsiPodLibrary* self;
	self = _data2_->self;
	g_return_if_fail (list != NULL);
	music_plugins_ipod_library_keep_playlist_synchronized (self, _data2_->p, list, FALSE);
}

static void
___lambda11__music_playlist_media_removed (MusicPlaylist* _sender,
                                           GeeCollection* media,
                                           gpointer self)
{
	__lambda11_ (self, media);
}

static void
music_plugins_ipod_library_real_add_playlist (MusicLibrary* base,
                                              MusicStaticPlaylist* p)
{
	MusicPluginsiPodLibrary * self;
	Block2Data* _data2_;
	MusicStaticPlaylist* _tmp0_;
	Itdb_Playlist* playlist = NULL;
	GeeHashMap* _tmp1_;
	Itdb_iTunesDB* _tmp2_;
	Itdb_Playlist* _tmp3_;
	Itdb_iTunesDB* _tmp4_;
	Itdb_iTunesDB* _tmp5_;
	Itdb_Playlist* _tmp6_;
	Itdb_iTunesDB* _tmp10_;
	GeeHashMap* _tmp11_;
	Itdb_Playlist* _tmp12_;
	GError* _inner_error0_ = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_if_fail (p != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (p);
	_g_object_unref0 (_data2_->p);
	_data2_->p = _tmp0_;
	_tmp1_ = self->priv->medias;
	_tmp2_ = self->priv->db;
	_tmp3_ = music_plugins_ipod_playlist_helper_get_gpod_playlist_from_playlist ((MusicPlaylist*) _data2_->p, _tmp1_, _tmp2_);
	playlist = _tmp3_;
	_tmp4_ = self->priv->db;
	itdb_start_sync (_tmp4_);
	_tmp5_ = self->priv->db;
	_tmp6_ = playlist;
	playlist = NULL;
	itdb_playlist_add (_tmp5_, _tmp6_, (gint32) -1);
	{
		Itdb_iTunesDB* _tmp7_;
		_tmp7_ = self->priv->db;
		itdb_write (_tmp7_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch18_g_error;
		}
	}
	goto __finally18;
	__catch18_g_error:
	{
		GError* err = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = err;
		_tmp9_ = _tmp8_->message;
		g_critical ("iPodLibrary.vala:466: Error when writing iPod database. iPod contents " \
"may be incorrect: %s", _tmp9_);
		_g_error_free0 (err);
	}
	__finally18:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_itdb_playlist_free0 (playlist);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp10_ = self->priv->db;
	itdb_stop_sync (_tmp10_);
	_tmp11_ = self->priv->playlists;
	_tmp12_ = playlist;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, _tmp12_, _data2_->p);
	g_signal_emit_by_name ((MusicLibrary*) self, "playlist-added", _data2_->p);
	g_signal_connect_data ((MusicPlaylist*) _data2_->p, "media-added", (GCallback) ___lambda10__music_playlist_media_added, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	g_signal_connect_data ((MusicPlaylist*) _data2_->p, "media-removed", (GCallback) ___lambda11__music_playlist_media_removed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_itdb_playlist_free0 (playlist);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}

static void
music_plugins_ipod_library_real_remove_playlist (MusicLibrary* base,
                                                 gint64 id)
{
	MusicPluginsiPodLibrary * self;
	Itdb_Playlist* to_unset = NULL;
	Itdb_Playlist* _tmp20_;
	Itdb_iTunesDB* _tmp23_;
	Itdb_Playlist* _tmp24_;
	Itdb_iTunesDB* _tmp28_;
	GError* _inner_error0_ = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	to_unset = NULL;
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->playlists;
		_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_entry_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeMapEntry* _tmp9_;
			gconstpointer _tmp10_;
			MusicStaticPlaylist* _tmp11_;
			gint64 _tmp12_;
			gint64 _tmp13_;
			_tmp6_ = _entry_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _entry_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			entry = (GeeMapEntry*) _tmp8_;
			_tmp9_ = entry;
			_tmp10_ = gee_map_entry_get_value (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = music_playlist_get_rowid ((MusicPlaylist*) ((MusicStaticPlaylist*) _tmp11_));
			_tmp13_ = _tmp12_;
			if (_tmp13_ == id) {
				GeeMapEntry* _tmp14_;
				gconstpointer _tmp15_;
				MusicStaticPlaylist* _tmp16_;
				GeeMapEntry* _tmp17_;
				gconstpointer _tmp18_;
				Itdb_Playlist* _tmp19_;
				_tmp14_ = entry;
				_tmp15_ = gee_map_entry_get_value (_tmp14_);
				_tmp16_ = _tmp15_;
				g_signal_emit_by_name ((MusicLibrary*) self, "playlist-removed", (MusicStaticPlaylist*) _tmp16_);
				_tmp17_ = entry;
				_tmp18_ = gee_map_entry_get_key (_tmp17_);
				_tmp19_ = _tmp18_;
				to_unset = (Itdb_Playlist*) _tmp19_;
			}
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	_tmp20_ = to_unset;
	if (_tmp20_ != NULL) {
		GeeHashMap* _tmp21_;
		Itdb_Playlist* _tmp22_;
		_tmp21_ = self->priv->playlists;
		_tmp22_ = to_unset;
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp21_, _tmp22_, NULL);
	}
	_tmp23_ = self->priv->db;
	itdb_start_sync (_tmp23_);
	_tmp24_ = to_unset;
	itdb_playlist_remove (_tmp24_);
	{
		Itdb_iTunesDB* _tmp25_;
		_tmp25_ = self->priv->db;
		itdb_write (_tmp25_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch19_g_error;
		}
	}
	goto __finally19;
	__catch19_g_error:
	{
		GError* err = NULL;
		GError* _tmp26_;
		const gchar* _tmp27_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp26_ = err;
		_tmp27_ = _tmp26_->message;
		g_critical ("iPodLibrary.vala:493: Error when writing iPod database. iPod contents " \
"may be incorrect: %s", _tmp27_);
		_g_error_free0 (err);
	}
	__finally19:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp28_ = self->priv->db;
	itdb_stop_sync (_tmp28_);
}

static void
music_plugins_ipod_library_keep_playlist_synchronized (MusicPluginsiPodLibrary* self,
                                                       MusicStaticPlaylist* p,
                                                       GeeCollection* m,
                                                       gboolean to_add)
{
	Itdb_Playlist* pl = NULL;
	Itdb_Playlist* _tmp15_;
	Itdb_iTunesDB* _tmp16_;
	Itdb_iTunesDB* _tmp38_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	g_return_if_fail (m != NULL);
	pl = NULL;
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->playlists;
		_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_entry_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeMapEntry* _tmp9_;
			gconstpointer _tmp10_;
			MusicStaticPlaylist* _tmp11_;
			_tmp6_ = _entry_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _entry_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			entry = (GeeMapEntry*) _tmp8_;
			_tmp9_ = entry;
			_tmp10_ = gee_map_entry_get_value (_tmp9_);
			_tmp11_ = _tmp10_;
			if (((MusicStaticPlaylist*) _tmp11_) == p) {
				GeeMapEntry* _tmp12_;
				gconstpointer _tmp13_;
				Itdb_Playlist* _tmp14_;
				_tmp12_ = entry;
				_tmp13_ = gee_map_entry_get_key (_tmp12_);
				_tmp14_ = _tmp13_;
				pl = (Itdb_Playlist*) _tmp14_;
			}
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	_tmp15_ = pl;
	if (_tmp15_ == NULL) {
		return;
	}
	_tmp16_ = self->priv->db;
	itdb_start_sync (_tmp16_);
	{
		GeeIterator* _t_it = NULL;
		GeeHashMap* _tmp17_;
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
		GeeIterator* _tmp20_;
		GeeIterator* _tmp21_;
		_tmp17_ = self->priv->medias;
		_tmp18_ = music_plugins_ipod_playlist_helper_get_gpod_tracks_from_medias (m, _tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
		_tmp21_ = _tmp20_;
		_g_object_unref0 (_tmp19_);
		_t_it = _tmp21_;
		while (TRUE) {
			GeeIterator* _tmp22_;
			Itdb_Track* t = NULL;
			GeeIterator* _tmp23_;
			gpointer _tmp24_;
			gboolean _tmp25_ = FALSE;
			Itdb_Playlist* _tmp26_;
			Itdb_Track* _tmp27_;
			_tmp22_ = _t_it;
			if (!gee_iterator_next (_tmp22_)) {
				break;
			}
			_tmp23_ = _t_it;
			_tmp24_ = gee_iterator_get (_tmp23_);
			t = (Itdb_Track*) _tmp24_;
			_tmp26_ = pl;
			_tmp27_ = t;
			if (!itdb_playlist_contains_track (_tmp26_, _tmp27_)) {
				_tmp25_ = to_add == TRUE;
			} else {
				_tmp25_ = FALSE;
			}
			if (_tmp25_) {
				Itdb_Playlist* _tmp28_;
				Itdb_Track* _tmp29_;
				_tmp28_ = pl;
				_tmp29_ = t;
				itdb_playlist_add_track (_tmp28_, _tmp29_, (gint32) -1);
			} else {
				gboolean _tmp30_ = FALSE;
				Itdb_Playlist* _tmp31_;
				Itdb_Track* _tmp32_;
				_tmp31_ = pl;
				_tmp32_ = t;
				if (itdb_playlist_contains_track (_tmp31_, _tmp32_)) {
					_tmp30_ = to_add == FALSE;
				} else {
					_tmp30_ = FALSE;
				}
				if (_tmp30_) {
					Itdb_Playlist* _tmp33_;
					Itdb_Track* _tmp34_;
					_tmp33_ = pl;
					_tmp34_ = t;
					itdb_playlist_remove_track (_tmp33_, _tmp34_);
				}
			}
		}
		_g_object_unref0 (_t_it);
	}
	{
		Itdb_iTunesDB* _tmp35_;
		_tmp35_ = self->priv->db;
		itdb_write (_tmp35_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch20_g_error;
		}
	}
	goto __finally20;
	__catch20_g_error:
	{
		GError* err = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp36_ = err;
		_tmp37_ = _tmp36_->message;
		g_critical ("iPodLibrary.vala:523: Error when writing iPod database. iPod contents " \
"may be incorrect: %s", _tmp37_);
		_g_error_free0 (err);
	}
	__finally20:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp38_ = self->priv->db;
	itdb_stop_sync (_tmp38_);
}

static MusicStaticPlaylist*
music_plugins_ipod_library_real_playlist_from_id (MusicLibrary* base,
                                                  gint64 id)
{
	MusicPluginsiPodLibrary * self;
	MusicStaticPlaylist* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	{
		GeeIterator* _p_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->playlists;
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_p_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			MusicStaticPlaylist* p = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			MusicStaticPlaylist* _tmp9_;
			gint64 _tmp10_;
			gint64 _tmp11_;
			_tmp6_ = _p_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _p_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			p = (MusicStaticPlaylist*) _tmp8_;
			_tmp9_ = p;
			_tmp10_ = music_playlist_get_rowid ((MusicPlaylist*) _tmp9_);
			_tmp11_ = _tmp10_;
			if (_tmp11_ == id) {
				result = p;
				_g_object_unref0 (_p_it);
				return result;
			}
			_g_object_unref0 (p);
		}
		_g_object_unref0 (_p_it);
	}
	result = NULL;
	return result;
}

static MusicStaticPlaylist*
music_plugins_ipod_library_real_playlist_from_name (MusicLibrary* base,
                                                    const gchar* name)
{
	MusicPluginsiPodLibrary * self;
	MusicStaticPlaylist* result = NULL;
	self = (MusicPluginsiPodLibrary*) base;
	g_return_val_if_fail (name != NULL, NULL);
	{
		GeeIterator* _playlist_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		_tmp0_ = music_library_get_playlists ((MusicLibrary*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_playlist_it = _tmp3_;
		while (TRUE) {
			GeeIterator* _tmp4_;
			MusicStaticPlaylist* playlist = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MusicStaticPlaylist* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			_tmp4_ = _playlist_it;
			if (!gee_iterator_next (_tmp4_)) {
				break;
			}
			_tmp5_ = _playlist_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			playlist = (MusicStaticPlaylist*) _tmp6_;
			_tmp7_ = playlist;
			_tmp8_ = music_playlist_get_name ((MusicPlaylist*) _tmp7_);
			_tmp9_ = _tmp8_;
			if (g_strcmp0 (_tmp9_, name) == 0) {
				result = playlist;
				_g_object_unref0 (_playlist_it);
				return result;
			}
			_g_object_unref0 (playlist);
		}
		_g_object_unref0 (_playlist_it);
	}
	result = NULL;
	return result;
}

static gboolean
music_plugins_ipod_library_real_start_file_operations (MusicLibrary* base,
                                                       const gchar* message)
{
	MusicPluginsiPodLibrary * self;
	gboolean result = FALSE;
	self = (MusicPluginsiPodLibrary*) base;
	result = TRUE;
	return result;
}

static gboolean
music_plugins_ipod_library_real_doing_file_operations (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	gboolean result = FALSE;
	self = (MusicPluginsiPodLibrary*) base;
	result = TRUE;
	return result;
}

static void
music_plugins_ipod_library_real_finish_file_operations (MusicLibrary* base)
{
	MusicPluginsiPodLibrary * self;
	self = (MusicPluginsiPodLibrary*) base;
}

static gchar*
_vala_itdb_filename_ipod2fs (const gchar* ipod_file)
{
	gchar* retval = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (ipod_file != NULL, NULL);
	_tmp0_ = g_strdup (ipod_file);
	retval = _tmp0_;
	itdb_filename_ipod2fs (retval);
	result = retval;
	return result;
}

static void
music_plugins_ipod_library_remove_media_from_ipod (MusicPluginsiPodLibrary* self,
                                                   Itdb_Track* t)
{
	gchar* current_operation = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	MusicDevice* _tmp10_;
	gchar* _tmp11_;
	MusicLibrariesManager* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (t != NULL);
	_tmp0_ = g_strdup (_ ("Removing <b>$NAME</b> by <b>$ARTIST</b> from $DEVICE"));
	current_operation = _tmp0_;
	_tmp2_ = t->title;
	_tmp1_ = _tmp2_;
	if (_tmp1_ == NULL) {
		_tmp1_ = "";
	}
	_tmp3_ = current_operation;
	_tmp4_ = string_replace (_tmp3_, "$NAME", _tmp1_);
	_g_free0 (current_operation);
	current_operation = _tmp4_;
	_tmp6_ = t->artist;
	_tmp5_ = _tmp6_;
	if (_tmp5_ == NULL) {
		_tmp5_ = "";
	}
	_tmp7_ = current_operation;
	_tmp8_ = string_replace (_tmp7_, "$ARTIST", _tmp5_);
	_g_free0 (current_operation);
	current_operation = _tmp8_;
	_tmp10_ = self->priv->device;
	_tmp11_ = music_device_get_display_name (_tmp10_);
	_tmp9_ = _tmp11_;
	if (_tmp9_ == NULL) {
		gchar* _tmp12_;
		_tmp12_ = g_strdup ("");
		_g_free0 (_tmp9_);
		_tmp9_ = _tmp12_;
	}
	_tmp13_ = music_libraries_manager;
	_tmp14_ = current_operation;
	_tmp15_ = string_replace (_tmp14_, "$DEVICE", _tmp9_);
	_g_free0 (_tmp13_->current_operation);
	_tmp13_->current_operation = _tmp15_;
	_tmp16_ = t->ipod_path;
	if (_tmp16_ != NULL) {
		gchar* uri = NULL;
		MusicDevice* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GFile* file = NULL;
		const gchar* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
		_tmp17_ = self->priv->device;
		_tmp18_ = music_device_get_uri (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = t->ipod_path;
		_tmp21_ = _vala_itdb_filename_ipod2fs (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = g_strconcat (_tmp19_, _tmp22_, NULL);
		_tmp24_ = _tmp23_;
		_g_free0 (_tmp22_);
		_g_free0 (_tmp19_);
		uri = _tmp24_;
		_tmp25_ = uri;
		_tmp26_ = g_file_new_for_uri (_tmp25_);
		file = _tmp26_;
		_tmp27_ = file;
		if (g_file_query_exists (_tmp27_, NULL)) {
			{
				Itdb_iTunesDB* _tmp28_;
				Itdb_iTunesDB* _tmp33_;
				GList* _tmp34_;
				Itdb_iTunesDB* _tmp37_;
				GList* _tmp38_;
				GeeArrayList* media_list = NULL;
				GeeArrayList* _tmp41_;
				GeeArrayList* _tmp42_;
				GeeHashMap* _tmp43_;
				gpointer _tmp44_;
				MusicMedia* _tmp45_;
				GeeArrayList* _tmp46_;
				GeeHashMap* _tmp47_;
				GFile* _tmp48_;
				const gchar* _tmp49_;
				_tmp28_ = self->priv->db;
				if (itdb_playlists_number (_tmp28_) != ((guint) 0)) {
					Itdb_iTunesDB* _tmp29_;
					Itdb_Playlist* _tmp30_;
					Itdb_iTunesDB* _tmp31_;
					Itdb_Playlist* _tmp32_;
					_tmp29_ = self->priv->db;
					_tmp30_ = itdb_playlist_mpl (_tmp29_);
					itdb_playlist_remove_track (_tmp30_, t);
					_tmp31_ = self->priv->db;
					_tmp32_ = itdb_playlist_podcasts (_tmp31_);
					itdb_playlist_remove_track (_tmp32_, t);
				}
				_tmp33_ = self->priv->db;
				_tmp34_ = _tmp33_->playlists;
				{
					GList* p_collection = NULL;
					GList* p_it = NULL;
					p_collection = _tmp34_;
					for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
						Itdb_Playlist* p = NULL;
						p = (Itdb_Playlist*) p_it->data;
						{
							Itdb_Playlist* _tmp35_;
							_tmp35_ = p;
							if (itdb_playlist_contains_track (_tmp35_, t)) {
								Itdb_Playlist* _tmp36_;
								_tmp36_ = p;
								itdb_playlist_remove_track (_tmp36_, t);
							}
						}
					}
				}
				_tmp37_ = self->priv->db;
				_tmp38_ = _tmp37_->playlists;
				{
					GList* p_collection = NULL;
					GList* p_it = NULL;
					p_collection = _tmp38_;
					for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
						Itdb_Playlist* p = NULL;
						p = (Itdb_Playlist*) p_it->data;
						{
							Itdb_Playlist* _tmp39_;
							_tmp39_ = p;
							if (itdb_playlist_contains_track (_tmp39_, t)) {
								Itdb_Playlist* _tmp40_;
								_tmp40_ = p;
								itdb_playlist_remove_track (_tmp40_, t);
							}
						}
					}
				}
				_tmp41_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
				media_list = _tmp41_;
				_tmp42_ = media_list;
				_tmp43_ = self->priv->medias;
				_tmp44_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp43_, t);
				_tmp45_ = (MusicMedia*) _tmp44_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp42_, _tmp45_);
				_g_object_unref0 (_tmp45_);
				_tmp46_ = media_list;
				g_signal_emit_by_name ((MusicLibrary*) self, "media-removed", (GeeCollection*) _tmp46_);
				_tmp47_ = self->priv->medias;
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp47_, t, NULL);
				itdb_track_remove (t);
				_tmp48_ = file;
				g_file_delete (_tmp48_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (media_list);
					goto __catch21_g_error;
				}
				_tmp49_ = uri;
				g_warning ("iPodLibrary.vala:594: Successfully removed music file %s from iPod Dis" \
"k", _tmp49_);
				_g_object_unref0 (media_list);
			}
			goto __finally21;
			__catch21_g_error:
			{
				GError* err = NULL;
				const gchar* _tmp50_;
				GError* _tmp51_;
				const gchar* _tmp52_;
				err = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp50_ = uri;
				_tmp51_ = err;
				_tmp52_ = _tmp51_->message;
				g_warning ("iPodLibrary.vala:596: Could not delete iPod File at %s. Unused file wi" \
"ll remain on iPod: %s", _tmp50_, _tmp52_);
				_g_error_free0 (err);
			}
			__finally21:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (file);
				_g_free0 (uri);
				_g_free0 (_tmp9_);
				_g_free0 (current_operation);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		} else {
			const gchar* _tmp53_;
			_tmp53_ = uri;
			g_warning ("iPodLibrary.vala:599: File not found, could not delete iPod File at %s" \
". File may already be deleted", _tmp53_);
		}
		_g_object_unref0 (file);
		_g_free0 (uri);
	}
	_g_free0 (_tmp9_);
	_g_free0 (current_operation);
}

static void
music_plugins_ipod_library_cleanup_files (MusicPluginsiPodLibrary* self,
                                          GFile* music_folder,
                                          GeeLinkedList* used_uris)
{
	GFileInfo* file_info = NULL;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (music_folder != NULL);
	g_return_if_fail (used_uris != NULL);
	file_info = NULL;
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp0_;
		_tmp0_ = g_file_enumerate_children (music_folder, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE, 0, NULL, &_inner_error0_);
		enumerator = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch22_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp1_ = NULL;
			GFileEnumerator* _tmp2_;
			GFileInfo* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			gchar* file_uri = NULL;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GFileInfo* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_ = FALSE;
			GFileInfo* _tmp15_;
			_tmp2_ = enumerator;
			_tmp3_ = g_file_enumerator_next_file (_tmp2_, NULL, &_inner_error0_);
			_tmp1_ = _tmp3_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (enumerator);
				goto __catch22_g_error;
			}
			_tmp4_ = _tmp1_;
			_tmp1_ = NULL;
			_g_object_unref0 (file_info);
			file_info = _tmp4_;
			_tmp5_ = file_info;
			if (!(_tmp5_ != NULL)) {
				_g_object_unref0 (_tmp1_);
				break;
			}
			_tmp6_ = g_file_get_uri (music_folder);
			_tmp7_ = _tmp6_;
			_tmp8_ = g_strconcat (_tmp7_, "/", NULL);
			_tmp9_ = _tmp8_;
			_tmp10_ = file_info;
			_tmp11_ = g_file_info_get_name (_tmp10_);
			_tmp12_ = g_strconcat (_tmp9_, _tmp11_, NULL);
			_tmp13_ = _tmp12_;
			_g_free0 (_tmp9_);
			_g_free0 (_tmp7_);
			file_uri = _tmp13_;
			_tmp15_ = file_info;
			if (g_file_info_get_file_type (_tmp15_) == G_FILE_TYPE_REGULAR) {
				const gchar* _tmp16_;
				_tmp16_ = file_uri;
				_tmp14_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) used_uris, _tmp16_);
			} else {
				_tmp14_ = FALSE;
			}
			if (_tmp14_) {
				const gchar* _tmp17_;
				GFile* file = NULL;
				const gchar* _tmp18_;
				GFile* _tmp19_;
				GFile* _tmp20_;
				_tmp17_ = file_uri;
				g_message ("iPodLibrary.vala:614: Deleting unused file %s\n", _tmp17_);
				_tmp18_ = file_uri;
				_tmp19_ = g_file_new_for_uri (_tmp18_);
				file = _tmp19_;
				_tmp20_ = file;
				g_file_delete (_tmp20_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (file);
					_g_free0 (file_uri);
					_g_object_unref0 (_tmp1_);
					_g_object_unref0 (enumerator);
					goto __catch22_g_error;
				}
				_g_object_unref0 (file);
			} else {
				GFileInfo* _tmp21_;
				_tmp21_ = file_info;
				if (g_file_info_get_file_type (_tmp21_) == G_FILE_TYPE_REGULAR) {
					const gchar* _tmp22_;
					_tmp22_ = file_uri;
					gee_abstract_collection_remove ((GeeAbstractCollection*) used_uris, _tmp22_);
				} else {
					GFileInfo* _tmp23_;
					_tmp23_ = file_info;
					if (g_file_info_get_file_type (_tmp23_) == G_FILE_TYPE_DIRECTORY) {
						const gchar* _tmp24_;
						GFile* _tmp25_;
						GFile* _tmp26_;
						_tmp24_ = file_uri;
						_tmp25_ = g_file_new_for_uri (_tmp24_);
						_tmp26_ = _tmp25_;
						music_plugins_ipod_library_cleanup_files (self, _tmp26_, used_uris);
						_g_object_unref0 (_tmp26_);
					}
				}
			}
			_g_free0 (file_uri);
			_g_object_unref0 (_tmp1_);
		}
		_g_object_unref0 (enumerator);
	}
	goto __finally22;
	__catch22_g_error:
	{
		GError* err = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp27_ = err;
		_tmp28_ = _tmp27_->message;
		g_critical ("iPodLibrary.vala:624: Could not pre-scan music folder. Progress percen" \
"tage may be off: %s", _tmp28_);
		_g_error_free0 (err);
	}
	__finally22:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (file_info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (file_info);
}

static void
music_plugins_ipod_library_class_init (MusicPluginsiPodLibraryClass * klass,
                                       gpointer klass_data)
{
	music_plugins_ipod_library_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPluginsiPodLibrary_private_offset);
	((MusicLibraryClass *) klass)->initialize_library = (void (*) (MusicLibrary*)) music_plugins_ipod_library_real_initialize_library;
	((MusicLibraryClass *) klass)->add_files_to_library = (void (*) (MusicLibrary*, GeeCollection*)) music_plugins_ipod_library_real_add_files_to_library;
	((MusicLibraryClass *) klass)->search_medias = (void (*) (MusicLibrary*, const gchar*)) music_plugins_ipod_library_real_search_medias;
	((MusicLibraryClass *) klass)->get_search_result = (GeeCollection* (*) (MusicLibrary*)) music_plugins_ipod_library_real_get_search_result;
	((MusicLibraryClass *) klass)->get_medias = (GeeCollection* (*) (MusicLibrary*)) music_plugins_ipod_library_real_get_medias;
	((MusicLibraryClass *) klass)->get_playlists = (GeeCollection* (*) (MusicLibrary*)) music_plugins_ipod_library_real_get_playlists;
	((MusicLibraryClass *) klass)->get_smart_playlists = (GeeCollection* (*) (MusicLibrary*)) music_plugins_ipod_library_real_get_smart_playlists;
	((MusicLibraryClass *) klass)->add_media = (void (*) (MusicLibrary*, MusicMedia*)) music_plugins_ipod_library_real_add_media;
	((MusicLibraryClass *) klass)->add_medias = (void (*) (MusicLibrary*, GeeCollection*)) music_plugins_ipod_library_real_add_medias;
	((MusicLibraryClass *) klass)->media_from_id = (MusicMedia* (*) (MusicLibrary*, gint64)) music_plugins_ipod_library_real_media_from_id;
	((MusicLibraryClass *) klass)->medias_from_ids = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_plugins_ipod_library_real_medias_from_ids;
	((MusicLibraryClass *) klass)->medias_from_uris = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_plugins_ipod_library_real_medias_from_uris;
	((MusicLibraryClass *) klass)->find_media = (MusicMedia* (*) (MusicLibrary*, MusicMedia*)) music_plugins_ipod_library_real_find_media;
	((MusicLibraryClass *) klass)->media_from_file = (MusicMedia* (*) (MusicLibrary*, GFile*)) music_plugins_ipod_library_real_media_from_file;
	((MusicLibraryClass *) klass)->media_from_uri = (MusicMedia* (*) (MusicLibrary*, const gchar*)) music_plugins_ipod_library_real_media_from_uri;
	((MusicLibraryClass *) klass)->update_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean, gboolean)) music_plugins_ipod_library_real_update_media;
	((MusicLibraryClass *) klass)->update_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean, gboolean)) music_plugins_ipod_library_real_update_medias;
	((MusicLibraryClass *) klass)->remove_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean)) music_plugins_ipod_library_real_remove_media;
	((MusicLibraryClass *) klass)->remove_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean)) music_plugins_ipod_library_real_remove_medias;
	((MusicLibraryClass *) klass)->add_smart_playlist = (void (*) (MusicLibrary*, MusicSmartPlaylist*)) music_plugins_ipod_library_real_add_smart_playlist;
	((MusicLibraryClass *) klass)->support_smart_playlists = (gboolean (*) (MusicLibrary*)) music_plugins_ipod_library_real_support_smart_playlists;
	((MusicLibraryClass *) klass)->remove_smart_playlist = (void (*) (MusicLibrary*, gint64)) music_plugins_ipod_library_real_remove_smart_playlist;
	((MusicLibraryClass *) klass)->smart_playlist_from_id = (MusicSmartPlaylist* (*) (MusicLibrary*, gint64)) music_plugins_ipod_library_real_smart_playlist_from_id;
	((MusicLibraryClass *) klass)->smart_playlist_from_name = (MusicSmartPlaylist* (*) (MusicLibrary*, const gchar*)) music_plugins_ipod_library_real_smart_playlist_from_name;
	((MusicLibraryClass *) klass)->support_playlists = (gboolean (*) (MusicLibrary*)) music_plugins_ipod_library_real_support_playlists;
	((MusicLibraryClass *) klass)->add_playlist = (void (*) (MusicLibrary*, MusicStaticPlaylist*)) music_plugins_ipod_library_real_add_playlist;
	((MusicLibraryClass *) klass)->remove_playlist = (void (*) (MusicLibrary*, gint64)) music_plugins_ipod_library_real_remove_playlist;
	((MusicLibraryClass *) klass)->playlist_from_id = (MusicStaticPlaylist* (*) (MusicLibrary*, gint64)) music_plugins_ipod_library_real_playlist_from_id;
	((MusicLibraryClass *) klass)->playlist_from_name = (MusicStaticPlaylist* (*) (MusicLibrary*, const gchar*)) music_plugins_ipod_library_real_playlist_from_name;
	((MusicLibraryClass *) klass)->start_file_operations = (gboolean (*) (MusicLibrary*, const gchar*)) music_plugins_ipod_library_real_start_file_operations;
	((MusicLibraryClass *) klass)->doing_file_operations = (gboolean (*) (MusicLibrary*)) music_plugins_ipod_library_real_doing_file_operations;
	((MusicLibraryClass *) klass)->finish_file_operations = (void (*) (MusicLibrary*)) music_plugins_ipod_library_real_finish_file_operations;
	G_OBJECT_CLASS (klass)->finalize = music_plugins_ipod_library_finalize;
}

static void
music_plugins_ipod_library_instance_init (MusicPluginsiPodLibrary * self,
                                          gpointer klass)
{
	self->priv = music_plugins_ipod_library_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_medias);
	g_rec_mutex_init (&self->priv->__lock_searched_medias);
	self->priv->operation_cancelled = FALSE;
	self->priv->is_doing_file_operations = FALSE;
}

static void
music_plugins_ipod_library_finalize (GObject * obj)
{
	MusicPluginsiPodLibrary * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_IPOD_LIBRARY, MusicPluginsiPodLibrary);
	g_rec_mutex_clear (&self->priv->__lock_medias);
	_g_object_unref0 (self->priv->medias);
	g_rec_mutex_clear (&self->priv->__lock_searched_medias);
	_g_object_unref0 (self->priv->searched_medias);
	_g_object_unref0 (self->priv->playlists);
	_g_object_unref0 (self->priv->smart_playlists);
	_g_object_unref0 (self->priv->device);
	G_OBJECT_CLASS (music_plugins_ipod_library_parent_class)->finalize (obj);
}

GType
music_plugins_ipod_library_get_type (void)
{
	return music_plugins_ipod_library_type_id;
}

GType
music_plugins_ipod_library_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsiPodLibraryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_ipod_library_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsiPodLibrary), 0, (GInstanceInitFunc) music_plugins_ipod_library_instance_init, NULL };
	music_plugins_ipod_library_type_id = g_type_module_register_type (module, MUSIC_TYPE_LIBRARY, "MusicPluginsiPodLibrary", &g_define_type_info, 0);
	MusicPluginsiPodLibrary_private_offset = sizeof (MusicPluginsiPodLibraryPrivate);
	return music_plugins_ipod_library_type_id;
}

