/* Core.c generated by valac 0.44.11, the Vala compiler
 * generated from Core.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>,
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Merely a place holder for multiple pieces of information regarding
 * the current media playing. Mostly here because of dependence. */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "music-lib.h"
#include "io.elementary.music-core.h"
#include <gee.h>
#include <libsoup/soup.h>
#include <time.h>
#include <json-glib/json-glib.h>

#define LAST_FM_TYPE_CORE (last_fm_core_get_type ())
#define LAST_FM_CORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LAST_FM_TYPE_CORE, LastFMCore))
#define LAST_FM_CORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LAST_FM_TYPE_CORE, LastFMCoreClass))
#define LAST_FM_IS_CORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LAST_FM_TYPE_CORE))
#define LAST_FM_IS_CORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LAST_FM_TYPE_CORE))
#define LAST_FM_CORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LAST_FM_TYPE_CORE, LastFMCoreClass))

typedef struct _LastFMCore LastFMCore;
typedef struct _LastFMCoreClass LastFMCoreClass;
typedef struct _LastFMCorePrivate LastFMCorePrivate;

#define LAST_FM_TYPE_SIMILAR_MEDIAS (last_fm_similar_medias_get_type ())
#define LAST_FM_SIMILAR_MEDIAS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMedias))
#define LAST_FM_SIMILAR_MEDIAS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMediasClass))
#define LAST_FM_IS_SIMILAR_MEDIAS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS))
#define LAST_FM_IS_SIMILAR_MEDIAS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LAST_FM_TYPE_SIMILAR_MEDIAS))
#define LAST_FM_SIMILAR_MEDIAS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMediasClass))

typedef struct _LastFMSimilarMedias LastFMSimilarMedias;
typedef struct _LastFMSimilarMediasClass LastFMSimilarMediasClass;
enum  {
	LAST_FM_CORE_0_PROPERTY,
	LAST_FM_CORE_NUM_PROPERTIES
};
static GParamSpec* last_fm_core_properties[LAST_FM_CORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _LastFMSimilarMediasPrivate LastFMSimilarMediasPrivate;
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
typedef struct _LastFmCoreFetchAlbumsSlowlyData LastFmCoreFetchAlbumsSlowlyData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _LastFmCoreGetSimilarTracksData LastFmCoreGetSimilarTracksData;
typedef struct _LastFmCoreGetAlbumInfosData LastFmCoreGetAlbumInfosData;
enum  {
	LAST_FM_CORE_SIMILAR_RETRIEVED_SIGNAL,
	LAST_FM_CORE_LOVED_SIGNAL,
	LAST_FM_CORE_BANED_SIGNAL,
	LAST_FM_CORE_NUM_SIGNALS
};
static guint last_fm_core_signals[LAST_FM_CORE_NUM_SIGNALS] = {0};

struct _LastFMCore {
	GObject parent_instance;
	LastFMCorePrivate * priv;
	gboolean is_initialized;
	gchar* api_key;
	gchar* api_secret;
	gchar* session_key;
};

struct _LastFMCoreClass {
	GObjectClass parent_class;
};

struct _LastFMCorePrivate {
	LastFMSimilarMedias* similar_medias;
	GCancellable* fetch_cancellable;
};

struct _LastFMSimilarMedias {
	GObject parent_instance;
	LastFMSimilarMediasPrivate * priv;
	MusicStaticPlaylist* similar_playlist;
};

struct _LastFMSimilarMediasClass {
	GObjectClass parent_class;
	void (*query_for_similar) (LastFMSimilarMedias* self, MusicMedia* s);
};

struct _LastFmCoreFetchAlbumsSlowlyData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	LastFMCore* self;
	GeeCollection* new_medias;
	GeeTreeSet* albums;
	GeeTreeSet* _tmp0_;
	GeeIterator* _media_it;
	GeeIterator* _tmp1_;
	GeeIterator* _tmp2_;
	MusicMedia* media;
	GeeIterator* _tmp3_;
	gpointer _tmp4_;
	GeeTreeSet* _tmp5_;
	MusicMedia* _tmp6_;
	MusicAlbum* _tmp7_;
	MusicAlbum* _tmp8_;
	GeeTreeSet* _tmp9_;
	MusicMedia* _tmp10_;
	MusicAlbum* _tmp11_;
	MusicAlbum* _tmp12_;
	MusicMedia* _tmp13_;
	MusicAlbum* _tmp14_;
	MusicAlbum* _tmp15_;
	GCancellable* _tmp16_;
};

struct _LastFmCoreGetSimilarTracksData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	LastFMCore* self;
	gchar* title;
	gchar* artist;
	GCancellable* cancellable;
	GeeTreeSet* result;
	GeeTreeSet* returned_medias;
	GeeTreeSet* _tmp0_;
	SoupURI* uri;
	SoupURI* _tmp1_;
	SoupURI* _tmp2_;
	const gchar* _tmp3_;
	SoupSession* session;
	SoupSession* _tmp4_;
	SoupRequest* uri_request;
	SoupSession* _tmp5_;
	SoupURI* _tmp6_;
	SoupRequest* _tmp7_;
	GInputStream* stream;
	SoupRequest* _tmp8_;
	GInputStream* _tmp9_;
	JsonParser* parser;
	JsonParser* _tmp10_;
	JsonParser* _tmp11_;
	GInputStream* _tmp12_;
	JsonObject* parser_object;
	JsonParser* _tmp13_;
	JsonNode* _tmp14_;
	JsonObject* _tmp15_;
	gboolean _tmp16_;
	JsonObject* _tmp17_;
	JsonObject* _tmp18_;
	JsonObject* similartracks;
	JsonObject* _tmp19_;
	JsonObject* _tmp20_;
	gboolean _tmp21_;
	JsonObject* _tmp22_;
	JsonObject* _tmp23_;
	JsonNode* _tmp24_;
	GList* similar_tracks_values;
	JsonObject* _tmp25_;
	JsonArray* _tmp26_;
	GList* _tmp27_;
	GList* _tmp28_;
	GList* element_collection;
	GList* element_it;
	JsonNode* element;
	JsonObject* track_object;
	JsonNode* _tmp29_;
	JsonObject* _tmp30_;
	MusicMedia* similar_to_add;
	MusicMedia* _tmp31_;
	GeeTreeSet* _tmp32_;
	MusicMedia* _tmp33_;
	MusicMedia* _tmp34_;
	JsonObject* _tmp35_;
	const gchar* _tmp36_;
	JsonObject* _tmp37_;
	MusicMedia* _tmp38_;
	JsonObject* _tmp39_;
	const gchar* _tmp40_;
	JsonObject* _tmp41_;
	JsonObject* artist_object;
	JsonObject* _tmp42_;
	JsonObject* _tmp43_;
	JsonObject* _tmp44_;
	MusicMedia* _tmp45_;
	JsonObject* _tmp46_;
	const gchar* _tmp47_;
	GError* e;
	GError* _tmp48_;
	const gchar* _tmp49_;
	GError* _inner_error0_;
};

struct _LastFmCoreGetAlbumInfosData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	LastFMCore* self;
	MusicAlbum* album;
	GCancellable* cancellable;
	SoupURI* uri;
	SoupURI* _tmp0_;
	SoupURI* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	SoupSession* session;
	SoupSession* _tmp7_;
	SoupRequest* uri_request;
	SoupSession* _tmp8_;
	SoupURI* _tmp9_;
	SoupRequest* _tmp10_;
	GInputStream* stream;
	SoupRequest* _tmp11_;
	GInputStream* _tmp12_;
	JsonParser* parser;
	JsonParser* _tmp13_;
	JsonParser* _tmp14_;
	GInputStream* _tmp15_;
	JsonObject* parser_object;
	JsonParser* _tmp16_;
	JsonNode* _tmp17_;
	JsonObject* _tmp18_;
	gboolean _tmp19_;
	JsonObject* _tmp20_;
	JsonObject* _tmp21_;
	JsonObject* album_object;
	JsonObject* _tmp22_;
	JsonNode* _tmp23_;
	JsonObject* _tmp24_;
	gboolean _tmp25_;
	JsonObject* _tmp26_;
	JsonObject* _tmp27_;
	JsonNode* _tmp28_;
	GList* image_values;
	JsonObject* _tmp29_;
	JsonArray* _tmp30_;
	GList* _tmp31_;
	gchar* image_url;
	gchar* _tmp32_;
	gchar* image_size;
	gchar* _tmp33_;
	GList* _tmp34_;
	GList* element_collection;
	GList* element_it;
	JsonNode* element;
	JsonObject* image_object;
	JsonNode* _tmp35_;
	JsonObject* _tmp36_;
	const gchar* new_size;
	JsonObject* _tmp37_;
	const gchar* _tmp38_;
	gboolean _tmp39_;
	gboolean _tmp40_;
	const gchar* _tmp41_;
	gboolean _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	gboolean _tmp45_;
	gboolean _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	JsonObject* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	GFile* _tmp58_;
	GFile* _tmp59_;
	gboolean _tmp60_;
	JsonObject* _tmp61_;
	guint _tmp62_;
	guint _tmp63_;
	gchar* releasedate;
	JsonObject* _tmp64_;
	const gchar* _tmp65_;
	gchar* _tmp66_;
	GDate date;
	const gchar* _tmp67_;
	GError* e;
	GError* _tmp68_;
	const gchar* _tmp69_;
	GError* _inner_error0_;
};

static gint LastFMCore_private_offset;
static gpointer last_fm_core_parent_class = NULL;
static LastFMCore* last_fm_core_core;
static LastFMCore* last_fm_core_core = NULL;
static GType last_fm_core_type_id = 0;

GType last_fm_core_register_type (GTypeModule * module);
GType last_fm_core_get_type (void) G_GNUC_CONST;
GType last_fm_similar_medias_register_type (GTypeModule * module);
GType last_fm_similar_medias_get_type (void) G_GNUC_CONST;
#define LAST_FM_CORE_API_URL "http://ws.audioscrobbler.com/2.0/"
LastFMCore* last_fm_core_get_default (void);
static LastFMCore* last_fm_core_new (void);
static LastFMCore* last_fm_core_construct (GType object_type);
LastFMSimilarMedias* last_fm_similar_medias_new (void);
LastFMSimilarMedias* last_fm_similar_medias_construct (GType object_type);
static void __lambda5_ (LastFMCore* self,
                 MusicMedia* media);
void last_fm_core_post_now_playing (LastFMCore* self,
                                    MusicMedia* m);
static void ___lambda5__music_library_window_interface_update_media_info (MusicLibraryWindowInterface* _sender,
                                                                   MusicMedia* m,
                                                                   gpointer self);
static void __lambda6_ (LastFMCore* self,
                 MusicMedia* media);
void last_fm_core_post_scrobble_track (LastFMCore* self,
                                       MusicMedia* m);
static void ___lambda6__music_library_window_interface_media_half_played (MusicLibraryWindowInterface* _sender,
                                                                   MusicMedia* m,
                                                                   gpointer self);
static void __lambda7_ (LastFMCore* self,
                 GeeCollection* medias);
void last_fm_core_fetch_albums_slowly (LastFMCore* self,
                                       GeeCollection* new_medias,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
void last_fm_core_fetch_albums_slowly_finish (LastFMCore* self,
                                              GAsyncResult* _res_);
static void ___lambda7__music_library_media_added (MusicLibrary* _sender,
                                            GeeCollection* medias,
                                            gpointer self);
static void last_fm_core_similar_retrieved_signal (LastFMCore* self,
                                            GeeLinkedList* similar_ids,
                                            GeeLinkedList* similar_dont);
static void _last_fm_core_similar_retrieved_signal_last_fm_similar_medias_similar_retrieved (LastFMSimilarMedias* _sender,
                                                                                      GeeLinkedList* similar_ids,
                                                                                      GeeLinkedList* similar_dont,
                                                                                      gpointer self);
void last_fm_core_initialize (LastFMCore* self,
                              const gchar* api_key,
                              const gchar* api_secret,
                              const gchar* session_key);
MusicStaticPlaylist* last_fm_core_get_similar_playlist (LastFMCore* self);
void last_fm_core_love_track (LastFMCore* self,
                              const gchar* title,
                              const gchar* artist);
gchar* last_fm_core_generate_tracklove_signature (LastFMCore* self,
                                                  const gchar* artist,
                                                  const gchar* track);
static void _vala_SoupURI_free (SoupURI* self);
void last_fm_core_ban_track (LastFMCore* self,
                             const gchar* title,
                             const gchar* artist);
gchar* last_fm_core_generate_trackban_signature (LastFMCore* self,
                                                 const gchar* artist,
                                                 const gchar* track);
static void last_fm_core_fetch_albums_slowly_data_free (gpointer _data);
static void last_fm_core_fetch_albums_slowly_async_ready_wrapper (GObject *source_object,
                                                           GAsyncResult *res,
                                                           void *user_data);
static gboolean last_fm_core_fetch_albums_slowly_co (LastFmCoreFetchAlbumsSlowlyData* _data_);
void last_fm_core_get_album_infos (LastFMCore* self,
                                   MusicAlbum* album,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
void last_fm_core_get_album_infos_finish (LastFMCore* self,
                                          GAsyncResult* _res_);
gchar* last_fm_core_generate_trackupdatenowplaying_signature (LastFMCore* self,
                                                              const gchar* artist,
                                                              const gchar* track);
gchar* last_fm_core_generate_trackscrobble_signature (LastFMCore* self,
                                                      const gchar* artist,
                                                      const gchar* track,
                                                      gint timestamp);
void last_fm_core_fetch_current_similar_songs (LastFMCore* self);
void last_fm_similar_medias_query_for_similar (LastFMSimilarMedias* self,
                                               MusicMedia* s);
static void last_fm_core_get_similar_tracks_data_free (gpointer _data);
static void last_fm_core_get_similar_tracks_async_ready_wrapper (GObject *source_object,
                                                          GAsyncResult *res,
                                                          void *user_data);
void last_fm_core_get_similar_tracks (LastFMCore* self,
                                      const gchar* title,
                                      const gchar* artist,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
GeeTreeSet* last_fm_core_get_similar_tracks_finish (LastFMCore* self,
                                                    GAsyncResult* _res_);
static gboolean last_fm_core_get_similar_tracks_co (LastFmCoreGetSimilarTracksData* _data_);
static void last_fm_core_get_similar_tracks_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void last_fm_core_get_album_infos_data_free (gpointer _data);
static void last_fm_core_get_album_infos_async_ready_wrapper (GObject *source_object,
                                                       GAsyncResult *res,
                                                       void *user_data);
static gboolean last_fm_core_get_album_infos_co (LastFmCoreGetAlbumInfosData* _data_);
static void last_fm_core_get_album_infos_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
gchar* last_fm_core_generate_md5 (LastFMCore* self,
                                  const gchar* text);
gchar* last_fm_core_generate_getsession_signature (LastFMCore* self,
                                                   const gchar* token);
gchar* last_fm_core_generate_trackscrobble_signature2 (LastFMCore* self,
                                                       const gchar* artist,
                                                       const gchar* track,
                                                       const gchar* album,
                                                       gint timestamp);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void last_fm_core_finalize (GObject * obj);

static inline gpointer
last_fm_core_get_instance_private (LastFMCore* self)
{
	return G_STRUCT_MEMBER_P (self, LastFMCore_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

LastFMCore*
last_fm_core_get_default (void)
{
	LastFMCore* _tmp0_;
	LastFMCore* _tmp2_;
	LastFMCore* _tmp3_;
	LastFMCore* result = NULL;
	_tmp0_ = last_fm_core_core;
	if (_tmp0_ == NULL) {
		LastFMCore* _tmp1_;
		_tmp1_ = last_fm_core_new ();
		_g_object_unref0 (last_fm_core_core);
		last_fm_core_core = _tmp1_;
	}
	_tmp2_ = last_fm_core_core;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

static void
__lambda5_ (LastFMCore* self,
            MusicMedia* media)
{
	g_return_if_fail (media != NULL);
	last_fm_core_post_now_playing (self, media);
}

static void
___lambda5__music_library_window_interface_update_media_info (MusicLibraryWindowInterface* _sender,
                                                              MusicMedia* m,
                                                              gpointer self)
{
	__lambda5_ ((LastFMCore*) self, m);
}

static void
__lambda6_ (LastFMCore* self,
            MusicMedia* media)
{
	g_return_if_fail (media != NULL);
	last_fm_core_post_scrobble_track (self, media);
}

static void
___lambda6__music_library_window_interface_media_half_played (MusicLibraryWindowInterface* _sender,
                                                              MusicMedia* m,
                                                              gpointer self)
{
	__lambda6_ ((LastFMCore*) self, m);
}

static void
__lambda7_ (LastFMCore* self,
            GeeCollection* medias)
{
	g_return_if_fail (medias != NULL);
	last_fm_core_fetch_albums_slowly (self, medias, NULL, NULL);
}

static void
___lambda7__music_library_media_added (MusicLibrary* _sender,
                                       GeeCollection* medias,
                                       gpointer self)
{
	__lambda7_ ((LastFMCore*) self, medias);
}

static void
_last_fm_core_similar_retrieved_signal_last_fm_similar_medias_similar_retrieved (LastFMSimilarMedias* _sender,
                                                                                 GeeLinkedList* similar_ids,
                                                                                 GeeLinkedList* similar_dont,
                                                                                 gpointer self)
{
	last_fm_core_similar_retrieved_signal ((LastFMCore*) self, similar_ids, similar_dont);
}

static LastFMCore*
last_fm_core_construct (GType object_type)
{
	LastFMCore * self = NULL;
	GCancellable* _tmp0_;
	LastFMSimilarMedias* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	MusicLibraryWindow* _tmp3_;
	MusicLibraryWindow* _tmp4_;
	MusicLibraryWindow* _tmp5_;
	MusicLibrariesManager* _tmp6_;
	MusicLibrary* _tmp7_;
	LastFMSimilarMedias* _tmp8_;
	self = (LastFMCore*) g_object_new (object_type, NULL);
	_tmp0_ = g_cancellable_new ();
	_g_object_unref0 (self->priv->fetch_cancellable);
	self->priv->fetch_cancellable = _tmp0_;
	_tmp1_ = last_fm_similar_medias_new ();
	_g_object_unref0 (self->priv->similar_medias);
	self->priv->similar_medias = _tmp1_;
	_tmp2_ = music_app_get_main_window ();
	_tmp3_ = _tmp2_;
	g_signal_connect_object ((MusicLibraryWindowInterface*) _tmp3_, "update-media-info", (GCallback) ___lambda5__music_library_window_interface_update_media_info, self, 0);
	_tmp4_ = music_app_get_main_window ();
	_tmp5_ = _tmp4_;
	g_signal_connect_object ((MusicLibraryWindowInterface*) _tmp5_, "media-half-played", (GCallback) ___lambda6__music_library_window_interface_media_half_played, self, 0);
	_tmp6_ = music_libraries_manager;
	_tmp7_ = _tmp6_->local_library;
	g_signal_connect_object (_tmp7_, "media-added", (GCallback) ___lambda7__music_library_media_added, self, 0);
	_tmp8_ = self->priv->similar_medias;
	g_signal_connect_object (_tmp8_, "similar-retrieved", (GCallback) _last_fm_core_similar_retrieved_signal_last_fm_similar_medias_similar_retrieved, self, 0);
	return self;
}

static LastFMCore*
last_fm_core_new (void)
{
	return last_fm_core_construct (LAST_FM_TYPE_CORE);
}

void
last_fm_core_initialize (LastFMCore* self,
                         const gchar* api_key,
                         const gchar* api_secret,
                         const gchar* session_key)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (api_key != NULL);
	g_return_if_fail (api_secret != NULL);
	g_return_if_fail (session_key != NULL);
	_tmp0_ = g_strdup (api_key);
	_g_free0 (self->api_key);
	self->api_key = _tmp0_;
	_tmp1_ = g_strdup (api_secret);
	_g_free0 (self->api_secret);
	self->api_secret = _tmp1_;
	_tmp2_ = g_strdup (session_key);
	_g_free0 (self->session_key);
	self->session_key = _tmp2_;
	self->is_initialized = TRUE;
}

MusicStaticPlaylist*
last_fm_core_get_similar_playlist (LastFMCore* self)
{
	LastFMSimilarMedias* _tmp0_;
	MusicStaticPlaylist* _tmp1_;
	MusicStaticPlaylist* _tmp2_;
	MusicStaticPlaylist* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->similar_medias;
	_tmp1_ = _tmp0_->similar_playlist;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

static void
_vala_SoupURI_free (SoupURI* self)
{
	g_boxed_free (soup_uri_get_type (), self);
}

void
last_fm_core_love_track (LastFMCore* self,
                         const gchar* title,
                         const gchar* artist)
{
	SoupURI* uri = NULL;
	SoupURI* _tmp0_;
	SoupURI* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	SoupSession* session = NULL;
	SoupSession* _tmp6_;
	SoupMessage* message = NULL;
	SoupURI* _tmp7_;
	SoupMessage* _tmp8_;
	SoupSession* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessage* _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (title != NULL);
	g_return_if_fail (artist != NULL);
	if (music_string_is_empty (title, TRUE) | music_string_is_empty (artist, TRUE)) {
		return;
	}
	_tmp0_ = soup_uri_new (LAST_FM_CORE_API_URL);
	uri = _tmp0_;
	_tmp1_ = uri;
	_tmp2_ = self->api_key;
	_tmp3_ = self->session_key;
	_tmp4_ = last_fm_core_generate_tracklove_signature (self, artist, title);
	_tmp5_ = _tmp4_;
	soup_uri_set_query_from_fields (_tmp1_, "method", "track.love", "api_key", _tmp2_, "artist", artist, "track", title, "sk", _tmp3_, "api_sig", _tmp5_, NULL);
	_g_free0 (_tmp5_);
	_tmp6_ = soup_session_new ();
	session = _tmp6_;
	_tmp7_ = uri;
	_tmp8_ = soup_message_new_from_uri ("POST", _tmp7_);
	message = _tmp8_;
	_tmp9_ = session;
	_tmp10_ = message;
	soup_session_send_message (_tmp9_, _tmp10_);
	_tmp11_ = message;
	g_object_get (_tmp11_, "status-code", &_tmp12_, NULL);
	_tmp13_ = _tmp12_;
	if (_tmp13_ == ((guint) SOUP_STATUS_OK)) {
		g_signal_emit (self, last_fm_core_signals[LAST_FM_CORE_LOVED_SIGNAL], 0, title, artist);
	}
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	__vala_SoupURI_free0 (uri);
}

void
last_fm_core_ban_track (LastFMCore* self,
                        const gchar* title,
                        const gchar* artist)
{
	SoupURI* uri = NULL;
	SoupURI* _tmp0_;
	SoupURI* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	SoupSession* session = NULL;
	SoupSession* _tmp6_;
	SoupMessage* message = NULL;
	SoupURI* _tmp7_;
	SoupMessage* _tmp8_;
	SoupSession* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessage* _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (title != NULL);
	g_return_if_fail (artist != NULL);
	if (music_string_is_empty (title, TRUE) | music_string_is_empty (artist, TRUE)) {
		return;
	}
	_tmp0_ = soup_uri_new (LAST_FM_CORE_API_URL);
	uri = _tmp0_;
	_tmp1_ = uri;
	_tmp2_ = self->api_key;
	_tmp3_ = self->session_key;
	_tmp4_ = last_fm_core_generate_trackban_signature (self, artist, title);
	_tmp5_ = _tmp4_;
	soup_uri_set_query_from_fields (_tmp1_, "method", "track.ban", "api_key", _tmp2_, "artist", artist, "track", title, "sk", _tmp3_, "api_sig", _tmp5_, NULL);
	_g_free0 (_tmp5_);
	_tmp6_ = soup_session_new ();
	session = _tmp6_;
	_tmp7_ = uri;
	_tmp8_ = soup_message_new_from_uri ("POST", _tmp7_);
	message = _tmp8_;
	_tmp9_ = session;
	_tmp10_ = message;
	soup_session_send_message (_tmp9_, _tmp10_);
	_tmp11_ = message;
	g_object_get (_tmp11_, "status-code", &_tmp12_, NULL);
	_tmp13_ = _tmp12_;
	if (_tmp13_ == ((guint) SOUP_STATUS_OK)) {
		g_signal_emit (self, last_fm_core_signals[LAST_FM_CORE_BANED_SIGNAL], 0, title, artist);
	}
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	__vala_SoupURI_free0 (uri);
}

static void
last_fm_core_fetch_albums_slowly_data_free (gpointer _data)
{
	LastFmCoreFetchAlbumsSlowlyData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->new_medias);
	_g_object_unref0 (_data_->self);
	g_slice_free (LastFmCoreFetchAlbumsSlowlyData, _data_);
}

static void
last_fm_core_fetch_albums_slowly_async_ready_wrapper (GObject *source_object,
                                                      GAsyncResult *res,
                                                      void *user_data)
{
	LastFmCoreFetchAlbumsSlowlyData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}

void
last_fm_core_fetch_albums_slowly (LastFMCore* self,
                                  GeeCollection* new_medias,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	LastFmCoreFetchAlbumsSlowlyData* _data_;
	LastFMCore* _tmp0_;
	GeeCollection* _tmp1_;
	_data_ = g_slice_new0 (LastFmCoreFetchAlbumsSlowlyData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, last_fm_core_fetch_albums_slowly_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, last_fm_core_fetch_albums_slowly_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (new_medias);
	_g_object_unref0 (_data_->new_medias);
	_data_->new_medias = _tmp1_;
	last_fm_core_fetch_albums_slowly_co (_data_);
}

void
last_fm_core_fetch_albums_slowly_finish (LastFMCore* self,
                                         GAsyncResult* _res_)
{
	LastFmCoreFetchAlbumsSlowlyData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

/** Fetches the current track's info from last.fm
     */
static gboolean
last_fm_core_fetch_albums_slowly_co (LastFmCoreFetchAlbumsSlowlyData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = gee_tree_set_new (MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_data_->albums = _data_->_tmp0_;
	{
		_data_->_tmp1_ = gee_iterable_iterator ((GeeIterable*) _data_->new_medias);
		_data_->_media_it = _data_->_tmp1_;
		while (TRUE) {
			_data_->_tmp2_ = _data_->_media_it;
			if (!gee_iterator_next (_data_->_tmp2_)) {
				break;
			}
			_data_->_tmp3_ = _data_->_media_it;
			_data_->_tmp4_ = gee_iterator_get (_data_->_tmp3_);
			_data_->media = (MusicMedia*) _data_->_tmp4_;
			_data_->_tmp5_ = _data_->albums;
			_data_->_tmp6_ = _data_->media;
			_data_->_tmp7_ = music_media_get_album_info (_data_->_tmp6_);
			_data_->_tmp8_ = _data_->_tmp7_;
			if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _data_->_tmp5_, _data_->_tmp8_)) {
				_data_->_tmp9_ = _data_->albums;
				_data_->_tmp10_ = _data_->media;
				_data_->_tmp11_ = music_media_get_album_info (_data_->_tmp10_);
				_data_->_tmp12_ = _data_->_tmp11_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp9_, _data_->_tmp12_);
				_data_->_tmp13_ = _data_->media;
				_data_->_tmp14_ = music_media_get_album_info (_data_->_tmp13_);
				_data_->_tmp15_ = _data_->_tmp14_;
				_data_->_tmp16_ = _data_->self->priv->fetch_cancellable;
				last_fm_core_get_album_infos (_data_->self, _data_->_tmp15_, _data_->_tmp16_, NULL, NULL);
			}
			_g_object_unref0 (_data_->media);
		}
		_g_object_unref0 (_data_->_media_it);
	}
	_g_object_unref0 (_data_->albums);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!_data_->_task_complete_) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

/** Update's the user's currently playing track on last.fm
     *
     */
void
last_fm_core_post_now_playing (LastFMCore* self,
                               MusicMedia* m)
{
	SoupURI* uri = NULL;
	SoupURI* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	SoupSession* session = NULL;
	SoupSession* _tmp13_;
	SoupMessage* message = NULL;
	SoupMessage* _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	g_debug ("Core.vala:139: Sound send as now_playing");
	_tmp0_ = soup_uri_new (LAST_FM_CORE_API_URL);
	uri = _tmp0_;
	_tmp1_ = self->api_key;
	_tmp2_ = music_media_get_artist (m);
	_tmp3_ = _tmp2_;
	_tmp4_ = music_media_get_title (m);
	_tmp5_ = _tmp4_;
	_tmp6_ = self->session_key;
	_tmp7_ = music_media_get_artist (m);
	_tmp8_ = _tmp7_;
	_tmp9_ = music_media_get_title (m);
	_tmp10_ = _tmp9_;
	_tmp11_ = last_fm_core_generate_trackupdatenowplaying_signature (self, _tmp8_, _tmp10_);
	_tmp12_ = _tmp11_;
	soup_uri_set_query_from_fields (uri, "method", "track.updateNowPlaying", "api_key", _tmp1_, "artist", _tmp3_, "track", _tmp5_, "sk", _tmp6_, "api_sig", _tmp12_, NULL);
	_g_free0 (_tmp12_);
	_tmp13_ = soup_session_new ();
	session = _tmp13_;
	_tmp14_ = soup_message_new_from_uri ("POST", uri);
	message = _tmp14_;
	soup_session_send_message (session, message);
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	__vala_SoupURI_free0 (uri);
}

/**
     * Scrobbles the currently playing track to last.fm
     */
void
last_fm_core_post_scrobble_track (LastFMCore* self,
                                  MusicMedia* m)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	gint timestamp = 0;
	time_t _tmp4_;
	SoupURI* uri = NULL;
	SoupURI* _tmp5_;
	SoupURI* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	SoupSession* session = NULL;
	SoupSession* _tmp21_;
	SoupMessage* message = NULL;
	SoupURI* _tmp22_;
	SoupMessage* _tmp23_;
	SoupSession* _tmp24_;
	SoupMessage* _tmp25_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		return;
	}
	g_debug ("Core.vala:162: Sound Scrobbled");
	_tmp4_ = time (NULL);
	timestamp = (gint) _tmp4_;
	_tmp5_ = soup_uri_new (LAST_FM_CORE_API_URL);
	uri = _tmp5_;
	_tmp6_ = uri;
	_tmp7_ = self->api_key;
	_tmp8_ = music_media_get_artist (m);
	_tmp9_ = _tmp8_;
	_tmp10_ = music_media_get_title (m);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strdup_printf ("%i", timestamp);
	_tmp13_ = _tmp12_;
	_tmp14_ = self->session_key;
	_tmp15_ = music_media_get_artist (m);
	_tmp16_ = _tmp15_;
	_tmp17_ = music_media_get_title (m);
	_tmp18_ = _tmp17_;
	_tmp19_ = last_fm_core_generate_trackscrobble_signature (self, _tmp16_, _tmp18_, timestamp);
	_tmp20_ = _tmp19_;
	soup_uri_set_query_from_fields (_tmp6_, "method", "track.scrobble", "api_key", _tmp7_, "artist", _tmp9_, "track", _tmp11_, "timestamp", _tmp13_, "sk", _tmp14_, "api_sig", _tmp20_, NULL);
	_g_free0 (_tmp20_);
	_g_free0 (_tmp13_);
	_tmp21_ = soup_session_new ();
	session = _tmp21_;
	_tmp22_ = uri;
	_tmp23_ = soup_message_new_from_uri ("POST", _tmp22_);
	message = _tmp23_;
	_tmp24_ = session;
	_tmp25_ = message;
	soup_session_send_message (_tmp24_, _tmp25_);
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	__vala_SoupURI_free0 (uri);
}

void
last_fm_core_fetch_current_similar_songs (LastFMCore* self)
{
	LastFMSimilarMedias* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicPlaybackManager* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->similar_medias;
	_tmp1_ = music_app_get_player ();
	_tmp2_ = _tmp1_;
	_tmp3_ = music_playback_manager_get_current_media (_tmp2_);
	_tmp4_ = _tmp3_;
	last_fm_similar_medias_query_for_similar (_tmp0_, _tmp4_);
}

static void
last_fm_core_similar_retrieved_signal (LastFMCore* self,
                                       GeeLinkedList* similar_ids,
                                       GeeLinkedList* similar_dont)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (similar_ids != NULL);
	g_return_if_fail (similar_dont != NULL);
	g_signal_emit (self, last_fm_core_signals[LAST_FM_CORE_SIMILAR_RETRIEVED_SIGNAL], 0, similar_ids, similar_dont);
}

static void
last_fm_core_get_similar_tracks_data_free (gpointer _data)
{
	LastFmCoreGetSimilarTracksData* _data_;
	_data_ = _data;
	_g_free0 (_data_->title);
	_g_free0 (_data_->artist);
	_g_object_unref0 (_data_->cancellable);
	_g_object_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (LastFmCoreGetSimilarTracksData, _data_);
}

static void
last_fm_core_get_similar_tracks_async_ready_wrapper (GObject *source_object,
                                                     GAsyncResult *res,
                                                     void *user_data)
{
	LastFmCoreGetSimilarTracksData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}

void
last_fm_core_get_similar_tracks (LastFMCore* self,
                                 const gchar* title,
                                 const gchar* artist,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	LastFmCoreGetSimilarTracksData* _data_;
	LastFMCore* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
	_data_ = g_slice_new0 (LastFmCoreGetSimilarTracksData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, last_fm_core_get_similar_tracks_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, last_fm_core_get_similar_tracks_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (title);
	_g_free0 (_data_->title);
	_data_->title = _tmp1_;
	_tmp2_ = g_strdup (artist);
	_g_free0 (_data_->artist);
	_data_->artist = _tmp2_;
	_tmp3_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp3_;
	last_fm_core_get_similar_tracks_co (_data_);
}

GeeTreeSet*
last_fm_core_get_similar_tracks_finish (LastFMCore* self,
                                        GAsyncResult* _res_)
{
	GeeTreeSet* result;
	LastFmCoreGetSimilarTracksData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

/** Gets similar medias
     * @param artist The artist of media to get similar to
     * @param title The title of media to get similar to
     * @return The media that are similar
     */
static void
last_fm_core_get_similar_tracks_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	LastFmCoreGetSimilarTracksData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	_data_->_task_complete_ = TRUE;
	last_fm_core_get_similar_tracks_co (_data_);
}

static gboolean
last_fm_core_get_similar_tracks_co (LastFmCoreGetSimilarTracksData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_data_->returned_medias = _data_->_tmp0_;
	_data_->_tmp1_ = soup_uri_new (LAST_FM_CORE_API_URL);
	_data_->uri = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->uri;
	_data_->_tmp3_ = _data_->self->api_key;
	soup_uri_set_query_from_fields (_data_->_tmp2_, "method", "track.getsimilar", "api_key", _data_->_tmp3_, "artist", _data_->artist, "track", _data_->title, "format", "json", NULL);
	_data_->_tmp4_ = soup_session_new ();
	_data_->session = _data_->_tmp4_;
	{
		_data_->_tmp5_ = _data_->session;
		_data_->_tmp6_ = _data_->uri;
		_data_->_tmp7_ = soup_session_request_uri (_data_->_tmp5_, _data_->_tmp6_, &_data_->_inner_error0_);
		_data_->uri_request = _data_->_tmp7_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp8_ = _data_->uri_request;
		_data_->_state_ = 1;
		soup_request_send_async (_data_->_tmp8_, _data_->cancellable, last_fm_core_get_similar_tracks_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp9_ = soup_request_send_finish (_data_->_tmp8_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp9_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_object_unref0 (_data_->uri_request);
			goto __catch0_g_error;
		}
		_data_->_tmp10_ = json_parser_new ();
		_data_->parser = _data_->_tmp10_;
		_data_->_tmp11_ = _data_->parser;
		_data_->_tmp12_ = _data_->stream;
		json_parser_load_from_stream (_data_->_tmp11_, _data_->_tmp12_, NULL, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_object_unref0 (_data_->parser);
			_g_object_unref0 (_data_->stream);
			_g_object_unref0 (_data_->uri_request);
			goto __catch0_g_error;
		}
		_data_->_tmp13_ = _data_->parser;
		_data_->_tmp14_ = json_parser_get_root (_data_->_tmp13_);
		_data_->_tmp15_ = json_node_get_object (_data_->_tmp14_);
		_data_->parser_object = _data_->_tmp15_;
		_data_->_tmp17_ = _data_->parser_object;
		if (_data_->_tmp17_ == NULL) {
			_data_->_tmp16_ = TRUE;
		} else {
			_data_->_tmp18_ = _data_->parser_object;
			_data_->_tmp16_ = json_object_has_member (_data_->_tmp18_, "similartracks") == FALSE;
		}
		if (_data_->_tmp16_) {
			_data_->result = _data_->returned_medias;
			_g_object_unref0 (_data_->parser);
			_g_object_unref0 (_data_->stream);
			_g_object_unref0 (_data_->uri_request);
			_g_object_unref0 (_data_->session);
			__vala_SoupURI_free0 (_data_->uri);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!_data_->_task_complete_) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp19_ = _data_->parser_object;
		_data_->_tmp20_ = json_object_get_object_member (_data_->_tmp19_, "similartracks");
		_data_->similartracks = _data_->_tmp20_;
		_data_->_tmp22_ = _data_->similartracks;
		if (json_object_has_member (_data_->_tmp22_, "track")) {
			_data_->_tmp23_ = _data_->similartracks;
			_data_->_tmp24_ = json_object_get_member (_data_->_tmp23_, "track");
			_data_->_tmp21_ = json_node_get_node_type (_data_->_tmp24_) == JSON_NODE_ARRAY;
		} else {
			_data_->_tmp21_ = FALSE;
		}
		if (_data_->_tmp21_) {
			_data_->_tmp25_ = _data_->similartracks;
			_data_->_tmp26_ = json_object_get_array_member (_data_->_tmp25_, "track");
			_data_->_tmp27_ = json_array_get_elements (_data_->_tmp26_);
			_data_->similar_tracks_values = _data_->_tmp27_;
			_data_->_tmp28_ = _data_->similar_tracks_values;
			{
				_data_->element_collection = _data_->_tmp28_;
				for (_data_->element_it = _data_->element_collection; _data_->element_it != NULL; _data_->element_it = _data_->element_it->next) {
					_data_->element = (JsonNode*) _data_->element_it->data;
					{
						_data_->_tmp29_ = _data_->element;
						_data_->_tmp30_ = json_node_get_object (_data_->_tmp29_);
						_data_->track_object = _data_->_tmp30_;
						_data_->_tmp31_ = music_media_new ("");
						_data_->similar_to_add = _data_->_tmp31_;
						_data_->_tmp32_ = _data_->returned_medias;
						_data_->_tmp33_ = _data_->similar_to_add;
						gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp32_, _data_->_tmp33_);
						_data_->_tmp34_ = _data_->similar_to_add;
						_data_->_tmp35_ = _data_->track_object;
						_data_->_tmp36_ = json_object_get_string_member (_data_->_tmp35_, "name");
						music_media_set_title (_data_->_tmp34_, _data_->_tmp36_);
						_data_->_tmp37_ = _data_->track_object;
						if (json_object_has_member (_data_->_tmp37_, "url")) {
							_data_->_tmp38_ = _data_->similar_to_add;
							_data_->_tmp39_ = _data_->track_object;
							_data_->_tmp40_ = json_object_get_string_member (_data_->_tmp39_, "url");
							music_media_set_comment (_data_->_tmp38_, _data_->_tmp40_);
						}
						_data_->_tmp41_ = _data_->track_object;
						if (json_object_has_member (_data_->_tmp41_, "artist")) {
							_data_->_tmp42_ = _data_->track_object;
							_data_->_tmp43_ = json_object_get_object_member (_data_->_tmp42_, "artist");
							_data_->artist_object = _data_->_tmp43_;
							_data_->_tmp44_ = _data_->artist_object;
							if (json_object_has_member (_data_->_tmp44_, "name")) {
								_data_->_tmp45_ = _data_->similar_to_add;
								_data_->_tmp46_ = _data_->artist_object;
								_data_->_tmp47_ = json_object_get_string_member (_data_->_tmp46_, "name");
								music_media_set_artist (_data_->_tmp45_, _data_->_tmp47_);
							}
						}
						_g_object_unref0 (_data_->similar_to_add);
					}
				}
			}
			(_data_->similar_tracks_values == NULL) ? NULL : (_data_->similar_tracks_values = (g_list_free (_data_->similar_tracks_values), NULL));
		}
		_g_object_unref0 (_data_->parser);
		_g_object_unref0 (_data_->stream);
		_g_object_unref0 (_data_->uri_request);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp48_ = _data_->e;
		_data_->_tmp49_ = _data_->_tmp48_->message;
		g_critical ("Core.vala:233: %s", _data_->_tmp49_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->session);
		__vala_SoupURI_free0 (_data_->uri);
		_g_object_unref0 (_data_->returned_medias);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = _data_->returned_medias;
	_g_object_unref0 (_data_->session);
	__vala_SoupURI_free0 (_data_->uri);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!_data_->_task_complete_) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
last_fm_core_get_album_infos_data_free (gpointer _data)
{
	LastFmCoreGetAlbumInfosData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->album);
	_g_object_unref0 (_data_->cancellable);
	_g_object_unref0 (_data_->self);
	g_slice_free (LastFmCoreGetAlbumInfosData, _data_);
}

static void
last_fm_core_get_album_infos_async_ready_wrapper (GObject *source_object,
                                                  GAsyncResult *res,
                                                  void *user_data)
{
	LastFmCoreGetAlbumInfosData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}

void
last_fm_core_get_album_infos (LastFMCore* self,
                              MusicAlbum* album,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	LastFmCoreGetAlbumInfosData* _data_;
	LastFMCore* _tmp0_;
	MusicAlbum* _tmp1_;
	GCancellable* _tmp2_;
	_data_ = g_slice_new0 (LastFmCoreGetAlbumInfosData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, last_fm_core_get_album_infos_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, last_fm_core_get_album_infos_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (album);
	_g_object_unref0 (_data_->album);
	_data_->album = _tmp1_;
	_tmp2_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp2_;
	last_fm_core_get_album_infos_co (_data_);
}

void
last_fm_core_get_album_infos_finish (LastFMCore* self,
                                     GAsyncResult* _res_)
{
	LastFmCoreGetAlbumInfosData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	if (NULL == _data_) {
		return;
	}
}

static void
last_fm_core_get_album_infos_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	LastFmCoreGetAlbumInfosData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	_data_->_task_complete_ = TRUE;
	last_fm_core_get_album_infos_co (_data_);
}

static gboolean
last_fm_core_get_album_infos_co (LastFmCoreGetAlbumInfosData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = soup_uri_new (LAST_FM_CORE_API_URL);
	_data_->uri = _data_->_tmp0_;
	_data_->_tmp1_ = _data_->uri;
	_data_->_tmp2_ = _data_->self->api_key;
	_data_->_tmp3_ = music_album_get_artist (_data_->album);
	_data_->_tmp4_ = _data_->_tmp3_;
	_data_->_tmp5_ = music_album_get_name (_data_->album);
	_data_->_tmp6_ = _data_->_tmp5_;
	soup_uri_set_query_from_fields (_data_->_tmp1_, "method", "album.getinfo", "api_key", _data_->_tmp2_, "artist", _data_->_tmp4_, "album", _data_->_tmp6_, "format", "json", NULL);
	_data_->_tmp7_ = soup_session_new ();
	_data_->session = _data_->_tmp7_;
	{
		_data_->_tmp8_ = _data_->session;
		_data_->_tmp9_ = _data_->uri;
		_data_->_tmp10_ = soup_session_request_uri (_data_->_tmp8_, _data_->_tmp9_, &_data_->_inner_error0_);
		_data_->uri_request = _data_->_tmp10_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		_data_->_tmp11_ = _data_->uri_request;
		_data_->_state_ = 1;
		soup_request_send_async (_data_->_tmp11_, _data_->cancellable, last_fm_core_get_album_infos_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp12_ = soup_request_send_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp12_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_object_unref0 (_data_->uri_request);
			goto __catch1_g_error;
		}
		_data_->_tmp13_ = json_parser_new ();
		_data_->parser = _data_->_tmp13_;
		_data_->_tmp14_ = _data_->parser;
		_data_->_tmp15_ = _data_->stream;
		json_parser_load_from_stream (_data_->_tmp14_, _data_->_tmp15_, NULL, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_object_unref0 (_data_->parser);
			_g_object_unref0 (_data_->stream);
			_g_object_unref0 (_data_->uri_request);
			goto __catch1_g_error;
		}
		_data_->_tmp16_ = _data_->parser;
		_data_->_tmp17_ = json_parser_get_root (_data_->_tmp16_);
		_data_->_tmp18_ = json_node_get_object (_data_->_tmp17_);
		_data_->parser_object = _data_->_tmp18_;
		_data_->_tmp20_ = _data_->parser_object;
		if (_data_->_tmp20_ == NULL) {
			_data_->_tmp19_ = TRUE;
		} else {
			_data_->_tmp21_ = _data_->parser_object;
			_data_->_tmp19_ = json_object_has_member (_data_->_tmp21_, "album") == FALSE;
		}
		if (_data_->_tmp19_) {
			_g_object_unref0 (_data_->parser);
			_g_object_unref0 (_data_->stream);
			_g_object_unref0 (_data_->uri_request);
			_g_object_unref0 (_data_->session);
			__vala_SoupURI_free0 (_data_->uri);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!_data_->_task_complete_) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp22_ = _data_->parser_object;
		_data_->_tmp23_ = json_object_get_member (_data_->_tmp22_, "album");
		_data_->_tmp24_ = json_node_get_object (_data_->_tmp23_);
		_data_->album_object = _data_->_tmp24_;
		_data_->_tmp26_ = _data_->album_object;
		if (json_object_has_member (_data_->_tmp26_, "image")) {
			_data_->_tmp27_ = _data_->album_object;
			_data_->_tmp28_ = json_object_get_member (_data_->_tmp27_, "image");
			_data_->_tmp25_ = json_node_get_node_type (_data_->_tmp28_) == JSON_NODE_ARRAY;
		} else {
			_data_->_tmp25_ = FALSE;
		}
		if (_data_->_tmp25_) {
			_data_->_tmp29_ = _data_->album_object;
			_data_->_tmp30_ = json_object_get_array_member (_data_->_tmp29_, "image");
			_data_->_tmp31_ = json_array_get_elements (_data_->_tmp30_);
			_data_->image_values = _data_->_tmp31_;
			_data_->_tmp32_ = g_strdup ("");
			_data_->image_url = _data_->_tmp32_;
			_data_->_tmp33_ = g_strdup ("");
			_data_->image_size = _data_->_tmp33_;
			_data_->_tmp34_ = _data_->image_values;
			{
				_data_->element_collection = _data_->_tmp34_;
				for (_data_->element_it = _data_->element_collection; _data_->element_it != NULL; _data_->element_it = _data_->element_it->next) {
					_data_->element = (JsonNode*) _data_->element_it->data;
					{
						_data_->_tmp35_ = _data_->element;
						_data_->_tmp36_ = json_node_get_object (_data_->_tmp35_);
						_data_->image_object = _data_->_tmp36_;
						_data_->_tmp37_ = _data_->image_object;
						_data_->_tmp38_ = json_object_get_string_member (_data_->_tmp37_, "size");
						_data_->new_size = _data_->_tmp38_;
						_data_->_tmp41_ = _data_->new_size;
						if (g_strcmp0 (_data_->_tmp41_, "mega") == 0) {
							_data_->_tmp40_ = TRUE;
						} else {
							_data_->_tmp43_ = _data_->new_size;
							if (g_strcmp0 (_data_->_tmp43_, "extralarge") == 0) {
								_data_->_tmp44_ = _data_->image_size;
								_data_->_tmp42_ = g_strcmp0 (_data_->_tmp44_, "mega") != 0;
							} else {
								_data_->_tmp42_ = FALSE;
							}
							_data_->_tmp40_ = _data_->_tmp42_;
						}
						if (_data_->_tmp40_) {
							_data_->_tmp39_ = TRUE;
						} else {
							_data_->_tmp47_ = _data_->new_size;
							if (g_strcmp0 (_data_->_tmp47_, "large") == 0) {
								_data_->_tmp48_ = _data_->image_size;
								_data_->_tmp46_ = g_strcmp0 (_data_->_tmp48_, "mega") != 0;
							} else {
								_data_->_tmp46_ = FALSE;
							}
							if (_data_->_tmp46_) {
								_data_->_tmp49_ = _data_->image_size;
								_data_->_tmp45_ = g_strcmp0 (_data_->_tmp49_, "extralarge") != 0;
							} else {
								_data_->_tmp45_ = FALSE;
							}
							_data_->_tmp39_ = _data_->_tmp45_;
						}
						if (_data_->_tmp39_) {
							_data_->_tmp50_ = _data_->image_object;
							_data_->_tmp51_ = json_object_get_string_member (_data_->_tmp50_, "#text");
							_data_->_tmp52_ = g_strdup (_data_->_tmp51_);
							_g_free0 (_data_->image_url);
							_data_->image_url = _data_->_tmp52_;
							_data_->_tmp53_ = _data_->new_size;
							_data_->_tmp54_ = g_strdup (_data_->_tmp53_);
							_g_free0 (_data_->image_size);
							_data_->image_size = _data_->_tmp54_;
						}
					}
				}
			}
			_data_->_tmp55_ = _data_->image_url;
			if (g_strcmp0 (_data_->_tmp55_, "") != 0) {
				_data_->_tmp56_ = _data_->image_url;
				g_debug ("Core.vala:275: Caching last.fm image from URL: %s", _data_->_tmp56_);
				_data_->_tmp57_ = _data_->image_url;
				_data_->_tmp58_ = g_file_new_for_uri (_data_->_tmp57_);
				_data_->_tmp59_ = _data_->_tmp58_;
				music_album_save_cover_file (_data_->album, _data_->_tmp59_);
				_g_object_unref0 (_data_->_tmp59_);
			}
			_g_free0 (_data_->image_size);
			_g_free0 (_data_->image_url);
			(_data_->image_values == NULL) ? NULL : (_data_->image_values = (g_list_free (_data_->image_values), NULL));
		}
		_data_->_tmp61_ = _data_->album_object;
		if (json_object_has_member (_data_->_tmp61_, "releasedate")) {
			_data_->_tmp62_ = music_album_get_year (_data_->album);
			_data_->_tmp63_ = _data_->_tmp62_;
			_data_->_tmp60_ = _data_->_tmp63_ == ((guint) 0);
		} else {
			_data_->_tmp60_ = FALSE;
		}
		if (_data_->_tmp60_) {
			_data_->_tmp64_ = _data_->album_object;
			_data_->_tmp65_ = json_object_get_string_member (_data_->_tmp64_, "releasedate");
			_data_->_tmp66_ = g_strdup (_data_->_tmp65_);
			_data_->releasedate = _data_->_tmp66_;
			memset (&_data_->date, 0, sizeof (GDate));
			_data_->_tmp67_ = _data_->releasedate;
			g_date_set_parse (&_data_->date, _data_->_tmp67_);
			if (g_date_valid (&_data_->date)) {
				music_album_set_year (_data_->album, (guint) g_date_get_year (&_data_->date));
			}
			_g_free0 (_data_->releasedate);
		}
		_g_object_unref0 (_data_->parser);
		_g_object_unref0 (_data_->stream);
		_g_object_unref0 (_data_->uri_request);
	}
	goto __finally1;
	__catch1_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp68_ = _data_->e;
		_data_->_tmp69_ = _data_->_tmp68_->message;
		g_critical ("Core.vala:289: %s", _data_->_tmp69_);
		_g_error_free0 (_data_->e);
	}
	__finally1:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->session);
		__vala_SoupURI_free0 (_data_->uri);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_object_unref0 (_data_->session);
	__vala_SoupURI_free0 (_data_->uri);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!_data_->_task_complete_) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

gchar*
last_fm_core_generate_md5 (LastFMCore* self,
                           const gchar* text)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (text != NULL, NULL);
	_tmp0_ = strlen (text);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_compute_checksum_for_string (G_CHECKSUM_MD5, text, (gsize) _tmp1_);
	result = _tmp2_;
	return result;
}

gchar*
last_fm_core_generate_getsession_signature (LastFMCore* self,
                                            const gchar* token)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (token != NULL, NULL);
	_tmp0_ = self->api_key;
	_tmp1_ = g_strconcat ("api_key", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "methodauth.getSessiontoken", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, token, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = self->api_secret;
	_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = last_fm_core_generate_md5 (self, _tmp9_);
	_tmp11_ = _tmp10_;
	_g_free0 (_tmp9_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	result = _tmp11_;
	return result;
}

gchar*
last_fm_core_generate_tracklove_signature (LastFMCore* self,
                                           const gchar* artist,
                                           const gchar* track)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (artist != NULL, NULL);
	g_return_val_if_fail (track != NULL, NULL);
	_tmp0_ = self->api_key;
	_tmp1_ = g_strconcat ("api_key", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "artist", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, artist, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp6_, "methodtrack.lovesk", NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = self->session_key;
	_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp11_, "track", NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strconcat (_tmp13_, track, NULL);
	_tmp15_ = _tmp14_;
	_tmp16_ = self->api_secret;
	_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
	_tmp18_ = _tmp17_;
	_tmp19_ = last_fm_core_generate_md5 (self, _tmp18_);
	_tmp20_ = _tmp19_;
	_g_free0 (_tmp18_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	result = _tmp20_;
	return result;
}

gchar*
last_fm_core_generate_trackban_signature (LastFMCore* self,
                                          const gchar* artist,
                                          const gchar* track)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (artist != NULL, NULL);
	g_return_val_if_fail (track != NULL, NULL);
	_tmp0_ = self->api_key;
	_tmp1_ = g_strconcat ("api_key", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "artist", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, artist, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp6_, "methodtrack.bansk", NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = self->session_key;
	_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp11_, "track", NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strconcat (_tmp13_, track, NULL);
	_tmp15_ = _tmp14_;
	_tmp16_ = self->api_secret;
	_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
	_tmp18_ = _tmp17_;
	_tmp19_ = last_fm_core_generate_md5 (self, _tmp18_);
	_tmp20_ = _tmp19_;
	_g_free0 (_tmp18_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	result = _tmp20_;
	return result;
}

gchar*
last_fm_core_generate_trackscrobble_signature (LastFMCore* self,
                                               const gchar* artist,
                                               const gchar* track,
                                               gint timestamp)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (artist != NULL, NULL);
	g_return_val_if_fail (track != NULL, NULL);
	_tmp0_ = self->api_key;
	_tmp1_ = g_strconcat ("api_key", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "artist", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, artist, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp6_, "methodtrack.scrobblesk", NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = self->session_key;
	_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp11_, "timestamp", NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strdup_printf ("%i", timestamp);
	_tmp15_ = _tmp14_;
	_tmp16_ = g_strconcat (_tmp13_, _tmp15_, NULL);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_strconcat (_tmp17_, "track", NULL);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_strconcat (_tmp19_, track, NULL);
	_tmp21_ = _tmp20_;
	_tmp22_ = self->api_secret;
	_tmp23_ = g_strconcat (_tmp21_, _tmp22_, NULL);
	_tmp24_ = _tmp23_;
	_tmp25_ = last_fm_core_generate_md5 (self, _tmp24_);
	_tmp26_ = _tmp25_;
	_g_free0 (_tmp24_);
	_g_free0 (_tmp21_);
	_g_free0 (_tmp19_);
	_g_free0 (_tmp17_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	result = _tmp26_;
	return result;
}

gchar*
last_fm_core_generate_trackscrobble_signature2 (LastFMCore* self,
                                                const gchar* artist,
                                                const gchar* track,
                                                const gchar* album,
                                                gint timestamp)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (artist != NULL, NULL);
	g_return_val_if_fail (track != NULL, NULL);
	g_return_val_if_fail (album != NULL, NULL);
	_tmp0_ = g_strconcat ("album", album, NULL);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat (_tmp1_, "api_key", NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->api_key;
	_tmp5_ = g_strconcat (_tmp3_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp6_, "artist", NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_tmp8_, artist, NULL);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strconcat (_tmp10_, "methodtrack.scrobblesk", NULL);
	_tmp12_ = _tmp11_;
	_tmp13_ = self->session_key;
	_tmp14_ = g_strconcat (_tmp12_, _tmp13_, NULL);
	_tmp15_ = _tmp14_;
	_tmp16_ = g_strconcat (_tmp15_, "timestamp", NULL);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_strdup_printf ("%i", timestamp);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_strconcat (_tmp17_, _tmp19_, NULL);
	_tmp21_ = _tmp20_;
	_tmp22_ = g_strconcat (_tmp21_, "track", NULL);
	_tmp23_ = _tmp22_;
	_tmp24_ = g_strconcat (_tmp23_, track, NULL);
	_tmp25_ = _tmp24_;
	_tmp26_ = self->api_secret;
	_tmp27_ = g_strconcat (_tmp25_, _tmp26_, NULL);
	_tmp28_ = _tmp27_;
	_tmp29_ = last_fm_core_generate_md5 (self, _tmp28_);
	_tmp30_ = _tmp29_;
	_g_free0 (_tmp28_);
	_g_free0 (_tmp25_);
	_g_free0 (_tmp23_);
	_g_free0 (_tmp21_);
	_g_free0 (_tmp19_);
	_g_free0 (_tmp17_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	result = _tmp30_;
	return result;
}

gchar*
last_fm_core_generate_trackupdatenowplaying_signature (LastFMCore* self,
                                                       const gchar* artist,
                                                       const gchar* track)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (artist != NULL, NULL);
	g_return_val_if_fail (track != NULL, NULL);
	_tmp0_ = self->api_key;
	_tmp1_ = g_strconcat ("api_key", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "artist", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, artist, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp6_, "methodtrack.updateNowPlayingsk", NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = self->session_key;
	_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp11_, "track", NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strconcat (_tmp13_, track, NULL);
	_tmp15_ = _tmp14_;
	_tmp16_ = self->api_secret;
	_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
	_tmp18_ = _tmp17_;
	_tmp19_ = last_fm_core_generate_md5 (self, _tmp18_);
	_tmp20_ = _tmp19_;
	_g_free0 (_tmp18_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	result = _tmp20_;
	return result;
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
last_fm_core_class_init (LastFMCoreClass * klass,
                         gpointer klass_data)
{
	last_fm_core_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &LastFMCore_private_offset);
	G_OBJECT_CLASS (klass)->finalize = last_fm_core_finalize;
	last_fm_core_signals[LAST_FM_CORE_SIMILAR_RETRIEVED_SIGNAL] = g_signal_new ("similar-retrieved", LAST_FM_TYPE_CORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_LINKED_LIST, GEE_TYPE_LINKED_LIST);
	last_fm_core_signals[LAST_FM_CORE_LOVED_SIGNAL] = g_signal_new ("loved", LAST_FM_TYPE_CORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
	last_fm_core_signals[LAST_FM_CORE_BANED_SIGNAL] = g_signal_new ("baned", LAST_FM_TYPE_CORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
}

static void
last_fm_core_instance_init (LastFMCore * self,
                            gpointer klass)
{
	self->priv = last_fm_core_get_instance_private (self);
	self->is_initialized = FALSE;
}

static void
last_fm_core_finalize (GObject * obj)
{
	LastFMCore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LAST_FM_TYPE_CORE, LastFMCore);
	_g_object_unref0 (self->priv->similar_medias);
	_g_free0 (self->api_key);
	_g_free0 (self->api_secret);
	_g_free0 (self->session_key);
	_g_object_unref0 (self->priv->fetch_cancellable);
	G_OBJECT_CLASS (last_fm_core_parent_class)->finalize (obj);
}

GType
last_fm_core_get_type (void)
{
	return last_fm_core_type_id;
}

GType
last_fm_core_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (LastFMCoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) last_fm_core_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LastFMCore), 0, (GInstanceInitFunc) last_fm_core_instance_init, NULL };
	last_fm_core_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "LastFMCore", &g_define_type_info, 0);
	LastFMCore_private_offset = sizeof (LastFMCorePrivate);
	return last_fm_core_type_id;
}

