/* SimilarMedia.c generated by valac 0.44.11, the Vala compiler
 * generated from SimilarMedia.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>,
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Merely a place holder for multiple pieces of information regarding
 * the current media playing. Mostly here because of dependence. */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include "music-lib.h"
#include <gee.h>
#include <stdlib.h>
#include <string.h>

#define LAST_FM_TYPE_SIMILAR_MEDIAS (last_fm_similar_medias_get_type ())
#define LAST_FM_SIMILAR_MEDIAS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMedias))
#define LAST_FM_SIMILAR_MEDIAS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMediasClass))
#define LAST_FM_IS_SIMILAR_MEDIAS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS))
#define LAST_FM_IS_SIMILAR_MEDIAS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LAST_FM_TYPE_SIMILAR_MEDIAS))
#define LAST_FM_SIMILAR_MEDIAS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMediasClass))

typedef struct _LastFMSimilarMedias LastFMSimilarMedias;
typedef struct _LastFMSimilarMediasClass LastFMSimilarMediasClass;
typedef struct _LastFMSimilarMediasPrivate LastFMSimilarMediasPrivate;
enum  {
	LAST_FM_SIMILAR_MEDIAS_0_PROPERTY,
	LAST_FM_SIMILAR_MEDIAS_NUM_PROPERTIES
};
static GParamSpec* last_fm_similar_medias_properties[LAST_FM_SIMILAR_MEDIAS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define LAST_FM_TYPE_CORE (last_fm_core_get_type ())
#define LAST_FM_CORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LAST_FM_TYPE_CORE, LastFMCore))
#define LAST_FM_CORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LAST_FM_TYPE_CORE, LastFMCoreClass))
#define LAST_FM_IS_CORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LAST_FM_TYPE_CORE))
#define LAST_FM_IS_CORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LAST_FM_TYPE_CORE))
#define LAST_FM_CORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LAST_FM_TYPE_CORE, LastFMCoreClass))

typedef struct _LastFMCore LastFMCore;
typedef struct _LastFMCoreClass LastFMCoreClass;
typedef struct _LastFmSimilarMediasSimilarAsyncData LastFmSimilarMediasSimilarAsyncData;
enum  {
	LAST_FM_SIMILAR_MEDIAS_SIMILAR_RETRIEVED_SIGNAL,
	LAST_FM_SIMILAR_MEDIAS_NUM_SIGNALS
};
static guint last_fm_similar_medias_signals[LAST_FM_SIMILAR_MEDIAS_NUM_SIGNALS] = {0};

struct _LastFMSimilarMedias {
	GObject parent_instance;
	LastFMSimilarMediasPrivate * priv;
	MusicStaticPlaylist* similar_playlist;
};

struct _LastFMSimilarMediasClass {
	GObjectClass parent_class;
	void (*query_for_similar) (LastFMSimilarMedias* self, MusicMedia* s);
};

struct _LastFMSimilarMediasPrivate {
	GRecMutex __lock_similar_playlist;
	GCancellable* cancellable;
};

struct _LastFmSimilarMediasSimilarAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	LastFMSimilarMedias* self;
	MusicMedia* s;
	GCancellable* _tmp0_;
	GeeTreeSet* similar_medias;
	LastFMCore* _tmp1_;
	LastFMCore* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GCancellable* _tmp7_;
	GeeTreeSet* _tmp8_;
	GeeTreeSet* _tmp9_;
	GCancellable* _tmp10_;
	GeeLinkedList* similar_ids;
	GeeLinkedList* _tmp11_;
	GeeLinkedList* similar_dont;
	GeeLinkedList* _tmp12_;
	MusicLibrariesManager* _tmp13_;
	MusicLibrary* _tmp14_;
	GeeTreeSet* _tmp15_;
	GeeLinkedList* _tmp16_;
	GeeLinkedList* _tmp17_;
	GCancellable* _tmp18_;
	GeeLinkedList* _tmp19_;
	gint64 _tmp20_;
	gint64 _tmp21_;
	GeeCollection* found_medias;
	MusicLibrariesManager* _tmp22_;
	MusicLibrary* _tmp23_;
	GeeLinkedList* _tmp24_;
	GeeCollection* _tmp25_;
	GeeCollection* _tmp26_;
	MusicStaticPlaylist* _tmp27_;
	GeeCollection* _tmp28_;
	GeeLinkedList* _tmp29_;
	GeeLinkedList* _tmp30_;
};

static gint LastFMSimilarMedias_private_offset;
static gpointer last_fm_similar_medias_parent_class = NULL;
static GType last_fm_similar_medias_type_id = 0;

GType last_fm_similar_medias_register_type (GTypeModule * module);
GType last_fm_similar_medias_get_type (void) G_GNUC_CONST;
#define LAST_FM_SIMILAR_MEDIAS_MAX_FETCHED 20
LastFMSimilarMedias* last_fm_similar_medias_new (void);
LastFMSimilarMedias* last_fm_similar_medias_construct (GType object_type);
static void __lambda4_ (LastFMSimilarMedias* self,
                 MusicPlaybackManager* m);
static void ___lambda4__music_playback_manager_changing_player (MusicPlaybackManager* _sender,
                                                         gpointer self);
void last_fm_similar_medias_query_for_similar (LastFMSimilarMedias* self,
                                               MusicMedia* s);
static void last_fm_similar_medias_real_query_for_similar (LastFMSimilarMedias* self,
                                                    MusicMedia* s);
void last_fm_similar_medias_similar_async (LastFMSimilarMedias* self,
                                           MusicMedia* s,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
void last_fm_similar_medias_similar_finish (LastFMSimilarMedias* self,
                                            GAsyncResult* _res_);
static void last_fm_similar_medias_similar_async_data_free (gpointer _data);
static void last_fm_similar_medias_similar_async_async_ready_wrapper (GObject *source_object,
                                                               GAsyncResult *res,
                                                               void *user_data);
static gboolean last_fm_similar_medias_similar_async_co (LastFmSimilarMediasSimilarAsyncData* _data_);
GType last_fm_core_register_type (GTypeModule * module);
GType last_fm_core_get_type (void) G_GNUC_CONST;
LastFMCore* last_fm_core_get_default (void);
void last_fm_core_get_similar_tracks (LastFMCore* self,
                                      const gchar* title,
                                      const gchar* artist,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
GeeTreeSet* last_fm_core_get_similar_tracks_finish (LastFMCore* self,
                                                    GAsyncResult* _res_);
static void last_fm_similar_medias_similar_async_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static gint64* _int64_dup (gint64* self);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void last_fm_similar_medias_finalize (GObject * obj);

static inline gpointer
last_fm_similar_medias_get_instance_private (LastFMSimilarMedias* self)
{
	return G_STRUCT_MEMBER_P (self, LastFMSimilarMedias_private_offset);
}

static void
__lambda4_ (LastFMSimilarMedias* self,
            MusicPlaybackManager* m)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (m != NULL);
	{
		MusicStaticPlaylist* _tmp0_;
		_tmp0_ = self->similar_playlist;
		g_rec_mutex_lock (&self->priv->__lock_similar_playlist);
		{
			MusicStaticPlaylist* _tmp1_;
			_tmp1_ = self->similar_playlist;
			music_playlist_clear ((MusicPlaylist*) _tmp1_);
		}
		__finally3:
		{
			MusicStaticPlaylist* _tmp2_;
			_tmp2_ = self->similar_playlist;
			g_rec_mutex_unlock (&self->priv->__lock_similar_playlist);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static void
___lambda4__music_playback_manager_changing_player (MusicPlaybackManager* _sender,
                                                    gpointer self)
{
	__lambda4_ ((LastFMSimilarMedias*) self, _sender);
}

LastFMSimilarMedias*
last_fm_similar_medias_construct (GType object_type)
{
	LastFMSimilarMedias * self = NULL;
	GCancellable* _tmp0_;
	MusicStaticPlaylist* _tmp1_;
	MusicStaticPlaylist* _tmp2_;
	MusicStaticPlaylist* _tmp3_;
	MusicStaticPlaylist* _tmp4_;
	MusicStaticPlaylist* _tmp5_;
	GThemedIcon* _tmp6_;
	MusicPlaybackManager* _tmp7_;
	MusicPlaybackManager* _tmp8_;
	self = (LastFMSimilarMedias*) g_object_new (object_type, NULL);
	_tmp0_ = g_cancellable_new ();
	_g_object_unref0 (self->priv->cancellable);
	self->priv->cancellable = _tmp0_;
	_tmp1_ = music_static_playlist_new ();
	_g_object_unref0 (self->similar_playlist);
	self->similar_playlist = _tmp1_;
	_tmp2_ = self->similar_playlist;
	music_playlist_set_name ((MusicPlaylist*) _tmp2_, _ ("Similar"));
	_tmp3_ = self->similar_playlist;
	music_static_playlist_set_read_only (_tmp3_, TRUE);
	_tmp4_ = self->similar_playlist;
	music_static_playlist_set_show_badge (_tmp4_, TRUE);
	_tmp5_ = self->similar_playlist;
	_tmp6_ = (GThemedIcon*) g_themed_icon_new ("playlist-similar");
	_g_object_unref0 (((MusicPlaylist*) _tmp5_)->icon);
	((MusicPlaylist*) _tmp5_)->icon = (GIcon*) _tmp6_;
	_tmp7_ = music_app_get_player ();
	_tmp8_ = _tmp7_;
	g_signal_connect_object (_tmp8_, "changing-player", (GCallback) ___lambda4__music_playback_manager_changing_player, self, 0);
	return self;
}

LastFMSimilarMedias*
last_fm_similar_medias_new (void)
{
	return last_fm_similar_medias_construct (LAST_FM_TYPE_SIMILAR_MEDIAS);
}

static void
last_fm_similar_medias_real_query_for_similar (LastFMSimilarMedias* self,
                                               MusicMedia* s)
{
	GCancellable* _tmp0_;
	g_return_if_fail (s != NULL);
	_tmp0_ = self->priv->cancellable;
	if (g_cancellable_is_cancelled (_tmp0_) == FALSE) {
		GCancellable* _tmp1_;
		_tmp1_ = self->priv->cancellable;
		g_cancellable_cancel (_tmp1_);
	}
	last_fm_similar_medias_similar_async (self, s, NULL, NULL);
}

void
last_fm_similar_medias_query_for_similar (LastFMSimilarMedias* self,
                                          MusicMedia* s)
{
	g_return_if_fail (self != NULL);
	LAST_FM_SIMILAR_MEDIAS_GET_CLASS (self)->query_for_similar (self, s);
}

static void
last_fm_similar_medias_similar_async_data_free (gpointer _data)
{
	LastFmSimilarMediasSimilarAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->s);
	_g_object_unref0 (_data_->self);
	g_slice_free (LastFmSimilarMediasSimilarAsyncData, _data_);
}

static void
last_fm_similar_medias_similar_async_async_ready_wrapper (GObject *source_object,
                                                          GAsyncResult *res,
                                                          void *user_data)
{
	LastFmSimilarMediasSimilarAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
last_fm_similar_medias_similar_async (LastFMSimilarMedias* self,
                                      MusicMedia* s,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	LastFmSimilarMediasSimilarAsyncData* _data_;
	LastFMSimilarMedias* _tmp0_;
	MusicMedia* _tmp1_;
	_data_ = g_slice_new0 (LastFmSimilarMediasSimilarAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, last_fm_similar_medias_similar_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, last_fm_similar_medias_similar_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (s);
	_g_object_unref0 (_data_->s);
	_data_->s = _tmp1_;
	last_fm_similar_medias_similar_async_co (_data_);
}

void
last_fm_similar_medias_similar_finish (LastFMSimilarMedias* self,
                                       GAsyncResult* _res_)
{
	LastFmSimilarMediasSimilarAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
last_fm_similar_medias_similar_async_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	LastFmSimilarMediasSimilarAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	_data_->_task_complete_ = TRUE;
	last_fm_similar_medias_similar_async_co (_data_);
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}

static gboolean
last_fm_similar_medias_similar_async_co (LastFmSimilarMediasSimilarAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	g_debug ("SimilarMedia.vala:65: In the similar thread");
	_data_->_tmp0_ = _data_->self->priv->cancellable;
	g_cancellable_reset (_data_->_tmp0_);
	_data_->_tmp1_ = last_fm_core_get_default ();
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp3_ = music_media_get_title (_data_->s);
	_data_->_tmp4_ = _data_->_tmp3_;
	_data_->_tmp5_ = music_media_get_artist (_data_->s);
	_data_->_tmp6_ = _data_->_tmp5_;
	_data_->_tmp7_ = _data_->self->priv->cancellable;
	_data_->_state_ = 1;
	last_fm_core_get_similar_tracks (_data_->_tmp2_, _data_->_tmp4_, _data_->_tmp6_, _data_->_tmp7_, last_fm_similar_medias_similar_async_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp8_ = last_fm_core_get_similar_tracks_finish (_data_->_tmp2_, _data_->_res_);
	_data_->_tmp9_ = _data_->_tmp8_;
	_g_object_unref0 (_data_->_tmp2_);
	_data_->similar_medias = _data_->_tmp9_;
	_data_->_tmp10_ = _data_->self->priv->cancellable;
	if (g_cancellable_is_cancelled (_data_->_tmp10_)) {
		_g_object_unref0 (_data_->similar_medias);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!_data_->_task_complete_) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp11_ = gee_linked_list_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_data_->similar_ids = _data_->_tmp11_;
	_data_->_tmp12_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_data_->similar_dont = _data_->_tmp12_;
	_data_->_tmp13_ = music_libraries_manager;
	_data_->_tmp14_ = _data_->_tmp13_->local_library;
	_data_->_tmp15_ = _data_->similar_medias;
	_data_->_tmp16_ = _data_->similar_ids;
	_data_->_tmp17_ = _data_->similar_dont;
	music_library_media_from_name (_data_->_tmp14_, (GeeCollection*) _data_->_tmp15_, (GeeCollection*) _data_->_tmp16_, (GeeCollection*) _data_->_tmp17_);
	_data_->_tmp18_ = _data_->self->priv->cancellable;
	if (g_cancellable_is_cancelled (_data_->_tmp18_)) {
		_g_object_unref0 (_data_->similar_dont);
		_g_object_unref0 (_data_->similar_ids);
		_g_object_unref0 (_data_->similar_medias);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!_data_->_task_complete_) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp19_ = _data_->similar_ids;
	_data_->_tmp20_ = music_media_get_rowid (_data_->s);
	_data_->_tmp21_ = _data_->_tmp20_;
	gee_deque_offer_head ((GeeDeque*) _data_->_tmp19_, &_data_->_tmp21_);
	_data_->_tmp22_ = music_libraries_manager;
	_data_->_tmp23_ = _data_->_tmp22_->local_library;
	_data_->_tmp24_ = _data_->similar_ids;
	_data_->_tmp25_ = music_library_medias_from_ids (_data_->_tmp23_, (GeeCollection*) _data_->_tmp24_);
	_data_->found_medias = _data_->_tmp25_;
	_data_->_tmp26_ = _data_->found_medias;
	gee_collection_remove (_data_->_tmp26_, _data_->s);
	_data_->_tmp27_ = _data_->self->similar_playlist;
	_data_->_tmp28_ = _data_->found_medias;
	music_playlist_add_medias ((MusicPlaylist*) _data_->_tmp27_, _data_->_tmp28_);
	_data_->_tmp29_ = _data_->similar_ids;
	_data_->_tmp30_ = _data_->similar_dont;
	g_signal_emit (_data_->self, last_fm_similar_medias_signals[LAST_FM_SIMILAR_MEDIAS_SIMILAR_RETRIEVED_SIGNAL], 0, _data_->_tmp29_, _data_->_tmp30_);
	_g_object_unref0 (_data_->found_medias);
	_g_object_unref0 (_data_->similar_dont);
	_g_object_unref0 (_data_->similar_ids);
	_g_object_unref0 (_data_->similar_medias);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!_data_->_task_complete_) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}

static void
last_fm_similar_medias_class_init (LastFMSimilarMediasClass * klass,
                                   gpointer klass_data)
{
	last_fm_similar_medias_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &LastFMSimilarMedias_private_offset);
	((LastFMSimilarMediasClass *) klass)->query_for_similar = (void (*) (LastFMSimilarMedias*, MusicMedia*)) last_fm_similar_medias_real_query_for_similar;
	G_OBJECT_CLASS (klass)->finalize = last_fm_similar_medias_finalize;
	last_fm_similar_medias_signals[LAST_FM_SIMILAR_MEDIAS_SIMILAR_RETRIEVED_SIGNAL] = g_signal_new ("similar-retrieved", LAST_FM_TYPE_SIMILAR_MEDIAS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_LINKED_LIST, GEE_TYPE_LINKED_LIST);
}

static void
last_fm_similar_medias_instance_init (LastFMSimilarMedias * self,
                                      gpointer klass)
{
	self->priv = last_fm_similar_medias_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_similar_playlist);
}

static void
last_fm_similar_medias_finalize (GObject * obj)
{
	LastFMSimilarMedias * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LAST_FM_TYPE_SIMILAR_MEDIAS, LastFMSimilarMedias);
	g_rec_mutex_clear (&self->priv->__lock_similar_playlist);
	_g_object_unref0 (self->similar_playlist);
	_g_object_unref0 (self->priv->cancellable);
	G_OBJECT_CLASS (last_fm_similar_medias_parent_class)->finalize (obj);
}

GType
last_fm_similar_medias_get_type (void)
{
	return last_fm_similar_medias_type_id;
}

GType
last_fm_similar_medias_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (LastFMSimilarMediasClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) last_fm_similar_medias_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LastFMSimilarMedias), 0, (GInstanceInitFunc) last_fm_similar_medias_instance_init, NULL };
	last_fm_similar_medias_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "LastFMSimilarMedias", &g_define_type_info, 0);
	LastFMSimilarMedias_private_offset = sizeof (LastFMSimilarMediasPrivate);
	return last_fm_similar_medias_type_id;
}

